import static java.lang.Math.*;
import static java.util.Arrays.*;

import java.util.*;
import java.io.*;

public class Main {

	static final String FILENAME = "burrito";

	public static void main(String[] args) {
		new Thread(null, new Runnable() {
			@Override
			public void run() {
				try {
					new Main().run();
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
		}, "1", 1 << 24).start();
	}

	BufferedReader in;
	PrintWriter out;
	StringTokenizer st = new StringTokenizer("");

	void run() throws IOException {
		in = new BufferedReader(new FileReader(FILENAME + ".in"));
		out = new PrintWriter(FILENAME + ".out");
		solve();
		in.close();
		out.close();
	}

	final int MAX_N = 5 * 100 * 1000 + 100;
	final double eps = 1e-9;

	int n;
	long A, B;

	State states[] = new State[MAX_N];
	double s[] = new double[MAX_N];

	void solve() throws IOException {
		n = nextInt();
		A = nextInt();
		B = nextInt();
		for (int i = 0; i < n; i++) {
			int g = nextInt();
			int a = nextInt();
			int b = nextInt();
			states[i] = new State(a, b, g, i);
		}

		sort(states, 0, n);
		double cA = 0;
		double cB = 0;
		for (int i = 0; i < n && cB <= B; i++) {
			int g = states[i].g;
			int a = states[i].a;
			int b = states[i].b;
			if (cB + b * g <= B || b == 0) {
				s[states[i].id] = g;
				cB += b * g;
				cA += a * g;
			} else {
				s[states[i].id] = (B - cB) / b;
				cB += s[states[i].id] * b;
				cA += s[states[i].id] * a;
			}
		}

		if (cA < A) {
			out.println("-1 -1");
		} else {
			out.println(cA + " " + cB);
			for (int i = 0; i < n; i++)
				out.print(s[i] + " ");
		}

	}

	class State implements Comparable<State> {

		int a, b, g;
		int id;

		public State(int a, int b, int g, int id) {
			super();
			this.a = a;
			this.b = b;
			this.g = g;
			this.id = id;
		}

		@Override
		public int compareTo(State o) {
			return Integer.compare(b * o.a, a * o.b);
		}

	}

	String nextToken() throws IOException {
		while (!st.hasMoreTokens())
			st = new StringTokenizer(in.readLine());
		return st.nextToken();
	}

	int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	long nextLong() throws IOException {
		return Long.parseLong(nextToken());
	}

	double nextDoutble() throws IOException {
		return Double.parseDouble(nextToken());
	}

	boolean EOF() throws IOException {
		while (!st.hasMoreTokens()) {
			String s = in.readLine();
			if (s == null)
				return true;
			st = new StringTokenizer(s);
		}
		return false;
	}

}
