import static java.lang.Math.*;
import static java.util.Arrays.*;

import java.util.*;
import java.io.*;

public class Main {

	static final String FILENAME = "filter";
	public static void main(String[] args) {
		new Thread(null, new Runnable() {
			@Override
			public void run() {
				try {
					new Main().run();
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
		},"1", 1 << 24).start();
	}
	
	BufferedReader in;
	PrintWriter out;
	StringTokenizer st = new StringTokenizer("");
	
	void run() throws IOException{
		in = new BufferedReader(new FileReader(FILENAME + ".in"));
		out = new PrintWriter(FILENAME + ".out");
		solve();
		in.close();
		out.close();
	}
	
	final int MAXM = 1000;
	final int longSize = 64;
	final int MAXMASK = MAXM / longSize + 3;
	
	class User {
		long[] mask = new long[MAXMASK];
		User() {
			
		}
		void addBit(int bit) {
			mask[bit / 64] |= 1L << (bit % 64);
		}
		boolean match(long[] mask) {
			for (int i = 0; i < MAXMASK; i++)
				if ((this.mask[i] & mask[i]) != mask[i])
					return false;
			return true;
		}
	}
	
	void solve() throws IOException{
		int m = nextInt();
		int f = nextInt();
		long[] a = new long[f];
		for (int i = 0; i < f; i++)
			a[i] = nextLong();
		
		int cntFiles = nextInt();
		User[] files = new User[cntFiles];
		for (int i = 0; i < cntFiles; i++) {
			files[i] = new User();
			char[] s = nextToken().toCharArray();
			for (int j = 0; j < s.length; j++) {
				int si = Integer.parseInt("" + s[j], 16);
				for (int k = 0; k < 4; k++)
					if (((1 << (k)) & si) != 0) {
						files[i].addBit(4 * j + k);
					}
			}
		}
		int cntUser = nextInt();
		User[] users = new User[cntUser];
		for (int i = 0; i < cntUser; i++) {
			users[i] = new User();
			long u = nextLong();
			for (int j = 0; j < f; j++) {
				users[i].addBit((int)((u * a[j]) % m));
			}
		}
		
//		BitSet bs;
//		bs.
		
		int[] answer = new int[cntFiles];
		int cntAns = 0;
		for (int i = 0; i < cntFiles; i++) {
			for (int j = 0; j < cntUser; j++) {
				if (files[i].match(users[j].mask)) {
					answer[cntAns++] = i;
					break;
				}
			}
		}
		out.print(cntAns);
		for (int i = 0; i < cntAns; i++)
			out.print(" " + answer[i]);
	}
	
	String nextToken() throws IOException{
		while(!st.hasMoreTokens())
			st = new StringTokenizer(in.readLine());
		return st.nextToken();
	}
	
	int nextInt()  throws IOException{
		return Integer.parseInt(nextToken());
	}
	
	long nextLong() throws IOException{
		return Long.parseLong(nextToken());
	}
	
	double nextDoutble() throws IOException{
		return Double.parseDouble(nextToken());
	}
	
	boolean EOF() throws IOException{
		while (!st.hasMoreTokens()) {
			String s = in.readLine();
			if (s == null)
				return true;
			st = new StringTokenizer(s);
		}
		return false;
	}

}
