import static java.lang.Math.*;
import static java.util.Arrays.*;

import java.util.*;
import java.io.*;

public class Main {

	static final String FILENAME = "improvements";

	public static void main(String[] args) {
		new Thread(null, new Runnable() {
			@Override
			public void run() {
				try {
					new Main().run();
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
		}, "1", 1 << 27).start();
	}

	BufferedReader in;
	PrintWriter out;
	StringTokenizer st = new StringTokenizer("");

	void run() throws IOException {
		in = new BufferedReader(new FileReader(FILENAME + ".in"));
		out = new PrintWriter(FILENAME + ".out");
		solve();
		in.close();
		out.close();
	}
	
	int n = 0;
	final int MAX = 1000 * 1000 * 700;
	int a[];
	int b[];
	int cnt = 0;
	
	void solve() throws IOException {
		
		n = nextInt();
		a = new int[n];
		b = new int[n];
		for (int i = 0; i < n; i++) {
			a[i] = nextInt() - 1;
			b[a[i]] = i;
		}
		int ans = rec(0, n + 1, 0);
		out.println(ans);
	}
	
	int rec(int l, int r, int x) {
		
		if (x == n)
			return 0;
		
		cnt++;
		if (cnt >= MAX)
			return 0;
		int ans = rec(l, r, x + 1);
		
		int pos = a[x];
		
		if (pos >= l && pos <= r) {
			ans = max(ans, rec(l, pos, x + 1) + 1);
			ans = max(ans, rec(pos, r, x + 1) + 1);
		}
		
		return ans;
	}
	
	class RSQ {

		int n;
		int tree[];
		int d[];

		public RSQ(int size) {
			n = 1;
			while (n <= size)
				n <<= 1;

			tree = new int[n << 1];
			d = new int[n << 1];
		}

		void push(int v, int l, int r) {
			if (d[v] == 0)
				return;

			tree[v] += d[v] * (r - l + 1);
			if (l != r) {
				d[v * 2] += d[v];
				d[v * 2 + 1] += d[v];
			}
			d[v] = 0;
		}

		int getSum(int v, int l, int r, int ll, int rr) {
			push(v, l, r);

			if (rr < ll)
				return 0;

			if (l == ll && r == rr) {
				return tree[v];
			}

			int m = (l + r) >> 1;
			int suml = getSum(v * 2, l, m, ll, min(m, rr));
			int sumr = getSum(v * 2 + 1, m + 1, r, max(m + 1, ll), rr);
			return suml + sumr;
		}

		void update(int v, int l, int r, int ll, int rr, int val) {
			push(v, l, r);

			if (rr < ll)
				return;

			if (l == ll && r == rr) {
				d[v] += val;
				push(v, l, r);
				return;
			}

			int m = (l + r) >> 1;
			update(v * 2, l, m, ll, min(m, rr), val);
			update(v * 2 + 1, m + 1, r, max(m + 1, ll), rr, val);
			tree[v] = tree[v * 2] + tree[v * 2 + 1];
		}

		void update(int l, int r, int val) {
			update(1, 0, n - 1, l, r, val);
		}

		int getSum(int l, int r) {
			return getSum(1, 0, n - 1, l, r);
		}

	}

	String nextToken() throws IOException {
		while (!st.hasMoreTokens())
			st = new StringTokenizer(in.readLine());
		return st.nextToken();
	}

	int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	long nextLong() throws IOException {
		return Long.parseLong(nextToken());
	}

	double nextDoutble() throws IOException {
		return Double.parseDouble(nextToken());
	}

	boolean EOF() throws IOException {
		while (!st.hasMoreTokens()) {
			String s = in.readLine();
			if (s == null)
				return true;
			st = new StringTokenizer(s);
		}
		return false;
	}

}
