import java.io.*;
import java.util.StringTokenizer;
import static java.util.Arrays.*;
import static java.lang.Math.*;

public class Main {
	
	public class P implements Comparable<P> {
		public int i;
		public double a, b, ab, g;
		
		public P(int in, double g, double a, double b) {
			i = in;
			this.a = a;
			this.b = b;
			this.g = g;
			ab = b > 0 ? a / b : a;
		}

		@Override
		public int compareTo(P o) {
			// TODO Auto-generated method stub
			return Double.compare(o.ab, ab);
		}
	}
	
	final double eps = 1E-9;
	
	public void solve() throws IOException {
		int n = nextInt();
		
		double A = nextDouble();
		double B = nextDouble();
		
		P ps[] = new P[n];
		
		double r = 0;
		double bm = 0;
		
		for (int i = 0; i < n; ++i) {
			double g = nextDouble(), a = nextDouble(), b = nextDouble();
			ps[i] = new P(i, g,a,b);
			
			r += a * g;
			bm += b * g;
		}
		
		sort(ps);
		
		double l = 0;
		
		B = min(B, bm);
		
		double s[] = new double[n];
		double bs = 0, as = 0;
		
		while (abs(r - l) > eps) {
			double mid = (r + l) / 2.0;
			
			bs = 0.0;
			as = 0.0;
			
			fill(s, 0.0);
			
			for (int i = 0; i < n && abs(B - bs) > eps; ++i) {
				double a = ps[i].a, b = ps[i].b, g = ps[i].g;
				int ind = ps[i].i;
				
				if (b*g + bs < B) {
					s[ind] = g;
				} else {
					double del = (B - bs) / (b*g);
					s[ind] = g * del;
				}
				
				as += a*s[ind];
				bs += b*s[ind];
			}
			
			if (as > mid) {
				l = mid;
			} else {
				r = mid;
			}	
		}
		
		if (A - as > 0) {
			out.println((-1) + " " + (-1));
		} else {
			out.println((as) + " " + (bs));
			for (int i = 0; i < n; ++i) {
				out.print(s[i]);
				out.print(" ");
			}
		}
		
		
	}
	
	public static void main(String[] args) throws IOException {
		new Main().run();
	}
	
	final String fileIn = "burrito.in";
	final String fileOut = "burrito.out";
	BufferedReader in;
	PrintWriter out;
	StringTokenizer st = new StringTokenizer("");
	
	private void run() throws IOException {
		in = new BufferedReader(new FileReader(fileIn));
//		in = new BufferedReader(new InputStreamReader(System.in));
		
		out = new PrintWriter(new FileWriter(fileOut));
//		out = new PrintWriter(System.out);
		
		solve();
		
		in.close();
		out.close();
	}
	
	String nextToken() throws IOException {
		while (!st.hasMoreTokens())
			st = new StringTokenizer(in.readLine());
		return st.nextToken();
	}
	
	Integer nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}
	
	Double nextDouble() throws IOException {
		return Double.parseDouble(nextToken());
	}
	
	Long nextLong() throws IOException {
		return Long.parseLong(nextToken());
	}
	
	String nextString() throws IOException {
		st = new StringTokenizer("");
		return in.readLine();
	}
	
	boolean EOF() throws IOException {
		while (!st.hasMoreTokens()) {
			String s = in.readLine();
			if (s == null)
				return true;
			st = new StringTokenizer(s);
		}
		return false;
	}
}
