//////////PC10//////////////////
#include <fstream>
#include <vector>
#include <string>
#include <algorithm>
//#include <iostream>
#include <math.h>
#include <set>

using namespace std;

set<int> kmp(string sourse, string t)
{
	string s = t + '#' + sourse;
	int n = s.length();
	vector<int> pi(n);
	for (int i = 1; i < n; i++)
	{
		int j = pi[i - 1];
		while (j>0 && s[j] != s[i])
			j = pi[j - 1];
		if (s[i] == s[j])
			j++;
		pi[i] = j;
	}

	set<int> rez;
	for (int i = t.length(); i < n; i++)
	{
		if (pi[i] == t.length())
			rez.insert(i - 2 * t.length());
	}
	return rez;
}

bool cmp(pair<int, int> p1, pair<int, int> p2)
{
	return p1.second < p2.second;
}

int maxn;
vector<set<int> > positions;

void eraseIntersept(int i, int tmp)
{
	for (int j = maxn; j >0; j--)
	{
		int h = 0;
		if (i == j) continue;
		if (j > 9)
		{
			if (positions[j].find(tmp - 1) != positions[j].end())
			{
				if (positions[j].size() > 1){
					positions[j].erase(positions[j].find(tmp - 1));
					h = 1;
				}
			}
		}

		if (i > 9)
		{
			if (positions[j].find(tmp) != positions[j].end())
			{
				if (positions[j].size() > 1){
					positions[j].erase(positions[j].find(tmp));
					h = 1;
				}
			}
			if (positions[j].find(tmp + 1) != positions[j].end())
			{
				if (positions[j].size() > 1){
					positions[j].erase(positions[j].find(tmp + 1));
					h = 1;
				}
			}
		}
		else
		{
			if (positions[j].find(tmp) != positions[j].end())
			{
				if (positions[j].size() > 1){
					positions[j].erase(positions[j].find(tmp));
					h = 1;
				}
			}
		}
		if (positions[j].size() == 1 && h == 1) eraseIntersept(j, *positions[j].begin());
	}
	return;
}

int main()
{
	ifstream cin("joke.in");
	ofstream cout("joke.out");
	////////////////////////////////

	string s;
	cin >> s;
	int sl = s.length();

	maxn = (sl > 9) ? sl - (sl - 9) / 2 : sl;

	positions.resize(maxn + 1);

	for (int i = maxn; i > 0; i--){
		string si = to_string(i);
		set<int> q = kmp(s, si);
		positions[i] = q;
	}


	for (int i = maxn; i >0; i--)
	{
		if (positions[i].size() == 1)
		{
			eraseIntersept(i, *positions[i].begin());
		}
	}


	for (int i = maxn; i >0; i--)
	{
		if (positions[i].size() > 1)
		{
			int tmp = *positions[i].begin();
			set<int> tmpset;
			tmpset.insert(tmp);
			positions[i] = tmpset;
			eraseIntersept(i, tmp);
		}
	}

	vector<pair<int, int> > rez;

	for (int i = 1; i <= maxn; i++)
	{
		//cout << i << ": " << positions[i].size() << ": " << *positions[i].begin()<< endl;
		rez.push_back(make_pair(i, *positions[i].begin()));
	}
	sort(rez.begin(), rez.end(), cmp);

	for (int i = 0; i < rez.size(); i++){
		cout << rez[i].first << " ";
	}





	/////////////////////////////////
	cin.close();
	cout.close();
	//system("pause");
	return 0;
}