#include <iostream>
#include <vector>
#include <string>

using namespace std;


bool get_bit(vector<int> &file, int bit) {
	int byte = bit / 4, pos = bit % 4;
	if (file[byte] & (1 << (pos))) {
		return true;
	} 
	return false;

}

bool in_file(vector<int> &file, vector<int> &a, int u, int m) {
	for (int i = 0; i < a.size(); ++i) {
		long long tmp = (long long)(u) * a[i];
		int j = tmp % m;
		if (!get_bit(file, j)) {
			return false;
		}
	}
	return true;
}

int main() {
	freopen("filter.in", "r", stdin);
	freopen("filter.out", "w", stdout);
	int m, f;
	cin >> m >> f;
	vector<int> a(f);
	for (int i = 0; i < f; ++i) {
		cin >> a[i];
	}

	int n;
	cin >> n;
	vector< vector<int> > files(n);
	for (int i = 0; i < n; ++i) {
		string s;

		cin >> s;

		files[i].resize(s.size());
		for (int j = 0; j < s.size(); ++j) {
			if (s[j] >= '0' && s[j] <= '9') {
				files[i][j] = (int)(s[j] - '0');
			}
			else {
				files[i][j] = (int)(s[j] - 'a') + 10;
			}
		}
		
	}

	int q;
	cin >> q;
	vector<int> u(q);
	vector<bool> file_contains(n,false);
	int count = 0;
	for (int i = 0; i < q; ++i) {

		cin >> u[i];
	}
	for (int j = 0; j < n; ++j) {
		for (int i = 0; i < q; ++i) {
			bool contains = in_file(files[j], a, u[i], m);

			if (contains) {
				
				file_contains[j] = true;
			}
		}

	}

	for (int i = 0; i < n; ++i) {
		if (file_contains[i]) count++;
	}
	cout << count << " ";
	for (int i = 0; i < n; ++i) {
		if (file_contains[i]) {
			cout << i << " ";
		}
	}
	cout << endl;

	return 0;
}