import java.io.*;
import java.util.*;

public class Main {

    static int dig[];
    static int max;

    public static void main(String[] args) {
        Reader in = null;
        PrintWriter out = null;
        try {
            in = new Reader(new FileInputStream("joke.in"));
            out = new PrintWriter(new FileOutputStream("joke.out"));
        } catch (FileNotFoundException e) {
            throw new RuntimeException();
        }

        char[] s = in.next().toCharArray();
        int n = s.length;
        dig = new int[n];
        for (int i = 0; i < n; i++) {
            dig[i] = s[i] - '0';
        }
        max = n;
        if (n>9) max = (n - 9)/2 + 9;

        LinkedList<Integer> l = new LinkedList<Integer>();
        rec(l, 0, 0);
        for (int i : l){
            out.print(i);
            out.print(" ");
        }
        out.println();

        out.close();
    }

    static boolean rec(LinkedList<Integer> list, int pos, long mask){
        if (pos>dig.length) return false;
        if (pos==dig.length) return true;

        if (rec1(list, pos, mask)) return true;
        return rec2(list, pos, mask);
    }
    static boolean rec1(LinkedList<Integer> list, int pos, long mask){
        int num = dig[pos];
        if ((mask&(1l<<(num-1)))>0) return false;
        if (num>max) return false;
        mask |= (1l<<(num-1));
        list.add(num);
        if (rec(list, pos+1, mask)) return true;
        list.remove();
        return false;
    }

    static boolean rec2(LinkedList<Integer> list, int pos, long mask){
        if (pos>=dig.length-1) return false;
        int num = dig[pos]*10+dig[pos+1];
        if ((mask&(1l<<(num-1)))>0) return false;
        if (num>max) return false;
        mask |= (1l<<(num-1));
        list.add(num);
        if (rec(list, pos+2, mask)) return true;
        list.remove();
        return false;
    }
}

class Reader {
    StringTokenizer st;
    BufferedReader is;

    public Reader(InputStream pis) {
        Locale.setDefault(Locale.US);
        is = new BufferedReader(new InputStreamReader(pis));
        st = new StringTokenizer("");
    }

    public String nextLine() {
        st = new StringTokenizer("");
        try {
            return is.readLine();
        } catch (IOException e) {
            throw new RuntimeException();
        }
    }

    public String next() {
        while (!st.hasMoreTokens()) st = new StringTokenizer(nextLine());
        return st.nextToken();
    }

    public long nextLong() {
        return Long.parseLong(next());
    }

    public int nextInt() {
        return Integer.parseInt(next());
    }
}