import java.io.*;
import java.util.*;

public class Main {

    public static StringTokenizer tokenizer;
    public static BufferedReader reader;
    public static PrintWriter writer;

    public static void init() {
        try {
            reader = new BufferedReader(new InputStreamReader(new FileInputStream("alter.in")));
            writer = new PrintWriter(new FileOutputStream("alter.out"));
        } catch (IOException e) {
            System.out.println(e);
            System.exit(1);
        }
    }

    public static String nextToken(){
        while (tokenizer == null || !tokenizer.hasMoreTokens()) {
            try {
                tokenizer = new StringTokenizer(reader.readLine());
            } catch (IOException e) {
                System.out.println(e);
                System.exit(1);
            }
        }
        return tokenizer.nextToken();
    }

    public static int nextInt() {
        return Integer.parseInt(nextToken());
    }

    public static Long nextLong() {
        return Long.parseLong(nextToken());
    }

    public static Byte nextByte() {
        return Byte.parseByte(nextToken());
    }

    public static Double nextDouble() {
        return Double.parseDouble(nextToken());
    }

    public static Short nextShort() {
        return Short.parseShort(nextToken());
    }

    public static Float nextFloat() {
        return Float.parseFloat(nextToken());
    }

    public static void close() {
        try {
            reader.close();
            writer.flush();
            writer.close();
        } catch (IOException e) {
            System.out.println(e);
            System.exit(1);
        }
    }

    public static void solve() {
        int n = nextInt();
        int m = nextInt();
        int i = 0;
        int j = 0;
        int cnt = 0;
        String[] ar = new String[n*m];
        while (i+2 <= n) {
            i+=2;
            ar[cnt] = i+" "+1+" "+i+" "+m;
            cnt++;
        }
        while (j+2 <= m) {
            j+=2;
            ar[cnt] = 1+" "+j+" "+n+" "+j;
            cnt++;
        }

        writer.println(cnt);
        for (int k = 0; k < cnt; k++) {
            writer.println(ar[k]);
        }
    }

    public static void main(String[] args) {
        init();
        solve();
        close();
    }
}
