import java.io.*;
import java.util.*;

public class Main {

    public static StringTokenizer tokenizer;
    public static BufferedReader reader;
    public static PrintWriter writer;

    public static void init() {
        try {
            reader = new BufferedReader(new InputStreamReader(new FileInputStream("knockout.in")));
            writer = new PrintWriter(new FileOutputStream("knockout.out"));
        } catch (IOException e) {
            System.out.println(e);
            System.exit(1);
        }
    }

    public static String nextToken(){
        while (tokenizer == null || !tokenizer.hasMoreTokens()) {
            try {
                tokenizer = new StringTokenizer(reader.readLine());
            } catch (IOException e) {
                System.out.println(e);
                System.exit(1);
            }
        }
        return tokenizer.nextToken();
    }

    public static int nextInt() {
        return Integer.parseInt(nextToken());
    }

    public static Long nextLong() {
        return Long.parseLong(nextToken());
    }

    public static Byte nextByte() {
        return Byte.parseByte(nextToken());
    }

    public static Double nextDouble() {
        return Double.parseDouble(nextToken());
    }

    public static Short nextShort() {
        return Short.parseShort(nextToken());
    }

    public static Float nextFloat() {
        return Float.parseFloat(nextToken());
    }

    public static void close() {
        try {
            reader.close();
            writer.flush();
            writer.close();
        } catch (IOException e) {
            System.out.println(e);
            System.exit(1);
        }
    }

    public static void solve() {
        int n = nextInt();
        int m = nextInt();

        int[][] ar = new int[n][2];

        for (int i = 0; i < n; i++) {
            ar[i][0] = nextInt();
            ar[i][1] = nextInt();
        }
        int x1, x2, x3, t,t1;
        for (int i = 0; i < m; i++) {
            x1 = nextInt();
            x2 = nextInt();
            t1 = nextInt();
            int cnt = 0;
            for (int j = 0; j < n; j++){
                int a = ar[j][0];
                int b = ar[j][1];
                if (a != b) {
                    t = t1 % ((b - a) * 2);
                } else {
                    t = 0;
                }
                if (t <= (b - a)) {
                    x3 = a + t;
                } else {
                    x3 = b - (t - (b - a));
                }
                if (x3 >= x1 && x3 <= x2) {
//                    System.out.println((i+1)+" : "+(j+1)+" : "+x1+" : "+x2+" : "+x3+" : "+t+" : "+a+" : "+b);
                    cnt++;
                }
            }
            writer.println(cnt);
        }

    }

    public static void main(String[] args) {
        init();
        solve();
        close();
    }
}
