#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#define M_PI       3.14159265358979323846

using namespace std;

double d, l, r, t, h;

double rast(double x)
{
	if (t == 0)
	{
		return h - d / 2;
	}
	if (t == l)
	{
		if (x < h) return 10000.0;
		return -10000.0;
	}
	static double b = sqrt(l*l - t*t);
	static double f = (d*b) / (2.0 * t);
	static double g = (l*h) / t;
	x = g - f - x;
	return (x*t) / b;
}

double vol(double R, double dist, double dx)
{
	if (dist > R)
	{
		return dx*(M_PI * R*R);
	}
	if (dist <= R || abs(dist - R) < 1e-9)
	{
		if (dist < -R)
			return 0.0;
			if (dist >= 0)
			{
				double alpha = 2 * acos(dist / R);
				double d = sqrt(R*R - dist *dist);
				return dx*(M_PI * R*R - (alpha*R*R / 2.0 - d*dist));
			}
			else
			{
				dist *= -1;
				double alpha = 2 * acos(dist / R);
				double d = sqrt(R*R- dist *dist);
				return dx*(alpha*R*R / 2.0 - d*dist);
			}
	}
	return 0.0;
}

int main()
{
	freopen("damage.in", "r", stdin);
	freopen("damage.out", "w", stdout);

	cin >> d >> l >> r >> t >> h;
	d /= 100;
	t /= 100;
	r /= 100;
	l /= 100;
	h /= 100;

	int n = 5000000;

	double v = 0.0;
	double e = sqrt(r*r - d*d / 4);

	double dx1 = (r - e) / n;
	double dx2 = (l) / n;

	for (int i = 1; i <= n; i++)
	{
		double x = e - r + ((double)i / n)*(r - e);
		double R = sqrt(r*r - (x - e)*(x - e));
		double dist = rast(x);
		v += vol(R, dist, dx1);
		
        x = l - x;
		dist = rast(x);
		v += vol(R, dist, dx1);

		x = ((double)i / n)*l;
		R = d / 2;
		dist = rast(x);
		v += vol(R, dist, dx2);
	}

	printf("%0.3lf", v);
	

	return 0;
}