#include <iostream>
#include <cstdio>
#include <fstream>
#include <vector>
#include <map>
#include <set>
#include <iomanip>
#include <stack>
#include <queue>
#include <algorithm>
#include <cmath>
#include <string>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef vector<ull> la_t;

void setbit(la_t& l, int i){
	int ind = i / 64;
	ull shift = i % 64;
	if (shift == 63){
		l[ind] |= 0x8000000000000000ULL;
	}
	else{
		l[ind] |= ull(1UL) << ull(shift);
	}
}
bool compare(la_t& x, la_t& y){
	bool res = true;
	for (int i = 0; i < x.size() && res; i++){
		res = res && ((x[i] & y[i]) == x[i]);
	}
	return res;
}

ull getull(string s){
	ull res = 0;
	ull mul = 1;
	for (int i = 15; i >= 0; i--){
		ull dig;
		if (i >= s.length()){ mul *= 16; continue; }
		switch (s[i]){
		case '0': dig = 0; break;
		case '1': dig = 1; break;
		case '2': dig = 2; break;
		case '3': dig = 3; break;
		case '4': dig = 4; break;
		case '5': dig = 5; break;
		case '6': dig = 6; break;
		case '7': dig = 7; break;
		case '8': dig = 8; break;
		case '9': dig = 9; break;
		case 'a': dig = 10; break;
		case 'b': dig = 11; break;
		case 'c': dig = 12; break;
		case 'd': dig = 13; break;
		case 'e': dig = 14; break;
		case 'f': dig = 15; break;
		}
		res += dig * mul / 16;
		mul *= 16;
	}
	return res;
}

int main(){
	ifstream in("filter.in");
	ofstream out("filter.out");
	cin.set_rdbuf(in.rdbuf());
	cout.set_rdbuf(out.rdbuf());

	ull asd = 0;
	asd = 0x8000000000000001ULL;

	cout.precision(10);

	int m, f;
	cin >> m >> f;
	vector<ll> a(f);
	for (int i = 0; i < f; i++){
		cin >> a[i];
	}
	int n;
	int displacement = (60 - m % 60) % 60;// +(8 - (m / 4) % 8) % 8;

	cin >> n;
	string cur;
	getline(cin, cur);
	vector<la_t> d(n);
	for (int i = 0; i < n; i++){
		getline(cin, cur);
		d[i].reserve(m / 4 + 1);
		for (int j = 0; j < m / 4; j += 15){
			d[i].push_back(getull(cur.substr(j, 15)));
		}
	}
	int p;
	cin >> p;
	vector<la_t> users(p);
	

	for (int i = 0; i < p; i++){
		int u;
		cin >> u;
		users[i].resize(d[0].size(), 0);
		for (int j = 0; j < f; j++){
			setbit(users[i], ((u*a[j]) % m) + displacement);
		}
	}

	vector<int> goods;
	goods.reserve(1000);
	for (int i = 0; i < n; i++){
		for (int j = 0; j < p; j++)
		{
			bool v = compare(users[j], d[i]);
			if (v) {
				goods.push_back(i);
				break;
			}
		}
	}

	cout << goods.size() << ' ';
	for (int i = 0; i < goods.size(); i++){
		cout << goods[i] << ' ';
	}

	return 0;
}
