#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cmath>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <cstring>
#include <cstdio>
#include <list>
#include <queue>
#include <stack>
#include <algorithm>

using namespace std;

#define mp make_pair
#define mt(a, b, c) mp(a, mp(b, c))
#define ZERO(x) memset((x), 0, sizeof(x))
#define NEGATE(x) memset((x), 255, sizeof(x))

typedef long long ll;
typedef pair<int, int> pii;

#define TASK "burrito"

const double EPS = 1e-9;
const int MAX_N = 100050;

int g[MAX_N];
int a[MAX_N];
int b[MAX_N];

double ingrs[MAX_N];

bool doubleEqual(double aa, double bb)
{
	return fabs(aa - bb) < EPS;
}

bool doubleGreaterOrEqual(double aa, double bb)
{
	return aa > bb || doubleEqual(aa, bb);
}

int main()
{
#ifdef XXX
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#elif defined(TASK)
	freopen(TASK ".in", "r", stdin);
	freopen(TASK ".out", "w", stdout);
#endif

	ZERO(ingrs);
	int n, A, B;
	cin >> n >> A >> B;

	vector<pair<double, int> > ang;
	for (int i = 0; i < n; ++i)
	{
		scanf("%d%d%d", g+i, a+i, b+i);
		ang.push_back(mp((a[i] + 0.0) / b[i], i));
	}

	sort(ang.begin(), ang.end());
	reverse(ang.begin(), ang.end());

	double aglob = 0.0;
	double bglob = 0.0;

	for (int i = 0; i < n; ++i)
	{
		int cur = ang[i].second;
		double maxc = max(min((B - bglob) / b[cur], g[cur] + 0.0), 0.0);
		aglob += a[cur] * maxc;
		bglob += b[cur] * maxc;

		ingrs[cur] = maxc;

		if (doubleEqual(bglob, B))
		{
			break;
		}
	}

	if (!doubleGreaterOrEqual(aglob, A))
	{
		cout << "-1 -1" << endl;
		return 0;
	}

	printf("%.10lf %.10lf\n", aglob, bglob);
	
	for (int i = 0; i < n; ++i)
	{
		printf("%.10lf ", ingrs[i]);
	}
	printf("\n");

	return 0;
}