#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cmath>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <cstring>
#include <cstdio>
#include <list>
#include <queue>
#include <stack>
#include <algorithm>

using namespace std;

#define mp make_pair
#define mt(a, b, c) mp(a, mp(b, c))
#define ZERO(x) memset((x), 0, sizeof(x))
#define NEGATE(x) memset((x), 255, sizeof(x))

typedef long long ll;
typedef pair<int, int> pii;

#define TASK "burrito"

const double EPS = 1e-10;
const int MAX_N = 100050;

int g[MAX_N];
int a[MAX_N];
int b[MAX_N];

double ingrs[MAX_N];

ll gcd(ll a, ll b)
{
	if (b == 0) return a;
	return gcd(b, a % b);
}

struct fraction
{
	ll p, q;
	fraction()
	{
		p = 0, q = 1;
	}
	fraction(ll _p)
	{
		p = _p; q = 1;
	}
	fraction(ll _p, ll _q)
	{
		p = _p, q = _q;
	}
	fraction operator +(fraction b)
	{
		ll new_p = p * b.q + b.p * q;
		ll new_q = b.q * q;
		ll g = gcd(new_p, new_q);
		return fraction(new_p / g, new_q / g);
	}
	fraction operator -(fraction b)
	{
		ll new_p = p * b.q - b.p * q;
		ll new_q = b.q * q;
		ll g = gcd(new_p, new_q);
		return fraction(new_p / g, new_q / g);
	}
	fraction operator *(fraction b)
	{
		ll new_p = p * b.p;
		ll new_q = q * b.q;
		ll g = gcd(new_p, new_q);
		return fraction(new_p / g, new_q / g);
	}
	fraction operator /(fraction b)
	{
		ll new_p = p * b.q;
		ll new_q = q * b.p;
		ll g = gcd(new_p, new_q);
		return fraction(new_p / g, new_q / g);
	}
	bool operator ==(const fraction& b) const
	{
		return b.p == p && q == b.q;
	}
	bool operator <(const fraction& b) const
	{
		return p * b.q < q * b.p;
	}
	double dbl()
	{
		return (p + 0.0) / q;
	}
};

int main()
{
#ifdef XXX
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#elif defined(TASK)
	freopen(TASK ".in", "r", stdin);
	freopen(TASK ".out", "w", stdout);
#endif

	ZERO(ingrs);
	int n, A, B;
	cin >> n >> A >> B;

	vector<pair<fraction, int> > ang;
	for (int i = 0; i < n; ++i)
	{
		scanf("%d%d%d", g + i, a + i, b + i);
		fraction goodn(INT_MAX);
		if (b[i] > 0)
		{
			goodn = fraction(a[i], b[i]);
		}

		ang.push_back(mp(goodn, i));
	}

	sort(ang.begin(), ang.end());
	reverse(ang.begin(), ang.end());

	fraction aglob;
	fraction bglob;
	fraction Bf = fraction(B);
	fraction Af = fraction(A);

	for (int i = 0; i < n; ++i)
	{
		int cur = ang[i].second;
		fraction maxc(g[cur]);
		if (b[cur] > 0)
		{
			fraction guk = (Bf - bglob) / fraction(b[cur]);
			if (guk < maxc)
			{
				maxc = guk;
			}
		}

		aglob = aglob + fraction(a[cur]) * maxc;
		bglob = bglob + fraction(b[cur]) * maxc;

		ingrs[cur] = maxc.dbl();
	}

	if (aglob < A)
	{
		cout << "-1 -1" << endl;
		return 0;
	}

	printf("%.12lf %.12lf\n", aglob.dbl(), bglob.dbl());

	for (int i = 0; i < n; ++i)
	{
		printf("%.12lf ", ingrs[i]);
	}
	printf("\n");

	return 0;
}