#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cmath>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <cstring>
#include <cstdio>
#include <list>
#include <queue>
#include <stack>
#include <algorithm>

using namespace std;

#define mp make_pair
#define mt(a, b, c) mp(a, mp(b, c))
#define ZERO(x) memset((x), 0, sizeof(x))
#define NEGATE(x) memset((x), 255, sizeof(x))

typedef long long ll;
typedef pair<int, int> pii;

#define TASK "filter"

const int MAX_F = 105;
const int MAX_N = 1005;
const int MAX_M = 1005;
const int MAX_Q = 1005;

int a[MAX_F];

bool bloom[MAX_N][4 * MAX_M];

bool simpl[16][4] = { { 0, 0, 0, 0 }, { 1, 0, 0, 0 }, { 0, 1, 0, 0 }, { 1, 1, 0, 0 },
{ 0, 0, 1, 0 }, { 1, 0, 1, 0 }, { 0, 1, 1, 0 }, { 1, 1, 1, 0 },
{ 0, 0, 0, 1 }, { 1, 0, 0, 1 }, { 0, 1, 0, 1 }, { 1, 1, 0, 1 },
{ 0, 0, 1, 1 }, { 1, 0, 1, 1 }, { 0, 1, 1, 1 }, { 1, 1, 1, 1 } };

int u[MAX_Q];

int hashes[MAX_Q][MAX_F];

int main()
{
#ifdef XXX
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#elif defined(TASK)
	freopen(TASK ".in", "r", stdin);
	freopen(TASK ".out", "w", stdout);
#endif

	int m, f;
	cin >> m >> f;
	for (int i = 0; i < f; ++i)
	{
		cin >> a[i];
	}

	int n;
	cin >> n;

	for (int i = 0; i < n; ++i)
	{
		string str;
		cin >> str;

		for (int j = 0; j < str.size(); ++j)
		{
			char c = str[j];

			int ci;
			if (c >= 'a' && c <= 'f')
			{
				ci = c - 'a' + 10;
			}
			else
			{
				ci = c - '0';
			}

			for (int q = 0; q < 4; ++q)
			{
				bloom[i][4 * j + q] = simpl[ci][q];
			}
		}
	}

	int q;
	cin >> q;
	for (int i = 0; i < q; ++i)
	{
		cin >> u[i];
		for (int j = 0; j < f; ++j)
		{
			ll uk = u[i];
			ll aj = a[j];
			hashes[i][j] = (uk * aj) % m;
		}
	}

	set<int> good;
	for (int i = 0; i < q; ++i)   // users
	{
		for (int j = 0; j < n; ++j)  // files
		{
			bool gh = true;
			for (int k = 0; k < f; ++k)  // filters
			{
				int hash = hashes[i][k];
				if (!bloom[j][hash])
				{
					gh = false;
					break;
				}
			}
			if (gh)
			{
				good.insert(j);
			}
		}
	}

	cout << good.size();
	for (auto fl : good)
	{
		cout << " " << fl;
	}

	return 0;
}