#include <stdio.h>
#include <cstdio>
#include <cmath>
#include <vector>
#include <map>
#include <queue>
#include <algorithm>
#include <iostream>

using namespace std;

#define int64 long long
#define FOR(i, n) for (int i =0; i < n ; i++)

#define TASK "burrito"

struct row
{
	double c;
	double g;
	double a, b;
	int n;
};

bool comp(row a, row b)
{
	return a.c > b.c;
}

vector<row> rows;
vector<double> g;
double A, B;
double b;

bool can(double A)
{
	g.clear();
	double cur = 0;
	b = 0;
	FOR(i, rows.size())
	{
		double add = min(A - cur, rows[i].a * rows[i].g);
		double gr = 0;
		if (rows[i].a > 0)
			gr = add / rows[i].a;
		b += gr * rows[i].b;
		cur += add;
		g.push_back(gr);
	}
	if (b > B)
		return false;
	return true;
}

int main()
{
	freopen(TASK ".in", "r", stdin);
	freopen(TASK ".out", "w", stdout);
	int n;
	cin >> n >> A >> B;
	double Amax = 0;
	FOR(i, n)
	{
		double g, a, b;
		cin >> g >> a >> b;
		row cur;
		if (b != 0)
			cur.c = a / b;
		else
			cur.c = 1000;
		cur.a = a;
		cur.b = b;
		cur.g = g;
		cur.n = i;
		rows.push_back(cur);
		Amax += g * a;
	}
	if (Amax < A)
	{
		cout << "-1 -1";
		return 0;
	}
	sort(rows.begin(), rows.end(), comp);
	while (fabs(Amax - A) > 1e-10)
	{
		double m = (A + Amax) / 2;
		if (can(m))
			A = m;
		else
			Amax = m;
	}
	if (!can(A))
	{
		cout << "-1 -1";
	}
	else
	{
		printf("%.9llf %.9llf\n", A, b);
		vector<double> res(n);
		FOR(i, n)
			res[rows[i].n] = g[i];
		FOR(i, n)
			printf("%.9llf ", res[i]);
	}
	return 0;
}