#define _USE_MATH_DEFINES
#define _CRT_SECURE_NO_WARNINGS
#include <algorithm>
#include <iostream>
#include <vector>
#include <cstdio>
#include <cstdlib>
#include <string>
#include <iomanip>
#include <set>
#include <map>
#include <sstream>
#include <cstring>
#include <deque>
#include <queue>
#include <cmath>
using namespace std;

typedef vector<int> vi;
typedef vector<vi> vvi;
typedef long double ldouble;
typedef long long llong;
typedef unsigned long long ullong;

#define forn(i,n) for(int i=0; i<(n); i++)
#define sz(x) int((x).size())
#define pb push_back
#define mp make_pair
#define inf int(1e9)
#define linf llong(4e18)
#define eps 1e-9

struct Elem {
	int id;
	double g;
	double a;
	double b;
	Elem() { }
	Elem(int id, double g, double a, double b) : id(id), g(g), a(a), b(b) { }
};

bool cmp(const Elem& lhs, const Elem& rhs) {
	return lhs.a * rhs.b > rhs.a * lhs.b;
}

#define TASK "burrito"
int main() {
	freopen(TASK ".in", "r", stdin);
#ifndef LOCAL_PROJECT	
	freopen(TASK ".out", "w", stdout);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	cout << setprecision(10) << fixed;
	int n, A, B;
	while (cin >> n >> A >> B){
		double a = 0, b = 0;
		vector<double> result;
		vector<Elem> d(n);
		forn(i, n)
			cin >> d[i].g >> d[i].a >> d[i].b, d[i].id = i;	
		sort(d.begin(), d.end(), cmp);

		forn(i, n) 
			if( b + eps < B ) {
				double add_a = d[i].g, add_b = d[i].g;
				if (B  + eps < b + add_b * d[i].b) {
					double l = 0, r = d[i].g;
					forn(lol, 100 * 1000) {
						double mid = l + (r - l) / 2;
						if (b + mid * d[i].b > B)
							r = mid;
						else
							l = mid;
					}
					add_a = l; add_b = l;
				}
				a += add_a * d[i].a; b += add_b * d[i].b;
				result.push_back(add_b);
			} else {
				result.push_back(0);
			}

		if (a + eps < A) {
			cout << "-1 -1\n";
		} else {
			vector<double> out(n);
			forn(i, n)
				out[d[i].id] = result[i];
			cout << a << " " << b << "\n";
			forn(i, n)
				cout << out[i] << " ";
			cout << "\n";
		}
	}

	return 0;
}