#define _USE_MATH_DEFINES
#define _CRT_SECURE_NO_WARNINGS
#include <algorithm>
#include <iostream>
#include <vector>
#include <cstdio>
#include <cstdlib>
#include <string>
#include <iomanip>
#include <set>
#include <map>
#include <sstream>
#include <cstring>
#include <deque>
#include <queue>
#include <cmath>
using namespace std;

typedef vector<int> vi;
typedef vector<vi> vvi;
typedef long double ldouble;
typedef long long llong;
typedef unsigned long long ullong;

#define forn(i,n) for(int i=0; i<(n); i++)
#define sz(x) int((x).size())
#define pb push_back
#define mp make_pair
#define inf int(1e9)
#define linf llong(4e18)
#define eps 1e-8

struct Elem {
	int id;
	llong g;
	llong a;
	llong b;
	Elem() { }
	Elem(int id, llong g, llong a, llong b) : id(id), g(g), a(a), b(b) { }
};

bool cmp(const Elem& lhs, const Elem& rhs) {
	return lhs.a * rhs.b > rhs.a * lhs.b;
}

#define TASK "burrito"
int main() {
	freopen(TASK ".in", "r", stdin);
#ifndef LOCAL_PROJECT	
	freopen(TASK ".out", "w", stdout);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	cout << setprecision(8) << fixed;
	int n;
	llong A, B;
	while (cin >> n >> A >> B){
		llong a = 0, b = 0;
		double aa = 0, bb = 0;
		vector<double> result;
		vector<Elem> d(n);
		forn(i, n)
			cin >> d[i].g >> d[i].a >> d[i].b, d[i].id = i;	
		sort(d.begin(), d.end(), cmp);

		vector<int> bad(n, 0);
		forn(i, n)
			if (d[i].g == 0 || d[i].a == 0)
				bad[i] = 1;
		vector<int> used(n, 0);
		forn(i, n)
			if (!bad[i] && d[i].b == 0) {
				a += d[i].a * d[i].g;
				aa = a;
				used[i] = 1;
			}

		bool found = false;
		forn(i, n) 
			if( !bad[i] && !used[i] && b < B && !found ) {			
				if (B < b + d[i].g * d[i].b) {
					double l = 0, r = d[i].g;
					forn(lol, 100 * 1000) {
						double mid = l + (r - l) / 2;
						if (b + mid * d[i].b > B)
							r = mid;
						else
							l = mid;
					}
					found = true;
					aa = a + d[i].a * l; 
					bb = b + d[i].b * l;
					result.push_back(l);
				} else {
					a += d[i].a * d[i].g;
					b += d[i].b * d[i].g;
					aa = a;
					bb = b;
					result.push_back(d[i].g);
				}								
			} else {
				if (used[i])
					result.push_back(d[i].g);
				else
					result.push_back(0);
			}

		if (aa + 1e-9 < A) {
			cout << "-1 -1\n";
		} else {
			vector<double> out(n);
			forn(i, n)
				out[d[i].id] = result[i];
			cout << aa << " " << bb << "\n";
			forn(i, n)
				cout << out[i] << " ";
			cout << "\n";
		}
	}

	return 0;
}