#define _CRT_SECURE_NO_WARNINGS
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <vector>
#include <set>
#include <algorithm>

using namespace std;
typedef long long int64_t;

void changeIO(const char* inp, const char* out)
{
	freopen(inp, "r", stdin);
	freopen(out, "w", stdout);
}

bool sortInOrder = false;

class ingredient
{
public:
	double ai, bi;
	double total;
	int ind;
	double res;

	ingredient()
	{
		ai = bi = total = 0;
		res = 0.0;
	}

	bool operator<(const ingredient& i) const
	{
		if (sortInOrder)
			return ind < i.ind;
		else
		{	
			return ((bi - ai) * total > (i.bi - i.ai) * i.total);
		}
	}

	bool operator==(const ingredient& i) const
	{
		if (sortInOrder)
			return ind == i.ind;
		else
		{
			return (bi - ai) == (i.bi - i.ai);
		}
	}
};

int main()
{
	changeIO("burrito.in", "burrito.out");
	int N;
	double A, B;
	scanf("%d%lf%lf", &N, &A, &B);
	vector<ingredient> ings(N);
	double sumAHappy = 0.0;
	double sumBUnHappy = 0.0;

	double gi, ai, bi;
	for (int i = 0; i < N; i++)
	{
		scanf("%lf%lf%lf", &gi, &ai, &bi);
		if (ai != 0)
		{
			sumAHappy += gi * ai;
			sumBUnHappy += gi * bi;
		}
		ings[i].ai = ai;
		ings[i].bi = bi;
		ings[i].res = gi;
		ings[i].total = gi;
		if (ai == 0)
			ings[i].res = 0;
		
		ings[i].ind = i;
	}

	sort(ings.begin(), ings.end());

	double left;
	bool solved = false;
	if (sumAHappy >= A)
	{
		for (int i = 0; i < N; i++)
		{
			left = sumBUnHappy - B;
			if (ings[i].bi == 0 || ings[i].ai == 0) continue;
			
			if (ings[i].bi * ings[i].total < left)
			{
				sumBUnHappy -= ings[i].bi * ings[i].total;
				sumAHappy -= ings[i].ai * ings[i].total;
				ings[i].res = 0.0;
			}
			else
			{
				left /= ings[i].bi;
				sumBUnHappy = B;
				sumAHappy -= ings[i].ai * left;
				ings[i].res -= left;
				solved = true;
			}

			if (sumAHappy < A)
			{
				printf("-1 -1");
				return 0;
			}

			if (solved)
				break;
		}
	}

	if (sumAHappy < A || sumBUnHappy > B)
	{
		printf("-1 -1");
		return 0;
	}

	sortInOrder = true;

	sort(ings.begin(), ings.end());

	printf("%.8lf %.8lf\n", sumAHappy, sumBUnHappy);

	for (int i = 0; i < N; i++)
	{
		printf("%.8lf ", ings[i].res);
	}

	return 0;
}