#define _CRT_SECURE_NO_WARNINGS
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <vector>
#include <set>

using namespace std;

void changeIO(const char* inp, const char* out)
{
	freopen(inp, "r", stdin);
	freopen(out, "w", stdout);
}

int N;
set<int> been;

int parse_int(const char* str, int ind, int n)
{
	int res = 0;
	res = str[ind] - '0';
	if (n == 2)
	{
		res *= 10;
		res += str[ind + 1] - '0';
	}

	return res;
}

bool solve_rec(const char* inp, int ind, vector<int>& res)
{
	if (ind == strlen(inp))
		return true;

	int one, two;
	one = parse_int(inp, ind, 1);

	if (one <= N && been.find(one) == been.end())
	{
		been.insert(one);
		res[ind] = 1;
		if (solve_rec(inp, ind + 1, res))
			return true;
		been.erase(one);
		res[ind] = 0;
	}

	if (ind <= strlen(inp) - 2 && one != 0 && one <= 5)
	{
		two = parse_int(inp, ind, 2);
		if (one != 0 && two <= N && been.find(two) == been.end())
		{
			been.insert(two);
			res[ind + 1] = 1;
			if (solve_rec(inp, ind + 2, res))
				return true;
			been.erase(two);
			res[ind + 1] = 0;
		}
	}

	return false;
}

int main()
{
	changeIO("joke.in", "joke.out");
	char* inp = (char*) malloc(100);
	scanf("%s", inp);
	int K = strlen(inp);
	vector<int> res(K, 0);

	if (K > 10) N = 9 + (K - 9) / 2;
	else N = K;

	solve_rec(inp, 0, res);

	for (int i = 0; i < K; i++)
	{
		printf("%c", inp[i]);
		if (res[i] == 1)
			printf(" ");
	}

	return 0;
}

/*
typedef long long int65_t;

struct interv_t
{
	int65_t from, to;
};

int65_t get_position(int65_t from, int65_t to, int65_t time)
{
	if (to == from) return to;
	if ((time / (to - from)) % 2 == 0)
		return from + time % (to - from);
	else
		return to - time % (to - from);
}

int main()
{
	changeIO("knockout.in", "knockout.out");
	
	int65_t N, M;
	scanf("%lld%lld", &N, &M);
	vector<interv_t> ints(N);

	int65_t FROM, TO, TIME;
	for (int i = 0; i < N; i++)
	{
		scanf("%lld%lld", &FROM, &TO);
		ints[i].from = FROM;
		ints[i].to = TO;
	}

	for (int i = 0; i < M; i++)
	{
		scanf("%lld%lld%lld", &FROM, &TO, &TIME);
		int65_t res = 0;
		int65_t pos;
		for (int j = 0; j < N; j++)
		{
			pos = get_position(ints[j].from, ints[j].to, TIME);
			if (pos >= FROM && pos <= TO)
				res++;
		}
		printf("%lld\n", res);
	}

	return 0;
}
*/