//G41

#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <stdio.h>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <iomanip>
#include <map>

using namespace std;

#define FILE_NAME ""
const int IINF = 1000000000;
const long long LING = 100000000000000000LL;
const double INF = 1000. * 1000 * 1000 + 1;
const double EPS = 1e-9;
const double PI = acos(-1.0);

const int maxN = 100000 + 7;

double A, B;
int ind[maxN];
double g[maxN], a[maxN], b[maxN];

bool cmp(int i, int j) {
	double d1 = a[i] * b[j];
	double d2 = b[i] * a[j];
	if (fabs(d1 - d2) <= EPS) {
		return a[i] > a[j];
	}
	return d1 > d2;
}

int main()
{
#ifndef RAU_1
	freopen("burrito.in", "r", stdin);
	freopen("burrito.out", "w", stdout);
#else
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	int n;
	scanf("%d%lf%lf", &n, &A, &B);
	for (int i = 0; i < n; ++i) {
		ind[i] = i;
		scanf("%lf%lf%lf", g + i, a + i, b + i);
	}
	sort(ind, ind + n);
	double sumA = 0.0, sumB = 0.0;
	vector<double> s(n, 0.0);
	for (int i = 0; i < n; ++i) {
		double lo = 0.0, hi = g[ind[i]];
		double answer = 0.0;
		for (int iter = 0; iter < 200; ++iter) {
			double mid = (hi + lo) * 0.5;
			if (mid * b[ind[i]] + sumB > B + EPS) {
				hi = mid;
			}
			else {
				answer = mid;
				lo = mid;
			}
		}
		sumA += a[ind[i]] * answer;
		sumB += b[ind[i]] * answer;
		s[ind[i]] = answer;
	}
	if (sumA >= A) {
		printf("%.13lf %.13lf\n", sumA, sumB);
		for (int i = 0; i < s.size(); ++i) {
			printf("%.13lf ", s[i]);
		}
	}
	else {
		printf("-1 -1\n");
	}

	return 0;
}