//G41

#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <stdio.h>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <iomanip>
#include <map>

using namespace std;

#define FILE_NAME ""
const int IINF = 1000000000;
const long long LING = 100000000000000000LL;
const double INF = 1000. * 1000 * 1000 + 1;
const double EPS = 1e-14;
const double PI = acos(-1.0);

int m, f, n, q;
const int maxm = 1000;
const int maxf = 100;
const int maxn = 1000;
const int maxq = 1000;

int a[maxf];
vector <long long> data[maxn];
set <int> bestData;
vector <long long> curr;
int bestSize = 0;

long long hexToInt(char c)
{
	if (c >= '0' && c <= '9')
		return c - '0';
	return c - 'A' + 10;
}

string getBin(int n)
{
	string ans;
	while (n)
	{
		ans.push_back(n % 2 + '0');
		n /= 2;
	}
	while (ans.size() < 4)
		ans.push_back('0');
	reverse(ans.begin(), ans.end());
	return ans;
}

string toBin(string& s)
{
	string ans;
	for (int i = 0; i < s.size(); ++i)
		ans = getBin(hexToInt(s[i])) + ans;
	int counter = 0;
	for (int j = s.size() - 1; counter < 64; --j)
	{
		ans[j] = '0';
		++counter;
	}
	while (ans.size() % 64 != 0)
		ans = "0" + ans;
	return ans;
}

vector <long long> parse(string& s)
{
	vector <long long> ans;
	while (s.size() % 64 != 0)
		s = "0" + s;
	for (int i = 0; i < s.size(); i += 64)
	{
		long long curr = 0;
		for (int j = 0; j < 64; ++j)
		{
			curr <<= 1;
			curr += s[i + j] - '0';
		}
		ans.push_back(curr);
	}
	return ans;
}

bool contains(int pos)
{
	for (int i = 0; i < curr.size(); ++i)
		if ((curr[i] & data[pos][i]) != 0)
			return false;
	return true;
}

int main()
{
#ifndef RAU_1
	freopen("filter.in", "r", stdin);
	freopen("filter.out", "w", stdout);
#else
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	cin >> m >> f;
	for (int i = 0; i < f; ++i)
		cin >> a[i];
	cin >> n;
	string s;
	for (int i = 0; i < n; ++i)
	{
		cin >> s;
		data[i] = parse(toBin(s));
	}
	cin >> q;
	for (int i = 0; i < q; ++q)
	{
		int u;
		cin >> u;
		string t(m, '0');
		for (int j = 0; j < f; ++j)
			t[(u * 1ll * a[j]) % m] = '1';
		curr = parse(t);

		for (int j = 0; j < n; ++j)
		{
			if (bestData.find(j) == bestData.end() && contains(j))
				bestData.insert(j);
		}
	}
	cout << bestData.size() << endl;
	for (auto it = bestData.begin(); it != bestData.end(); ++it)
		cout << *it << ' ';
}