#include <algorithm>
#include <iostream>
#include <string>
#include <array>
#include <map>

using namespace std;

const int bsize = 250;

typedef unsigned short uchar;
typedef array<uchar, bsize> bloom;

const int maxn = 1001;

int a[maxn];
bloom blooms[maxn];
bloom ucodes[maxn];

bool can[maxn];

map<char, uchar> smap;


uchar trans(uchar t)
{
	uchar ret = 0;
	for (int i = 0; i < 4; ++i)
		if (t & (1 << i))
			ret |= (1 << (3 - i));
	return ret;
}

bool contains(const bloom& df, const bloom& usr)
{
	int sz = df.size();
	for (int i = 0; i < sz; ++i)
		if ((df[i] & usr[i]) != usr[i])
			return false;
	return true;
}

int main()
{
	freopen("filter.in", "r", stdin);
	freopen("filter.out", "w", stdout);
	ios_base::sync_with_stdio(0);
	int n, f, m, sz;
	cin >> m >> f;
	int i, j;
	for (i = 0; i < f; ++i)
		cin >> a[i];

	string s;
	
	for (i = 0; i < 10; ++i)
		smap['0' + i] = i;
	for (i = 10; i < 16; ++i)
		smap['a' + i - 10] = i;

	cin >> n;
	for (i = 0; i < n; ++i)
	{
		cin >> s;
		
		sz = s.size();
		for (j = 0; j < sz; ++j)
			blooms[i][j] = smap[s[j]];
	}

	int q, uc, ind;
	cin >> q;
	for (j = 0; j < q; ++j)
	{
		cin >> uc;
		for (i = 0; i < f; ++i)
		{
			ind = uc * a[i] % m;
			ucodes[j][ind / 4] |= (1 << (ind % 4));
		}
		for (i = 0; i < n; ++i)
			if (contains(blooms[i], ucodes[j]))
				can[i] = 1;
	}

	int cnt = 0;
	for (i = 0; i < n; ++i)
		if (can[i])
			++cnt;

	cout << cnt << ' ';
	for (i = 0; i < n; ++i)
		if (can[i])
			cout << i << ' ';
	cout << endl;
}


/*


23 4 3 5 7 11
3
effde7
c07902
0800c1
3 2 4 6

*/