#include <iostream>
#include <vector>
#include <cstdio>
#include <cmath>
#include <memory.h>
#include <cassert>
#include <algorithm>

typedef long long LL;
using namespace std;

struct tp {
	int mark;
	int go[3];
} au[111], out[55555];
int unterm[55555];
int ch2id[255], id2ch[255], anti[255];
int vn = 0, term[111];
int cl[5555][111], cnl[5555];

int dfs(const vector<int>& a, int level) {	
	int v = ++vn;

/*	cerr << "level " << level << ", class " << cl[level][a[0]] << ": ";
	for (int i = 0; i < a.size(); ++i) {
		cerr << a[i] << " ";
	}
	cerr << endl;
*/
	out[v].mark = -1;
	for (int ch = 0; ch < 3; ++ch) {
		vector< pair<pair<int, pair<int, int> >, int> > pp;
		for (int m1 = 0; m1 < 3; ++m1) {
			for (size_t i = 0; i < a.size(); ++i) {
				if (au[a[i]].mark == m1) {
					int to = au[a[i]].go[ch];
					pp.push_back(make_pair(make_pair(m1, make_pair(cl[level][to], cl[level][a[i]])), to));
				}
			}
		}
		sort(pp.begin(), pp.end());

		int last = 0, cc = 0;
		int& cn = cnl[level];
		for (size_t i = 1; i <= pp.size(); ++i) {
			if (i == pp.size() || pp[i].first != pp[i - 1].first) {
				++cn;
				++cc;
				for (size_t j = last; j < i; ++j) {
					cl[level + 1][pp[j].second] = cn;
				}
			}
		}
		if (cc > 1) {
			out[v].mark = ch;
			int last = 0;
			for (size_t i = 1; i <= pp.size(); ++i) {
				if (i == pp.size() || pp[i].first.first != pp[i - 1].first.first) {
					vector<int> aa;
					for (size_t j = last; j < i; ++j) {
						aa.push_back(pp[j].second);
					}
					out[v].go[pp[last].first.first] = dfs(aa, level + 1);
					last = i;
				}
			}
			return v;
		}
	}

	for (size_t i = 0; i < a.size(); ++i) term[ a[i] ] = v;
	unterm[v] = a[0];

	return v;
}


int main() {
	freopen("epic.in", "r", stdin);
	freopen("epic.out", "w", stdout);

	ch2id['R'] = 0;
	ch2id['P'] = 1;
	ch2id['S'] = 2;
	id2ch[0] = 'R';
	id2ch[1] = 'P';
	id2ch[2] = 'S';

	anti[0] = 1;
	anti[1] = 2;
	anti[2] = 0;

	int n;
	scanf("%d\n", &n);
	for (int i = 1; i <= n; ++i) {
		char ch;
		scanf("%c %d %d %d\n", &ch, &au[i].go[0], &au[i].go[1], &au[i].go[2]);
		au[i].mark = ch2id[(int)ch];
	}

	vector<int> a;
	for (int i= 0; i < n; ++i) {
		a.push_back(i + 1);
	}

	memset(cl[0], 0, sizeof(cl[0]));
	dfs(a, 0);
	for (int i = 1; i <= n; ++i) if (!term[i]) {
		term[i] = ++vn;
		unterm[vn] = i;
		out[vn].mark = -1;
	}

	for (int i = 1; i <= vn; ++i) {
		if (out[i].mark == -1) {
			int x = unterm[i];
			out[i].mark = anti[au[x].mark];
			out[i].go[0] =
			out[i].go[1] =
			out[i].go[2] = 
				term[ au[x].go[out[i].mark] ];
		}
		for (int j =0; j < 3; ++j) if (out[i].go[j] == 0) out[i].go[j] = i;
	}

	assert(vn <= 50000);
	printf("%d\n", vn);
	for (int i = 1; i <= vn; ++i) {
		printf("%c %d %d %d\n", id2ch[out[i].mark], out[i].go[0], out[i].go[1], out[i].go[2]);
	}

	return 0;
}