#include <iostream>
#include <vector>
#include <cstdio>
#include <cmath>
#include <memory.h>
#include <algorithm>
#include <set>

typedef long long LL;
typedef long long ll;
using namespace std;

const int N = 30033;
const int M = 500;
ll f[N][M];
int h[N];
int f2[N][M];
int have[N][M];
const int SHIFT = M / 2;
bool used[N];	
int Depth[N];
int parent[N];

set< pair<int, int> > q;

vector<int> g[N];
vector<int> sons[N];
ll num = 0, den = 0;

int paths[N][2];
int spaths[N][2];

void dfs(int x) {
	used[x] = true;
	f2[x][0] = 1;
	Depth[x] = 1;

	paths[x][0] = 1;
	for (int i = 0; i < g[x].size(); ++i) {
		int y = g[x][i];
		if (used[y]) continue;
		sons[x].push_back(y);
		parent[y] = x;
		h[y] = h[x] + 1;
		dfs(y);
		Depth[x] = max(Depth[x], Depth[y] + 1);

		for (int depth = 0; f2[y][depth]; ++depth) {
			f2[x][depth + 1] += f2[y][depth];
		}

		den += ll(paths[x][0]) * paths[y][0];
		den += ll(paths[x][1]) * paths[y][1];
		paths[x][0] += paths[y][1];
		paths[x][1] += paths[y][0];
	}	
	
	for (int len = 0; f2[x][len]; ++len) {
		f[x][len + SHIFT] = f2[x][len]; 
	}
}

struct edge {
	int a, b, c;

	bool operator<(const edge& A) const {
		return c < A.c;
	}
} edges[N];

int cused[N];
int tim = 0;

void rebuild(int x, int y, ll cost) {
	++tim;
	cused[x] = cused[y] = tim;

	int cur = x;
	int len = 1, marked = 0;
	while (cur != 0) {
		cused[cur] = tim;
		for (int val = -Depth[y] - 1; val <= Depth[y] + 1; ++val) {
			f[cur][len - marked - marked + val + SHIFT] -= f[y][val + SHIFT];		
		}

		if (q.find(make_pair(cur, parent[cur])) != q.end()) ++marked;
		++len;

		cur = parent[cur];
	}

	cur = x;
	len = 1, marked = 1;
	while (cur != 0) {
		for (int val = -Depth[y] - 1; val <= Depth[y] + 1; ++val) {
			f[cur][len - marked - marked + val + SHIFT] += f[y][val + SHIFT];		
		}

		if (q.find(make_pair(cur, parent[cur])) != q.end()) ++marked;
		++len;

		cur = parent[cur];
	}

	q.insert(make_pair(y, x));

	cur = x;
	len = 1, marked = 1;
    while (cur != 0) {
		for (int i = 0; i < sons[cur].size(); ++i) {
			int son = sons[cur][i];
			if (cused[son] == tim) continue;
			int cmarked = 0;
			if (q.find(make_pair(son, cur)) != q.end()) cmarked = 1;

			for (int val = -Depth[son] - 1; val <= Depth[son] + 1; ++val) {
				int need = -1 + (cmarked + marked) * 2 - 1 - len - val;
				num += (f[y][need + SHIFT] * f[son][val + SHIFT] * cost);  
			} 
		}

		num += (f[y][-1 + marked + marked - len + SHIFT] * cost);
		if (q.find(make_pair(cur, parent[cur])) != q.end()) ++marked;
		++len;

		

		cur = parent[cur];
    }                         
}

int main() {
	freopen("hidden.in", "r", stdin);
	freopen("hidden.out", "w", stdout);

	int n;
	scanf("%d", &n);
	for (int i = 0; i + 1 < n; ++i) {
		scanf("%d%d%d", &edges[i].a, &edges[i].b, &edges[i].c);
		g[edges[i].a].push_back(edges[i].b);
		g[edges[i].b].push_back(edges[i].a);
	}
	sort(edges, edges + n - 1);

	dfs(1);

	for (int T = 0; T + 1 < n; ++T) {
		int a = edges[T].a, b = edges[T].b, c = edges[T].c;
		if (h[a] > h[b]) swap(a, b);

		rebuild(a, b, c);
	}

	//cerr << num << " " << den << endl;
	cout.precision(15); cout << fixed;
	cout << double(num) / den << endl;


	return 0;
}