#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cstdlib>
#include <cmath>
#include <vector>
#include <map>
#include <set>
#include <string>
#include <cstring>
#include <queue>
#include <ctime>
#include <cassert>
using namespace std;

const int N = 100500;
const double EPS = 1e-9;

bool eq(double a, double b)
{
	return abs(a - b) < EPS;
}

bool gr_eq(double a, double b)
{
	return a > b || eq(a, b);
}

struct Item
{
	int g, a, b, ind;

	Item() : g(), a(), b(), ind() {}

	void scan()
	{
		scanf("%d%d%d", &g, &a, &b);
	}

	bool operator < (const Item & other) const
	{
		return a - b > other.a - other.b;
	}
};

int n;
double A, B;
Item items[N];
double amount[N];

void solve()
{
	scanf("%d%lf%lf", &n, &A, &B);
	double suma = 0, sumb = 0;
	for (int i = 0; i < n; i++)
	{
		items[i].scan();
		items[i].ind = i;
	}

	sort(items, items + n);

	for (int i = 0; i < n; i++)
	{
		double can = items[i].g;
		if (items[i].b > 0)
			can = min(can, B / items[i].b);
		amount[items[i].ind] = can;
		B -= can * items[i].b;
		if (!eq(can, items[i].g))
			B = 0;
		suma += can * items[i].a;
		sumb += can * items[i].b;
	}

	if (gr_eq(suma, A))
	{
		printf("%.10lf %.10lf\n", suma, sumb);
		for (int i = 0; i < n; i++)
			printf("%.10lf ", amount[i]);
	}
	else
		printf("-1 -1\n");
}

int main()
{
	freopen("burrito.in", "r", stdin);
	freopen("burrito.out", "w", stdout);

	solve();

	return 0;
}