#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cstdlib>
#include <cmath>
#include <vector>
#include <map>
#include <set>
#include <string>
#include <cstring>
#include <queue>
#include <ctime>
#include <cassert>
#include <bitset>
using namespace std;

bool bit(int a, int b)
{
	return (a & (1 << b)) != 0;
}

int encode(char c)
{
	if (isdigit(c))
		return c - '0';
	return c - 'a' + 10;
}

const int F = 105;
const int N = 1005;

int m, f;
int coef[F];
int n;
bitset<N> files[N];
char buf[N];
int q;
bool has_file[N];

int mul(int a, int b)
{
	long long c = (long long)a * b;
	return (int)(c % m);
}

void check_user(int user)
{
	bitset<N> cur;
	for (int i = 0; i < f; i++)
	{
		int val = mul(user, coef[i]);
		cur[val] = true;
	}

	for (int i = 0; i < n; i++)
		if ((files[i] & cur) == cur)
			has_file[i] = true;
}

void solve()
{
	scanf("%d%d", &m, &f);
	for (int i = 0; i < f; i++)
		scanf("%d", &coef[i]);

	int is_short = -1;
	if (m % 4 != 0)
		is_short = m % 4;

	scanf("%d", &n);
	for (int i = 0; i < n; i++)
	{
		scanf("%s", buf);
		int len = strlen(buf);

		for (int j = 0; j < len; j++)
		{
			int start = j * 4;
			int chr = encode(buf[j]);
			int cnt = 4;
			if (is_short != -1 && j == len - 1)
				cnt = is_short;

			for (int l = 0; l < cnt; l++)
				if (bit(chr, l))
					files[i][start + l] = true;
		}
	}

	scanf("%d", &q);
	for (int i = 0; i < q; i++)
	{
		int user;
		scanf("%d", &user);
		check_user(user);
	}

	int res_cnt = 0;
	for (int i = 0; i < n; i++)
		if (has_file[i])
			res_cnt++;
	printf("%d ", res_cnt);
	for (int i = 0; i < n; i++)
		if (has_file[i])
			printf("%d ", i);
}

int main()
{
	freopen("filter.in", "r", stdin);
	freopen("filter.out", "w", stdout);

	solve();

	return 0;
}