#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cstdlib>
#include <cmath>
#include <vector>
#include <map>
#include <set>
#include <string>
#include <cstring>
#include <queue>
#include <ctime>
#include <cassert>
using namespace std;

#pragma comment(linker, "/STACK:64000000")

const int N = 2e5 + 100;

int n;
int perm[N];
int ind_to_pos[N];

struct cmp_by_pos
{
	bool operator () (int a, int b)
	{
		return ind_to_pos[a] < ind_to_pos[b];
	}
};

set<int> set_by_ind;
set<int, cmp_by_pos> set_by_pos;

void scan()
{
	scanf("%d", &n);
	for (int i = 1; i <= n; i++)
	{
		scanf("%d", &perm[i]);
		perm[i];
	}
	n++;
	perm[0] = 0;
}

void erase_list(const vector<int> &list)
{
	for (int i = 0; i < (int)list.size(); i++)
	{
		set_by_ind.erase(list[i]);
		set_by_pos.erase(list[i]);
	}
}

void insert_list(const vector<int> &list)
{
	for (int i = 0; i < (int)list.size(); i++)
	{
		set_by_ind.insert(list[i]);
		set_by_pos.insert(list[i]);
	}
}

int rec()
{
	if (set_by_ind.empty())
		return 0;

	int cur_ind = *set_by_ind.begin();
	set_by_ind.erase(cur_ind);

	vector<int> left_list;
	auto it = set_by_pos.find(cur_ind);
	while (it != set_by_pos.begin())
	{
		it--;
		left_list.push_back(*it);
	}

	erase_list(left_list);
	set_by_pos.erase(cur_ind);

	int left_ans = (int)left_list.size() + rec();

	insert_list(left_list);
	set_by_pos.insert(cur_ind);
	
	vector<int> right_list;
	it = set_by_pos.find(cur_ind);
	while (true)
	{
		it++;
		if (it == set_by_pos.end())
			break;
		right_list.push_back(*it);
	}

	erase_list(right_list);
	set_by_pos.erase(cur_ind);

	int right_ans = (int)right_list.size() + rec();

	insert_list(right_list);
	set_by_pos.insert(cur_ind);

	set_by_ind.insert(cur_ind);

	return min(left_ans, right_ans);
}

int solve()
{
	for (int i = 0; i < n; i++)
		ind_to_pos[i] = perm[i];

	set_by_ind.clear();
	set_by_pos.clear();

	for (int i = 0; i < n; i++)
		set_by_ind.insert(i);

	for (int i = 0; i < n; i++)
		set_by_pos.insert(i);

	return n - 1 - rec();
}

int main()
{
	freopen("improvements.in", "r", stdin);
	freopen("improvements.out", "w", stdout);

	scan();
	int ans = solve();
	printf("%d", ans);

	return 0;
}