#pragma comment(linker, "/STACK:100000000")
#define _CRT_SECURE_NO_WARNINGS
#include <cstdio>
#include <cstdlib>
#include <ctime>
#include <cstring>
#include <cctype>
#include <cassert>
#include <cmath>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <iostream>
#include <deque>
#include <queue>
#include <string>
using namespace std;
#define int64 long long
#define ldb long double
#define pb push_back
#define mp make_pair
#define fs first
#define sc second
#define sz(a) ((int) (a).size())
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
const double pi = acos(-1.0);
#define taskname "cactus"
const int N = (int) 2e6;
const int A = 27;
int total, p[N], pos, value[A], used[N], cnt, cur[N];
char s[N];
bool usede[N];
vector< pair<int, int> > edges, adj[N], res;

int dsu_find(int v) {
	return (v == p[v]) ? v : (p[v] = dsu_find(p[v]));
}

void dsu_union(int u, int v) {
	p[dsu_find(u)] = dsu_find(v);
}

int new_vertex() {
	p[total] = total;
	return total++;
}

struct t_graph {
	int first, last;
};

struct t_list {
	vector<t_graph> graphs;
};

t_graph basic() {
	t_graph res;
	res.first = new_vertex(), res.last = new_vertex();
	edges.pb(mp(res.first, res.last));
	return res;
}

t_graph chain(const t_list& l) {
	for (int i = 0; i + 1 < sz(l.graphs); ++i)
		dsu_union(l.graphs[i].last, l.graphs[i + 1].first);
	t_graph res;
	res.first = l.graphs[0].first, res.last = l.graphs.back().last;
	return res;
}

t_graph loop(const t_list& l) {
	for (int i = 0; i < sz(l.graphs); ++i)
		dsu_union(l.graphs[i].last, l.graphs[(i + 1) % sz(l.graphs)].first);
	t_graph res;
	res.first = l.graphs[0].first, res.last = l.graphs[0].last;
	return res;
}

t_graph merge(const t_list& l) {
	for (int i = 1; i < sz(l.graphs); ++i)
		dsu_union(l.graphs[0].first, l.graphs[i].first);
	t_graph res;
	res.first = l.graphs[0].first, res.last = l.graphs[0].last;
	return res;
}

t_graph parse_graph();

t_list list_builder(int var, int l, int r) {
	t_list lst;
	int start_pos = -1;
	if (s[pos] == ',') {
		pos++;
		start_pos = pos;
	}
	for (int tmp = l; tmp <= r; ++tmp) {
		value[var] = tmp;
		if (start_pos == -1) {
			lst.graphs.pb(basic());
		} else {
			pos = start_pos;
			lst.graphs.pb(parse_graph());
		}
	}
	return lst;
}

int read_number() {
	int num = 0;
	while (isdigit(s[pos]))
		num = num * 10 + s[pos++] - '0';
	return num;
}

t_list parse_list() {
	if (isdigit(s[pos])) {
		int num = read_number();
		return list_builder(26, 0, num - 1);
	} else if (('A' <= s[pos]) && (s[pos] <= 'Z')) {
		int num = value[s[pos++] - 'A'];
		return list_builder(26, 0, num - 1);
	} else if (s[pos] == 'r') {
		pos++;
		assert(s[pos++] == 'a');
		assert(s[pos++] == 'n');
		assert(s[pos++] == 'g');
		assert(s[pos++] == 'e');
		assert(s[pos++] == '(');
		assert(('A' <= s[pos]) && (s[pos] <= 'Z'));
		int varnum = s[pos++] - 'A';
		assert(s[pos++] == ',');
		int lbound, rbound;
        if (isdigit(s[pos])) lbound = read_number();
		else lbound = value[s[pos++] - 'A'];
		assert(s[pos++] == ',');
        if (isdigit(s[pos])) rbound = read_number();
		else rbound = value[s[pos++] - 'A'];
		if (lbound > rbound) swap(lbound, rbound);
		assert(s[pos++] == ')');
		t_list list = list_builder(varnum, lbound, rbound);
		return list;
	} else {
		t_list list;
		list.graphs.pb(parse_graph());
		while (s[pos] == ',') {
			pos++;
			list.graphs.pb(parse_graph());
		}
		return list;
	}
}

t_graph parse_graph() {
	if (s[pos] == 'c') {
		pos++;
		if (s[pos] == '(') {
			pos++;
			t_list list = parse_list();
			assert(s[pos++] == ')');
			return chain(list);
		} else
			return basic();
	} else if (s[pos] == 't') {
		pos++;
		assert(s[pos++] == '(');
		t_list list = parse_list();
		assert(s[pos++] == ')');
		return merge(list);
	} else {
		assert(s[pos++] == 'l');
		assert(s[pos++] == 'o');
		assert(s[pos++] == 'o');
		assert(s[pos++] == 'p');
		assert(s[pos++] == '(');
		t_list list = parse_list();
		assert(s[pos++] == ')');
		return loop(list);
	}
}

void recolor(int v, int color) {
	int ncolor = p[v];
	if (ncolor == color) return;
	for (int i = 0; i < total; ++i) {
		if (p[i] == color) p[i] = ncolor;
		else if (p[i] == ncolor) p[i] = color;
	}
}

void dfs(int v) {
	for (; cur[v] < sz(adj[v]); ++cur[v]) {
		int u = adj[v][cur[v]].fs, num = adj[v][cur[v]].sc;
		if (usede[num]) continue;
		usede[num] = true;
		dfs(u);
		res.pb(mp(u, num));
	}
}

void add_edge(int u, int v, int num) {
	adj[u].pb(mp(v, num));
	adj[v].pb(mp(u, num));
}

int main() {
	assert(freopen(taskname".in", "r", stdin));
	assert(freopen(taskname".out", "w", stdout));
	scanf("%s", s);
	t_graph g = parse_graph();
	for (int i = 0; i < total; ++i)
		used[i] = -1;
	for (int i = 0; i < total; ++i) {
		p[i] = dsu_find(i);
		if (used[p[i]] == -1) used[p[i]] = cnt++;
	}
	for (int i = 0; i < total; ++i)
		p[i] = used[p[i]];
	recolor(g.first, 0);
	recolor(g.last, cnt - 1);
	int m = sz(edges);
	for (int i = 0; i < m; ++i) {
		edges[i].fs = p[edges[i].fs];
		edges[i].sc = p[edges[i].sc];
		add_edge(edges[i].fs, edges[i].sc, i);
	}
	vector<int> odd;
	for (int i = 0; i < cnt; ++i)
		if (sz(adj[i]) % 2 == 1)
			odd.pb(i);
	int start_m = m;
	for (int i = 0; i + 1 < sz(odd); i += 2)
		add_edge(odd[i], odd[i + 1], m++);
	dfs(0);
	reverse(res.begin(), res.end());
	if (odd.empty()) {
		printf("%d 1\n%d %d", cnt, sz(res) + 1, res.back().fs + 1);
		for (int i = 0; i < sz(res); ++i)
			printf(" %d", res[i].fs + 1);
		printf("\n");
	} else {
		printf("%d %d\n", cnt, (sz(odd) + 1) / 2);
		for (int i = 0; i < sz(res); ++i)
			if (res[i].sc >= start_m) {
			    rotate(res.begin(), res.begin() + i, res.end());
			    break;
            }
		for (int i = 0; i < sz(res);) {
			vector<int> path;
			path.pb(res[i++].fs);
			while ((i < sz(res)) && (res[i].sc < start_m))
				path.pb(res[i++].fs);
			printf("%d", sz(path));
			for (int j = 0; j < sz(path); ++j)
				printf(" %d", path[j] + 1);
			printf("\n");
		}
	}
	return 0;
}