#pragma comment(linker, "/STACK:100000000")
#define _CRT_SECURE_NO_WARNINGS
#include <cstdio>
#include <cstdlib>
#include <ctime>
#include <cstring>
#include <cctype>
#include <cassert>
#include <cmath>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <iostream>
#include <deque>
#include <queue>
#include <string>
using namespace std;
#define int64 long long
#define ldb long double
#define pb push_back
#define mp make_pair
#define fs first
#define sc second
#define sz(a) ((int) (a).size())
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
const double pi = acos(-1.0);
#define taskname "damage"
const double eps = 1e-10;
const int PARTS = (int) 4e6;
double tmp, d, l, r, t, h, alpha, f[PARTS + 1];

double sqr(double x) {
	return x * x;
}

double h0(double x) {
	return d / 2 * cos(alpha) + x * sin(alpha);
}

double getr(double x) {
	if (x < -eps) return sqrt(fabs(sqr(r) - sqr(r - tmp - x)));
	if (x > l + eps) return sqrt(fabs(sqr(r) - sqr(r - tmp + x - l)));
	return d / 2;
}

double h1(double x) {
	double gr = getr(x), gh0 = h0(x);
	if (fabs(cos(alpha)) < eps) return ((h > gh0 + eps) ? 1 : -1) * gr;
	return min(gr, max(-gr, (h - gh0) / cos(alpha)));
}

double beta(double x) {
	return acos(min(1., max(-1., h1(x) / getr(x))));
}

double s(double x) {
	double gr = getr(x), gbeta = beta(x);
	return sqr(gr) * (pi - gbeta + 0.5 * sin(2 * gbeta));
}

double integrate(double l, double r) {
	double h = (r - l) / (double) PARTS, res = 0;
	for (int i = 0; i <= PARTS; ++i)
		f[i] = s(l + i * h);
	for (int i = 1; i < PARTS; i += 2)
		res += (f[i - 1] + 4 * f[i] + f[i + 1]) / 6 * 2 * h;
	return res;
}

int main() {
	assert(freopen(taskname".in", "r", stdin));
	assert(freopen(taskname".out", "w", stdout));
	scanf("%lf%lf%lf%lf%lf", &d, &l, &r, &t, &h);
	d /= 100, l /= 100, r /= 100, t /= 100, h /= 100;
    tmp = r - sqrt(fabs(sqr(r) - sqr(d / 2)));
	alpha = asin(t / l);
	printf("%.10lf\n", integrate(-tmp, l + tmp));
	return 0;
}