#pragma comment(linker, "/STACK:100000000")
#define _CRT_SECURE_NO_WARNINGS
#include <cstdio>
#include <cstdlib>
#include <ctime>
#include <cstring>
#include <cctype>
#include <cassert>
#include <cmath>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <iostream>
#include <deque>
#include <queue>
#include <string>
using namespace std;
#define int64 long long
#define ldb long double
#define pb push_back
#define mp make_pair
#define fs first
#define sc second
#define sz(a) ((int) (a).size())
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
const double pi = acos(-1.0);
#define taskname "improvements"

const int rms = (1 << 19) - 1;
const int hrms = rms / 2;
const int size = 250 * 1000;

int rmq[rms + 1];
int bestleft[size];
int bestright[size];
int n;
int num[size];

void changeval(int ps, int val) {
	ps += hrms + 1;
	rmq[ps] = val;

	while (ps > 1) {
		ps /= 2;
		rmq[ps] = max(rmq[ps * 2], rmq[ps * 2 + 1]);
	}
}

int rss(int v, int lb, int rb, int i, int j) {
	if (lb > j || rb < i)
		return 0;
	if (lb >= i && rb <= j)
		return rmq[v];
	return max(rss(v * 2, lb, (lb + rb) / 2, i, j), rss(v * 2 + 1, (lb + rb) / 2 + 1, rb, i, j));
}

int main() {
	assert(freopen(taskname".in", "r", stdin));
	assert(freopen(taskname".out", "w", stdout));

	scanf("%d", &n);

	for (int i = 0; i <= n; i++)
		num[i] = -1;
	num[0] = 0;

	for (int i = 0; i < n; i++) {
		int d;
		scanf("%d", &d);
		num[d] = i + 1;
	}

	for (int i = 0; i <= rms; i++)
		rmq[i] = 0;
	bestleft[0] = 0;
	for (int i = 1; i <= n; i++) {
		if (num[i] != -1) {
			bestleft[i] = rss(1, 1, hrms + 1, 1, num[i] + 1) + 1;
			changeval(num[i], bestleft[i]);
        }
	}

	for (int i = 0; i <= rms; i++)
		rmq[i] = 0;
	for (int i = n; i >= 0; i--) {
		if (num[i] != -1) {
			bestright[i] = rss(1, 1, hrms + 1, 1, num[i] + 1) + 1;
			changeval(num[i], bestright[i]);
        }
	}

	int ans = 0;
	for (int i = 0; i <= n; i++)
		if (num[i] != -1)
		    ans = max(ans, bestleft[i] + bestright[i] - 1);

	cout << ans << endl;

	return 0;
}