#if 1
#include <iostream>
#include <algorithm>
#include <cmath>
#include <cstring>
#include <string>
#include <cstdio>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <cstdlib>
#include <cassert>
#include <ctime>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef vector<int> vi;
typedef pair<int, int> pii;

#define X first
#define Y second
#define bbb push_back
#define mp make_pair
#define file "epic"

int betterv(int v)
{
	return (v + 1) % 3;
}
int c2v(char c)
{
	if (c == 'R') return 0;
	if (c == 'P') return 1;
	if (c == 'S') return 2;
	assert(false);
	return -1;
}

char v2c(int v)
{
	if (v == 0) return 'R';
	if (v == 1) return 'P';
	if (v == 2) return 'S';
}

struct rps
{
	int v;
	int next[3];
	rps() 
    {
		memset(next, 255, sizeof(next));
    }
	rps(int v) : v(v) 
    {
		memset(next, 255, sizeof(next));
    }
};

typedef vector<rps> graph;

void output(graph g)
{
	cout << g.size() << endl;
	for (int i = 0; i < g.size(); ++i)
	{
		cout << v2c(g[i].v);
		for (int j = 0; j < 3; ++j)
			cout << ' ' << char(g[i].next[j] + '1');
		cout << endl;
	}
}

int main()
{
	srand(25452435);
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#else
	freopen(file".in", "r", stdin);
	freopen(file".out", "w", stdout);
#endif
	cin.sync_with_stdio(false);
	int n; cin >> n;
	graph g(n);
	for (int i = 0; i < n; ++i)
	{
		string s; cin >> s;
		g[i].v = c2v(s[0]);
		for (int j = 0; j < 3; ++j)
		{
			cin >> g[i].next[j];
			g[i].next[j]--;
		}
	}
    
	vector<graph> gs;
	for (int start = 0; start < n; ++start)
	{
		graph myg;
		vector<int> used(n);
		int othv = start;
		int prevopval = -1;
        while (true)
		{
			int opval = g[othv].v;
			if(myg.size()) myg.back().next[prevopval] = myg.size(); 
			
			int myval = betterv(opval);
            myg.push_back(rps(myval));

			int newothv = g[othv].next[myval];
			othv = newothv;
			if (used[othv])
			{
				int opval = g[othv].v;
				myg.back().next[opval] = used[othv] - 1;
				break;
			}
			else used[othv] = myg.size(); //-1
			prevopval = opval;
		}
		gs.push_back(myg);
	}

	int add = 0;
	graph ans;
	int count = 0;
	for (int i = 0; i < gs.size(); ++i)
		count += gs[i].size();

	for (int i = 0; i < gs.size(); ++i)
	{
		for (int j = 0; j < gs[i].size(); ++j)
		{
			ans.push_back(gs[i][j]);
			for (int k = 0; k < 3; ++k)
			{
				if (ans.back().next[k] == -1) ans.back().next[k] = rand() % count;
				else ans.back().next[k] += add;
			}
		}
		add += gs[i].size();
	}

	output(ans);

	return 0;
}
#endif
/*


*/