// LU - 1
#include <iostream>
#include <fstream>
#include <cstdio>
#include <string>
#include <sstream>
#include <cstring>
#include <cmath>
#include <cstdlib>
#include <cassert>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <stack>
#include <deque>
#include <bitset>
#include <iomanip>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef unsigned int ui;
typedef pair<int, int> ii;
typedef double real;

struct item
{
    ll a, b, g;
    int ind;
};

bool cmp(const item& A, const item& B)
{
    return A.a * B.b < A.b * B.a;
}

const int MAXN=100*1000+9;
item I[MAXN];
int n;
ll A, B;

real ans[MAXN];

void solve()
{
    for(int i=0; i<n; i++) ans[i]=0;

    real LEFT = B;
    real unhap = 0;
    real GOT_A = 0;
    sort(I, I + n, cmp);
    int it=n-1;

    while(it >=0 && LEFT >= I[it].b * I[it].g)
    {
        LEFT -=I[it].b*I[it].g;
        unhap += I[it].b*I[it].g;

        ans[I[it].ind] = I[it].g;
        GOT_A += I[it].a*I[it].g;

        it--;
    }

    if(it >= 0)
    {
        real s = LEFT / I[it].b;
        LEFT -= s * I[it].b;
        unhap += I[it].b * s;
        GOT_A += s*I[it].a;

        ans[I[it].ind] = s;
    }

    if(GOT_A >= A)
    {
        cout << GOT_A << ' ' << unhap << '\n';
        for(int i=0; i<n; i++)
        {
            cout << ans[i] << ' ';
        }
    }
    else
    {
        cout << "-1 -1";
    }
}

int main()
{
    freopen("burrito.in", "r", stdin);
    freopen("burrito.out", "w", stdout);
    //ios_base::sync_with_stdio(false);
    //cin.tie(NULL); //cout.tie(NULL);

    cin >> n >> A >> B;
    for(int i=0; i<n; i++)
    {
        cin >> I[i].g >> I[i].a >> I[i].b;
        I[i].ind=i;
    }

    cout << setprecision(10);

    solve();

    return 0;
}
