// LU - 1
#include <iostream>
#include <fstream>
#include <cstdio>
#include <string>
#include <sstream>
#include <cstring>
#include <cmath>
#include <cstdlib>
#include <cassert>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <stack>
#include <deque>
#include <bitset>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef unsigned int ui;
typedef pair<int, int> ii;
typedef double real;

const int MXN = 1024;
const int MXL=16;
int fk[MXN];
int uk[MXN];

int f, m, q, n;
int digits;
char inp[MXN][MXN/4];
ull dat[MXN][MXL];
int used[MXN];
const int WINU64 = 64/4;

static void hToBin(char txt[], ull out[])
{
    for (int i=0; i<digits; i++)
    {
        ull wnum;
        if (txt[i] >= '0' && txt[i] <= '9') wnum = txt[i]-'0';
        else wnum = txt[i]-'a'+10;
        //cout << "word: " << wnum << " " <<  txt[i] << endl;
        out[i/WINU64] |= wnum << (4*(i%WINU64));
    }
}

static int solve()
{
    memset(used, 0, sizeof(used));
    memset(dat, 0, sizeof(dat));
    digits = (m+3)/4;
    for (int i=0; i<n; i++)
    {
        hToBin(inp[i], dat[i]);
     //   cout << "DAT: " << bitset<64>(dat[i][0]) << endl;
    }
    int ans = 0;
    for (int i=0; i<q; i++)
    {
        ull uMASK[MXL]={0};
        for (int j=0; j<f; j++)
        {
            int bitpos = ((uk[i]%m)*(fk[j]%m))%m;
           // cout << i << " " << j << " " << uk[i] << " " << " " << fk[j] << endl;
          //  cout << " " << bitpos << endl;
            uMASK[bitpos/64] |= (1ULL<<(bitpos%64));
        }
        //cout << " us: " << bitset<64>(uMASK[0]) << endl;
        for (int j=0; j<n; j++)
        {
            if (used[j]) continue;
            bool good = true;
            for (int t=0; t<MXL; t++)
            {
                if ((uMASK[t]&dat[j][t]) != uMASK[t])
                {
                    good = false;
                    break;
                }
            }

            if (good) {
                used[j] = 1;
                ans++;
            }
        }
    }
    return ans;
}

int main()
{
    freopen("filter.in", "r", stdin);
    freopen("filter.out", "w", stdout);
    //ios_base::sync_with_stdio(false);
    //cin.tie(NULL); //cout.tie(NULL);
    while (scanf("%d %d", &m, &f) == 2)
    {
        for (int i=0; i<f; i++) scanf("%d", fk+i);
        scanf("%d", &n);
        for (int i=0; i<n; i++) scanf("%s", inp[i]);
        scanf("%d", &q);
        for (int i=0; i<q; i++) scanf("%d", uk+i);
        printf("%d", solve());
        for (int i=0; i<n; i++)
        {
            if (used[i]) printf(" %d", i);
        }
        printf("\n");
    }
    return 0;
}
