// LU - 1
#include <iostream>
#include <fstream>
#include <cstdio>
#include <string>
#include <sstream>
#include <cstring>
#include <cmath>
#include <cstdlib>
#include <cassert>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <stack>
#include <deque>
#include <bitset>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef unsigned int ui;
typedef pair<int, int> ii;
typedef double real;

const int MXN = 64;

char txt[MXN*2];

//unordered_set sleft[MXN];
//unordered_set sright[MXN];
struct ans
{
    ll mask;
    int lastlen;
    int lastnum;
    int lastpos;
};

typedef vector<ans> Vans;

static bool operator<(const ans& A, const ans& B)
//cmp(const ans& A, const ans& B)
{
    return A.mask < B.mask;
}

static void transf(const Vans& in, int id, Vans& out, int len)
{
    out.resize(0);
    out.reserve(in.size());
    ll mask (1LL<<id);
    for (size_t i=0; i<in.size(); i++)
    {
        if ((in[i].mask & mask) == 0LL)
        {
            out.push_back(in[i]);
            out.back().mask |= mask;
            out.back().lastlen = len;
            out.back().lastnum = id;
            out.back().lastpos = i;
        }
    }
}

void solve(const string& s, Vans dp[], bool rev)
{
    int n=s.size();

    Vans tmp1;
    Vans tmp2;

    ans first;
    first.mask=0ULL; first.lastlen = -1;

    dp[0].push_back(first);

    for (int i = 0; i<n; i++)
    {
        tmp1.resize(0);
        tmp2.resize(0);
        int n0 = s[i]-'0';
        if (n0 > 0)
        {
            transf(dp[i], n0, tmp1, 1);
        }
        if (i > 0)
        {
            int n2;
            if(!rev) n2 = 10*(s[i-1]-'0')+n0;
            else n2 = (s[i-1]-'0')+10*n0;
            transf(dp[i-1], n2, tmp2, 2);
        }
        dp[i+1].resize(tmp1.size() + tmp2.size());
        merge(tmp1.begin(), tmp1.end(), tmp2.begin(), tmp2.end(), dp[i+1].begin());
        int w = 1;
        for (size_t r=1; r<dp[i+1].size(); r++)
        {
            if (dp[i+1][r].mask != dp[i+1][r-1].mask)
            {
                dp[i+1][w++] = dp[i+1][r];
            }
        }
    }
}

Vans ldp[2*MXN];
Vans rdp[2*MXN];
int N;
ll maskFull;

vector<int> rebuldAns(int pos, int level, ll mask, Vans dp[])
{
    vector<int> ret;
    while (level > 0)
    {
       // cout << level << " " << bitset<20>(mask) << " " << dp[level][pos].lastnum << endl;
         ans t = dp[level][pos];
       // cout << bitset<52>(t.mask) << " " << t.lastlen << " " << t.lastnum << "\n";

        ret.push_back(dp[level][pos].lastnum);
        mask ^= (1LL<<dp[level][pos].lastnum);



        int nextlevel = level - dp[level][pos].lastlen;
        pos = dp[level][pos].lastpos;
        /*for (size_t i=0; i<dp[nextlevel].size(); i++)
        {
            if (dp[nextlevel][i].mask == mask)
            {
                pos = i;
                break;
            }
        }*/
        if (pos == -1)
        {
            /*for (int i=0; i<dp[nextlevel].size(); i++)
            {
                ans t = dp[nextlevel][i];
                cout << bitset<52>(t.mask) << " " << t.lastlen << " " << t.lastnum << "\n";
            }*/
        }
        assert(pos != -1);
        level = nextlevel;
    }

   // cout << "FINISHED rebuilding\n" << endl;

    reverse(ret.begin(), ret.end());
    return ret;
}

bool tryJoin(int lsize, int rsize)
{
    //cout << "TJ " << lsize << " " << rsize << " " << ldp[lsize].size() << endl;
    for (size_t i=0; i<ldp[lsize].size(); i++)
    {
        ll lmask = ldp[lsize][i].mask;
        ll rmask = maskFull^lmask;
        ans need;
        need.mask = rmask;
        int pos  = lower_bound(rdp[rsize].begin(), rdp[rsize].end(), need)-rdp[rsize].begin();
        if (pos < (int)rdp[rsize].size())
        {
            //cout << "found smth!!!" << endl;
            vector<int> leftAns = rebuldAns(i, lsize, lmask, ldp);
            vector<int> rightAns = rebuldAns(pos, rsize, rmask, rdp);
            //cout << "found smt2222!!!" << endl;

            reverse(rightAns.begin(), rightAns.end());


            for (size_t j=0; j<leftAns.size(); j++)
            {
                printf("%d ", leftAns[j]);
            }
            for (size_t j=0; j<rightAns.size(); j++)
            {
                printf("%d ", rightAns[j]);
            }
            return true;
        }
    }
    return false;
}

void solve()
{
    string allText = txt;
    int l2 = (allText.size()+1)/2;
    string lstr = allText.substr(0, l2);
    solve(lstr, ldp, false);
    reverse(allText.begin(), allText.end());
    string rstr = allText.substr(0, l2);
    //reverse(rstr.begin(), rstr.end());
    solve(rstr, rdp, true);
   // cout << "STR: " << lstr << " " << rstr << endl;

   // cout << "solved !!!!!!!\n";

    int l = allText.size();
    int sizeHalf = (allText.size())/2;
    if (l<=9)
    {
        N = l;
    }
    else
    {
        N = (l-9)/2 + 9;
    }
    maskFull = ((1LL<<N)-1)<<1;

    if (!tryJoin(sizeHalf, l-sizeHalf))
    {
        tryJoin(sizeHalf+1, l-(sizeHalf+1));
    }
}

int main()
{
    freopen("joke.in", "r", stdin);
    freopen("joke.out", "w", stdout);
    if (scanf("%s", txt))
    {
        solve();
    }
    //ios_base::sync_with_stdio(false);
    //cin.tie(NULL); //cout.tie(NULL);

    return 0;
}
