#define FILENAME "burrito"

#ifdef SU1
#define _GLIBCXX_DEBUG
#endif

#include <iostream>
#include <iomanip>

#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cmath>
#include <cassert>
#include <climits>
#include <ctime>

#include <string>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <algorithm>

using namespace std;

#define forn(i, n) for (int i = 0; i < int(n); i++)
#define forl(i, n) for (int i = 1; i <= int(n); i++)
#define fore(i, l, r) for (int i = int(l); i <= int(r); i++)
#define ford(i, n) for (int i = int(n) - 1; i >= 0; i--)
#define sz(a) int((a).size())
#define all(a) (a).begin(), (a).end()
#define pb push_back
#define mp make_pair
#define x first
#define y second
#define ft first
#define sc second

typedef long long li;
typedef long double ld;
typedef pair<int, int> pt;

template<typename X> inline X sqr(const X &a) { return a * a; }
template<typename X> inline X abs(const X &a) { return a < 0 ? -a : a; }

const int INF = int(1e9);
const li INF64 = li(1e18);
const ld EPS = 1e-9, PI = acosl(ld(-1));

const int N = 100 * 1000 + 13;

int n, A, B;
int g[N], a[N], b[N];
int perm[N];
ld ans[N];
ld ansa, ansb;

inline bool cmp (int i, int j)
{
	return a[i] * 1LL * b[j] > b[i] * 1LL * a[j];
}

inline bool read()
{
	if (scanf("%d%d%d", &n, &A, &B) != 3) return false;
	forn(i, n)
	{
		assert(scanf("%d%d%d", &g[i], &a[i], &b[i]) == 3);
		perm[i] = i;
	}
	return true;
}

inline void solve()
{
	sort(perm, perm + n, cmp);
	
	ld remb = B;
	
	forn(idx, n)
	{
		int i = perm[idx];
		
		if (b[i] == 0)
			ans[i] = g[i];
		else
			ans[i] = min(ld(g[i]), remb / b[i]);
			
		ansa += ans[i] * a[i];
		ansb += ans[i] * b[i];
		remb -= ans[i] * b[i];
	}
	
	if (ansa + EPS < A)
	{
		puts("-1 -1");
		return;
	}
	
	printf("%.10f %.10f\n", double(ansa), double(ansb));
	
	forn(i, n)
	{
		if (i) putchar(' ');
		printf("%.10f", double(ans[i]));
	}
	puts("");
}

int main()
{
#ifdef SU1
	freopen("input.txt", "rt", stdin);
	//freopen("output.txt", "wt", stdout);
#else
	freopen(FILENAME ".in", "rt", stdin);	
	freopen(FILENAME ".out", "wt", stdout);
#endif

	cout << setprecision(10) << fixed;
	cerr << setprecision(5) << fixed;
	
	assert(read());
	solve();

	return 0;
}