#define FILENAME "damage"

#ifdef SU1
#define _GLIBCXX_DEBUG
#endif

#include <iostream>
#include <iomanip>

#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cmath>
#include <cassert>
#include <climits>
#include <ctime>

#include <string>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <algorithm>

using namespace std;

#define forn(i, n) for (int i = 0; i < int(n); i++)
#define forl(i, n) for (int i = 1; i <= int(n); i++)
#define fore(i, l, r) for (int i = int(l); i <= int(r); i++)
#define ford(i, n) for (int i = int(n) - 1; i >= 0; i--)
#define sz(a) int((a).size())
#define all(a) (a).begin(), (a).end()
#define pb push_back
#define mp make_pair
#define x first
#define y second
#define ft first
#define sc second

typedef long long li;
typedef long double ld;
typedef pair<int, int> pt;

template<typename X> inline X sqr(const X &a) { return a * a; }
template<typename X> inline X abs(const X &a) { return a < 0 ? -a : a; }

const int INF = int(1e9);
const li INF64 = li(1e18);
const ld EPS = 1e-9, PI = acosl(ld(-1));

ld readLd() {
	double x;
	assert(scanf("%lf", &x) == 1);
	return ld(x);
}

ld d, l, r, t, h;
ld co;

inline bool read()
{
	d = readLd();
	l = readLd();
	r = readLd();
	t = readLd();
	h = readLd();
	d /= 2;
	return true;
}

ld cs, sn;

ld calc(ld r, ld up) {
	if (r < EPS) return 0;
	if (up > r) return PI * r * r;
	if (up < -r) return 0;
	ld a = acosl(up / r);
	ld seg = a * r * r - r * r * sinl(2 * a) / 2;
	return PI * r * r - seg;
}

ld calc(ld x) {
	ld rad = d, up = 1e100;
	if (x < 0)
		rad = sqrtl(max(ld(0), sqr(r) - sqr(x - co)));
	if (x > l) {
		rad = sqrtl(max(ld(0), sqr(r) - sqr(x - (l - co))));
	}
	if (t + EPS >= l) {
		if (x > h) return 0;
	} else {
		ld up0 = -d + h / sn;
//		ld upl = -d + (t + h) * sn; // TODO
		up = up0 - cs / sn * x;
	}
	//cerr << x << ' ' << rad << ' ' << up << endl;
	return calc(rad, up);
}

inline void solve()
{
	co = sqrtl(sqr(r) - sqr(d));
	cs = max(ld(-1), min(ld(1), t / l));
	sn = max(ld(-1), min(ld(1), sqrtl(max(ld(0), 1 - sqr(cs)))));
	ld res = 0;
	ld lf = co - r, rg = l - co + r;
	const int MAGIC = 1e7;
	forn(i, MAGIC) {
		ld h = (rg - lf) / (MAGIC);
		ld x = lf + (rg - lf) * i / ld(MAGIC);
//		cerr << lf << ' ' << rg << ' ' << i << ' ' << x << endl;
//		printf("%f %f %f\n", double(lf), double(rg), double(x));
		res += calc(x) * h;
	}
	printf("%.10f\n", double(res) / 1000000);
}

int main()
{
#ifdef SU1
	freopen("input.txt", "rt", stdin);
	//freopen("output.txt", "wt", stdout);
#else
	freopen(FILENAME ".in", "rt", stdin);	
	freopen(FILENAME ".out", "wt", stdout);
#endif

	cout << setprecision(10) << fixed;
	cerr << setprecision(5) << fixed;
	
	assert(read());
	solve();
	
	#ifdef SU1
	cerr << clock() << endl;
	#endif

	return 0;
}