#define FILENAME "epic"

#ifdef SU1
#define _GLIBCXX_DEBUG
#endif

#include <iostream>
#include <iomanip>

#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cmath>
#include <cassert>
#include <climits>
#include <ctime>

#include <string>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <algorithm>

using namespace std;

#define forn(i, n) for (int i = 0; i < int(n); i++)
#define forl(i, n) for (int i = 1; i <= int(n); i++)
#define fore(i, l, r) for (int i = int(l); i <= int(r); i++)
#define ford(i, n) for (int i = int(n) - 1; i >= 0; i--)
#define sz(a) int((a).size())
#define all(a) (a).begin(), (a).end()
#define pb push_back
#define mp make_pair
#define x first
#define y second
#define ft first
#define sc second

typedef long long li;
typedef long double ld;
typedef pair<int, int> pt;

template<typename X> inline X sqr(const X &a) { return a * a; }
template<typename X> inline X abs(const X &a) { return a < 0 ? -a : a; }

const int INF = int(1e9);
const li INF64 = li(1e18);
const ld EPS = 1e-9, PI = acosl(ld(-1));

const char cc[] = {'R', 'P', 'S'};

inline int getNum (char c)
{
	forn(i, 3) if (cc[i] == c) return i;
	throw;
}

const int N = 1000 + 3;

int n;
char c[N];
int numc[N];
int to[N][3];
vector<int> tg[N][3];

inline bool read()
{
	if (scanf("%d", &n) != 1) return false;
	
	forn(i, n)
	{
		assert(scanf(" %c", &c[i]) == 1);
		numc[i] = getNum(c[i]);
		forn(j, 3)
		{
			assert(scanf("%d", &to[i][j]) == 1);
			to[i][j]--;
			tg[to[i][j]][j].pb(i);
		}
	}
	
	return true;
}

int dif[N][N];
pt pdif[N][N];
int pch[N][N];
bool hasSame[N];

inline void getDiff ()
{
	queue<pt> q;
	forn(i, n) forn(j, n) if (c[i] != c[j])
	{
		q.push(mp(i, j));
		dif[i][j] = true;
		pdif[i][j] = mp(-1, -1);
	}
	
	while (!q.empty())
	{
		int v1 = q.front().ft, v2 = q.front().sc;
		q.pop();
		
		forn(curc, 3)
		{
			forn(i, sz(tg[v1][curc]))
			forn(j, sz(tg[v2][curc]))
			{
				int u1 = tg[v1][curc][i], u2 = tg[v2][curc][j];
				if (!dif[u1][u2])
				{
					dif[u1][u2] = true;
					q.push(mp(u1, u2));
					pdif[u1][u2] = mp(v1, v2);
					pch[u1][u2] = curc;
				}
			}
		}
	}
	
	forn(i, n) forn(j, i) if (!dif[i][j]) hasSame[i] = true;
}

inline vector<int> getDif (int v1, int v2)
{
	vector<int> ans;
	while (pdif[v1][v2] != mp(-1, -1))
	{
		ans.pb(pch[v1][v2]);
		int ov1 = v1, ov2 = v2;
		v1 = pdif[ov1][ov2].ft;
		v2 = pdif[ov1][ov2].sc;
	}
	reverse(all(ans));
	return ans;
}

inline pair<li, pt> go (const pt& state, const vector<int>& add)
{
	int start = state.ft, v = state.sc;
	li h = 0;
	forn(i, sz(add))
	{
		int cur = numc[v];
		h = h * 1009 + cur + 1;
		v = to[v][add[i]];
	}
	return mp(h, mp(start, v));
}

inline vector<int> getString ()
{
	vector<int> ans;
	ans.pb(0);
	
	vector<vector<pt> > sets;
	vector<pt> tmp;
	forn(i, n) if (!hasSame[i]) tmp.pb(mp(i, i));
	if (sz(tmp) > 1) sets.pb(tmp);
	
	while (!sets.empty())
	{
		vector<pt> v = sets.back();
		sets.pop_back();
		assert(sz(v) >= 2);
		int v1 = v[0].ft, v2 = v[1].ft;
		
		vector<int> add = getDif(v1, v2);
   		forn(i, sz(add)) ans.pb(add[i]);
		
		vector<vector<pt> > nwsets;
		
		forn(i, sz(sets))
		{
    		vector<pair <li, pt> > curv;
    		forn(j, sz(sets[i]))
    			curv.pb(go(sets[i][j], add));
    			
    		sort(all(curv));
    		
    		for (int j = 0; j < sz(curv); )
    		{
    			int st = j;
    			while (j < sz(curv) && curv[j].ft == curv[st].ft) j++;
    			vector<pt> nw;
    			for (int k = st; k < j; k++) nw.pb(curv[k].sc);
    			if (sz(nw) >= 2) nwsets.pb(nw);
    		}
		}
		
		sets = nwsets;
	}
	
	return ans;
}

inline vector<int> getPath (int start, const vector<int>& diffString)
{
	vector<int> ans;
	int v = start;
	forn(i, sz(diffString))
	{
		ans.pb(v);
		v = to[v][diffString[i]];
	}
	ans.pb(v);
	return ans;
}

const int SZT = 1000 * 1000 + 3;

vector<int> diffString;

int t[SZT][3];
int tp[SZT], ptch[SZT];
int szt;
int term[SZT];
int ver[SZT];
int tc[SZT];

int addInTree (const vector<int>& path, const vector<int>& diffString)
{
	int vt = 0;
	
	forn(i, sz(path) - 1)
	{
		tc[vt] = diffString[i];
		int curc = numc[path[i]];
		if (t[vt][curc] == -1)
		{
			t[vt][curc] = szt;
			tp[szt] = vt;
			ptch[szt] = curc;
			szt++;
		}
		vt = t[vt][curc];
		ver[vt] = path[i];
	}
	
	return vt;
}

inline int getCnt (int v)
{
	int res = 0;
	forn(i, 3) if (t[v][i] != -1) res++;
	return res;
}

void cut (int v)
{
	assert(getCnt(v) == 0);
	int last = v, lastc = ptch[v];
	while (getCnt(v) < 2 && v != 0)
	{
		last = v;
		lastc = ptch[v];
		v = tp[v];
	}
	t[v][lastc] = ver[last] + SZT;
}

vector<int> nums;

void dfs (int v)
{
	nums.pb(v);
	forn(i, 3)
	{
		if (t[v][i] < 0 || t[v][i] >= SZT) continue;
		dfs(t[v][i]);
	}
}

inline void prepare ()
{
	getDiff();
	
	//forn(i, n) { forn(j, n) cerr << dif[i][j] << ' '; cerr << endl; }
	
	diffString = getString();
	
	//forn(i, sz(diffString)) cerr << diffString[i] << ' '; cerr << endl;
	
	memset(t, -1, sizeof(t));
	memset(term, -1, sizeof(term));
	szt = 1;
	
	vector<int> finished;
	
	forn(i, n)
	{
		if (hasSame[i]) continue;
		vector<int> path = getPath(i, diffString);
		//forn(j, sz(path)) cerr << path[j] << ' '; cerr << endl;
		finished.pb(addInTree(path, diffString));
	}
	
	//forn(i, sz(finished)) cerr << finished[i] << ' '; cerr << endl;
	
	forn(i, sz(finished))
		cut(finished[i]);
		
	dfs(0);
	
	sort(all(nums));
	nums.erase(unique(all(nums)), nums.end());
	
	forn(i, sz(nums))
		forn(j, 3)
			if (t[i][j] == -1)
				t[i][j] = sz(nums);
			else if (t[i][j] < SZT)
				t[i][j] = int(lower_bound(all(nums), t[i][j]) - nums.begin());
			else
				t[i][j] = (t[i][j] - SZT) + sz(nums) + 1;
				
	printf("%d\n", sz(nums) + 1 + n);
	
	forn(i, sz(nums))
	{
		int v = nums[i];
		printf("%c %d %d %d\n", cc[tc[v]], t[v][0] + 1, t[v][1] + 1, t[v][2] + 1);
	}
	
	printf("P %d %d %d\n", sz(nums) + 1, sz(nums) + 1, sz(nums) + 1);
	
	forn(i, n)
	{
		printf("%c", cc[(numc[i] + 1) % 3]);
		forn(j, 3) printf(" %d", to[i][j] + sz(nums) + 2);
		puts("");
	}	
}

inline void solve()
{
	prepare();
}

int main()
{
#ifdef SU1
	freopen("input.txt", "rt", stdin);
	//freopen("output.txt", "wt", stdout);
#else
	freopen(FILENAME ".in", "rt", stdin);	
	freopen(FILENAME ".out", "wt", stdout);
#endif

	cout << setprecision(10) << fixed;
	cerr << setprecision(5) << fixed;
	
	assert(read());
	solve();

	return 0;
}