#define FILENAME "filter"

#ifdef SU1
#define _GLIBCXX_DEBUG
#endif

#include <iostream>
#include <iomanip>

#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cmath>
#include <cassert>
#include <climits>
#include <ctime>

#include <string>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <algorithm>

using namespace std;

#define forn(i, n) for (int i = 0; i < int(n); i++)
#define forl(i, n) for (int i = 1; i <= int(n); i++)
#define fore(i, l, r) for (int i = int(l); i <= int(r); i++)
#define ford(i, n) for (int i = int(n) - 1; i >= 0; i--)
#define sz(a) int((a).size())
#define all(a) (a).begin(), (a).end()
#define pb push_back
#define mp make_pair
#define x first
#define y second
#define ft first
#define sc second

typedef long long li;
typedef long double ld;
typedef pair<int, int> pt;

template<typename X> inline X sqr(const X &a) { return a * a; }
template<typename X> inline X abs(const X &a) { return a < 0 ? -a : a; }

const int INF = int(1e9);
const li INF64 = li(1e18);
const ld EPS = 1e-9, PI = acosl(ld(-1));

const int N = 1050;
li a[N];
int m, f, n;

bool bits[N][N];
char buf[N];
bool curBits[10];
void getBit(char c) {
	int x = isdigit(c) ? (c - '0') : (10 + c - 'a');
	memset(curBits, 0, sizeof(curBits));
	for (int i = 0; x; i++) {
		curBits[i] = x & 1;
		x >>= 1;
	}
}

int q;
li u[N];

inline bool read()
{
	assert(scanf("%d%d", &m, &f) == 2);
	forn(i, f) {
		assert(scanf("%I64d", &a[i]) == 1);
	}
	assert(scanf("%d", &n) == 1);
	forn(i, n) {
		assert(scanf("%s", buf) == 1);
		int j = 0;
		while (buf[j]) {
			getBit(buf[j]);
			forn(t, 4)
				bits[i][j * 4 + t] = curBits[t];
			j++;
		}
	}
	assert(scanf("%d", &q) == 1);
	forn(i, q)
		assert(scanf("%I64d", &u[i]) == 1);
	return true;
}

inline void solve()
{
	vector<int> ans;
	forn(fIdx, n) {
		forn(k, q) {
			bool good = true;
			forn(i, f) {
				li lj = u[k] * a[i];
				if (lj >= m)
					lj %= m;
				int j = int(lj);
				if (!bits[fIdx][j]) {
					good = false;
					break;
				}
			}
			if (good) {
				ans.pb(fIdx);
				break;
			}
		}
	}
	printf("%d", sz(ans));
	forn(i, sz(ans)) {
		printf(" %d", ans[i]);
	}
	puts("");
}

int main()
{
#ifdef SU1
	freopen("input.txt", "rt", stdin);
	//freopen("output.txt", "wt", stdout);
#else
	freopen(FILENAME ".in", "rt", stdin);	
	freopen(FILENAME ".out", "wt", stdout);
#endif

	cout << setprecision(10) << fixed;
	cerr << setprecision(5) << fixed;
	
	assert(read());
	solve();

	return 0;
}