#define FILENAME "improvements"

#ifdef SU1
#define _GLIBCXX_DEBUG
#endif

#include <iostream>
#include <iomanip>

#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cmath>
#include <cassert>
#include <climits>
#include <ctime>

#include <string>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <algorithm>

using namespace std;

#define forn(i, n) for (int i = 0; i < int(n); i++)
#define forl(i, n) for (int i = 1; i <= int(n); i++)
#define fore(i, l, r) for (int i = int(l); i <= int(r); i++)
#define ford(i, n) for (int i = int(n) - 1; i >= 0; i--)
#define sz(a) int((a).size())
#define all(a) (a).begin(), (a).end()
#define pb push_back
#define mp make_pair
#define x first
#define y second
#define ft first
#define sc second

typedef long long li;
typedef long double ld;
typedef pair<int, int> pt;

template<typename X> inline X sqr(const X &a) { return a * a; }
template<typename X> inline X abs(const X &a) { return a < 0 ? -a : a; }

const int INF = int(1e9);
const li INF64 = li(1e18);
const ld EPS = 1e-9, PI = acosl(ld(-1));

const int N = 200500;
int n;
int a[N];

inline bool read()
{
	assert(scanf("%d", &n) == 1);
	forn(i, n)
		assert(scanf("%d", &a[i]) == 1);
	return true;
}

int t[4 * N];
void put(int pos, int val, int v, int lf, int rg) {
	if (lf == rg) {
		t[v] = val;
		return;
	}
	int mid = (lf + rg) / 2;
	if (pos <= mid)
		put(pos, val, v * 2 + 1, lf, mid);
	else
		put(pos, val, v * 2 + 2, mid + 1, rg);
	t[v] = max(t[v * 2 + 1], t[v * 2 + 2]);
}
int get(int from, int to, int v, int lf, int rg) {
	if (from == lf && to == rg)
		return t[v];
	int res = 0;
	int mid = (lf + rg) / 2;
	if (from <= mid)
		res = max(res, get(from, min(to, mid), v * 2 + 1, lf, mid));
	if (to > mid)
		res = max(res, get(max(from, mid + 1), to, v * 2 + 2, mid + 1, rg));
	return res;
}

int lf[N], rg[N];

inline void solve()
{
	memset(t, 0, sizeof(t));
	forn(i, n) {
		lf[i] = get(0, a[i] - 1, 0, 0, N - 1) + 1;
		put(a[i], lf[i], 0, 0, N - 1);
	}
	memset(t, 0, sizeof(t));
	forn(i, n) {
		rg[i] = get(a[i] + 1, N - 1, 0, 0, N - 1) + 1;
		put(a[i], rg[i], 0, 0, N - 1);
	}
	
	int ans = 0;
	forn(i, n)
		ans = max(ans, lf[i] + rg[i] - 1);
	printf("%d\n", ans);
}

int main()
{
#ifdef SU1
	freopen("input.txt", "rt", stdin);
	//freopen("output.txt", "wt", stdout);
#else
	freopen(FILENAME ".in", "rt", stdin);	
	freopen(FILENAME ".out", "wt", stdout);
#endif

	cout << setprecision(10) << fixed;
	cerr << setprecision(5) << fixed;
	
	assert(read());
	solve();

	return 0;
}