#define FILENAME "knockout"

#ifdef SU1
#define _GLIBCXX_DEBUG
#endif

#include <iostream>
#include <iomanip>

#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cmath>
#include <cassert>
#include <climits>
#include <ctime>

#include <string>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <algorithm>

using namespace std;

#define forn(i, n) for (int i = 0; i < int(n); i++)
#define forl(i, n) for (int i = 1; i <= int(n); i++)
#define fore(i, l, r) for (int i = int(l); i <= int(r); i++)
#define ford(i, n) for (int i = int(n) - 1; i >= 0; i--)
#define sz(a) int((a).size())
#define all(a) (a).begin(), (a).end()
#define pb push_back
#define mp make_pair
#define x first
#define y second
#define ft first
#define sc second

typedef long long li;
typedef long double ld;
typedef pair<int, int> pt;

template<typename X> inline X sqr(const X &a) { return a * a; }
template<typename X> inline X abs(const X &a) { return a < 0 ? -a : a; }

const int INF = int(1e9);
const li INF64 = li(1e18);
const ld EPS = 1e-9, PI = acosl(ld(-1));

const int N = 1000 + 3;

int n, m;
int a[N], b[N];

inline bool read()
{
	if (scanf("%d%d", &n, &m) != 2) return false;
	forn(i, n) assert(scanf("%d%d", &a[i], &b[i]) == 2);
	return true;
}

inline int sign (int x) { return x > 0 ? 1 : x < 0 ? -1 : 0; }

inline int calc (int lf, int rg, int T)
{
	int ans = 0;
	
	forn(i, n)
	{
		int cnt = abs(a[i] - b[i]) + 1;
		int mod = 2 * cnt - 2;
		if (mod == 0) mod = 1;
		
		int t = T % mod;
		int len = abs(a[i] - b[i]);
		int dx = sign(b[i] - a[i]);
		
		int pos = 0;
		if (t <= len)
			pos = a[i] + t * dx;
		else
			pos = b[i] - (t - len) * dx;
			
		//cerr << i << ' ' << pos << endl;
		
		if (lf <= pos && pos <= rg)
			ans++;
	}
	
	return ans;
}

inline void solve()
{
	forn(iter, m)
	{
		int lf, rg, T;
		assert(scanf("%d%d%d", &lf, &rg, &T) == 3);
		printf("%d\n", calc(lf, rg, T));
	}
}

int main()
{
#ifdef SU1
	freopen("input.txt", "rt", stdin);
	//freopen("output.txt", "wt", stdout);
#else
	freopen(FILENAME ".in", "rt", stdin);	
	freopen(FILENAME ".out", "wt", stdout);
#endif

	cout << setprecision(10) << fixed;
	cerr << setprecision(5) << fixed;
	
	assert(read());
	solve();

	return 0;
}