#include <cstdio>
#include <iostream>
#include <cstring>
#include <cassert>
#include <algorithm>

using namespace std;

const int N = 555;
const string let = "RPS";

vector < pair <int, int> > gr[N];
int type[N];
int to[N][3];
int n;

int x[N * N], y[N * N];
bool was[N][N];
string best[N][N];

int cnt;
int my_type[N * N];
int my_to[N * N][3];

void solve(int v, vector <bool> can_be) {
  int mn = (int)1e9, mi = -1, mj = -1;
  for (int i = 0; i < n; i++) {
    for (int j = 0; j < n; j++) {
      if (can_be[i] && can_be[j] && was[i][j] && best[i][j].length() < mn) {
        mn = best[i][j].length();
        mi = i;
        mj = j;
      }
    }
  }
  if (mi == -1) {
    int start = -1;
    for (int i = 0; i < n; i++) {
      if (can_be[i]) {
        start = i;
        break;
      }
    }
    if (start == -1) {
      my_type[v] = 0;
      my_to[v][0] = my_to[v][1] = my_to[v][2] = v;
      return;
    }
    vector <int> id(n);
    id[start] = v;
    for (int i = 0; i < n; i++) {
      if (i != start) {
        id[i] = cnt++;
      }
    }
    for (int i = 0; i < n; i++) {
      my_type[id[i]] = (type[i] + 1) % 3;
      my_to[id[i]][0] = id[to[i][1]];
      my_to[id[i]][1] = id[to[i][2]];
      my_to[id[i]][2] = id[to[i][0]];
    }
    return;
  }
  for (int pos = 0; pos < mn; pos++) {
    my_type[v] = best[mi][mj][pos] - '0';
    my_to[v][0] = my_to[v][1] = my_to[v][2] = cnt;
    v = cnt;
    cnt++;
  }
  vector <bool> new_can_be[3];
  for (int q = 0; q < 3; q++) {
    new_can_be[q] = vector <bool>(n, false);
  }
  my_type[v] = 0;
  my_to[v][0] = cnt;
  my_to[v][1] = cnt + 1;
  my_to[v][2] = cnt + 2;
  for (int i = 0; i < n; i++) {
    if (can_be[i]) {
      int cur = i;
      for (int pos = 0; pos < mn; pos++) {
        cur = to[cur][best[mi][mj][pos] - '0'];
      }
      new_can_be[type[cur]][to[cur][my_type[v]]] = true;
    }
  }
  cnt += 3;
  int offset = cnt - 3;
  for (int q = 0; q < 3; q++) {
    solve(offset + q, new_can_be[q]);
  }
}

int main() {
  freopen("epic.in", "r", stdin);
  freopen("epic.out", "w", stdout);
  scanf("%d", &n);
  for (int i = 0; i < n; i++) {
    gr[i].clear();
  }
  for (int i = 0; i < n; i++) {
    char ch = getchar();
    while (ch < 'A' || ch > 'Z') {
      ch = getchar();
    }
    type[i] = let.find(ch);
    for (int j = 0; j < 3; j++) {
      scanf("%d", to[i] + j);
      to[i][j]--;
      gr[to[i][j]].push_back(make_pair(i, j));
    }
  }
  int e = 0;
  for (int i = 0; i < n; i++) {
    for (int j = 0; j < n; j++) {
      if (type[i] != type[j]) {
        e++;
        x[e] = i;
        y[e] = j;
        was[i][j] = true;
      } else {
        was[i][j] = false;
      }
      best[i][j] = "";
    }
  }
  int b = 1;
  while (b <= e) {
    int sx = gr[x[b]].size();
    int sy = gr[y[b]].size();
    for (int jx = 0; jx < sx; jx++) {
      for (int jy = 0; jy < sy; jy++) {
        if (gr[x[b]][jx].second != gr[y[b]][jy].second) {
          continue;
        }
        int xx = gr[x[b]][jx].first;
        int yy = gr[y[b]][jy].first;
        if (was[xx][yy]) {
          continue;
        }
        e++;
        x[e] = xx;
        y[e] = yy;
        was[xx][yy] = true;
        string z = "";
        z += (gr[x[b]][jx].second + '0');
        best[xx][yy] = z + best[x[b]][y[b]];
      }
    }
    b++;
  }
  cnt = 1;
  solve(0, vector <bool>(n, true));
  printf("%d\n", cnt);
  for (int i = 0; i < cnt; i++) {
    printf("%c %d %d %d\n", let[my_type[i]], my_to[i][0] + 1, my_to[i][1] + 1, my_to[i][2] + 1);
  }
  return 0;
}
