import java.util.*;
import java.io.*;

public class F {

	void solve() {
		int m = in.nextInt(), f = in.nextInt();
		int[] a = new int[f];
		for (int i = 0; i < f; i++) {
			a[i] = in.nextInt();
		}

		int n = in.nextInt();
		BitSet[] sets = new BitSet[n];
		for (int i = 0; i < n; i++) {
			String val = in.next();
			sets[i] = new BitSet(m);

			for (int j = 0; j < m; j++) {
				char p = val.charAt(j / 4);
				int toInt = Character.digit(p, 16);
				sets[i].set(j, ((toInt >> (j % 4)) & 1) == 1);
			}
		}

		int q = in.nextInt();

		boolean[] ans = new boolean[n];

		for (int i = 0; i < q; i++) {
			int[] hash = new int[f];
			int value = in.nextInt();

			for (int j = 0; j < f; j++) {
				long h = (1L * a[j] * value) % m;
				hash[j] = (int) h;
			}

			for (int j = 0; j < n; j++) {
				boolean all = true;
				for (int t = 0; t < f; t++) {
					if (!sets[j].get(hash[t])) {
						all = false;
						break;
					}
				}
				if (all) {
					ans[j] = true;
				}
			}
		}

		int cnt = 0;
		for (int i = 0; i < n; i++) {
			if (ans[i]) {
				cnt++;
			}
		}
		out.print(cnt);
		for (int i = 0; i < n; i++) {
			if (ans[i]) {
				out.print(" " + i);
			}
		}
		out.println();
	}

	FastScanner in;
	PrintWriter out;

	void run() {
		try {
			in = new FastScanner("filter.in");
			out = new PrintWriter("filter.out");
			solve();
			out.close();
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	class FastScanner {
		BufferedReader br;
		StringTokenizer st;

		public FastScanner(String s) {
			try {
				br = new BufferedReader(new FileReader(s));
			} catch (FileNotFoundException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}

		String next() {
			while (st == null || !st.hasMoreElements()) {
				try {
					st = new StringTokenizer(br.readLine());
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
			return st.nextToken();
		}

		int nextInt() {
			return Integer.parseInt(next());
		}

		long nextLong() {
			return Long.parseLong(next());
		}

		double nextDouble() {
			return Double.parseDouble(next());
		}
	}

	public static void main(String[] args) {
		new F().run();
	}
}
