#include <cstdio>
#include <iostream>
#include <cstring>
#include <cassert>
#include <algorithm>

using namespace std;

const int N = 400010;

int n;
int m[2][N];

void modify(int q, int x, int v) {
  while (x <= n) {
    if (v > m[q][x]) {
      m[q][x] = v;
    }
    x = (x | (x - 1)) + 1;
  }
}

int find_max(int q, int x) {
  int v = 0;
  while (x > 0) {
    if (m[q][x] > v) {
      v = m[q][x];
    }
    x &= x - 1;
  }
  return v;
}

int a[N];

int main() {
  freopen("improvements.in", "r", stdin);
  freopen("improvements.out", "w", stdout);
  scanf("%d", &n);
  for (int i = 1; i <= n; i++) {
    scanf("%d", a + i);
    m[1][i] = m[2][i] = 0;
  }
  int ans = 0;
  for (int i = 1; i <= n; i++) {
    int incr = find_max(1, a[i]) + 1;
    int decr = find_max(2, n - a[i] + 1) + 1;
    modify(1, a[i], incr);
    modify(2, n - a[i] + 1, decr);
    if (incr + decr - 1 > ans) {
      ans = incr + decr - 1;
    }
  }
  printf("%d\n", ans);
  return 0;
}
