import java.util.*;
import java.io.*;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.math.RoundingMode;

public class Solver {
	public static void main(String[] args) throws Throwable {		
		BufferedReader br = new BufferedReader(new FileReader("burrito.in"));
		PrintWriter out = new PrintWriter("burrito.out");
		//BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
		//PrintWriter out = new PrintWriter(System.out);				
		
		long n, A, B;
		String[] t = br.readLine().split(" ");
		n = Integer.parseInt(t[0]);
		A = Integer.parseInt(t[1]);
		B = Integer.parseInt(t[2]);
		
		List<Info> infos = new ArrayList<Info>();
		
		for(int i = 0; i < n; ++i) {
			int g, a, b;
			t = br.readLine().split(" ");
			g = Integer.parseInt(t[0]);
			a = Integer.parseInt(t[1]);
			b = Integer.parseInt(t[2]);
			infos.add(new Info(i, g, a, b));
		}
		
		
		
		Collections.sort(infos);
		try {
		Collections.reverse(infos);
		
		BigDecimal sumA = BigDecimal.ZERO, sumB = BigDecimal.ZERO;
		
		
		
		BigDecimal[] ans = new BigDecimal[(int)n];
		for(int i = 0; i < n; ++i) ans[i] = BigDecimal.ZERO;
		
		BigDecimal bigB = BigDecimal.valueOf(B), bigA = BigDecimal.valueOf(A);		
		
		
			
		for(int i = 0; i < n; ++i) {
			Info cur = infos.get(i);
			if (sumB.add( BigDecimal.valueOf( 0.0 + cur.b * cur.g) ).compareTo(bigB) <= 0) {
				
				ans[cur.index] = BigDecimal.valueOf(cur.g);
				
				sumA = sumA.add(BigDecimal.valueOf( 0.0 + cur.a * cur.g));
				sumB = sumB.add(BigDecimal.valueOf( 0.0 + cur.b * cur.g));				
			} else {
				BigDecimal rest = bigB.subtract(sumB);
				
				BigDecimal g;
				if (cur.b == 0) {
					g = BigDecimal.valueOf(cur.g);
				} else {
					g = rest.divide(BigDecimal.valueOf(cur.b), 20, RoundingMode.CEILING);
				}				
				
				sumB = bigB;
				sumA = sumA.add(BigDecimal.valueOf(cur.a).multiply(g)); 
				ans[cur.index] = g;
			}
		}
		
		if (sumA.compareTo(bigA) < 0) {
			out.println("-1 -1");
		} else {
			out.println(sumA.toString() + " " + sumB.toString());
			for (int i = 0; i < n; ++i) {
				out.print(ans[i].toString() + " ");
			}
		}
		} catch(Exception e) {
			out.print("-1 -1");
		}
		out.flush();
	}
		
}

class Info implements Comparable<Info> {
	int g, a, b, index;
	
	Info(int i, int gp, int ap, int bp) {
		this.index = i;
		this.g = gp;
		this.a = ap;
		this.b = bp;			
	}
	
	@Override
	public int compareTo(Info o) {
		return new Integer(a * o.b).compareTo(b * o.a);
	}
}
