import java.util.*;
import java.io.*;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.math.RoundingMode;

public class Solver {
	
	public static ArrayList<Info> tmp;
	
	public static void mergeSort(List<Info> a, int l, int r) {
		if (l >= r)
			return;		
		int m = l + (r - l) / 2;
		mergeSort(a, l, m);
		mergeSort(a, m + 1, r);
		
		for (int i = l; i <= r; i++)
			tmp.set(i, a.get(i));
		int ia = l, ib = m + 1;
		for (int i = l; i <= r; i++) {
			if (ia > m)
				a.set(i, tmp.get(ib++));
			else if (ib > r)
				a.set(i, tmp.get(ia++));
			else if (tmp.get(ia).compareTo(tmp.get(ib)) <= 0)
				a.set(i, tmp.get(ia++));
			else
				a.set(i, tmp.get(ib++));
		}
	}
	
	
	public static void main(String[] args) throws Throwable {		
		BufferedReader br = new BufferedReader(new FileReader("burrito.in"));
		PrintWriter out = new PrintWriter("burrito.out");
		//BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
		//PrintWriter out = new PrintWriter(System.out);				
		
		long n, A, B;
		String[] t = br.readLine().split(" ");
		n = Long.parseLong(t[0]);
		A = Long.parseLong(t[1]);
		B = Long.parseLong(t[2]);
		
		List<Info> infos = new ArrayList<Info>();
		
		for(long i = 0; i < n; ++i) {
			long g, a, b;
			String s = br.readLine();
			if (s == "")
				throw new Exception();
			t = s.split(" ");
			g = Long.parseLong(t[0]);
			a = Long.parseLong(t[1]);
			b = Long.parseLong(t[2]);
			infos.add(new Info(i, g, a, b));
		}
		
		
		
		//Collections.sort(infos);
		tmp = new ArrayList<Info>();
		for (int i = 0; i < infos.size(); i++)
			tmp.add(infos.get(i));
		
		mergeSort(infos, 0, infos.size() - 1);
		try {
		Collections.reverse(infos);
		
		BigDecimal sumA = BigDecimal.ZERO, sumB = BigDecimal.ZERO;
		
		
		
		BigDecimal[] ans = new BigDecimal[(int)n];
		for(long i = 0; i < n; ++i) ans[(int)i] = BigDecimal.ZERO;
		
		BigDecimal bigB = BigDecimal.valueOf(B), bigA = BigDecimal.valueOf(A);		
		
		
			
		for(long i = 0; i < n; ++i) {
			Info cur = infos.get((int)i);
			if (sumB.add( BigDecimal.valueOf( 0.0 + cur.b * cur.g) ).compareTo(bigB) <= 0) {
				
				ans[(int)cur.index] = BigDecimal.valueOf(cur.g);
				
				sumA = sumA.add(BigDecimal.valueOf( 0.0 + cur.a * cur.g));
				sumB = sumB.add(BigDecimal.valueOf( 0.0 + cur.b * cur.g));				
			} else {
				BigDecimal rest = bigB.subtract(sumB);
				
				BigDecimal g;
				if (cur.b == 0) {
					g = BigDecimal.valueOf(cur.g);
				} else {
					g = rest.divide(BigDecimal.valueOf(cur.b), 20, RoundingMode.CEILING);
				}				
				
				sumB = bigB;
				sumA = sumA.add(BigDecimal.valueOf(cur.a).multiply(g)); 
				ans[(int)cur.index] = g;
			}
		}
		
		if (sumA.compareTo(bigA) < 0) {
			out.println("-1 -1");
		} else {
			out.println(sumA.toString() + " " + sumB.toString());
			for (long i = 0; i < n; ++i) {
				out.print(ans[(int)i].toString() + " ");
			}
		}
		} catch(Exception e) {
			out.print("-1 -1");
		}
		out.flush();
	}
		
}

class Info implements Comparable<Info> {
	long g, a, b, index;
	
	Info(long i, long gp, long ap, long bp) {
		this.index = i;
		this.g = gp;
		this.a = ap;
		this.b = bp;			
	}
	
	@Override
	public int compareTo(Info o) {
		long A = (long)a * (long)o.b;
		long B = (long)b * (long)o.a;
		if (A == B) return 0;
		return A > B ? 1 : -1;
	}
}
