#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <ctime>
#include <cctype>
#include <cassert>
#include <iostream>
#include <fstream>
#include <iomanip>
#include <sstream>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <deque>
#include <queue>
#include <functional>
#include <bitset>
#include <cctype>

using namespace std;

#define pb push_back
#define mp make_pair

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef unsigned int uint;
typedef pair<int, int> pii;
typedef vector<int> vi;

template <class T> inline T sqr(const T& a) { return a * a; }
template <class T> inline void updMin(T& a, const T& b) { if (b < a) a = b; }
template <class T> inline void updMax(T& a, const T& b) { if (a < b) a = b; }


struct BitSet
{
	bitset< 1024 > arr;
	int size;
	BitSet(int size_ = 0) {
		size = size_;
	}
	void setSize(int nsize) {
		size = nsize;
	}
	void readInput() {
		int cnt = (size + 4 - 1) / 4;
		for (int i = 0, pos = 0; i < cnt; ++i) {
			char c;
			cin >> c;
			int val = isdigit(c) ? (c - '0') : (10 + c - 'a');
			for (int j = 0; j < 4 && pos < size; ++j, ++pos) {
				arr[pos] = val % 2;
				val /= 2;
			}
		}
	}
	void computeFilter(int *a, int f, int u) {
		for (int i = 0; i < f; ++i) {
			int curVal = 1ll * u * a[i] % size;
			arr[curVal] = 1;
		}
	}
	bool operator==(const BitSet &x) const
	{
		if (size != x.size) {
			return false;
		}
		return arr == x.arr;
	}
};

int main()
{
	//freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#define TASKNAME "filter"
	 freopen(TASKNAME ".in", "r", stdin); freopen(TASKNAME ".out", "w", stdout);

	ios::sync_with_stdio(false);


	int m, f;
	int a[2000];
	cin >> m >> f;
	for (int i = 0; i < f; ++i) {
		cin >> a[i];
	}
	int n;
	cin >> n;
	vector< BitSet > tmp(n);
	for (int i = 0; i < n; ++i) {
		tmp[i].setSize(m);
		tmp[i].readInput();
	}
	int q;
	cin >> q;
	vector< BitSet > qq(q);
	vector< int > ans(n, 0);
	for (int i = 0; i < q; ++i) {
		int id;
		cin >> id;
		qq[i].setSize(m);
		qq[i].computeFilter(a, f, id);
		for (int j = 0; j < n; ++j) {
			if ((qq[i].arr & tmp[j].arr) == qq[i].arr) {
				ans[j] = 1;
			}
		}
	}
	vector< int > res;
	for (int i = 0; i < n; ++i) {
		if (ans[i]) {
			res.push_back(i);
		}
	}
	cout << res.size();
	for (int i = 0; i < int(res.size()); ++i) {
		cout << " " << res[i];
	}
	cout << '\n';
	return 0;
}


