import java.io.*;
import java.util.Arrays;
import java.util.StringTokenizer;

/**
 * Created by neerc on 07.12.2014.
 */
public class B {

    private BufferedReader in;
    private PrintWriter out;
    private StringTokenizer st;

    public static void main(String[] args) throws IOException {
        final B solver = new B();
        solver.open();
        solver.solve();
        solver.close();
    }

    private String nextToken() throws IOException {
        while (st == null || !st.hasMoreElements()) {
            st = new StringTokenizer(in.readLine());
        }
        return st.nextToken();
    }

    private int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    private long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    private double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    private final String filename = "burrito";

    class Comp implements Comparable<Comp>{
        int num;
        int maxKol;
        double curKol=0;
        int a,b;
        double range;

        public Comp(int anum, int amax, int aa, int ab){
            num=anum;
            maxKol=amax;
            a=aa;
            b=ab;
            if (b>0)
                range=(double)a/b;
            else
                range=1e7;
        }

        @Override
        public int compareTo(Comp o) {
            return Double.compare(o.range, range);
        }
    }

    int n;
    long minA, maxB;
    Comp[] comps;

    public void solve() throws IOException {
        n=nextInt();
        minA=nextInt();
        maxB=nextInt();
        comps=new Comp[n];
        Comp[] buf=new Comp[n];
        for (int i=0; i<n; i++){
            comps[i]=new Comp(i,nextInt(),nextInt(), nextInt());
            buf[i]=comps[i];
        }
        Arrays.sort(buf);
        double curA=0;
        double curB=0;
        for (int i=0; i<n; i++){
            double toGet=buf[i].maxKol;
            if (buf[i].b>0)
                toGet=Math.min(toGet, (maxB-curB)/buf[i].b);

            curA+=buf[i].a*toGet;
            curB+=buf[i].b*toGet;
            buf[i].curKol=toGet;
        }

        if (curA<minA)
            out.println("-1 -1");
        else {
            out.print(curA);
            out.print(' ');
            out.println(curB);
            for (int i=0; i<n; i++){
                out.print(comps[i].curKol);
                out.print(' ');
            }
            out.println();
        }
    }

    public void open() throws IOException {
        in = new BufferedReader(new FileReader(filename + ".in"));
        out = new PrintWriter(new FileWriter(filename + ".out"));
//        out = new PrintWriter(System.out);
    }

    public void close() {
        out.flush();
        out.close();
    }

}
