import java.io.*;
import java.util.StringTokenizer;

/**
 * Created by neerc on 07.12.2014.
 */
public class I {

    private BufferedReader in;
    private PrintWriter out;
    private StringTokenizer st;

    public static void main(String[] args) throws IOException {
        final I solver = new I();
        solver.open();
        solver.solve();
        solver.close();
    }

    private String nextToken() throws IOException {
        while (st == null || !st.hasMoreElements()) {
            st = new StringTokenizer(in.readLine());
        }
        return st.nextToken();
    }

    private int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    private long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    private double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    private final String filename = "improvements";

    class Pair {

        int left, right;
        int value;

        public Pair(int aleft, int aright, int avalue) {
            left = aleft;
            right = aright;
            value = avalue;
        }

    }

    int result = 0;
    int n;
    int[] mas;
    Pair[] toLeft, toRight;

    public void solve() throws IOException {
        n = nextInt();
        mas = new int[n];
        for (int i = 0; i < n; i++) {
            mas[i] = nextInt()-1;
        }
        //toLeft = new Pair[n];
        //toRight = new Pair[n];
        SegmentTree toRight=new SegmentTree(n ,true);
        SegmentTree toLeft=new SegmentTree(n, false);

        for (int i = n - 1; i >= 0; i--) {
            int ind=mas[i];
            Pair maxRight=toRight.get(ind+1,n-1);
            if (maxRight==null){
                Pair pair=new Pair(ind,ind,1);
                result=Math.max(result, pair.value);
                toRight.update(ind,pair);
                toLeft.update(ind, pair);
            } else {
                Pair pair=new Pair(ind, maxRight.right, maxRight.value+1);
                result=Math.max(result, pair.value);
                toRight.update(ind, pair);
                toLeft.update(pair.right, pair);
            }

            Pair maxLeft=toLeft.get(0,ind-1);
            if (maxLeft==null){
                Pair pair=new Pair(ind,ind,1);
                result=Math.max(result, pair.value);
                toRight.update(ind,pair);
                toLeft.update(ind, pair);
            } else {
                Pair pair=new Pair(maxLeft.left, ind, maxLeft.value+1);
                result=Math.max(result, pair.value);
                toLeft.update(ind, pair);
                toRight.update(pair.left, pair);
            }
        }
        out.println(result);
    }

    public void open() throws IOException {
        in = new BufferedReader(new FileReader(filename + ".in"));
        out = new PrintWriter(new FileWriter(filename + ".out"));

//        out = new PrintWriter(System.out);
    }

    class SegmentTree {
        final int n;
        final Pair[] tree;
        final boolean leftMost;

        SegmentTree(final int n, boolean leftMost) {
            this.n = n;
            this.tree = new Pair[4 * n];
            this.leftMost = leftMost;
        }

        private void build(int v, int tl, int tr, Pair[] array) {
            if (tl == tr) {
                tree[v] = array[tl];
            } else {
                final int middle = (tl + tr) / 2;
                build(2 * v, tl, middle, array);
                build(2 * v + 1, middle + 1, tr, array);
                tree[v] = merge(tree[2 * v], tree[2 * v + 1]);
            }
        }

        private void update(int v, int tl, int tr, int index, Pair value) {
            if (tl == tr) {
                tree[v] = value;
            } else {
                final int middle = (tl + tr) / 2;
                if (index <= middle)
                    update(2 * v, tl, middle, index, value);
                else
                    update(2 * v + 1, middle + 1, tr, index, value);
                tree[v] = merge(tree[2 * v], tree[2 * v + 1]);
            }
        }

        public void update(int index, Pair value) {
            update(1, 0, n - 1, index, value);
        }

        private Pair get(int v, int tl, int tr, int l, int r) {
            if (l > r)
                return null;
            if (tl == l && tr == r) {
                return tree[v];
            }
            final int middle = (tl + tr) / 2;
            return merge(
                    get(2 * v, tl, middle, l, Math.min(r, middle)),
                    get(2 * v + 1, middle + 1, tr, Math.max(middle + 1, l), r)
            );
        }

        public Pair get(int l, int r) {
            return get(1, 0, n - 1, l, r);
        }

        private Pair merge(Pair left, Pair right) {
            if (left == null)
                return right;
            if (right == null)
                return left;
            if (left.right == right.left-1) {
                return new Pair(left.left, right.right, left.value + right.value);
            }
            if (left.value > right.value) {
                return left;
            } else if (left.value < right.value) {
                return right;
            } else { //left == right
                return leftMost ? left : right;
            }
        }
    }

    public void close() {
        out.flush();
        out.close();
    }

}
