import java.io.*;
import java.util.HashSet;
import java.util.Set;
import java.util.StringTokenizer;
import java.util.TreeSet;

/**
 * Created by neerc on 07.12.2014.
 */
public class J {

    private BufferedReader in;
    private PrintWriter out;
    private StringTokenizer st;

    public static void main(String[] args) throws IOException {
        final J solver = new J();
        solver.open();
        solver.solve();
        solver.close();
    }

    private String nextToken() throws IOException {
        while (st == null || !st.hasMoreElements()) {
            st = new StringTokenizer(in.readLine());
        }
        return st.nextToken();
    }

    private int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    private long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    private double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    private final String filename = "joke";

    int n = 0;
    final Set<Integer>[] places = new Set[]{
            new TreeSet<Integer>(), // 0
            new TreeSet<Integer>(), // 1
            new TreeSet<Integer>(), // 2
            new TreeSet<Integer>(), // 3
            new TreeSet<Integer>(), // 4
            new TreeSet<Integer>(), // 5
    };
    char[] s;
    boolean[] usedPlaces;

    public void solve() throws IOException {
        s = nextToken().toCharArray();

        int length = 0;
        while (length < s.length) {
            n++;
            length += Integer.toString(n).length();
        }

        usedPlaces = new boolean[s.length];

        for (int i = 0; i < s.length; i++) {
            if ('1' <= s[i] && s[i] <= '5') {
                places[s[i] - '0'].add(i);
            }
        }

        if (!dfs(1))
            throw new RuntimeException("Solution was not found");
    }

    private boolean dfs(final int number) {
        if (number == 6) {
            final StringBuilder result = new StringBuilder();
            final Set<Integer> usedInts = new HashSet<Integer>();
            for (int i = 0; i < s.length; i++) {
                int next = -1;
                if (usedPlaces[i] || s[i] >= '6') {
                    next = s[i] - '0';
                } else {
                    if (s[i] == '0' || i == s.length - 1 || usedPlaces[i + 1]) {
                        return false;
                    }
                    next = (s[i] - '0') * 10 + s[i + 1] - '0';
                    i++;
                }
                if (usedInts.contains(next))
                    return false;
                usedInts.add(next);
                result.append(next).append(' ');
            }
            boolean answer = true;
            for (int i = 1; i <= n; i++) {
                answer = answer && usedInts.contains(i);
            }
            if (answer) {
                out.println(result.toString());
                return true;
            } else {
                return false;
            }
        }
        if (places[number].isEmpty()) {
            if (dfs(number + 1))
                return true;
        }
        for (final int i : places[number]) {
            usedPlaces[i] = true;
            if (dfs(number + 1))
                return true;
            usedPlaces[i] = false;
        }
        return false;
    }

    public void open() throws IOException {
        in = new BufferedReader(new FileReader(filename + ".in"));
        out = new PrintWriter(new FileWriter(filename + ".out"));

//        out = new PrintWriter(System.out);
    }

    public void close() {
        out.flush();
        out.close();
    }

}
