import java.io.*;
import java.util.StringTokenizer;

/**
 * Created by neerc on 07.12.2014.
 */
public class K {

    private BufferedReader in;
    private PrintWriter out;
    private StringTokenizer st;

    public static void main(String[] args) throws IOException {
        final K solver = new K();
        solver.open();
        solver.solve();
        solver.close();
    }

    private String nextToken() throws IOException {
        while (st == null || !st.hasMoreElements()) {
            st = new StringTokenizer(in.readLine());
        }
        return st.nextToken();
    }

    private int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    private long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    private double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    private final String filename = "knockout";

    int n,m;
    int[] a,b;

    private void solve() throws IOException {
        n=nextInt();
        m=nextInt();
        a=new int[n];
        b=new int[n];
        for (int i=0; i<n; i++){
            a[i]=nextInt();
            b[i]=nextInt();
        }
        for (int i=0; i<m; i++){
            int left=nextInt();
            int right=nextInt();
            int time=nextInt();
            int result=0;
            for (int j=0; j<n; j++){
                int kolfull=time/(b[j]-a[j]);
                int koord;
                if ((kolfull&1)==0){
                    koord=a[j]+time%(b[j]-a[j]);
                } else
                    koord=b[j]-time%(b[j]-a[j]);

                if (left<=koord && koord<=right)
                    result++;
            }
            out.println(result);
        }
    }

    private void open() throws IOException {
        in = new BufferedReader(new FileReader(filename + ".in"));
        out = new PrintWriter(new FileWriter(filename + ".out"));
        //out = new PrintWriter(System.out);
    }

    private void close() {
        out.flush();
        out.close();
    }

}
