#include <iostream>
#include <cstdio>

#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <bitset>
#include <queue>
#include <stack>

#include <math.h>
#include <string>

#include <memory.h>
#include <time.h>
#include <cassert>

using namespace std;

#define forn(i, n) for(int i = 0; i < (int)(n); i++)
#define fornd(i, n) for(int i = (int)(n - 1); i >= 0; i--)
#define forab(i, a, b) for(int i = (int)(a); i <= (int)(b); i++)
#define forabd(i, b, a) for(int i = (int)(b); i >= (int)(a); i--)
#define pb push_back
#define make_pair mp
#define sz(a) (int)(a).size()
#define _(a, val) memset(a, val, sizeof(a))
#define all(a) (a).begin(), (a).end()

#ifdef MY_DEBUG
#define dbgx(x) {  cerr << #x << " = " << x << endl; }
#define dbg(...){ fprintf(stderr, __VA_ARGS__); fflush(stderr); }
#else
#define dbgx(x) {}
#define dbg(...){}
#endif

typedef long long lint;
typedef unsigned long long ull;
typedef pair<int, int> pii;
typedef double ld;

const int INF = 1000 * 1000 * 1000;
const lint LINF = (lint)INF*(lint)INF;
const ld eps = 1e-9;

void prepare(string s)
{
#ifdef MY_DEBUG
	freopen("input.txt", "r", stdin);
#else
	freopen((s + ".in").c_str(), "r", stdin);
	freopen((s + ".out").c_str(), "w", stdout);
#endif
}

struct my
{
	lint g, a, b;

	my() {}
	my(lint _g, lint _a, lint _b)
	{
		g = _g;
		a = _a;
		b = _b;
	}

	bool operator< (const my &q)
	{
		if (b == 0)
			return false;

		if (q.b == 0)
			return true;

		return a*q.b < b*q.a;
	}
};

int n;
double A, B;
vector<my> v;

void read()
{
	scanf("%d%lf%lf", &n, &A, &B);

	int g, a, b;
	forn(i, n)
	{
		scanf("%d%d%d", &g, &a, &b);
		v.pb(my(g, a, b));
	}
}

void solve()
{
	sort(all(v));

	double _A = 0, _B = 0;
	vector<double> ans;
	fornd(i, n)
	{
		double s = min( (double)v[i].g, (B - _B) / (double)v[i].b );
		_B += s * v[i].b;
		_A += s * v[i].a;
		ans.pb(s);
	}

	if (A > _A)
		printf("-1 -1\n");
	else
	{
		printf("%.12lf %.12lf\n", _A, _B);
		forn(i, n)
		{
			printf("%.12lf ", ans[i]);
		}
		printf("\n");
	}
}

int main()
{
	prepare("burrito");

	read();
	solve();

	return 0;
}