#include <iostream>
#include <cstdio>

#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <bitset>
#include <queue>
#include <stack>

#include <math.h>
#include <string>

#include <memory.h>
#include <time.h>
#include <cassert>

using namespace std;

#define forn(i, n) for(int i = 0; i < (int)(n); i++)
#define fornd(i, n) for(int i = (int)(n - 1); i >= 0; i--)
#define forab(i, a, b) for(int i = (int)(a); i <= (int)(b); i++)
#define forabd(i, b, a) for(int i = (int)(b); i >= (int)(a); i--)
#define pb push_back
#define mp make_pair
#define sz(a) (int)(a).size()
#define _(a, val) memset(a, val, sizeof(a))
#define all(a) (a).begin(), (a).end()

#ifdef MY_DEBUG
#define dbgx(x) {  cerr << #x << " = " << x << endl; }
#define dbg(...){ fprintf(stderr, __VA_ARGS__); fflush(stderr); }
#else
#define dbgx(x) {}
#define dbg(...){}
#endif

typedef long long lint;
typedef unsigned long long ull;
typedef pair<int, int> pii;
typedef double ld;

const int INF = 1000 * 1000 * 1000;
const lint LINF = (lint)INF*(lint)INF;
const ld eps = 1e-9;

void prepare(string s)
{
#ifdef MY_DEBUG
	freopen("input.txt", "r", stdin);
#else
	freopen((s + ".in").c_str(), "r", stdin);
	freopen((s + ".out").c_str(), "w", stdout);
#endif
}

const int NMAX = 505;
const int FILE_MAX = 2005;

int m, f, n;
int a[NMAX];
int bloom[FILE_MAX][FILE_MAX];
char s[FILE_MAX*NMAX];
int q[FILE_MAX];
int nq;

int get(char c)
{
	if (c <= '9')
		return c - '0';
	return c - 'a' + 10;
}

int gb(int msk, int b)
{
	return (msk >> b) & 1;
}

void get(int id)
{
	int len = strlen(s);
	for(int i = 0; i < len; i++)
	{
		int t = get(s[i]);
		forn(j, 4)
			bloom[id][i*4 + j] = gb(t, j);
	}
}

void read()
{
	scanf("%d %d", &m, &f);
	forn(i, f)
		scanf("%d", &a[i]);

	scanf("%d", &n);
	forn(i, n)
	{
		scanf(" %s", s);
		get( i );
	}

	scanf("%d", &nq);
	forn(i, nq)
		scanf("%d", &q[i]);
}

int ans[FILE_MAX];
int id_ans;

int check3(int id_file, int id, int id_f)
{
	int k = a[id_f] % m;
	k = (k * (q[id] % m)) % m;
	return bloom[id_file][k];
}

bool check2(int id_file, int id)
{
	forn(i, f)
	{
		if (!check3(id_file, id, i))
			return false;
	}
	return true;
}

bool check(int id)
{
	forn(i, nq)
	{
		if (check2(id, i))
		{
			return true;
		}
	}
	return false;
}

void solve()
{
	id_ans = 0;
	forn(i, n)
	{
		if (check(i))
			ans[id_ans ++] = i;
	}

	printf("%d", id_ans);
	forn(i, id_ans)
	{
		printf(" %d", ans[i]);
	}
	printf("\n");
}

int main()
{
	prepare("filter");

	read();
	solve();

	return 0;
}