#include <iostream>
#include <cstdio>

#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <bitset>
#include <queue>
#include <stack>

#include <math.h>
#include <string>

#include <memory.h>
#include <time.h>
#include <cassert>

using namespace std;

#define forn(i, n) for(int i = 0; i < (int)(n); i++)
#define fornd(i, n) for(int i = (int)(n - 1); i >= 0; i--)
#define forab(i, a, b) for(int i = (int)(a); i <= (int)(b); i++)
#define forabd(i, b, a) for(int i = (int)(b); i >= (int)(a); i--)
#define pb push_back
#define make_pair mp
#define sz(a) (int)(a).size()
#define _(a, val) memset(a, val, sizeof(a))
#define all(a) (a).begin(), (a).end()

#ifdef MY_DEBUG
#define dbgx(x) {  cerr << #x << " = " << x << endl; }
#define dbg(...){ fprintf(stderr, __VA_ARGS__); fflush(stderr); }
#else
#define dbgx(x) {}
#define dbg(...){}
#endif

typedef long long lint;
typedef unsigned long long ull;
typedef pair<int, int> pii;
typedef double ld;

const int INF = 1000 * 1000 * 1000;
const lint LINF = (lint)INF*(lint)INF;
const ld eps = 1e-9;

void prepare(string s)
{
#ifdef MY_DEBUG
	freopen("input.txt", "r", stdin);
#else
	freopen((s + ".in").c_str(), "r", stdin);
	freopen((s + ".out").c_str(), "w", stdout);
#endif
}

const int NMAX = 155;
char s[NMAX];
int d[NMAX];
int n, c;
int used[NMAX];

void read()
{
	scanf("%s", s);
}

bool check()
{
	lint msk = (1 << min(c, 9)) - 1;
	for(int i = 0; i < n; )
	{
		if (used[i] == 0)
		{
			if (i + 1 >= n && used[i + 1] != 0)
				return false;

			used[i] = 2;
			used[i + 1] = 0;
			msk |= 1LL << (d[i]*10 + d[i + 1] - 1);
			i += 2;
		}
		else
			i ++;
	}
	if (msk + 1 != (1LL << c))
	{
		forn(i, n)
			if (used[i] == 2)
				used[i] = 0;
		return false;
	}
	return true;
}

bool go(int dig)
{
	if (dig == min(c + 1, 10))
		return check();

	for(int i = 0; i < n; i++) if (used[i] == 0)
	{
		if (d[i] == dig)
		{
			used[i] = 1;
			if (go( dig + 1 ))
				return true;
			used[i] = 0;
		}
	}
	return false;
}

void solve()
{
	n = strlen(s);

	c = 1;
	int cnt = 0;
	for(int i = 1; ; i++)
	{
		if (i < 10)
			cnt ++;
		else
			cnt += 2;
		if (cnt == n)
			break;
		c ++;
	}

	forn(i, n)
		d[i] = s[i] - '0';

	_(used, 0);
	assert(go( 1 ));

	for(int i = 0; i < n; )
	{
		if (used[i] == 1)
		{
			printf("%d ", d[i]);
			i ++;
		}
		else
		{
			printf("%d ", d[i]*10 + d[i + 1]);
			i += 2;
		}
	}
	printf("\n");
}

void gen()
{
	freopen("input.txt", "w", stdout);
	n = 50;
	int a[50];
	forn(i, n)
		a[i] = i + 1;
	random_shuffle(a, a + 50);

	for(int i = 1; i <= n; i++)
		printf("%d", a[i - 1]);
	printf("\n");
}

int main()
{
	prepare("joke");

	read();
	solve();

	return 0;
}