#include <iostream>
#include <cstdio>
#include <string>
#include <vector>
#include <set>
#include <algorithm>
#include <bitset>

using namespace std;

const int maxn = 1024;

int m, f, a[maxn];
int n;
string s[maxn];
int q, u[maxn];
bitset<1024> file[maxn], user[maxn];

vector<char> parse(int u) {
	vector<char> v(m, 0);
	for (int i = 0; i < f; i++) v[1LL * a[i] * u % m] = 1;
	return v;
}

int g(char c) {
	if (c >= '0' && c <= '9') return c - '0';
	return c - 'a' + 10;
}

vector<char> parse(string &s) {
	vector<char> res(m + 5, 0);
	for (int i = 0; i < (int)s.length(); i++) {
		int k = g(s[i]);
		for (int j = 0; j < 4; j++) {
			res[i * 4 + j] = (k >> j) & 1;
		}
	}
	res.resize(m);
	return res;
}

int main() {
	freopen("filter.in", "r", stdin);
	freopen("filter.out", "w", stdout);

	cin >> m >> f;
	for (int i = 0; i < f; i++) cin >> a[i];
	cin >> n;
	for (int i = 0; i < n; i++) cin >> s[i];
	cin >> q;
	for (int i = 0; i < q; i++) {
		cin >> u[i];
		vector<char> cur = parse(u[i]);
		for (int j = 0; j < m; j++) user[i].set(j, cur[j]);
	}

	vector<int> ans;
	for (int i = 0; i < n; i++) {
		vector<char> cur = parse(s[i]);
		for (int j = 0; j < m; j++) file[i].set(j, cur[j]);

		bool ok = false;
		for (int j = 0; j < q && !ok; j++) {
			bitset<1024> c = user[j];
			int cnt = c.count();
			c &= file[i];
			ok |= c.count() == cnt;
		}
		if (ok) ans.push_back(i);
	}
	cout << ans.size();
	for (int i = 0; i < (int)ans.size(); i++) cout << " " << ans[i];
	cout << endl;

	return 0;
}