#pragma comment(linker, "/STACK:64000000")

#include <iostream>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <ctime>
#include <sstream>
#include <string>
#include <cassert>
#include <cstring>
#include <queue>

#define forn(i, n) for (int i = 0; i < (int)(n); ++i)
#define for1(i, n) for (int i = 1; i <= (int)(n); ++i)
#define mp make_pair
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

using namespace std;

typedef vector<int> vi;
typedef vector<vi> vvi;
typedef pair<int, int> pii;
typedef vector<pii> vpi;
typedef long long i64;
typedef vector<i64> vi64;
typedef vector<vi64> vvi64;
typedef double ld;

const char* STR = "RPS";

int fromchar(char c) {
	forn(i, 3) if (STR[i] == c) return i;
	assert(false);
}

int win(int i) {
	return (i + 1) % 3;
}

struct st {
	int out;
	int go[3];
};

struct fsm {
	map<int, st> m;
} a, b, c;
int n;
const int N = 105;
int neq[N][N];
int lneq[N][N];

void init_neq() {
	map<pii, vector<pii> > ng[3];
	forn(i, n) forn(j, n) if (i != j) forn(t, 3) if (a.m[i].go[t] != a.m[j].go[t])
		ng[t][mp(a.m[i].go[t], a.m[j].go[t])].pb(mp(i, j));
	forn(i, n) forn(j, n) neq[i][j] = -2;
	forn(i, n) forn(j, n) lneq[i][j] = -1;
	queue<pii> Q;
	forn(j, n) forn(i, n) if( a.m[i].out != a.m[j].out ) {
		Q.push(mp(j, i));
		neq[i][j] = -1;
		lneq[i][j] = 0;
	}
	while (!Q.empty()) {
		pii ij = Q.front(); Q.pop();
		forn(t, 3) {
			for (pii e : ng[t][ij]) {
				if (neq[e.first][e.second] == -2) {
					neq[e.first][e.second] = t;
					lneq[e.first][e.second] = lneq[ij.first][ij.second] + 1;
					Q.push(e);
				}
			}
		}
	}
}

template<typename T>
bool uax(T& a, const T& b) {
	if (a < b ) { a = b; return true; }
	return false;
}


template<typename T> 
bool uin(T& a, const T& b) {
	if (b < a) { a = b; return true; }
	return false;
}

template<typename T> 
void sunique(vector<T>& v) {
	sort(all(v));
	v.resize(unique(all(v)) - v.begin());
}

int free_b = 0;
int go_brute(vi sts) {
	if (sts.empty()) return -1;
	int sx = -1, sy = -1, mxy = 1e9;
	forn(i, sts.size()) forn(j, i) {
		int x = sts[i], y = sts[j];
		if (lneq[x][y] != -1) {
			if (uin(mxy, lneq[x][y])) {
				sx = x; sy = y;
			}
		}
	}
	if (sx == -1) {
		return -1-sts[0];
	}
	vector<int> mstr;
	while (neq[sx][sy] != -1) {
		int t = neq[sx][sy];
		mstr.pb(t);
		sx = a.m[sx].go[t];
		sy = a.m[sy].go[t];
	}
	forn(i, mstr.size()) {
		st x;
		x.out = mstr[i];
		forn(j, 3) x.go[j] = free_b + i + 1;
		b.m[free_b + i] = x;
	}
	int res_v = free_b;
	forn(i, sts.size()) {
		int x = sts[i];
		forn(j, mstr.size())
			x = a.m[x].go[mstr[j]];
		sts[i] = x;
	}
	sunique(sts);
	if (mstr.empty()) {
		int minmax = 1e9, toutans = -1;
		forn(tout, 3) {
			vi csts[3];
			forn(j, 3) for (int x : sts) {
				csts[a.m[x].out].pb(a.m[x].go[tout]);
			}
			int mxsz = 0;
			forn(j, 3) uax(mxsz, (int)csts[j].size());
			if (uin(minmax, mxsz)) {
				toutans = tout;
			}
		}
		free_b += 1;
		int last = free_b - 1;
		b.m[last].out = toutans;
		forn(t, 3) {
			vi csts;
			for (int x : sts) if (a.m[x].out == t) {
				csts.pb(a.m[x].go[toutans]);
			}
			b.m[last].go[t] = go_brute(csts);
		}
	}
	else {
		free_b += mstr.size();
		int last = free_b - 1;
		/*forn(j, 3) {
			vi csts;
			for (int x : sts) if (a.m[x].out == j)
				csts.pb(x);
			b.m[last].go[j] = go_brute(csts);
		}*/
		forn(j, 3) b.m[last].go[j] = go_brute(sts);
	}
	return res_v;
}

void output(const fsm& in, int start_id, fsm& out) {
	map<int, int> perm;
	assert(in.m.find(start_id) != in.m.end());
	int fb = 1;
	for (auto e : in.m) {
		if (e.first == start_id) {
			perm[e.first] = 0;
		}
		else {
			perm[e.first] = fb++;
		}
	}
	for (auto e : in.m) {
		st x = e.second;
		x.go[0] = perm[x.go[0]];
		x.go[1] = perm[x.go[1]];
		x.go[2] = perm[x.go[2]];
		out.m[perm[e.first]] = x;
	}
}

void checker(fsm& a, int i, fsm& b, int j) {
	while (j >= 0) {
		int ao = a.m[i].out;
		int bo = b.m[j].out;
		i = a.m[i].go[bo];
		j = b.m[j].go[ao];
	}
	assert(i == -1 - j);
}

void solve() {
	cin >> n;
	forn(i, n) {
		st s;
		char c;
		cin >> c;
		forn(j, 3) {
			cin >> s.go[j];
			s.go[j] -= 1;
		}
		s.out = fromchar(c);
		a.m[i] = s;
	}
	init_neq();
#ifdef HOME
	cout << "lneq\n";
	forn(i, n) forn(j, n) {
		cout << lneq[i][j] << " \n"[j + 1 == n];
	}
	cout << "neq\n";
	forn(i, n) forn(j, n) {
		cout << neq[i][j] << " \n"[j + 1 == n];
	}
#endif
	forn(i, n) {
		st s;
		s.out = win(a.m[i].out);
		forn(j, 3) s.go[j] = -1;
		s.go[a.m[i].out] = -1-a.m[i].go[s.out];
		b.m[-1 - i] = s;
	}
	vi id(n);
	forn(i, n) id[i] = i;
	int res = go_brute(id);
#ifdef HOME
	cout << "fsm b=\n";
	for (auto e : b.m) {
		cout << e.first << ':';
		cout << e.second.out << "(R" << e.second.go[0] << "P" << e.second.go[0] << "S" << e.second.go[0] << ")\n";
	}
#endif
	output(b, res, c);
	assert(c.m.size() <= 50000);
	cout << c.m.size() << '\n';
	forn(i, c.m.size()) {
		cout << STR[c.m[i].out] << ' ' << 1+c.m[i].go[0] << ' ' << 1+c.m[i].go[1] << ' ' << 1+c.m[i].go[2] << '\n';
	}
#ifdef HOME
	forn(i, a.m.size())
		checker(a, i, b, res);
#endif
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.precision(15);
    cout << fixed;
#define TASK "epic"
#ifdef HOME
    freopen("input.txt", "rt", stdin);
#else 
    freopen(TASK".in", "rt", stdin);
    freopen(TASK".out", "wt", stdout);
#endif
	solve();
#ifdef HOME
    cerr << "Time elapsed: " << 1.0 * clock() / CLOCKS_PER_SEC << " sec.\n";
#endif
    return 0;
}
