#pragma comment(linker, "/STACK:64000000")

#include <iostream>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <ctime>
#include <sstream>
#include <string>
#include <cstring>

#define forn(i, n) for (int i = 0; i < (int)(n); ++i)
#define fore(i, a, b) for (int i = (int)(a); i <= (int)(b); ++i)
#define for1(i, n) for (int i = 1; i <= (int)(n); ++i)
#define mp make_pair
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

using namespace std;

typedef vector<int> vi;
typedef vector<vi> vvi;
typedef pair<int, int> pii;
typedef vector<pii> vpi;
typedef long long i64;
typedef vector<i64> vi64;
typedef vector<vi64> vvi64;
typedef double ld;

typedef unsigned long long u64;

const int N = 1024 / 64;

struct bset {	
	u64 a[N];
	void clear() {
		forn(i, N) a[i] = 0;
	}
	void set(int pos) {
		a[pos / 64] |= 1ull << (pos % 64);
	}
	bool test(int pos) const {
		return (a[pos / 64] >> (pos % 64)) & 1ull;
	}
} a[1010];

bool issub(const bset& a, const bset& b) {
	forn(i, N) if ((a.a[i] & b.a[i]) != a.a[i])
		return false;
	return true;
}

void solve()
{
	int m, f;
	cin >> m >> f;
	vi af(f);
	forn(i, f) {
		cin >> af[i];
		af[i] %= m;
	}
	int n;
	cin >> n;
	fore(i, 1, n) {
		string s;
		cin >> s;
		forn(j, s.length()) {
			int x;
			if (s[j] >= '0' && s[j] <= '9') x = s[j] - '0';
			else x = s[j] - 'a' + 10;
			forn(t, 4) if ((x >> t) & 1) {
				a[i].set(4 * j + t);
			}
		}
	}
	int q;
	cin >> q;
	vector<bool> vans(n, false);
	forn(_i, q) {
		int mq;
		cin >> mq;
		mq %= m;
		a[0].clear();
		forn(i, f) {
			a[0].set((mq * af[i]) % m);
		}
		fore(i, 1, n) {
			if (issub(a[0], a[i])) {
				vans[i-1] = true;
			}
		}
	}
	vi ans;
	forn(i, n) if (vans[i]) ans.pb(i);
	cout << ans.size();
	for (int x : ans) cout << ' ' << x;
	cout << '\n';

}

#define TASK "filter"
int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.precision(15);
    cout << fixed;
#ifdef HOME
    freopen("input.txt", "rt", stdin);
#else 
    freopen(TASK".in", "rt", stdin);
    freopen(TASK".out", "wt", stdout);
#endif
	solve();

#ifdef HOME
    cerr << "Time elapsed: " << 1.0 * clock() / CLOCKS_PER_SEC << " sec.\n";
#endif
    return 0;
}
