#pragma comment(linker, "/STACK:64000000")

#include <iostream>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <ctime>
#include <sstream>
#include <string>
#include <cstring>

#define forn(i, n) for (int i = 0; i < (int)(n); ++i)
#define for1(i, n) for (int i = 1; i <= (int)(n); ++i)
#define mp make_pair
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

using namespace std;

typedef vector<int> vi;
typedef vector<vi> vvi;
typedef pair<int, int> pii;
typedef vector<pii> vpi;
typedef long long i64;
typedef vector<i64> vi64;
typedef vector<vi64> vvi64;
typedef double ld;

const int MAXN = 300000;
int fenw[MAXN];

int getm(int i) {
    int res = 0;
    while (i >= 0) {
        res = max(res, fenw[i]);
        i = i & (i + 1); --i;
    }
    return res;
}

void setm(int i, int x) {
    while (i < MAXN) {
        fenw[i] = max(fenw[i], x);
        i = i | (i + 1);
    }
}

vi increase(const vi &a) {
    int N = a.size();
    vi res(N + 1);
    forn(i, MAXN) fenw[i] = 0;
    forn(i, N) {
        res[i + 1] = getm(a[i]) + 1;
        setm(a[i], res[i + 1]);
    }
    forn(i, N) res[i + 1] = max(res[i], res[i + 1]);
    return res;
}

#define TASK "improvements"

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.precision(15);
    cout << fixed;
#ifdef HOME
    freopen("input.txt", "rt", stdin);
#else 
    freopen(TASK".in", "rt", stdin);
    freopen(TASK".out", "wt", stdout);
#endif

    int N;
    cin >> N;
    vi p(N);
    forn(i, N) {    
        cin >> p[i];
        --p[i];
    }

    vi a(N), b(N);
    forn(i, N) {
        a[p[i]] = i;
    }
    forn(i, N) {
        b[i] = a[i];
    }
    reverse(all(b));
    vi ra = increase(a), rb = increase(b);

/*    forn(i, ra.size()) cerr << ra[i] << ' ';
    cerr << '\n';
    forn(i, ra.size()) cerr << rb[i] << ' ';
    cerr << '\n';*/
    
    int ans = 0;
    forn(i, N + 1) ans = max(ans, ra[i] + rb[N - i]);
    cout << ans << '\n';

#ifdef HOME
    cerr << "Time elapsed: " << 1.0 * clock() / CLOCKS_PER_SEC << " sec.\n";
#endif
    return 0;
}
