#pragma comment(linker, "/STACK:64000000")

#include <iostream>
#include <cassert>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <ctime>
#include <sstream>
#include <string>
#include <cstring>

#define forn(i, n) for (int i = 0; i < (int)(n); ++i)
#define for1(i, n) for (int i = 1; i <= (int)(n); ++i)
#define mp make_pair
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

using namespace std;

typedef vector<int> vi;
typedef vector<vi> vvi;
typedef pair<int, int> pii;
typedef vector<pii> vpi;
typedef long long i64;
typedef vector<i64> vi64;
typedef vector<vi64> vvi64;
typedef double ld;

const int MAXN = 500;

struct TEdge {
    int to, c, w;
    TEdge(int to = 0, int c = 0, int w = 0)
        : to(to)
        , c(c)
        , w(w)
    {
    }
};

vi e[MAXN];
int vis[MAXN];
vector<TEdge> edges;

void addEdge(int from, int to, int c) {
    e[from].pb(edges.size());
    edges.pb(TEdge(to, c));
    e[to].pb(edges.size());
    edges.pb(TEdge(from, 0));
}

bool dfs(int v, int to) {
    if (v == to) return true;
    if (vis[v]) return false;
    vis[v] = 1;
    for (int u: e[v]) {
        TEdge w = edges[u];
        if (w.w == w.c) continue;
        if (dfs(w.to, to)) {
            ++edges[u].w;
            --edges[u ^ 1].w;
            return true;
        }
    }
    return false;
}

void dfs2(int v) {
    if (vis[v]) return;
    vis[v] = 1;
    for (int u: e[v]) {
        TEdge w = edges[u];
        if (w.w != 1) continue;
        dfs2(w.to);
    }
}

#define TASK "joke"

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.precision(15);
    cout << fixed;
#ifdef HOME
    freopen("input.txt", "rt", stdin);
#else 
    freopen(TASK".in", "rt", stdin);
    freopen(TASK".out", "wt", stdout);
#endif

    string s;
    cin >> s;
    int N = s.size();
    if (N < 10) {
        forn(i, N) cout << s[i] << ' ';
        cout << '\n';
        return 0;
    }
    int M = 9 + (N - 9) / 2;
    int S = 0, T = 1;
    int off1 = 2;
    forn(i, N) addEdge(S, off1 + i, 1);
    int off2 = off1 + N;
    forn(i, N - 1) {
        addEdge(off1 + i, off2 + i, 1);
        addEdge(off1 + i + 1, off2 + i, 1);
    }
    int off3 = off2 + N - 1;
    forn(i, N - 1) {
        if (s[i] == '0') continue;
        int x = 10 * (s[i] - '0') + (s[i + 1] - '0');
        if (x > M) continue;
        addEdge(off2 + i, off3 + x - 10, 1);
    }
    forn(i, M - 9) addEdge(off3 + i, T, 1);
    int K = off3 + M - 9;
    forn(i, M - 9) {
        forn(j, K) vis[j] = 0;
        assert(dfs(0, 1));
    }
    forn(j, K) vis[j] = 0;
    dfs2(0);
    forn(i, N) {
        cout << s[i];
        if (i < N && !vis[off2 + i]) cout << ' ';
    }
    cout << '\n';

#ifdef HOME
    cerr << "Time elapsed: " << 1.0 * clock() / CLOCKS_PER_SEC << " sec.\n";
#endif
    return 0;
}
