#pragma comment(linker, "/STACK:64000000")

#include <iostream>
#include <cassert>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <ctime>
#include <sstream>
#include <string>
#include <cstring>

#define forn(i, n) for (int i = 0; i < (int)(n); ++i)
#define for1(i, n) for (int i = 1; i <= (int)(n); ++i)
#define mp make_pair
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

using namespace std;

typedef vector<int> vi;
typedef vector<vi> vvi;
typedef pair<int, int> pii;
typedef vector<pii> vpi;
typedef long long i64;
typedef vector<i64> vi64;
typedef vector<vi64> vvi64;
typedef double ld;

#define TASK "joke"

i64 mask[100][100];
int d[100];

void rec(int l, int r, int left, i64 m, vi p, vector< pair<i64, vi> > &res) {
    if (left == 0) {
        i64 mm = mask[l][r];
        if (mm == -1 || (m & mm)) {}
        else res.pb(mp(m | mm, p));
        return;
    }
    for (int i = l; i < r; i += 2) {
        if (mask[l][i] == -1 || d[i] == 0) continue;
        i64 mm = mask[l][i] | (1LL << d[i]);
        if (m & mm) continue;
        p.pb(i);
        rec(i + 1, r, left - 1, m | mm, p, res);
        p.pop_back();
    }
}

bool cut[100];

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.precision(15);
    cout << fixed;
#ifdef HOME
    freopen("input.txt", "rt", stdin);
#else 
    freopen(TASK".in", "rt", stdin);
    freopen(TASK".out", "wt", stdout);
#endif

    string s;
    cin >> s;
    int N = s.size();
    forn(i, N) d[i] = s[i] - '0';
    if (N < 10) {
        forn(i, N) cout << s[i] << ' ';
        cout << '\n';
        return 0;
    }
    int M = 9 + (N - 9) / 2;
    forn(i, N + 1) mask[i][i] = 0;
    forn(r, N + 1) forn(l, r) {
        mask[l][r] = -1;
        if ((r - l) & 1) {
            continue;
        }
        i64 m = 0;
        bool ok = true;
        for (int i = l; i < r; i += 2) {
            int x = 10 * d[i] + d[i + 1];
            if (x < 10 || x > M || (m & (1LL << x))) {
                ok = false;
                break;
            }
            m |= (1LL << x);
        }
        if (ok) mask[l][r] = m;
    }
    forn(p, N) {    
        if (d[p] == 0) continue;
        vector< pair<i64, vi> > leftPart, rightPart;
        vi q;

        rec(0, p, 4, 0, q, leftPart);
        rec(p + 1, N, 4, 0, q, rightPart);
        sort(all(leftPart));
        sort(rall(rightPart));
        i64 sum = (2LL << M) - 2 - (1LL << d[p]);
        int i = 0, j = 0;
        bool ok = false;
        while (i < leftPart.size() && j < rightPart.size()) {
            i64 x = leftPart[i].first + rightPart[j].first;
            if (x == sum) {
                ok = true;
                break;
            }
            if (x < sum) ++i;
            else ++j;
        }
        if (ok) {
            vi digs;
            digs.pb(p);
            for (int x: leftPart[i].second) digs.pb(x);
            for (int x: rightPart[j].second) digs.pb(x);
            sort(all(digs));
            digs.pb(-1);
            int z = 0;
            int l = -1;
            forn(k, N) {
                cout << d[k];
                if (k == digs[z]) {
                    l = k;
                    cout << ' ';
                    ++z;
                } else if ((k - l) % 2 == 0) {
                    cout << ' ';
                }
            }
            cout << '\n';
            return 0;
        }
    }
    assert(false);

#ifdef HOME
    cerr << "Time elapsed: " << 1.0 * clock() / CLOCKS_PER_SEC << " sec.\n";
#endif
    return 0;
}
