#include <iostream>
#include <vector>
#include <algorithm>
#include <cstdio>
using namespace std;

typedef long double ld;

struct Ingred
{
	int id;
	int g, a, b;

	bool operator<(Ingred y)
	{
		return (a - b) > (y.a - y.b);
	}

};


int main()
{
	freopen("burrito.in", "r", stdin);
	freopen("burrito.out", "w", stdout);
	int n, A, B;
	cin >> n >> A >> B;
	vector<Ingred> v(n);
	vector<ld> res(n, 0);
	for (int i = 0; i < n; ++i)
	{
		cin >> v[i].g >> v[i].a >> v[i].b;
		v[i].id = i;
	}
	sort(v.begin(), v.end());
	int j = 0;
	ld hap = 0, unhap = 0;
	while (j < n && unhap < B)
	{
		ld temp = min((ld)v[j].g, (B - unhap) / v[j].b);
		hap += temp*v[j].a;
		unhap += temp*v[j].b;
		res[v[j].id] = temp;
		j++;
	}
	if (hap < A)
		cout << "-1 -1" << endl;
	else
	{
		cout.precision(9);
		cout << hap << ' ' << unhap << endl;
		for (int i = 0; i < n; ++i)
			cout << res[i] << ' ';
	}
	return 0;
}