#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <cstdio>
using namespace std;

typedef long double ld;
const ld INF = 1 << 30;

struct Ingred
{
	int id;
	ld g, a, b;

	bool operator<(Ingred y)
	{
		ld z1 = b ? a / b : INF;
		ld z2 = y.b ? y.a / y.b : INF;
		return z1 > z2;
	}

};


int main()
{
	freopen("burrito.in", "r", stdin);
	freopen("burrito.out", "w", stdout);
	int n, A, B;
	cin >> n >> A >> B;
	vector<Ingred> v(n);
	vector<ld> res(n, 0);
	for (int i = 0; i < n; ++i)
	{
		cin >> v[i].g >> v[i].a >> v[i].b;
		v[i].id = i;
	}
	sort(v.begin(), v.end());
	int j = 0;
	ld hap = 0, unhap = 0;
	while (j < n)
	{
		ld temp = min((ld)v[j].g, v[j].b?(B - unhap) / v[j].b:INF);
		hap += temp*v[j].a;
		unhap += temp*v[j].b;
		res[v[j].id] = temp;
		j++;
	}
	if (hap < A)
		cout << "-1 -1" << endl;
	else
	{
		cout.precision(12);
		cout << hap << ' ' << unhap << endl;
		for (int i = 0; i < n; ++i)
			cout << res[i] << ' ';
	}
	return 0;
}