#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <string>
#include <cstdio>
#include <set>
#include <list>
using namespace std;

typedef long double ld;
typedef unsigned long long ull;
const ld INF = 1 << 30;

int m, f;

int pos(char c)
{
	if (c >= '0' && c <= '9')
		return c - '0';
	else return c - 'a' + 10;
}

string trans(string s)
{
	string pattern[16] = {"0000", "1000", "0100", "1100", "0010", "1010", "0110", "1110",
							"0001", "1001", "0101", "1101", "0011", "1011", "0111", "1111"};
	string res = "";
	for (int i = 0; i < s.size()-1; ++i)
	{
		if (s[i] >= '0' && s[i] <= '9')
			res += pattern[s[i] - '0'];
		else res += pattern[s[i] - 'a' + 10];
	}
	if (m % 4 != 0)
	{
		res += pattern[pos(s[s.size() - 1])].substr(0, m%4);
	}
	else res += pattern[pos(s[s.size() - 1])];
	return res;
}

int main()
{
	freopen("filter.in", "r", stdin);
	freopen("filter.out", "w", stdout);
	cin >> m >> f;
	vector<ull> a(f);
	for (int i = 0; i < f; ++i)
		cin >> a[i];
	int n;
	cin >> n;
	vector<string> d(n);
	for (int i = 0; i < n; ++i)
		cin >> d[i];
	int q;
	cin >> q;
	vector<ull> u(q);
	for (int i = 0; i < q; ++i)
		cin >> u[i];
	for (int i = 0; i < n; ++i)
		d[i] = trans(d[i]);

	set<int> resFiles;
	for (int i = 0; i < q; ++i)
	{
		vector<ull> hash(f);
		for (int j = 0; j < f; ++j)
			hash[j] = (u[i] * a[j]) % m;
		for (int j = 0; j < n; ++j)
		{
			bool ok = true;
			for (int k = 0; k < f; ++k)
				if (d[j][hash[k]] == '0')
					ok = false;
			if (ok)
				resFiles.insert(j);
		}
	}
	cout << resFiles.size();
	for (auto p : resFiles)
		cout << ' ' << p;
	return 0;
}