#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <string>
#include <cstdio>
#include <set>
#include <list>
using namespace std;

typedef long double ld;
typedef unsigned long long ull;
const ld INF = 1 << 30;

#define mp(x,y) make_pair(x, y)

vector<pair<int, int> > seg;

struct Bound
{
	int x;
	bool type; //true-left, false-right
	int idSeg;

	Bound()
	{}

	Bound(int x, bool type, int idSeg) : x(x), type(type), idSeg(idSeg)
	{}

	bool operator<(Bound b)
	{
		if (x != b.x) return x<b.x;
		if (type == true && b.type == true)
		{
			return seg[idSeg].second > seg[b.idSeg].second;
		}
		if (type == false && b.type == false)
		{
			return seg[idSeg].first > seg[b.idSeg].first;
		}
		if (type == false && b.type == true)
			return true;
		else return false;
	}
};

int main()
{
	freopen("improvements.in", "r", stdin);
	freopen("improvements.out", "w", stdout);
	int n;
	cin >> n;
	seg.resize(n);
	vector<Bound> v(2 * n);
	int prevPos = 0;
	for (int i = 0; i < n; ++i)
	{
		int curPos;
		cin >> curPos;
		if (curPos < prevPos)
		{
			v[2 * i] = Bound(curPos, true, i);
			v[2 * i + 1] = Bound(prevPos, false, i);
			seg[i] = mp(curPos, prevPos);
		}
		else
		{
			v[2 * i] = Bound(prevPos, true, i);
			v[2 * i + 1] = Bound(curPos, false, i);
			seg[i] = mp(prevPos, curPos);
		}
		prevPos = curPos;
	}
	sort(v.begin(), v.end());
	/*for (int i = 0; i < v.size(); ++i)
		cout << v[i].idSeg+1;
	cout << endl;*/
	vector<int> st;
	set<int> res;
	vector<bool> used(n, false);
	for (int i = 0; i < v.size(); ++i)
	{
		if (!used[v[i].idSeg])
		{
			used[v[i].idSeg] = true;
			st.push_back(v[i].idSeg);
		}
		else
		{
			int p = st.size() - 1;
			while (st[p] != v[i].idSeg)
				p--;
			if (p == st.size()-1)
			{
				st.pop_back();
			}
			else
			{
				int delta = st.size() - p - 1;
				res.insert(v[i].idSeg);
				for (int j = i; j < i + delta; ++j)
					swap(v[j], v[j + 1]);
				i--;
			}
		}
	}
	cout << n - res.size() << endl;
	return 0;
}