
import java.util.*;
import java.io.*;

import static java.lang.Math.*;

public class A {

	final boolean ONLINE_JUDGE = !new File("input.txt").exists();
	
	BufferedReader in;
	PrintWriter out;
	StringTokenizer tok = new StringTokenizer("");
	
	public static void main(String[] args) {
		new A().run();
	}
	
	public void run() {
		try {
			long t1 = System.currentTimeMillis();
			
			init();
			solve();
			
			out.close();
			
			long t2 = System.currentTimeMillis();
			System.err.println(t2 - t1);
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(-1);
		}
	}
	
	public void init() throws IOException {
		String fileName = "alter";
		if (fileName.isEmpty()) {
			throw new RuntimeException();
		}
		
		if (ONLINE_JUDGE) {
			in = new BufferedReader(new FileReader(fileName + ".in"));
			out = new PrintWriter(fileName + ".out");
		} else {
			in = new BufferedReader(new FileReader("input.txt"));
			out = new PrintWriter("output.txt");
		}
	}
	
	public String readString() throws IOException {
		while (!tok.hasMoreTokens()) {
			tok = new StringTokenizer(in.readLine());
		}
		
		return tok.nextToken();
	}
	
	int readInt() throws IOException {
		return Integer.parseInt(readString());
	}
	
	long readLong() throws IOException {
		return Long.parseLong(readString());
	}
	
	void solve() throws IOException {
		int rows = readInt();
		int columns = readInt();
		
		int first = 0;
		for (int i = 0; rows > 1 && i < rows; i += 2) {
			first++;
		}
		
		for (int j = 1; columns > 1 && j < columns; j += 2) {
			first++;
		}
		
		int second = 0;
		for (int i = 1; rows > 1 && i < rows; i += 2) {
			second++;
		}
		
		for (int j = 0; columns > 1 && j < columns; j += 2) {
			second++;
		}
		
		if (first < second) {
			out.println(first);
			
			for (int i = 0; rows > 1 && i < rows; i += 2) {
				out.println((i + 1) + " " + 1 + " " + (i + 1) + " " + columns);
			}
			
			for (int j = 1; columns > 1 && j < columns; j += 2) {
				out.println(1 + " " + (j + 1) + " " + rows + " " + (j + 1));
			}
		} else {
			out.println(second);
			
			for (int i = 1; rows > 1 && i < rows; i += 2) {
				out.println((i + 1) + " " + 1 + " " + (i + 1) + " " + columns);
			}
			
			for (int j = 0; columns > 1 && j < columns; j += 2) {
				out.println(1 + " " + (j + 1) + " " + rows + " " + (j + 1));
			}
		}
		
//		int[][] field = new int[rows][columns];
//		for (int i = 0; i < rows; ++i) {
//			field[i][0] = (i & 1);
//			for (int j = 1; j < columns; ++j) {
//				field[i][j] = 1 - field[i][j-1];
//			}
//		}
//		
//		int blackCount = 0;
//		for (int[] row : field) {
//			for (int cell : row) {
//				blackCount += cell; 
//			}
//		}
//		
//		int whiteCount = rows * columns - blackCount;
//		
//		int needReverse = (blackCount < whiteCount ? 1 : 0);
//		
//		out.println(min(blackCount, whiteCount));
//		for (int i = 0; i < rows; ++i) {
//			for (int j = 0; j < columns; ++j) {
//				if (field[i][j] == needReverse) {
//					int x = i + 1;
//					int y = j + 1;
//					
//					out.println(x + " " + y + " " + x + " " + y);
//				}
//			}
//		}
	}
}
