
import java.util.*;
import java.io.*;

import static java.lang.Math.*;

public class A {

	final boolean ONLINE_JUDGE = !new File("input.txt").exists();
	
	BufferedReader in;
	PrintWriter out;
	StringTokenizer tok = new StringTokenizer("");
	
	public static void main(String[] args) {
		new A().run();
	}
	
	public void run() {
		try {
			long t1 = System.currentTimeMillis();
			
			init();
			solve();
			
			out.close();
			
			long t2 = System.currentTimeMillis();
			System.err.println(t2 - t1);
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(-1);
		}
	}
	
	public void init() throws IOException {
		String fileName = "alter";
		if (fileName.isEmpty()) {
			throw new RuntimeException();
		}
		
		if (ONLINE_JUDGE) {
			in = new BufferedReader(new FileReader(fileName + ".in"));
			out = new PrintWriter(fileName + ".out");
		} else {
			in = new BufferedReader(new FileReader("input.txt"));
			out = new PrintWriter("output.txt");
		}
	}
	
	public String readString() throws IOException {
		while (!tok.hasMoreTokens()) {
			tok = new StringTokenizer(in.readLine());
		}
		
		return tok.nextToken();
	}
	
	int readInt() throws IOException {
		return Integer.parseInt(readString());
	}
	
	long readLong() throws IOException {
		return Long.parseLong(readString());
	}
	
	void solve() throws IOException {
		int rows = readInt();
		int columns = readInt();
		
		int bestMask = -1;
		int bestSum = Integer.MAX_VALUE;
		for (int mask = 0; mask < 4; ++mask) {
			int sum = 0;
			for (int i = (mask & 1); rows > 1 && i < rows; i += 2) {
				sum++;
			}
			
			for (int j = (mask >> 1); columns > 1 && j < columns; j += 2) {
				sum++;
			}
			
			if (sum < bestSum) {
				bestMask = mask;
				bestSum = sum;
			}
		}
		
		out.println(bestSum);
		
		for (int i = (bestMask & 1); rows > 1 && i < rows; i += 2) {
			out.println((i + 1) + " " + 1 + " " + (i + 1) + " " + columns);
		}
		
		for (int j = (bestMask >> 1); columns > 1 && j < columns; j += 2) {
			out.println(1 + " " + (j + 1) + " " + rows + " " + (j + 1));
		}
	}
}
