import java.io.*;
import java.lang.reflect.Array;
import java.util.Arrays;
import java.util.StringTokenizer;

public class B {

    final boolean ONLINE_JUDGE = !new File("input.txt").exists();

    BufferedReader in;
    PrintWriter out;
    StringTokenizer tok = new StringTokenizer("");

    public static void main(String[] args) {
        new B().run();
    }

    public void run() {
        try {
            long t1 = System.currentTimeMillis();

            init();
            solve();

            out.close();

            long t2 = System.currentTimeMillis();
            System.err.println(t2 - t1);
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(-1);
        }
    }

    public void init() throws IOException {
        String fileName = "burrito";
        if (fileName.isEmpty()) {
            throw new RuntimeException();
        }

        if (ONLINE_JUDGE) {
            in = new BufferedReader(new FileReader(fileName + ".in"));
            out = new PrintWriter(fileName + ".out");
        } else {
            in = new BufferedReader(new FileReader("input.txt"));
            out = new PrintWriter("output.txt");
        }
    }

    public String readString() throws IOException {
        while (!tok.hasMoreTokens()) {
            tok = new StringTokenizer(in.readLine());
        }

        return tok.nextToken();
    }

    int readInt() throws IOException {
        return Integer.parseInt(readString());
    }

    long readLong() throws IOException {
        return Long.parseLong(readString());
    }

    class Ingridients implements Comparable<Ingridients> {
        int a;
        int b;
        int g;
        int index;

        Ingridients(int g, int a, int b, int index) {
            this.g = g;
            this.a = a;
            this.b = b;
            this.index = index;
        }

        @Override
        public int compareTo(Ingridients o) {
           return -(a * o.b - o.a * b);
        }
    }

    void solve() throws IOException {
        int n = readInt();
        int x = readInt();
        int y = readInt();
        Ingridients[] c = new Ingridients[n];
        for(int i = 0; i < n; i++) {
            c[i] = new Ingridients(readInt(), readInt(), readInt(), i);
        }
        Arrays.sort(c);
        int aSum = 0;
        int bSum = 0;
        double totalSumA = 0;
        double totalSumB = 0;
        double[] res = new double[n];
        boolean find = false;
        for(int i = 0; i < n; i++) {
            if(bSum + c[i].g * c[i].b > y) {
                int delta = y - bSum; // gramm * unhap
                double count = delta * 1.0 / c[i].b; // gramm * unhap / unhap
                totalSumA += count * c[i].a; // g*u += g * u
                totalSumB += count * c[i].b; //
                res[c[i].index] = count;
                if(delta * 1l * c[i].a >= (x-aSum)*1l*c[i].b) {
                    find = true;
                }
                break;
            } else {
                res[c[i].index] = c[i].g;
                aSum += c[i].a * c[i].g;
                bSum += c[i].b * c[i].g;
                totalSumA = aSum;
                totalSumB = bSum;
                if(aSum >= x) {
                    find = true;
                }
            }
        }
        if(find) {
            out.println(totalSumA + " " + totalSumB);
            for(int i = 0; i < n; i++) {
                out.print(res[i] + " ");
            }
        } else {
            out.println(-1 + " " + -1);
        }
    }

}
