import java.io.*;
import java.lang.reflect.Array;
import java.util.Arrays;
import java.util.StringTokenizer;

public class B {

    final boolean ONLINE_JUDGE = !new File("input.txt").exists();

    BufferedReader in;
    PrintWriter out;
    StringTokenizer tok = new StringTokenizer("");

    public static void main(String[] args) {
        new B().run();
    }

    public void run() {
        try {
            long t1 = System.currentTimeMillis();

            init();
            solve();

            out.close();

            long t2 = System.currentTimeMillis();
            System.err.println(t2 - t1);
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(-1);
        }
    }

    public void init() throws IOException {
        String fileName = "burrito";
        if (fileName.isEmpty()) {
            throw new RuntimeException();
        }

        if (ONLINE_JUDGE) {
            in = new BufferedReader(new FileReader(fileName + ".in"));
            out = new PrintWriter(fileName + ".out");
        } else {
            in = new BufferedReader(new FileReader("input.txt"));
            out = new PrintWriter("output.txt");
        }
    }

    public String readString() throws IOException {
        while (!tok.hasMoreTokens()) {
            tok = new StringTokenizer(in.readLine());
        }

        return tok.nextToken();
    }

    int readInt() throws IOException {
        return Integer.parseInt(readString());
    }

    long readLong() throws IOException {
        return Long.parseLong(readString());
    }

    class Ingridients implements Comparable<Ingridients> {
        int a;
        int b;
        int g;
        int index;

        Ingridients(int g, int a, int b, int index) {
            this.g = g;
            this.a = a;
            this.b = b;
            this.index = index;
        }

        @Override
        public int compareTo(Ingridients other) {
           int res = -(this.a * other.b - other.a * this.b);
           if (res != 0) return res;

           return this.index - other.index;
        }
    }

    void sort(Ingridients[] a, int l, int r) {
        if (l == r) return;

        int mid = (l + r) / 2;
        sort(a, l, mid);
        sort(a, mid + 1, r);

        merge(a, l, mid, r);
    }

    void merge(Ingridients[] a, int l, int m, int r) {
        int leftSize = (m - l + 1);
        int rightSize = (r - m);

        Ingridients[] left = new Ingridients[leftSize];
        for (int i = 0; i < leftSize; ++i) {
            left[i] = a[i+l];
        }

        Ingridients[] right = new Ingridients[rightSize];
        for (int j = 0; j < rightSize; ++j) {
            right[j] = a[m+1+j];
        }

        int i = 0, j = 0;
        for (int k = l; k <= r; ++k) {
            if (i == leftSize) {
                a[k] = right[j++];
            } else if (j == rightSize) {
                a[k] = left[i++];
            } else {
                int cmp = left[i].compareTo(right[j]);

                if (cmp <= 0) {
                    a[k] = left[i++];
                } else {
                    a[k] = right[j++];
                }
            }
        }
    }

    void solve() throws IOException {
        int n = readInt();
        int x = readInt();
        int y = readInt();
        Ingridients[] c = new Ingridients[n];
        for(int i = 0; i < n; i++) {
            c[i] = new Ingridients(readInt(), readInt(), readInt(), i);
        }

        sort(c, 0, n - 1);
        int aSum = 0;
        int bSum = 0;

        double totalSumA = 0;
        double totalSumB = 0;

        double[] res = new double[n];
        boolean find = (x == 0);

        for(int i = 0; i < n && bSum <= y; i++) {
            if(c[i].a == 0) {

            } else if (c[i].b == 0) {
                res[c[i].index] = c[i].g;
                aSum += c[i].a * c[i].g;
                bSum += c[i].b * c[i].g;

                totalSumA = aSum;
                totalSumB = bSum;

                if(aSum >= x) {
                    find = true;
                }


            } else if(bSum + c[i].g * c[i].b > y) {
                try {
                    int delta = y - bSum; // gramm * unhap
                    double count = delta * 1.0 / c[i].b; // gramm * unhap / unhap

                    bSum += c[i].g * c[i].b;

                    totalSumA += count * c[i].a; // g*u += g * u
                    totalSumB += count * c[i].b; // g * u += g * u

                    res[c[i].index] = count;

                    if(delta * 1l * c[i].a >= (x - aSum) * 1l * c[i].b) {
                        find = true;
                    }
                } catch (Exception e) {
                    aSum += c[i].g * c[i].a;
                    bSum += c[i].g * c[i].b;

                    totalSumA = aSum;

                    find |= (aSum >= x);
                }

            } else {
                res[c[i].index] = c[i].g;

                aSum += c[i].a * c[i].g;
                bSum += c[i].b * c[i].g;

                totalSumA = aSum;
                totalSumB = bSum;

                if(aSum >= x) {
                    find = true;
                }
            }
        }

        if(find) {
            out.println(totalSumA + " " + totalSumB);
            for(int i = 0; i < n; i++) {
                out.print(res[i] + " ");
            }
        } else {
            out.println(-1 + " " + -1);
        }
    }

}
