
import java.util.*;
import java.io.*;

import static java.lang.Math.*;

public class F {

	final boolean ONLINE_JUDGE = !new File("input.txt").exists();
	
	BufferedReader in;
	PrintWriter out;
	StringTokenizer tok = new StringTokenizer("");
	
	public static void main(String[] args) {
		new F().run();
	}
	
	public void run() {
		try {
			long t1 = System.currentTimeMillis();
			
			init();
			solve();
			
			out.close();
			
			long t2 = System.currentTimeMillis();
			System.err.println(t2 - t1);
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(-1);
		}
	}
	
	public void init() throws IOException {
		String fileName = "filter";
		if (fileName.isEmpty()) {
			throw new RuntimeException();
		}
		
		if (ONLINE_JUDGE) {
			in = new BufferedReader(new FileReader(fileName + ".in"));
			out = new PrintWriter(fileName + ".out");
		} else {
			in = new BufferedReader(new FileReader("input.txt"));
			out = new PrintWriter("output.txt");
		}
	}
	
	public String readString() throws IOException {
		while (!tok.hasMoreTokens()) {
			tok = new StringTokenizer(in.readLine());
		}
		
		return tok.nextToken();
	}
	
	int readInt() throws IOException {
		return Integer.parseInt(readString());
	}
	
	long readLong() throws IOException {
		return Long.parseLong(readString());
	}
	
	boolean[][] translate = {
			{false, false, false, false},
			{true, false, false, false},
			{false, true, false, false},
			{true, true, false, false},
			{false, false, true, false},
			{true, false, true, false},
			{false, true, true, false},
			{true, true, true, false},
			{false, false, false, true},
			{true, false, false, true},
			{false, true, false, true},
			{true, true, false, true},
			{false, false, true, true},
			{true, false, true, true},
			{false, true, true, true},
			{true, true, true, true}
	};
	
	void solve() throws IOException {
		int bitsCount = readInt();
		
		int hashCount = readInt();
		int[] hashes = new int[hashCount];
		for (int i = 0; i < hashCount; ++i) {
			hashes[i] = readInt() % bitsCount;
		}
		
		int n = readInt();
		boolean[][] bits = new boolean[n][bitsCount];
		for (int it = 0; it < n; ++it) {
			String bloom = readString();
			
			char[] digits = bloom.toCharArray();
			for (int i = 0; i < digits.length; ++i) {
				char digit = digits[i];
				
				int firstBit = i * 4;
				int lastBit = min(firstBit + 3, bitsCount - 1);
				
				int index = ('a' <= digit && digit <= 'f' ? digit + 10 - 'a' : digit - '0');
				for (int bit = firstBit; bit <= lastBit; ++bit) {
					bits[it][bit] = translate[index][bit-firstBit];
				}
			}
		}
		
		boolean[] cool = new boolean[n];
		
		int setSize = readInt();
		for (int i = 0; i < setSize; ++i) {
			int user = readInt();
			int[] needBits = new int[hashCount];
			for (int j = 0; j < hashCount; ++j) {
				needBits[j] = (user % bitsCount * hashes[i]) % bitsCount;
			}
			
			for (int it = 0; it < n; ++it) {
				if (cool[it]) continue;
				
				boolean isCool = true;
				for (int j = 0; j < hashCount; ++j) {
					isCool &= bits[it][needBits[j]];
				}
				
				cool[it] |= isCool;
			}
		}
		
		List<Integer> answer = new ArrayList<Integer>();
		for (int i = 0; i < n; ++i) {
			if (cool[i]) answer.add(i);
		}
		
		out.print(answer.size() + " ");
		for (int ans : answer) {
			out.print(ans + " ");
		}
	}
}
