import java.io.*;
import java.util.*;

public class J {

    final boolean ONLINE_JUDGE = !new File("input.txt").exists();

    BufferedReader in;
    PrintWriter out;
    StringTokenizer tok = new StringTokenizer("");

    public static void main(String[] args) {
        new J().run();
    }

    public void run() {
        try {
            long t1 = System.currentTimeMillis();

            init();
            solve();

            out.close();

            long t2 = System.currentTimeMillis();
            System.err.println(t2 - t1);
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(-1);
        }
    }

    public void init() throws IOException {
        String fileName = "joke";
        if (fileName.isEmpty()) {
            throw new RuntimeException();
        }

        if (ONLINE_JUDGE) {
            in = new BufferedReader(new FileReader(fileName + ".in"));
            out = new PrintWriter(fileName + ".out");
        } else {
            in = new BufferedReader(new FileReader("input.txt"));
            out = new PrintWriter("output.txt");
        }
    }

    public String readString() throws IOException {
        while (!tok.hasMoreTokens()) {
            tok = new StringTokenizer(in.readLine());
        }

        return tok.nextToken();
    }

    int readInt() throws IOException {
        return Integer.parseInt(readString());
    }

    long readLong() throws IOException {
        return Long.parseLong(readString());
    }

    void solve() throws IOException {
        char[] c = readString().toCharArray();
        int n = 0;
        for(int i = 1; i <= c.length; i++) {
            if(i < 10) {
                int cur = i;
                if(cur == c.length) {
                    n = i;
                    break;
                }
            } else {
                int cur = 9;
                int d = c.length - 9;
                cur += d / 2;
                if(cur == i) {
                    n = i;
                    break;
                }
            }
        }
        if(n == 0) {
            throw new RuntimeException();
        }

        Map<Long, Integer>[] d = new Map[c.length + 1];
        d[0] = new HashMap<Long, Integer>();
        d[0].put(0L, 0);
        for(int i = 1; i <= c.length; i++) {
            d[i] = new HashMap<Long, Integer>();
            if(i > 1) {
                int number = (c[i-2] - '0') * 10 + (c[i-1] - '0');
                if(number <= n) {
                    for(long mask: d[i-2].keySet()) {
                        if((mask & (1l << number)) == 0) {
                            d[i].put(mask | (1l << number), number);
                        }
                    }
                }
            }
            int number = (c[i-1] - '0');
            for(long mask: d[i-1].keySet()) {
                if((mask & (1l << number)) == 0) {
                    d[i].put(mask | (1l << number), number);
                }
            }
        }
        long curMask = 0;
        for(long mask: d[c.length].keySet()) {
            curMask = mask;
        }
        int lvl = c.length;
        List<Integer> res = new ArrayList<Integer>();
        while(curMask != 0) {
            int curNumber = d[lvl].get(curMask);
            res.add(curNumber);
            curMask = (curMask ^ (1l << curNumber));
            if(curNumber >= 10) {
                lvl--;
            }
            lvl--;
        }
        Collections.reverse(res);
        for(int i: res) {
            out.print(i + " ");
        }
    }
}
