import java.io.*;
import java.util.StringTokenizer;

public class K {

    final boolean ONLINE_JUDGE = !new File("input.txt").exists();

    BufferedReader in;
    PrintWriter out;
    StringTokenizer tok = new StringTokenizer("");

    public static void main(String[] args) {
        new K().run();
    }

    public void run() {
        try {
            long t1 = System.currentTimeMillis();

            init();
            solve();

            out.close();

            long t2 = System.currentTimeMillis();
            System.err.println(t2 - t1);
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(-1);
        }
    }

    public void init() throws IOException {
        String fileName = "knockout";
        if (fileName.isEmpty()) {
            throw new RuntimeException();
        }

        if (ONLINE_JUDGE) {
            in = new BufferedReader(new FileReader(fileName + ".in"));
            out = new PrintWriter(fileName + ".out");
        } else {
            in = new BufferedReader(new FileReader("input.txt"));
            out = new PrintWriter("output.txt");
        }
    }

    public String readString() throws IOException {
        while (!tok.hasMoreTokens()) {
            tok = new StringTokenizer(in.readLine());
        }

        return tok.nextToken();
    }

    int readInt() throws IOException {
        return Integer.parseInt(readString());
    }

    long readLong() throws IOException {
        return Long.parseLong(readString());
    }

    void solve() throws IOException {
        int n = readInt();
        int m = readInt();
        int[] a = new int[n];
        int[] b = new int[n];
        for(int i = 0; i < n; i++) {
            a[i] = readInt();
            b[i] = readInt();
        }

        for(int i = 0; i < m; i++) {
            int x = readInt();
            int y = readInt();
            int t = readInt();
            int sum = 0;
            for(int j = 0; j < n; j++) {
                if(consist(a[j], b[j], x, y, t)) {
                    sum++;
                }
            }
            out.println(sum);
        }
    }

    boolean consist(int a, int b, int x, int y, int t) {
        int d = Math.abs(a-b);
        int cur = t % d;
        int number = t / d;
        int z;
        if(a < b) {
            if(number % 2 == 0) {
                z = a + cur;
            } else {
                z = b - cur;
            }
        } else {
            if(number % 2 == 0) {
                z = b - cur;
            } else {
                z = a + cur;
            }
        }
        return (x <= z && z <= y);
    }
}
