// Main.cpp : Defines the entry point for the console application.
//

#include <iostream>
#include <fstream>
#include <cstddef>
#include <vector>
#include <algorithm>
#include <string>
#include <numeric>
#include <utility>
#include <unordered_map>
#include <iomanip>

#ifdef _DEBUG

auto& in = std::cin;
auto& out = std::cout;

#else

std::ifstream in("burrito.in");
std::ofstream out("burrito.out");

#endif


class Burito
{
public:
	std::size_t mass;
	std::size_t proc;
	std::size_t cons;

public:
	double awd() const
	{
		return static_cast<double>(proc) / cons;
	}

public:
	friend bool operator< (const Burito& b1, const Burito& b2)
	{
		return b1.awd() < b2.awd();
	}

	friend bool operator== (const Burito& b1, const Burito& b2)
	{
		return std::tie(b1.mass, b1.proc, b1.cons) == std::tie(b2.mass, b2.proc, b2.cons);
	}

};

struct Hasher
{
	std::size_t operator() (const Burito& b)
	{
		std::hash<std::size_t> hasher;
		return hasher(b.mass) ^ hasher(b.proc) ^ hasher(b.cons);
	}
};

int main()
{
	std::size_t n;
	int proc, cons;
	in >> n >> proc >> cons;


	std::vector<Burito> ingr;
	ingr.reserve(n);
	std::vector<Burito> copy;
	copy.reserve(n);
	std::vector<Burito> zero_cons;
	zero_cons.reserve(n);
	std::unordered_map<Burito, std::size_t, Hasher> rev;

	std::vector<double> ans(n, 0);
	double sum_proc = 0, sum_cons = 0;

	for (std::size_t i = 0; i < n; ++i)
	{
		Burito ing;

		in >> ing.mass >> ing.proc >> ing.cons;

		if (ing.cons == 0)
		{
			ans.at(i) = ing.mass;
			sum_proc += ing.mass * ing.proc;
		}
		else
		{
			ingr.push_back(ing);
			copy.push_back(ing);
			rev[ing] = i;
		}
	}

	std::sort(ingr.begin(), ingr.end());

	for (auto& it = ingr.rbegin(); it != ingr.rend(); ++it)
	{
		if (sum_cons + it->cons * it->mass < cons)
		{
			sum_cons += it->cons * it->mass;
			sum_proc += it->proc * it->mass;
			
			ans.at(rev[*it]) = it->mass;
		}
		else
		{
			auto req_mass = (static_cast<double>(cons) - sum_cons) / it->cons;

			sum_cons += it->cons * req_mass;
			sum_proc += it->proc * req_mass;

			ans.at(rev[*it]) = req_mass;

			break;
		}
	}

	if (sum_proc < proc)
	{
		out << "-1 -1" << std::endl;
	}
	else
	{
		out << std::fixed << std::setprecision(std::numeric_limits<double>::digits10) << sum_proc << ' ';
		out << std::fixed << std::setprecision(std::numeric_limits<double>::digits10) << sum_cons << std::endl;
		for (const auto& a : ans)
		{
			out << std::fixed << std::setprecision(std::numeric_limits<double>::digits10) << a << ' ';
		}

		out << std::endl;
	}

	return 0;
}


