// Main.cpp : Defines the entry point for the console application.
//

#include <iostream>
#include <fstream>
#include <cstddef>
#include <vector>
#include <algorithm>

#ifdef _DEBUG

auto& in = std::cin;
auto& out = std::cout;

#else

std::ifstream in("knockout.in");
std::ofstream out("knockout.out");

#endif

class Car
{
public:
	std::size_t a;
	std::size_t b;

public:
	std::size_t min() const
	{
		return std::min(a, b);
	}

	std::size_t max() const
	{
		return std::max(a, b);
	}

	std::size_t at_time(std::size_t t) const
	{
		auto dist = max() - min();
		t %= dist * 2;

		if (t == dist)
		{
			return b;
		}
		else if (t < dist)
		{
			if (a == min())
			{
				return a + t;
			}
			else
			{
				return a - t;
			}
		}
		else
		{
			t -= dist;

			if (b == max())
			{
				return b - t;
			}
			else
			{
				return b + t;
			}
		}
	}
};

std::size_t answer(const std::vector<Car>& cars, std::size_t x, std::size_t y, std::size_t t)
{
	return std::count_if(cars.begin(), cars.end(), [x, y, t](const Car& c) {
		auto pos = c.at_time(t);

		return pos >= x && pos <= y;
	});
}

int main()
{
	std::size_t n, m;
	in >> n >> m;

	std::vector<Car> cars(n);

	for (auto& c : cars)
	{
		in >> c.a >> c.b;
	}

	for (std::size_t i = 0; i < m; ++i)
	{
		std::size_t x, y, t;
		in >> x >> y >> t;
		out << answer(cars, x, y, t) << std::endl;
	}


	return 0;
}

