#include <iostream>
#include <sstream>
#include <fstream>
#include <cstdio>
#include <cstdlib>
#include <cassert>
#include <ctime>
#include <cmath>
#include <cstring>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <deque>
#include <bitset>
#include <list>
#include <algorithm>
#include <iomanip>

using namespace std;

#define forn(i,n) for (int i = 0; i < int(n); i++)
#define ford(i,n) for (int i = int(n) - 1; i >= 0; i--)
#define fore(i,l,r) for (int i = int(l); i <= int(r); i++)
#define mp make_pair
#define pb push_back
#define all(a) a.begin(), a.end()
#define sz(a) int(a.size())
#define ft first
#define sc second
#define x first
#define y second

template<typename X> inline X abs(const X& a) { return a < 0 ? -a : a; }
template<typename X> inline X sqr(const X& a) { return a * a; }

typedef pair<int, int> pt;
typedef long double ld;
typedef long long li;

const int INF = int(1e9);
const li INF64 = li(1e18);
const ld PI = 3.1415926535897932384626433832795L;
const ld EPS = 1e-9;

const int N = 100 * 1000 + 13;
int n, A, B;
pair<pt, pt> a[N];

inline bool read()
{
	if (scanf ("%d%d%d", &n, &A, &B) != 3)
		return false;
		
	forn (i, n)
	{
		int g, a, b;
		assert(scanf ("%d%d%d", &g, &a, &b) == 3);
		
		::a[i] = mp(mp(g, i), mp(a, b));
	}
	
	return true;
}

inline bool cmp (const pair<pt, pt>& a, const pair<pt, pt>& b)
{
	int a1 = a.sc.ft, b1 = a.sc.sc;
	int a2 = b.sc.ft, b2 = b.sc.sc;
	
	if (b1 == 0 && b2 == 0)
		return a1 > a2;
		
	if (b1 == 0)
		return true;
		
	if (b2 == 0)
		return false;
		
	return a1 * b2 > a2 * b1;
}

ld ans[N];

inline void solve()
{
	sort(a, a + n, cmp);
	
	ld curA = 0, curB = B;
	forn (i, n)
	{
		int a = ::a[i].sc.ft, b = ::a[i].sc.sc;
		int g = ::a[i].ft.ft;
		int id = ::a[i].ft.sc;
		
		if (b == 0)
		{
			ans[id] = ld(g);
			curA += ld(a) * ld(g);
		}
		else
		{
			ld cur = min(ld(g), curB / ld(b));
			curB -= cur * ld(b);
			curA += cur * ld(a);
			
			ans[id] = cur;
		}
	}
	
	if (curA < ld(A) - EPS)
	{
		puts("-1 -1");
		return;
	}
	
	printf ("%.15f %.15f\n", double(curA), double(B - curB));
	forn (i, n)
		printf ("%.15f ", double(ans[i]));
	puts("");
}

int main()
{
#ifdef SU2_PROJ
	freopen("input.txt", "rt", stdin);
	freopen("output.txt", "wt", stdout);
#else
	freopen("burrito.in", "rt", stdin);
	freopen("burrito.out", "wt", stdout);
#endif	

	cerr << setprecision(10) << fixed;
	cout << setprecision(15) << fixed;
	
	srand(time(NULL));
	
	assert(read());
	solve();
	
#ifdef SU2_PROJ
	cerr << "TIME: " << clock() << endl;
#endif	
	
	return 0;
}