#include <iostream>
#include <sstream>
#include <fstream>
#include <cstdio>
#include <cstdlib>
#include <cassert>
#include <ctime>
#include <cmath>
#include <cstring>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <deque>
#include <bitset>
#include <list>
#include <algorithm>
#include <iomanip>

using namespace std;

#define forn(i,n) for (int i = 0; i < int(n); i++)
#define ford(i,n) for (int i = int(n) - 1; i >= 0; i--)
#define fore(i,l,r) for (int i = int(l); i <= int(r); i++)
#define mp make_pair
#define pb push_back
#define all(a) a.begin(), a.end()
#define sz(a) int(a.size())
#define ft first
#define sc second
#define x first
#define y second

template<typename X> inline X abs(const X& a) { return a < 0 ? -a : a; }
template<typename X> inline X sqr(const X& a) { return a * a; }

typedef pair<int, int> pt;
typedef long double ld;
typedef long long li;

const int INF = int(1e9);
const li INF64 = li(1e18);
const ld PI = 3.1415926535897932384626433832795L;
const ld EPS = 1e-9;

const int N = 100 + 13;
int n;
char c[N];
int g[N][3];

inline bool read()
{
	if (scanf ("%d", &n) != 1)
		return false;
		
	forn (i, n)
	{
		assert(scanf (" %c", &c[i]) == 1);
		
		forn (j, 3)
		{
			assert(scanf ("%d", &g[i][j]) == 1);
			
			g[i][j]--;
		}
	}
	
	return true;
}

const int M = 1000 * 1000 + 13;

struct state 
{
	vector<int> a;
	char c;
};

inline bool operator < (const state& a, const state& b) 
{
	if (a.a == b.a)
		return a.c < b.c;
		
	return a.a < b.a;
}

inline void add (state& a, int id)
{
	a.a.pb(id);
}

map<state, int> name;
state rname[M];
int ng[M][3];

inline int getName (const state& a)
{
	if (!name.count(a))
	{
		int sz = sz(name);
		
		name[a] = sz;
		rname[sz] = a;
	}
	
	return name[a];
}

inline int charToInt (const char& c)
{
	if (c == 'R')
		return 0;
		
	if (c == 'P')
		return 1;
		
	if (c == 'S')
		return 2;
		
	throw;
}

const char bc[3] = {'P', 'S', 'R'};

int q[M], head = 0, tail = 0;

inline void solve()
{
	state s;
	s.c = 'S';
	forn (i, n)
		add(s, i);
		
	int sId = getName(s);	
	
	q[tail++] = sId;
	
	while (head != tail)
	{
		int vId = q[head++];
		
		state v = rname[vId];
		char curC = v.c;

		vector<int> na[3];
		forn (i, sz(v.a))
		{
			int curId = v.a[i];
			
			int to = g[curId][charToInt(curC)];
			na[charToInt(c[curId])].pb(to);
		}
		
		forn (i, 3)
		{
			if (sz(na[i]) == 0)
			{
				ng[vId][i] = vId;
				continue;
			}
			
			sort(all(na[i]));
			na[i].erase(unique(all(na[i])), na[i].end());
			
			int cnt[3];
			forn (k, 3)
				cnt[k] = 0;
			forn (k, sz(na[i]))
				cnt[ charToInt(c[ na[i][k] ]) ]++;
				
			int maxVal = 0;
			forn (k, 3)
				if (cnt[k] > cnt[maxVal])
					maxVal = k;
			
			state nv;
			nv.c = bc[maxVal];
			nv.a = na[i];

			bool newTo = !(name.count(nv));
			int to = getName(nv);
			ng[vId][i] = to;
			
			if (newTo)
				q[tail++] = to;
		}
	}
	
	cout << sz(name) << endl;
	
	forn (i, sz(name))
	{
		state cur = rname[i];
		printf ("%c %d %d %d\n", char(cur.c), ng[i][0] + 1, ng[i][1] + 1, ng[i][2] + 1);
	}
}

int main()
{
#ifdef SU2_PROJ
	freopen("input.txt", "rt", stdin);
	freopen("output.txt", "wt", stdout);
#else
	freopen("epic.in", "rt", stdin);
	freopen("epic.out", "wt", stdout);
#endif	

	cerr << setprecision(10) << fixed;
	cout << setprecision(15) << fixed;
	
	srand(time(NULL));
	
	assert(read());
	solve();
	
#ifdef SU2_PROJ
	cerr << "TIME: " << clock() << endl;
#endif	
	
	return 0;
}