#include <iostream>
#include <sstream>
#include <fstream>
#include <cstdio>
#include <cstdlib>
#include <cassert>
#include <ctime>
#include <cmath>
#include <cstring>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <deque>
#include <bitset>
#include <list>
#include <algorithm>
#include <iomanip>

using namespace std;

#define forn(i,n) for (int i = 0; i < int(n); i++)
#define ford(i,n) for (int i = int(n) - 1; i >= 0; i--)
#define fore(i,l,r) for (int i = int(l); i <= int(r); i++)
#define mp make_pair
#define pb push_back
#define all(a) a.begin(), a.end()
#define sz(a) int(a.size())
#define ft first
#define sc second
#define x first
#define y second

template<typename X> inline X abs(const X& a) { return a < 0 ? -a : a; }
template<typename X> inline X sqr(const X& a) { return a * a; }

typedef pair<int, int> pt;
typedef long double ld;
typedef long long li;

const int INF = int(1e9);
const li INF64 = li(1e18);
const ld PI = 3.1415926535897932384626433832795L;
const ld EPS = 1e-9;

const int N = 200 * 1000 + 13;

int n;
int a[N];
int p[N];

inline bool read()
{
	if (scanf("%d", &n) != 1)
		return false;
	forn(i, n) {
		scanf("%d", &p[i]);
	}
	return true;
}

bool cmp(const int& i, const int& j) {
	return p[i] < p[j];
}

int z[4 * N][2];

inline void update(int idx, int j) {
	z[idx][j] = max(z[2 * idx + 1][j], z[2 * idx + 2][j]);
}

void update(int idx, int j, int l, int r, int pos, int val) {
	if (l == r) {
		z[idx][j] = val;
		return;	
	}
	int m = (l + r) >> 1;
	if (pos <= m) 
		update(2 * idx + 1, j, l, m, pos, val);
	else
		update(2 * idx + 2, j, m + 1, r, pos, val);
	update(idx, j);
}

int getMax(int idx, int j, int l, int r, int lf, int rg) {
	if (lf > rg)
		return 0;
	if (l == lf && r == rg) {
		return z[idx][j];
	}
	int m = (l + r) >> 1;
	int res = 0;
	if (lf <= m) 
		res = max(res, getMax(2 * idx + 1, j, l, m, lf, min(m, rg)));
	if (rg >= m + 1)
		res = max(res, getMax(2 * idx + 2, j, m + 1, r, max(m + 1, lf), rg));
	return res;
}

inline void solve()
{
	forn(i, n)
		a[i] = i;
	sort(a, a + n, cmp);
	int ans = 0;
	forn(i, n) {
		//0
		{
			int dv = getMax(0, 0, 0, n - 1, 0, a[i] - 1);
			int nv = dv + 1;
			update(0, 0, 0, n - 1, a[i], nv);
			ans = max(ans, nv);
		}
		//1
		{
			int dv = getMax(0, 0, 0, n - 1, a[i] + 1, n - 1);
			dv = max(dv, getMax(0, 1, 0, n - 1, a[i] + 1, n - 1));
			int nv = dv + 1;
			update(0, 1, 0, n - 1, a[i], nv);
			ans = max(ans, nv);
		}
	}
	printf("%d\n", ans);
}

int main()
{
#ifdef SU2_PROJ
	freopen("input.txt", "rt", stdin);
	freopen("output.txt", "wt", stdout);
#else
	freopen("improvements.in", "rt", stdin);
	freopen("improvements.out", "wt", stdout);
#endif	

	cerr << setprecision(10) << fixed;
	cout << setprecision(15) << fixed;
	
	srand(time(NULL));
	
	assert(read());
	solve();
	
#ifdef SU2_PROJ
	cerr << "TIME: " << clock() << endl;
#endif	
	
	return 0;
}