#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <cstring>
#include <algorithm>
#include <cassert>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <cstdlib>
#include <cmath>


#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#define all(c) (c).begin(), (c).end()
#define sz(c) (int)(c).size()

using namespace std;

const int N = 1 << 20;
const double M_PI = acos(-1.);
const double eps = 1e-9;

double d, l, r, t, h;
double u, p;

double alpha;
	
double g(double teta) {
	return teta + 0.5 * sin(M_PI - 2 * teta); 
}

double f(double par, double b) {
	double yy = d / 2 * cos(alpha) + par * sin(alpha);

	//eprintf("yy = %.5f\n", yy);
//	eprintf("cos(alpha) = %f\n", cos(alpha));
	if (abs(cos(alpha)) < eps) {
		if (yy >= h) return 0.; else return M_PI * b * b;
	} else {
		double tt = (h - yy) / cos(alpha); //yy + cos(alpha) * tt = h
//	eprintf("h - y = %.5f\n", h - yy);
//	eprintf("tt = %.5f\n", tt);
		if (!(tt == tt)) return 0.;
		if (tt > b) return M_PI * b * b;
		if (tt < -b) return 0.;
		double teta = asin(max(min(abs(tt / b), 1.), 0.)); 
		if (tt > 0.) {
//		eprintf("!!!\n");
//		eprintf("teta = %.2f\n", teta);
			return b * b * (M_PI * 0.5 + g(teta));
		} else {
		//assert(0);
		  return b * b * (M_PI * 0.5 - g(teta));
		}
	}
}	
                                           
int main() {
	freopen("damage.in", "rt", stdin);
	freopen("damage.out", "wt", stdout);
	scanf("%lf%lf%lf%lf%lf", &d, &l, &r, &t, &h);
	//eprintf("%f %f %f %f %f\n", d, l, r, t, h);
	d *= 1e-3;
	l *= 1e-3;
	r *= 1e-3;
	t *= 1e-3;
	h *= 1e-3;

	u = d / 2;
	double q = sqrt(r * r - u * u);
	alpha = asin(1. * t / l);
	//eprintf("alpha = %f\n", cos(alpha));
	double res0 = 0.;
	double step = l / N;
	for (int i = 1; i <= N; i += 2) {
		double val0 = f((i - 1) * l / N, u);
		double val1 = f((i) * l / N, u);
		double val2 = f((i + 1) * l / N, u);
		res0 += val0;
		res0 += 4. * val1;
		res0 += val2;
	}
	res0 *=  2 * step / 6;
	//eprintf("res0 = %.20f\n", res0 * 1e3);
	double res1 = 0.;
	step = (r - q) / N;
	for (int i = 1; i <= N; i += 2) {
		double t0 = -(i - 1) * step;
		double t1 = -(i) * step;
		double t2 = -(i + 1) * step;

		double val0 = f(t0, sqrt(max(r * r - (q - t0) * (q - t0), 0.)));
		double val1 = f(t1, sqrt(max(r * r - (q - t1) * (q - t1), 0.)));
		double val2 = f(t2, sqrt(max(r * r - (q - t2) * (q - t2), 0.)));
		res1 += val0 + val1 * 4 + val2;
	}
	res1 *= 2 * step / 6;
	//eprintf("res1 = %.20f\n", res1 * 1e3);
	double res2 = 0.;
	step = (r - q) / N;
	for (int i = 1; i <= N; i += 2) {
		assert(i + 1 <= N);
		double t0 = (i - 1) * (r - q) / N;
		double t1 = (i) * (r - q) / N;
		double t2 = (i + 1) * (r - q) / N;
		double val0 = f(t0 + l, sqrt(max(r * r - (q + t0) * (q + t0), 0.)));
		double val1 = f(t1 + l, sqrt(max(r * r - (q + t1) * (q + t1), 0.)));
		double val2 = f(t2 + l, sqrt(max(r * r - (q + t2) * (q + t2), 0.)));
		res2 += val0 + val1 * 4 + val2;
	}

	res2 *= step * 2 / 6; 
	
	
	//eprintf("res2 = %.20f\n", res2 * 1e-3);
	printf("%.20f\n", 1e3 * (res1 + res0 + res2));
}
/*
alpha = 0.000000
res0 = 14637.59668632216562400572
res1 = 4104.13475435696727799950
res2 = 4104.13475435696727799950
*/