#include <cstdio>
#include <ctime>
#include <iostream>
#include <cstdlib>
#include <cmath>
#include <cstring>
#include <algorithm>
#include <cassert>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <cstdlib>
#include <cmath>
 
 
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#define all(c) (c).begin(), (c).end()
#define sz(c) (int)(c).size()
 
using namespace std;
 
const int N = 1 << 21;
const long double M_PI = acos(-1.);
const long double eps = 1e-9;
 
long double d, l, r, t, h;
long double u, p;
 
long double alpha;
     
long double g(long double teta) {
    return teta + 0.5 * sin(M_PI - 2 * teta); 
}
long double norm(long double x, long double a, long double b) {
    return max(min(x, b), a);
}
 
 
long double f(long double par, long double b) {
    double yy = d / 2 * cos(alpha) + par * sin(alpha);
    //if (b < eps) return 0.;
    if (abs(cos(alpha)) < 1e-3) {
        if (yy >= h) return 0.; else return M_PI * b * b;
    } else {
        long double tt = (h - yy) / cos(alpha);
        if (!(tt == tt)) return 0.;
        if (tt >= b) return M_PI * b * b;
        if (tt <= -b) return 0.;
        long double teta = asin(norm(abs(tt / b), 0., 1.)); 
        if (tt > 0.) {
        	if (teta < teta + 1)
           return b * b * (M_PI * 0.5 + g(teta));
          else
          	return 0;
        } else {
          if (teta < teta + 1) {
          	return b * b * (M_PI * 0.5 - g(teta));
          	}else {
          		return 0;
          	}
        }
    }
}   
 
long double norm(long double x, long double a) {
    return max(x, a);
}
                                            
int main() {
    freopen("damage.in", "rt", stdin);
    freopen("damage.out", "wt", stdout);
    int _d, _l, _r, _t, _h;
    cin >> _d >> _l >> _r >> _t >> _h;
    d = _d;
    l = _l;
    r = _r;
    t = _t;
    h = _h;
    d *= 1e-3;
    l *= 1e-3;
    r *= 1e-3;
    t *= 1e-3;
    h *= 1e-3;
    u = d / 2;
    long double q = sqrt(norm(r * r - u * u, 0.));
    alpha = asin(norm(1. * t / l, 0., 1.));
    //eprintf("alpha = %f\n", cos(alpha));
    long double res0 = 0.;
    long double step = l / N;
    for (int i = 1; i <= N; i += 2) {
        long double val0 = f((i - 1) * step, u);
        long double val1 = f((i) * step, u);
        long double val2 = f((i + 1) * step, u);
        res0 += (val0 + 4 * val1 + val2) * step;
    }
    res0 /= 3;
    //eprintf("res0 = %.20f\n", res0 * 1e3);
    long double res1 = 0.;
    step = (r - q) / N;
    for (int i = 1; i <= N; i += 2) {
        long double t0 = -(i - 1) * step;
        long double t1 = -(i) * step;
        long  double t2 = -(i + 1) * step;
        long  double val0 = f(t0, sqrt(norm(r * r - (q - t0) * (q - t0), 0.)));
        long  double val1 = f(t1, sqrt(norm(r * r - (q - t1) * (q - t1), 0.)));
        long  double val2 = f(t2, sqrt(norm(r * r - (q - t2) * (q - t2), 0.)));
        res1 += (val0 + val1 * 4 + val2) * step;
    }
    res1 /= 3;
    //eprintf("res1 = %.20f\n", res1 * 1e3);
    long double res2 = 0.;
    step = (r - q) / N;
    for (int i = 1; i <= N; i += 2) {
        assert(i + 1 <= N);
        long double t0 = (i - 1) * step;
        long double t1 = (i) * step;
        long double t2 = (i + 1) * step;
        long double val0 = f(t0 + l, sqrt(norm(r * r - (q + t0) * (q + t0), 0.)));
        long double val1 = f(t1 + l, sqrt(norm(r * r - (q + t1) * (q + t1), 0.)));
        long double val2 = f(t2 + l, sqrt(norm(r * r - (q + t2) * (q + t2), 0.)));
        res2 += (val0 + val1 * 4 + val2) * step;
    }
 
    res2 /= 3; 
     
     
    long double res = 1e3 * (res1 + res0 + res2);
    assert(res == res);
    //assert(2 * res > res);
    //eprintf("res2 = %.20f\n", res2 * 1e-3);
    printf("%.20f\n", (double)(res));
    	eprintf("clock = %d ms\n", (int)clock());
}
/*
alpha = 0.000000
res0 = 14637.59668632216562400572
res1 = 4104.13475435696727799950
res2 = 4104.13475435696727799950
*/