#include <cstdio>
#include <cstring>
#include <algorithm>
#include <cassert>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <cstdlib>
#include <cmath>
#include <bitset>
#include <iostream>

#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#define all(c) (c).begin(), (c).end()
#define sz(c) (int)(c).size()
#define forn(i, n) for (int i = 0; i < (int)n; ++i)

using namespace std;

const int MAXN = 110;
const int MAXN3 = MAXN * MAXN * MAXN;
char all_cols[] = {'R', 'P', 'S'};
int col[MAXN];
int go[MAXN][3];
bitset<MAXN> sets[MAXN3];
map<pair<long long, long long>, int> vs;
int col2[MAXN3];
int go2[MAXN3][3];
int q[MAXN3];
int cnt[3];

pair<long long, long long> encode(bitset<MAXN> const& b) {
  pair<long long, long long> res = make_pair(0, 0);
  for (int i = 0; i < 55; ++i) if (b[i]) {
    res.first |= (1ll << i);
  }
  for (int j = 0; j < 55; ++j) if (b[55 + j]) {
    res.second |= (1ll << j);
  }
  return res;
}

int main() {
  assert(freopen("epic.in", "r", stdin));
  assert(freopen("epic.out", "w", stdout));
  int n;
  scanf("%d", &n);
  forn(i, n) {
    char ccol;
    scanf("\n%c %d %d %d", &ccol, &go[i][0], &go[i][1], &go[i][2]);
    --go[i][0];
    --go[i][1];
    --go[i][2];
    if (ccol == 'R') col[i] = 0;
    if (ccol == 'P') col[i] = 1;
    if (ccol == 'S') col[i] = 2;
  }
  forn(i, MAXN3) {
    sets[i] = 0;
  }
  forn(i, n) {
    sets[0][i] = 1;
  }
  int qs = 0, qe = 0;
  int size = 1;
  q[qe++] = 0;
  vs[encode(sets[0])] = 0;
  while (qs < qe) {
    int u = q[qs++];
    cnt[0] = cnt[1] = cnt[2] = 0;
    forn(i, n) if (sets[u][i]) {
      ++cnt[col[i]];      
    }
    if (cnt[0] >= cnt[1] && cnt[0] >= cnt[2]) {
      col2[u] = 1;
    } else if (cnt[1] >= cnt[2]) {
      col2[u] = 2;      
    } else {
      col2[u] = 0;
    }
    forn(acol, 3) {
      bitset<MAXN> nset = 0;
      bool fl = false;
      forn(i, n) if (sets[u][i] && col[i] == acol) {            
        nset[go[i][col2[u]]] = true;
        fl = true;
      }
      if (!fl) continue;

/*      forn(i, n) {
        cerr << nset[i];
      }
      cerr << endl;*/

      pair<long long, long long> code = encode(nset);
      if (vs.count(code)) {
        go2[u][acol] = vs[code];
      } else {
        int v = size++;
        sets[v] = nset;
        go2[u][acol] = v;
        vs[code] = v;
//        cerr << "add " << v << endl;
        q[qe++] = v;
      }
    }
  }
  printf("%d\n", size);
  forn(i, size) {
    printf("%c", all_cols[col2[i]]);
    forn(j, 3) {
      printf(" %d", go2[i][j] + 1);
    }
    printf("\n");
  }
}
