#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

const int MAXN = 100500;
const double eps = 1e-10;

int n;
double A, B, As, Bs;

struct ingredient{
	int id;
	double g, a, b, val;

	void scan(int idx){
		id = idx;
		scanf("%lf %lf %lf", &g, &a, &b);
		if (b < eps)
			val = 1000000;
		else
			val = a / b;
	}

	bool operator< (const ingredient &other) const{
		return val > other.val;
	}
};

bool doubleLess(double x, double y) {
	return x + eps < y;
}

vector<ingredient> ings;
double amounts[MAXN];

int main(){
	freopen("burrito.in", "rt", stdin);
	freopen("burrito.out", "wt", stdout);

	scanf("%d %lf %lf", &n, &A, &B);
	ings.resize(n);
	for (int i = 0; i < n; ++i){
		ings[i].scan(i);
	}
	sort(ings.begin(), ings.end());

	for (int i = 0; i < n; ++i){
		if (doubleLess(Bs + ings[i].b * ings[i].g, B) || ings[i].b < eps){
			Bs += ings[i].b * ings[i].g;
			As += ings[i].a * ings[i].g;
			amounts[ings[i].id] = ings[i].g;
		}
		else{
			double ost = (B - Bs) / ings[i].b;
			amounts[ings[i].id] = ost;
			Bs = B;
			As += ings[i].a * ost;
			//break;
		}
	}

	if (doubleLess(As, A)){
		printf("-1 -1");
		return 0;
	}

	printf("%.9lf %.9lf\n", As, Bs);
	for (int i = 0; i < n; i++){
		printf("%.9lf ", amounts[i]);
    }
	return 0;
}