#include <iostream>
#include <iomanip>
#include <string>
#include <vector>
#include <set>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <iterator>

using namespace std;

typedef long long ll;

bool is_set(const ll mask, int pos)
{
    return (((1LL << pos) & mask) != 0);
}

int from_hex (char c)
{
    if ('0' <= c && c <= '9')
        return c - '0';
    else if ('a' <= c && c <= 'f')
        return 10 + (c - 'a');
}

ll to_ll (const string &s, int m)
{
    ll res = 0;
    for (int i = 0; i < s.size(); ++i)
    {
        int h = from_hex (s[i]), hh = h;
        /*
        int hh = 0;
        int lim;
        if (i < s.size() || m % 4 == 0)
            lim = 4;
        else if (m % 4 != 0)
            lim = m % 4;
        for (int j = 0; j < lim; ++j)
        {
            if (is_set (h, j))
                hh |= (1LL << (lim - j - 1));
        }*/
        res |= (hh << (4*i));
//        cout << hh << endl;

    }

//    cout << s << " translates to ";
/*    for (int i = 0; i < m; ++i)
    {
        if (is_set (res, i))
            cout << 1;
        else cout << 0;
        if ((i+1) % 4 == 0)
            cout << " ";
    }
    cout << endl;*/
    return res;
}

bool has (ll bloom, vector <ll> &a, ll u, ll m)
{
    set <int> to_check;
    for (int i = 0; i < a.size(); ++i)
    {
        int idx = (u * a[i]) % m;
        to_check.insert (idx);
    }
    for (set<int>::iterator it = to_check.begin(); it != to_check.end(); ++it)
        if (!is_set (bloom, *it))
            return false;

    return true;
}

int main()
{
    freopen ("filter.in", "rt", stdin);
    freopen ("filter.out", "wt", stdout);

    int f;
    ll m;
    cin >> m >> f;
    vector <ll> a (f);
    for (int i = 0; i < f; ++i)
        cin >> a[i];

    int n;
    cin >> n;
    vector <ll> bloom (n);
    for (int i = 0; i < n; ++i)
    {
        string s;
        cin >> s;
        bloom[i] = to_ll (s, m);
    }

    int t;
    cin >> t;
    vector <int> cnt (n, 0);
    for (int i = 0; i < t; ++i)
    {
        ll u;
        cin >> u;
        for (int j = 0; j < n; ++j)
            if (has (bloom[j], a, u, m))
            {
                ++cnt[j];
//                cout << "Set " << j << " has user " << u << endl;
            }
    }
    cout << t - count (cnt.begin(), cnt.end(), 0);
    for (int i = 0; i < t; ++i)
        if (cnt[i] > 0)
            cout << " " << i;
    cout << endl;
    return 0;
}
