#include<iostream>
#include<fstream>
#include<string>
#include<cstdlib>
#include<vector>
#define f first
#define s second
#define mp make_pair
using namespace std;

int n, p[100][3], diffwep[100][100];
char weapon[100];

char finweapon[100];
int finmove[100][3];

pair<int, int> nextp[100][100][3];

string wstr = "RPS";

struct node {
	char w;
	int mv[3];
};

vector<node> nodes;



//------------------------------------------------------------------------
//Difference algorithm here

int differ(vector<int> &poses) {
	if (poses.size() == 0)
		return 0;

	int diffuse = -1;

	for (int i = 0; i < poses.size(); i++)
		for (int j = i; j < poses.size(); j++)
			if (diffwep[poses[i]][poses[j]] != -1)
				diffuse = diffwep[poses[i]][poses[j]];

	if (diffuse == -1)
		return -poses[0] - 1;


	int cind = nodes.size();
	nodes.resize(nodes.size() + 1);

	vector<int> nextpose[3];

	nodes.back().w = wstr[diffuse];

	for (int i = 0; i < poses.size(); i++) {
		int wind = wstr.find(weapon[poses[i]]);

		nextpose[wind].push_back(p[poses[i]][diffuse]);
	}

	nodes[cind].mv[0] = differ(nextpose[0]);
	nodes[cind].mv[1] = differ(nextpose[1]);
	nodes[cind].mv[2] = differ(nextpose[2]);

	return cind;
}




//------------------------------------------------------------------------
//Main algorithm here



int main() {
	ifstream in("epic.in");

	in >> n;

	//First we initialize the victory FSM
	for (int i = 0; i < n; i++) {
		in >> weapon[i];

		for (int j = 0; j < 3; j++)
			in >> p[i][j], finmove[i][j] = i, p[i][j]--;

		int wind = wstr.find(weapon[i]);

		finweapon[i] = wstr[(wind + 1) % 3];

		finmove[i][wind] = p[i][(wind + 1) % 3];
	}

	//Initialize the nextpair array and find all the pairs that are initially differenciable

	for(int i=0;i<n;i++)
		for (int j = i; j < n; j++)
			for(int w=0;w<3;w++) {
				
				int fnext = p[i][w], snext = p[j][w];

				if (snext < fnext)
					swap(fnext, snext);

				nextp[i][j][w] = mp(fnext, snext);

				diffwep[i][j] = -1;

				if (weapon[fnext] != weapon[snext])
					diffwep[fnext][snext] = 0;
			}



	//Next we find all the pairs that are differenciable
	//Note that if a pair is not differenciable, then we can pick any one of the satisfying fsms

	bool done = false;

	while (!done) {
		done = true;

		for(int i=0;i<n;i++)
			for (int j = i; j < n; j++)
				if(diffwep[i][j] == -1)
					for(int w=0;w<3;w++) {
					
						pair<int, int> nx = nextp[i][j][w];
						if (diffwep[nx.f][nx.s] != -1) {
							diffwep[i][j] = w;
							done = false;
						}
					}
	}



	//Finally we create the differenciation fsm

	vector<int> ini;
	for (int i = 0; i < n; i++)
		ini.push_back(i);


	differ(ini);


	for (int i = 0; i < nodes.size(); i++)
		for (int j = 0; j < 3; j++) {
			if (nodes[i].mv[j] < 0)
				nodes[i].mv[j] = nodes.size() - nodes[i].mv[j] - 1;
			else
				nodes[i].mv[j]++;
		}


	ofstream out("epic.out");

	out << nodes.size() + n << '\n';

	for (int i = 0; i < nodes.size(); i++)
		out << nodes[i].w << ' ' << nodes[i].mv[0] << ' ' << nodes[i].mv[1] << ' ' << nodes[i].mv[2] << '\n';

	for (int i = 0; i < n; i++)
		out << finweapon[i] << ' ' << nodes.size() + finmove[i][0] + 1 << ' ' << nodes.size() + finmove[i][1] + 1 << ' ' << nodes.size() + finmove[i][2] + 1 << '\n';

	return 0;
}