#include<iostream>
#include<fstream>
#include<string>
#include<sstream>
#include<vector>

using namespace std;

string s;
bool posfixed[100], found[51];
int num[100];
int uto = 0, slen = 0;

vector<int> op;


//--------------------------------------------------------------------------------
//Preprocessing function here

bool preproc() {
	bool done = false;

	while (!done) {
		done = true;

		for (int i = 1; i <= uto; i++) {
			if (found[i])
				continue;

			string cur;

			int p = i;

			while (p > 0) {
				cur = string(1, '0' + p % 10) + cur;
				p /= 10;
			}

			int app = -1;

			//Here we find the places that match
			for (int j = 0; j <= slen - cur.size(); j++) {
				bool match = true;

				for (int k = 0; k < cur.size(); k++)
					if (posfixed[j + k] || s[j + k] != cur[k])
						match = false;

				if (match) {
					if (app == -1)
						app = j;
					else
						app = -2;
				}
			}


			//Finally deal with the result
			if (app == -1)
				return false;

			else if (app != -2) {
				for (int k = 0; k < cur.size(); k++)
					posfixed[app + k] = true;

				num[app] = i;
				done = false;
				op.push_back(app);
				found[i] = true;
			}
		}

	}

	return true;
}



void unop(int pos) {
	int ind = 0;

	found[num[pos]] = false;

	while (num[pos] != 0) {
		posfixed[pos + ind] = true;

		num[pos] /= 10;
		ind++;
	}
}

void undoto(int opsz) {
	while (op.size() > opsz)
		unop(op.back()), op.pop_back();
}


int strnum(int beg, int fin) {
	if (fin < beg)
		return 0;
	return (s[fin] - '0') + 10 * strnum(beg, fin-1);
}



//-------------------------------------------------------------------------------------
//Complete search function here

bool solve(int pos) {
	if (pos == slen)
		return true;

	if (posfixed[pos] == true)
		return solve(pos + 1);

	if (s[pos] == '0')
		return false;


	int opind = op.size();

	//First pick next two characters

	if (!posfixed[pos + 1] && strnum(pos, pos + 1) <= uto && !found[strnum(pos, pos+1)] ) {
		num[pos] = strnum(pos, pos + 1);
		found[strnum(pos, pos + 1)] = true;

		posfixed[pos] = true;
		posfixed[pos + 1] = true;
		op.push_back(pos);

		if (preproc() && solve(pos + 2))
			return true;

		undoto(opind);
	}

	//Next pick just the next character

	if (!found[strnum(pos, pos + 1)]) {
		num[pos] = strnum(pos, pos);
		found[strnum(pos, pos)] = true;

		posfixed[pos] = true;
		op.push_back(pos);

		if (preproc() && solve(pos + 1))
			return true;

		undoto(opind);
	}

	return false;
}



//-------------------------------------------------------------------
//Main function here

int main() {
	ifstream in("joke.in");

	in >> s;


	for (int i = 1; i < 100 && slen < s.size(); i++) {
		int p = i;

		uto++;

		while (p > 0)
			slen++, p /= 10;
	}

	//First do the preprocessing:
	preproc();



	//Next perform the binary search
	solve(0);



	//Finally find the result

	ofstream out("joke.out");

	for (int i = 0; i < slen; i++)
		if (num[i] != 0)
			out << num[i] << ' ';
	out << '\n';

	return 0;
}