import java.io.*;
import java.util.*;

public class TaskB extends PrintWriter {
    BufferedReader in;
    StringTokenizer stok;

    static String FILENAME = "burrito";

    class Item implements Comparable<Item> {
        long cnt, a, b;
        int id;
        boolean bad = false;
        double part = 0;

        Item(int cnt, int a, int b, int id) {
            this.cnt = cnt;
            this.a = a;
            this.b = b;
            this.id = id;
        }

        @Override
        public int compareTo(Item o) {
            if (bad) {
                if (o.bad) {
                    return 0;
                }
                return 1;
            }
            if (o.bad) {
                return -1;
            }
            long a = this.a;
            long b = this.b;
            long c = o.a;
            long d = o.b;
            return Long.compare(b * c, a * d);
        }
    }

    void solve() throws IOException {
        int n = nextInt();
        int A = nextInt();
        int B = nextInt();
        List<Item> a = new ArrayList<>();
        for (int i = 0; i < n; i++) {
            Item it = new Item(nextInt(), nextInt(), nextInt(), i);
            if (it.a == 0) {
                it.bad = true;
            }
            a.add(it);
        }
        Collections.sort(a);
        double curA = 0, curB = 0;
        for (Item i : a) {
            if (i.bad) {
                continue;
            }
            if (i.b == 0 || i.b * i.cnt + curB < B + 1e-9) {
                curA += i.a * i.cnt;
                curB += i.b * i.cnt;
                i.part = i.cnt;
            } else {
                i.part = (B - curB) / i.b;
                curA += i.a * i.part;
                curB += i.b * i.part;
                break;
            }
        }
        Collections.sort(a, (i1, i2) -> i1.id - i2.id);
        if (curA > A - 1e-9) {
            printf("%.11f %.11f%n", curA, curB);
            for (Item i : a) {
                printf("%.11f ", i.part);
            }
        } else {
            println("-1 -1");
        }
    }

    void run() {
        try {
            solve();
            close();
        } catch (Exception e) {
            System.exit(1);
        }
    }

    TaskB() throws IOException {
        super(System.out);
        in = new BufferedReader(new InputStreamReader(System.in));
    }

    TaskB(String s) throws IOException {
        super(s + ".out");
        in = new BufferedReader(new FileReader(s + ".in"));
    }

    public static void main(String[] args) throws IOException {
        if (FILENAME == null) {
            new TaskB().run();
        } else {
            new TaskB(FILENAME).run();
        }
    }

    String next() throws IOException {
        while (stok == null || !stok.hasMoreTokens()) {
            String s = in.readLine();
            if (s == null) {
                return null;
            }
            stok = new StringTokenizer(s);
        }
        return stok.nextToken();
    }

    int nextInt() throws IOException {
        return Integer.parseInt(next());
    }
}