import java.io.*;
import java.util.*;

public class TaskB extends PrintWriter {
    BufferedReader in;
    StringTokenizer stok;

    static String FILENAME = "burrito";

    class Item implements Comparable<Item> {
        long cnt, a, b;
        int id;
      /*  boolean bad = false;
        double part = 0;*/

        Item(int cnt, int a, int b, int id) {
            this.cnt = cnt;
            this.a = a;
            this.b = b;
            this.id = id;
        }

        @Override
        public int compareTo(Item o) {
            /*if (bad) {
                if (o.bad) {
                    return 0;
                }
                return 1;
            }
            if (o.bad) {
                return -1;
            }*/
            long a = this.a;
            long b = this.b;
            long c = o.a;
            long d = o.b;
            return Long.compare(b * c, a * d);
        }
    }

    void solve() throws IOException {
        int n = nextInt();
        int A = nextInt();
        int B = nextInt();
        List<Item> a = new ArrayList<>();
        double[] ans = new  double[n];

        double curA = 0, curB = 0;
        for (int i = 0; i < n; i++) {
            Item it = new Item(nextInt(), nextInt(), nextInt(), i);
            if (it.b == 0) {
                ans[i] = it.cnt;
                curA += it.cnt * it.a;
                continue;
            }
            if (it.a == 0) {
                continue;
            }
            a.add(it);
        }
        Collections.sort(a);
        int i = 0;
        for (Item it : a) {
           /* if (i.bad) {
                continue;
            }*/
            if (/*i.b == 0 || */it.b * it.cnt + curB <= B) {
                curA += it.a * it.cnt;
                curB += it.b * it.cnt;
                ans[i] = it.cnt;
            } else {
                ans[i] = (1.0* B - curB) / it.b;
                curA += it.a * ans[i];
                curB += it.b * ans[i];
                break;
            }
            i++;
        }
        //Collections.sort(a, (i1, i2) -> i1.id - i2.id);
        if (curA >= A) {
            printf("%.11f %.11f%n", curA, curB);
            for (int j = 0; j < n; j++) {
                print(ans[j] + " " );
            }
        } else {
            println("-1 -1");
        }
    }

    void run() {
        try {
            solve();
            close();
        } catch (Exception e) {
            System.exit(1);
        }
    }

    TaskB() throws IOException {
        super(System.out);
        in = new BufferedReader(new InputStreamReader(System.in));
    }

    TaskB(String s) throws IOException {
        super(s + ".out");
        in = new BufferedReader(new FileReader(s + ".in"));
    }

    public static void main(String[] args) throws IOException {
        if (FILENAME == null) {
            new TaskB().run();
        } else {
            new TaskB(FILENAME).run();
        }
    }

    String next() throws IOException {
        while (stok == null || !stok.hasMoreTokens()) {
            String s = in.readLine();
            if (s == null) {
                return null;
            }
            stok = new StringTokenizer(s);
        }
        return stok.nextToken();
    }

    int nextInt() throws IOException {
        return Integer.parseInt(next());
    }
}