import java.io.*;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.StringTokenizer;

public class TaskE extends PrintWriter {
    BufferedReader in;
    StringTokenizer stok;

    static String FILENAME = "epic";

    final int ROCK = 0;
    final int PAPER = 1;
    final int SCISSORS = 2;

    int f(char c) {
        switch (c) {
            case 'R':
                return ROCK;
            case 'P':
                return PAPER;
            case 'S':
                return SCISSORS;
            default:
                throw new AssertionError();
        }
    }

    final char[] back = new char[]{'R', 'P', 'S'};

    int win(int type) {
        switch (type) {
            case ROCK:
                return PAPER;
            case PAPER:
                return SCISSORS;
            case SCISSORS:
                return ROCK;
            default:
                throw new AssertionError();
        }
    }

    int ids = 0;
    List<Node> weAll = new ArrayList<>();

    class Node {
        final int id;
        int play, winId;
        Node[] to;

        Node(int id) {
            this.id = id;
            to = new Node[3];
            to[0] = to[1] = to[2] = this;
        }

        Node() {
            this(ids++);
            weAll.add(this);
        }

        @Override
        public String toString() {
            return String.format("%c %d %d %d", back[play], to[0].id + 1, to[1].id + 1, to[2].id + 1);
        }
    }

    Node[] inNodes;
    Node[] tmp;

    Node[] coolNodes;

    Node cool(Node cur) {
        Node cn = coolNodes[cur.id];
        if (cn == null) {
            cn = new Node();
            cn.play = win(cur.play);
            coolNodes[cur.id] = cn;
            cn.to[cur.play] = cool(cur.to[cn.play]);
        }
        return cn;
    }

    void solve() throws IOException {
        int n = nextInt();
        inNodes = new Node[n];
        for (int i = 0; i < n; i++) {
            inNodes[i] = new Node(i);
        }
        for (int i = 0; i < n; i++) {
            Node node = inNodes[i];
            node.play = f(next().charAt(0));
            for (int j = 0; j < 3; j++) {
                node.to[j] = inNodes[nextInt() - 1];
            }
        }

        tmp = new Node[n];
        Node[][] wins = new Node[n][n];
        for (int i = 0; i < n; i++) {
            coolNodes = wins[i];
            for (int j = 0; j < n; j++) {
                if (coolNodes[inNodes[j].id] == null) {
                    cool(inNodes[j]);
                }
            }
        }

        int[][] was = new int[n][ids];
        int time = 0;
        for (int i = 0; i < n; i++) {
            Node cur = inNodes[i];
            Node we = wins[0][0];
            int curLayer = 0;
            time++;
            while (was[cur.id][we.id] != time) {
                was[cur.id][we.id] = time;
                Node next = cur.to[we.play];
                if (win(cur.play) != we.play) {

                    we.to[cur.play] = wins[curLayer + 1][next.id];
                    curLayer++;
                    if (curLayer == n - 1)
                        curLayer = 0;
                } else {
                    we.to[cur.play] = wins[curLayer][next.id];
                }
                Node weNext = we.to[cur.play];
                we = weNext;
                cur = next;
            }
        }
        println(weAll.size());
        for (Node i : weAll) {
            println(i);
        }
    }

    void run() {
        try {
            solve();
            close();
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    TaskE() throws IOException {
        super(System.out);
        in = new BufferedReader(new InputStreamReader(System.in));
    }

    TaskE(String s) throws IOException {
        super(s + ".out");
        in = new BufferedReader(new FileReader(s + ".in"));
    }

    public static void main(String[] args) throws IOException {
        if (FILENAME == null) {
            new TaskE().run();
        } else {
            new TaskE(FILENAME).run();
        }
    }

    String next() throws IOException {
        while (stok == null || !stok.hasMoreTokens()) {
            String s = in.readLine();
            if (s == null) {
                return null;
            }
            stok = new StringTokenizer(s);
        }
        return stok.nextToken();
    }

    int nextInt() throws IOException {
        return Integer.parseInt(next());
    }

    long nextLong() throws IOException {
        return Long.parseLong(next());
    }

    double nextDouble() throws IOException {
        return Double.parseDouble(next());
    }
}