import java.io.*;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.StringTokenizer;

public class TaskF extends PrintWriter {
    BufferedReader in;
    StringTokenizer stok;

    static String FILENAME = "filter";

    boolean get(char c, int i) {
        int x = 0;
        if (c <= '9')
            x = c - '0';
        else
            x = 10 + c - 'a';
        int res = (x >> i) & 1;
        if (res == 1)
            return true;
        else return false;
    }

    void solve() throws IOException {
        int m = nextInt(), f = nextInt();
        long[] a = new long[f];
        for (int i = 0; i < f; ++i)
            a[i] = nextInt();
        int n = nextInt();
        boolean[][] bloom = new boolean[m][n];
        for (int i = 0; i < n; ++i) {
            char[] c = next().toCharArray();
            for (int j = 0; j < m; j++) {
                char ch = c[j / 4];
                bloom[j][i] = get(ch, j % 4);
            }
        }

        boolean[] good = new boolean[n];
        boolean[] bits = new boolean[m];
        int q = nextInt();
        for (int i = 0; i < q; ++i) {
            int u = nextInt();
            boolean[] ok = new boolean[n];
            Arrays.fill(ok, true);
            for (int j = 0; j < f; ++j) {
                int x = (int)((u * a[j]) % m);
                for (int k = 0; k < n; k++)
                    if (!bloom[x][k])
                        ok[k] = false;
            }
            for (int j = 0; j < n; j++)
                if (ok[j])
                    good[j] = true;
        }
        ArrayList<Integer> ans = new ArrayList<>();
        for (int i = 0; i < n; ++i)
            if (good[i])
                ans.add(i);

        print(ans.size() + " ");
        for (int x : ans)
            print(x + " ");
    }

    void run() {
        try {
            solve();
            close();
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    TaskF() throws IOException {
        super(System.out);
        in = new BufferedReader(new InputStreamReader(System.in));
    }

    TaskF(String s) throws IOException {
        super(s + ".out");
        in = new BufferedReader(new FileReader(s + ".in"));
    }

    public static void main(String[] args) throws IOException {
        if (FILENAME == null) {
            new TaskF().run();
        } else {
            new TaskF(FILENAME).run();
        }
    }

    String next() throws IOException {
        while (stok == null || !stok.hasMoreTokens()) {
            String s = in.readLine();
            if (s == null) {
                return null;
            }
            stok = new StringTokenizer(s);
        }
        return stok.nextToken();
    }

    int nextInt() throws IOException {
        return Integer.parseInt(next());
    }

    long nextLong() throws IOException {
        return Long.parseLong(next());
    }

    double nextDouble() throws IOException {
        return Double.parseDouble(next());
    }
}