import java.io.*;
import java.util.Arrays;
import java.util.StringTokenizer;

public class TaskI extends PrintWriter {
    BufferedReader in;
    StringTokenizer stok;

    static String FILENAME = "improvements";

    void solve() throws IOException {
        int n =nextInt();
        int[] a = new int[n + 1];
        for (int i = 0; i < n; i++) {
            a[nextInt()] = i + 1;
        }

        int[] l = new int[n + 1];
        int[] r = new int[n + 1];
        Arrays.fill(l, 1);
        Arrays.fill(r, 1);
        l[0] = r[0] = 0;
        for (int i = n; i >= 1; i--) {
            for (int j = i + 1; j <= n; j++) {
                if (a[j] < a[i]) {
                    r[i] = Math.max(r[i], r[j] + 1);
                }
            }
        }


        for (int i = 1; i <= n; i++) {
            for (int j = i - 1; j > 0; j--) {
                if (a[j] < a[i]) {
                    l[i] = Math.max(l[i], l[j] + 1);
                }
            }
        }

        int ans = 0;

        /*for (int x : l) {
            print(x + " " );
        }
        println();
        for (int x : r) {
            print(x + " " );
        }
        println();
        */
        for (int i = 0; i <= n; i++) {
            for (int j = i + 1; j <= n; j++) {
                ans = Math.max(ans, l[i] + r[j]);
            }
        }
        println(ans);
    }


    void run() {
        try {
            solve();
            close();
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    TaskI() throws IOException {
        super(System.out);
        in = new BufferedReader(new InputStreamReader(System.in));
    }

    TaskI(String s) throws IOException {
        super(s + ".out");
        in = new BufferedReader(new FileReader(s + ".in"));
    }

    public static void main(String[] args) throws IOException {
        if (FILENAME == null) {
            new TaskI().run();
        } else {
            new TaskI(FILENAME).run();
        }
    }

    String next() throws IOException {
        while (stok == null || !stok.hasMoreTokens()) {
            String s = in.readLine();
            if (s == null) {
                return null;
            }
            stok = new StringTokenizer(s);
        }
        return stok.nextToken();
    }

    int nextInt() throws IOException {
        return Integer.parseInt(next());
    }

    long nextLong() throws IOException {
        return Long.parseLong(next());
    }

    double nextDouble() throws IOException {
        return Double.parseDouble(next());
    }
}