import java.io.*;
import java.util.Arrays;
import java.util.StringTokenizer;

public class TaskI extends PrintWriter {
    BufferedReader in;
    StringTokenizer stok;

    static String FILENAME = "improvements";

    int[] longest(int[] a) {
        int n = a.length;
        int[] d = new int[n + 1];
        Arrays.fill(d, Integer.MAX_VALUE);
        d[0] = 0;
        int[] res = new int[n];
        for (int i = 0; i < n; i++) {
            int l = 0;
            int r = n + 1;
            while (r - l > 1) {
                int m = (l + r) >> 1;
                if (d[m] > a[i]) {
                    r = m;
                } else {
                    l = m;
                }
            }
            res[i] = l + 1;
            d[l + 1] = Math.min(d[l + 1], a[i]);
        }
        return res;
    }


    void solve() throws IOException {
        int n =nextInt();
        int[] a = new int[n + 1];
        for (int i = 0; i < n; i++) {
            a[nextInt()] = i + 1;
        }



        a[0] = n + 1;
        int[] l = longest(a);
        l[0] = 0;

        int[] b = new int[n + 1];
        for (int i = 1; i <= n; i++) {
            b[i] = a[n + 1 - i];
        }

        b[0] = n + 1;
        int[] rr = longest(b);
        int[] r = new int[n + 1];
        for (int i = 1; i <= n; i++) {
            r[i] = rr[n - i + 1];
        }
        r[0] = 0;


        /*for (int i = n; i >= 1; i--) {
            for (int j = i + 1; j <= n; j++) {
                if (a[j] < a[i]) {
                    r[i] = Math.max(r[i], r[j] + 1);
                }
            }
        }


        for (int i = 1; i <= n; i++) {
            for (int j = i - 1; j > 0; j--) {
                if (a[j] < a[i]) {
                    l[i] = Math.max(l[i], l[j] + 1);
                }
            }
        }*/

        int ans = 0;
/*
        for (int x : l) {
            print(x + " " );
        }
        println();
        for (int x : r) {
            print(x + " " );
        }
        println();
*/
        /*
        for (int i = 0; i <= n; i++) {
            for (int j = i + 1; j <= n; j++) {
                ans = Math.max(ans, l[i] + r[j]);
            }
        }*/
        int curmax = l[0];
        for (int i = 1; i <= n; i++) {
            ans = Math.max(ans, r[i] + curmax);
            curmax = Math.max(curmax, l[i]);
        }
        ans = Math.max(ans, curmax);
        println(ans);
    }


    void run() {
        try {
            solve();
            close();
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    TaskI() throws IOException {
        super(System.out);
        in = new BufferedReader(new InputStreamReader(System.in));
    }

    TaskI(String s) throws IOException {
        super(s + ".out");
        in = new BufferedReader(new FileReader(s + ".in"));
    }

    public static void main(String[] args) throws IOException {
        if (FILENAME == null) {
            new TaskI().run();
        } else {
            new TaskI(FILENAME).run();
        }
    }

    String next() throws IOException {
        while (stok == null || !stok.hasMoreTokens()) {
            String s = in.readLine();
            if (s == null) {
                return null;
            }
            stok = new StringTokenizer(s);
        }
        return stok.nextToken();
    }

    int nextInt() throws IOException {
        return Integer.parseInt(next());
    }

    long nextLong() throws IOException {
        return Long.parseLong(next());
    }

    double nextDouble() throws IOException {
        return Double.parseDouble(next());
    }
}