#include <iostream>
#include <cstdio>
#include <climits>
#include <memory.h>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <deque>
#include <iomanip>
#include <algorithm>
#include <numeric>

using namespace std;

const double e = 1e-10;

struct T
{
	int g, a, b, num;
	long double r;
	T(int g, int a, int b, int num, long double r) : g(g), a(a), b(b), num(num), r(r) {}
};

vector<T> v;

int cmp(T u, T v)
{
	return u.r > v.r;
}

vector<long double> res;

int main()
{
#ifdef LOCAL
	freopen("input.txt", "rt", stdin);
	freopen("output.txt", "wt", stdout);
#else
	freopen("burrito.in", "rt", stdin);
	freopen("burrito.out", "wt", stdout);
#endif
	int n, A, B;
	scanf("%d %d %d", &n, &A, &B);
	for (int i = 0; i < n; i++)
	{
		int g, a, b;
		scanf("%d %d %d", &g, &a, &b);
		v.push_back(T(g, a, b, i, b == 0 ? INT_MAX : ((long double)a)/b));
	}
	sort(v.begin(), v.end(), cmp);
	res.assign(n, 0);
	long long a = 0, b = 0;
	long double d_a = 0, d_b = 0;
	for (int i = 0; i < n; i++)
	{
		if (v[i].a == 0)
			continue;
		if (v[i].b * v[i].g <= (B - b))
		{
			res[v[i].num] = v[i].g;
			b += v[i].b * v[i].g;
			a += v[i].a * v[i].g;
			d_a = a;
			d_b = b;
		}
		else
		{
			if (1LL*(A - a) * v[i].b > 1LL*(B - b) * v[i].a)
			{
				cout << "-1 -1";
				return 0;
			}
			long double k;
			if (v[i].b == 0)
				k = v[i].g;
			else
			    k = ((long double)B - b) / v[i].b;
			d_a = a + v[i].a * k;
			d_b = b + v[i].b * k;
			res[v[i].num] = k;
			break;
		}
	}
	if (d_a+e < A)
	{
		cout << "-1 -1";
		return 0;
	}
	cout << fixed << setprecision(8) << d_a << ' ' << d_b << endl;
	for (int i = 0; i < n; i++)
		cout << fixed << setprecision(8) << res[i] << ' ';
    return 0;
}