#include <iostream>
#include <cstdio>
#include <climits>
#include <memory.h>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <deque>
#include <iomanip>
#include <algorithm>
#include <numeric>

using namespace std;

const int MAXF = 110;
const int MAXN = 1100;
const int MAXM = 1100;
const int MAXQ = 1100;
const int MAXWCNT = (MAXM + 31) / 32;
int a[MAXF];
unsigned files[MAXN][MAXWCNT];

char s[MAXM];
unsigned cur_hash[MAXWCNT];

inline void calc_hash(int u, int f, int m)
{
	memset(cur_hash, 0, sizeof(cur_hash));
	for (int i = 0; i < f; ++i)
	{
		int j = (u * 1LL * a[i]) % m;
		int wpos = j >> 5; // j / 32
		int bpos = j & 31;
		cur_hash[wpos] |= 1U << bpos;
	}
}

inline bool test_file(int d)
{
	for (int i = 0; i < MAXWCNT; ++i)
		if ((cur_hash[i] & files[d][i]) != cur_hash[i])
			return false;
	return true;
}

int main()
{
#ifdef LOCAL
	freopen("input.txt", "rt", stdin);
	freopen("output.txt", "wt", stdout);
#else
	freopen("filter.in", "rt", stdin);
	freopen("filter.out", "wt", stdout);
#endif
	int m, f;
	scanf("%d%d", &m, &f);
	for (int i = 0; i < f; ++i)
		scanf("%d", &a[i]);

	int charcnt = (m + 3) / 4;
	int n;
	scanf("%d", &n);
	for (int i = 0; i < n; ++i)
	{
		scanf("%s", s);
		for (int j = 0; s[j]; ++j)
		{
			int w = j >> 3; // j / 8
			int digit;
            sscanf(s + j, "%1x", &digit);
			files[i][w] = files[i][w] | (digit << (j % 8 * 4));
		}
	}
	int q;
	scanf("%d", &q);
	vector<int> u(q);
	for (int i = 0; i < q; ++i)
		scanf("%d", &u[i]);

	vector<int> res(n);
	for (int i = 0; i < q; ++i)
	{
		calc_hash(u[i], f, m);
		for (int j = 0; j < n; ++j)
			if (test_file(j))
				res[j] = 1;
	}

	int sum = accumulate(res.begin(), res.end(), 0);
	printf("%d", sum);
	for (int i = 0; i < (int)res.size(); ++i)
		if (res[i])
			printf(" %d", i);
	puts("");
	return 0;
}