#include <iostream>
#include <cstdio>
#include <string>
#include <cassert>
#include <vector>
#include <cstdlib>
#include <sstream>
#include <algorithm>
#include <ctime>
#include <set>
#include <map>
#include <cstring>

using namespace std;

#define forab(i, a, b) for(int i = int(a); i < int(b); ++i)
#define forn(i, n) forab(i, 0, n)
#define forba(i, b, a) for(int i = int(b) - 1; i >= int(a); --i)

typedef long long ll;
typedef long double ldb;

const int MAXN = 110;

const char intToCh[] = {'R', 'P', 'S'};
const int losesTo[] = {1, 2, 0};

map<char, int> chToInt;

struct msk{
    ll x[2];

    msk() {
        x[0] = x[1] = 0;
    }

    bool getBit(int i) {
        if (i < 64)
            return (x[0] & (1ll << i));
        return (x[1] & (1ll << (i - 64)));
    }

    void set1(int i) {
        if (i < 64)
            x[0] |= (1ll << i);
        else
            x[1] |= (1ll << (i - 64));
    }

    void set0(int i) {
        if (i < 64)
            x[0] &= ~(1ll << i);
        else
            x[1] &= ~(1ll << (i - 64));
    }

    bool operator <(const msk & mask) const {
        if (x[0] != mask.x[0])
            return x[0] < mask.x[0];
        return x[1] < mask.x[1];
    }
};

int n;
int turn[MAXN];
int to[3][MAXN];

int sz = 0;
map<msk, int> getNum;
vector<int> myTo[3];
vector<int> myTurn;

int addNewMask(msk mask) {
    getNum[mask] = sz;
    forn(q, 3)
        myTo[q].push_back(-1);

    int cnt[3];
    memset(cnt, 0, sizeof(cnt));
    forn(i, n)
        if (mask.getBit(i))
            cnt[turn[i]]++;
    int t = 0;
    forn(q, 3)
        if (cnt[q] > cnt[t])
            t = q;

    myTurn.push_back(losesTo[t]);

    /*forn(i, n)
        cerr << mask.getBit(i);
    cerr << ' ' << sz + 1 << '\n';*/

    return sz++;
}

void dfs(msk mask) {
    int num = getNum[mask];

    forn(q, 3) {
        msk nxt = msk();
        forn(i, n)
            if (mask.getBit(i) && turn[i] == q)
                nxt.set1(to[myTurn[num]][i]);

        if (!getNum.count(nxt)) {
            int nxtNum = addNewMask(nxt);
            myTo[q][num] = nxtNum;
            dfs(nxt);
        } else
            myTo[q][num] = getNum[nxt];
    }
}

int main()
{
    freopen("epic.in", "r", stdin);
    freopen("epic.out", "w", stdout);

    chToInt['R'] = 0;
    chToInt['P'] = 1;
    chToInt['S'] = 2;

    scanf("%d", &n);
    forn(i, n) {
        char c;
        scanf(" %c %d%d%d ", &c, &to[0][i], &to[1][i], &to[2][i]);
        forn(q, 3)
            to[q][i]--;
        turn[i] = chToInt[c];
    }

    msk st;
    forn(i, n)
        st.set1(i);
    addNewMask(st);
    dfs(st);

    printf("%d\n", sz);
    forn(i, sz)
        printf("%c %d %d %d\n", intToCh[myTurn[i]], myTo[0][i] + 1, myTo[1][i] + 1, myTo[2][i] + 1);

    return 0;
}

