#include <cstdio>
#include <iostream>
#include <cstdlib>
#include <vector>
#include <cstring>

#define FOR(a, b) for (int a = 0; a < (b); ++a)
#define clr(a) memset(a, 0, sizeof(a))

using namespace std;

typedef long long ll;
const int n = 19;
const ll INF = 1e18 + 1000;
const int dx[4] = {1, 1, 0, -1};
const int dy[4] = {0, -1,-1, -1};

int board[n][n];

bool good(int x, int y) {
	return x>= 0 && y >= 0 && x < n && y < n;
}

ll pow[10];

ll score(int * c) {
	if (c[1] != 0 && c[2] != 0)
		return 0;
	if (c[2] != 0) {
		return pow[2 * c[2] - 1];
	}
	if (c[1] != 0) {
		return -pow[2 * c[1]];
	}
	return 0;
}

ll get(int x, int y) {
	ll res = 0;
	FOR(d, 4) {
		int c[3];
		FOR(j, 5) {
			clr(c);
			int tx = x - j * dx[d];
			int ty = y - j * dy[d];
			bool flag = true;
			FOR(k, 5) {
				if (!good(tx, ty)) {
					flag = false;
					break;
				}
				c[board[tx][ty]]++;
				tx += dx[d];
				ty += dy[d];
			}
			if (!flag)
				continue;
			res += score(c);
		}
	}
	return res;

}

ll value(int x, int y) {
	
	board[x][y] = 0;
	ll sc1 = get(x, y);

	board[x][y] = 2;
	ll sc2 = get(x, y);
	board[x][y] = 0;
//	cerr << sc2 << ' ' << sc1 << '\n';
	return sc2 - sc1;
}

int main() {
//	freopen("filter.in", "r", stdin);
//	freopen("filter.out", "w", stdout);
	clr(board);
	pow[0] = 1;
	FOR(i, 10) {
		pow[i + 1] = pow[i] * 50;
	}
	/*
	board[0][0] = 1;
	cerr << value(1, 1) << '\n';*/
	while (true) {
		int x, y;
		scanf("%d%d", &x, &y);
		if (x == -1)
			break;
		x--, y--;
		board[x][y] = 1;
		ll best = -INF;
		int bestx, besty;
		FOR(i, n)
			FOR(j, n) {
				if (board[i][j] != 0)
					continue;
	//			board[i][j] = 2;
				int val = value(i, j);
	//			board[i][j] = 0;
				if (val > best) {
					best = val;
					bestx = i;
					besty = j;
				}
			}
		board[bestx][besty] = 2;
		printf("%d %d\n", bestx + 1, besty + 1);
		fflush(stdout);
	}
	return 0;

}


