#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <queue>

#define all(v) v.begin(), v.end()
typedef long long ll;

using namespace std;
const double inf = 1e9;
const double eps = 1e-9;

struct ingr {
	ingr(int g, int a, int b) 
	: g(g), a(a), b(b) {
		if (b == 0)
			o = inf;
		else
			o = (double)a / (double)b;
	}

	int g, a, b;
	int n;
	double taken;
	double o;
};

bool cmp_o(const ingr &a, const ingr &b) {
	return a.o < b.o;
}

bool cmp_n(const ingr &a, const ingr &b) {
	return a.n < b.n;
}

int main()
{
	ios_base::sync_with_stdio(false);
	freopen("burrito.in", "r", stdin);
	freopen("burrito.out", "w", stdout);
	int n, A, B;
	vector < ingr > vc;
	cin >> n >> A >> B;
	for (int i = 0; i < n; ++i) {
		int g, a, b;
		cin >> g >> a >> b;
		vc.push_back(ingr(g, a, b));
		vc.back().n = i;
	}
	sort(all(vc), cmp_o);
	reverse(all(vc));

	double mA = 0, mB = 0;
	for (int i = 0; i < vc.size(); ++i) {
		if (vc[i].o < eps)
			break;
		double d = (double)B - mB;
		if (d < eps)
			break;
		double ng = d / vc[i].b;
		ng = min((double)vc[i].g, ng);
		vc[i].taken = ng;
		mA += (double)vc[i].a * ng;
		mB += (double)vc[i].b * ng;
	}

	if ((double)A - mA > eps) {
		cout << -1 << " " << -1 << endl;
		return 0;
	}
	cout << mA << " " << mB << endl;
	sort(all(vc), cmp_n);
	
	for (int i = 0; i < vc.size(); ++i) {
		cout << vc[i].taken << " ";
	}

	return 0;
}