#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <queue>
#include <iomanip>

#define all(v) v.begin(), v.end()
typedef long long ll;

using namespace std;
const double inf = 1e7;
const double eps = 1e-10;

struct ingr {
	ingr(int g, int a, int b) 
	: g(g), a(a), b(b) {
		if (b == 0)
			o = inf;
		else
			o = (double)a / (double)b;
		if (a == 0)
			o = 0;
		taken = 0;
	}

	ll g, a, b;
	int n;
	double taken;
	double o;
};

bool cmp_o(const ingr &a, const ingr &b) {
	return a.o < b.o;
}

bool cmp_n(const ingr &a, const ingr &b) {
	return a.n < b.n;
}

int main()
{
	//ios_base::sync_with_stdio(false);
	freopen("burrito.in", "r", stdin);
	freopen("burrito.out", "w", stdout);
	int n, A, B;
	vector < ingr > vc;
	cin >> n >> A >> B;
	for (int i = 0; i < n; ++i) {
		int g, a, b;
		cin >> g >> a >> b;
		vc.push_back(ingr(g, a, b));
		vc.back().n = i;
	}
	sort(all(vc), cmp_o);
	reverse(all(vc));

	ll mA = 0, mB = 0;
	double mAs = -1, mBs = -1;
	bool flag = false;
	for (int i = 0; i < vc.size(); ++i) {
		//if (vc[i].o < eps)
		//	break;
		ll nmB = mB + vc[i].b * vc[i].g;
		if (nmB > B) {
			ll d = B - mB;
			double ng = (double)d / (double)vc[i].b;
			mAs = (double)mA + (double)vc[i].a * ng;
			mBs = (double)mB + (double)vc[i].b * ng;
			while (mBs - B > eps) {
				ng -= eps;
				mAs = (double)mA + (double)vc[i].a * ng;
				mBs = (double)mB + (double)vc[i].b * ng;
			}
			
			vc[i].taken = ng;
			flag = true;
			break;
		}
		ll ng = vc[i].g;
		
		mA += vc[i].a * ng;
		mB += vc[i].b * ng;

		vc[i].taken = ng;
	}

	if (!flag)
	{
		mAs = (double)mA;
		mBs = (double)mB;
	}

	
	if ((double)A - mAs > eps) {
		cout << -1 << " " << -1 << endl;
		return 0;
	}

	cout << fixed;
	cout << setprecision(9);

	cout << mAs << " " << mBs << endl;
	sort(all(vc), cmp_n);
	
	for (int i = 0; i < vc.size(); ++i) {
		cout << vc[i].taken << " ";
	}

	return 0;
}