#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <queue>

#define all(v) v.begin(), v.end()
typedef long long ll;

using namespace std;

inline bool in_str(const string &s, int pos, int num)
{
	if (num > 9) {
		if (pos >= s.length() - 1)
			return false;
		char ft = num / 10 + '0';
		char sd = num % 10 + '0';
		if (ft == s[pos] && sd == s[pos + 1])
			return true;
		return false;
	} else {
		if (pos >= s.length())
			return false;
		char ft = num + '0';
		return s[pos] == ft;
	}
	return false;
}

vector<int> nums;
struct TNum {
	vector<int> poses;
	int num;
	TNum(int num, const string &s) 
	 : num(num) {
		for (int i = 0; i < s.length(); ++i) {
			if (in_str(s, i, num))
				poses.push_back(i);
		}
	}
};

bool perebor(vector<TNum> &t, int t_num, string &s) {
	if (t_num == t.size())
		return true;
	TNum &tn = t[t_num];
	for (int i = 0; i < tn.poses.size(); ++i) {
		int tpose = tn.poses[i];
		if (in_str(s, tpose, tn.num)) {
			s[tpose] = '#';
			nums[tpose] = tn.num;
			if (tn.num > 9) {
				s[tpose + 1] = '#';
				nums[tpose + 1] = tn.num;
			}
				
			if (perebor(t, t_num + 1, s))
				return true;
			s[tpose] = tn.num / 10 + '0';
			nums[tpose] = -1;
			if (tn.num > 9) {
				s[tpose + 1] = tn.num % 10 + '0';
				nums[tpose + 1] = -1;
			}
				
		}
	}
	return false;
}

int main()
{
	ios_base::sync_with_stdio(false);
	freopen("joke.in", "r", stdin);
	freopen("joke.out", "w", stdout);
	//vector<int> perm;
	//for (int i = 0; i < 25; ++i)
	//	perm.push_back(i + 1);
	//for (int i = 0; i < 300; ++i)
	//	next_permutation(all(perm));
	string s;
	//for (int i = 0; i < perm.size(); ++i) {
	//	if (perm[i] > 9)
	//		s.push_back(perm[i] / 10 + '0');
	//	s.push_back(perm[i] % 10 + '0');
	//}
	//cout << s << endl;
	cin >> s;
	string ds(s);

	int mx = (s.length() - 9) / 2 + 9;
	if (s.length() <= 9)
		mx = s.length();

	nums.resize(s.length(), -1);

	queue<TNum> q;
	for (int i = 0; i < mx; ++i)
		q.push(TNum(mx - i, s));

	//int iters = 0;
	//while (!q.empty()) {
	//	TNum tn = q.front();
	//	int t = tn.num;
	//	q.pop();
	//	int count = 0, tpos = -2;
	//	for (int i = 0; i < tn.poses.size(); ++i) {
	//		if (in_str(s, tn.poses[i], t)) {
	//			++count;
	//			tpos = tn.poses[i];
	//		}
	//	}

	//	if (count == 1) {
	//		s[tpos] = '#';
	//		nums[tpos] = t;
	//		if (t > 9) {
	//			s[tpos + 1] = '#';
	//			nums[tpos + 1] = t;
	//		}
	//	} else {
	//		q.push(tn);
	//	}
	//	++iters;
	//	if (iters > (int)1e4)
	//		break;
	//}

	//while (!q.empty()) {
	//	TNum t = q.front();
	//	for (int i = 0; i < s.length(); ++i) {
	//		if (in_str(s, i, t)) {
	//			s[i] = '#';
	//			nums[i] = t;
	//			if (t > 9) {
	//				s[i + 1] = '#';
	//				nums[i + 1] = t;
	//			}
	//			break;
	//		}
	//	}
	//	q.pop();
	//}
	vector<TNum> vect;
	while (!q.empty()) {
		vect.push_back(q.front());
		q.pop();
	}
	perebor(vect, 0, s);

	for (int i = 0; i < ds.length(); ++i) {
		//cout << i << " " << nums[i] << endl;
		if (i != 0 && nums[i] != nums[i - 1])
			cout << ' ';
		cout << ds[i];
	}
	return 0;
}