#define _CRT_SECURE_NO_WARNINGS


#include <iostream>
#include <cstdio>
#include <cstring>


const int BLACK = 1;
const int WHITE = -1;
const int EMPTY = 0;
const int maxn = 19;
const long long infin = 18LL * 1000000000LL * 1000000000LL;
const int dx[] = {1, 0, 1};
const int dy[] = {0, 1, 1};


using namespace std;


int field[maxn][maxn];


int valid(int a, int b)
{
    return 0 <= a && a < maxn && 0 <= b && b < maxn;
}


long long power(int a, int b)
{
    long long res = 1;
    for(int i = 0; i < b; i++)
        res *= a;
    return res;
}


long long getCost()
{
    long long score = 0;
    for(int x = 0; x < maxn; x++)
        for(int y = 0; y < maxn; y++)
		{
            for(int dir = 0; dir < 3; dir++)
			{
                int wh = 0;
                int bl = 0;
                for(int i = 0; i < 5; i++)
				{
                    int nx = x + dx[dir] * i;
                    int ny = y + dy[dir] * i;
                    if(!valid(nx, ny))
                        wh = bl = 1;
					else if(field[nx][ny] == WHITE)
                        wh++;
					else if(field[nx][ny] == BLACK)
                        bl++;
				}
                if(wh == 0 && bl == 0)
                    continue;
                if(wh > 0 && bl > 0)
                    continue;
                if(wh > 0)
                    score += power(50, 2 * wh - 1);
                if(bl > 0)
                    score -= power(50, 2 * bl);
			}
		}
    return score;
}


void tryFix(int & sx, int & sy)
{
    for(int i = 0; i < maxn; i++)
        for(int j = 0; j < maxn; j++)
		{
            for(int dir = 0; dir < 3; dir++)
			{
                for(int k = 0; k < 5; k++)
				{
                    int nx = i + dx[dir] * k;
                    int ny = j + dy[dir] * k;
				}
			}
		}
}


void tryWin(int & sx, int & sy)
{
}


int main()
{
    while(true)
	{
        int x, y;
        scanf("%d%d", &x, &y);
        if(x == -1 && y == -1)
            break;
        x--;
        y--;
        field[x][y] = BLACK;
        long long worst = -infin;
        int sx, sy;
        for(int i = 0; i < maxn; i++)
            for(int j = 0; j < maxn; j++)
			{
                if(field[i][j] != EMPTY)
                    continue;
                field[i][j] = WHITE; 
                long long cur = getCost();
                if(worst < cur || worst == -infin)
				{
                    worst = cur;
                    sx = i;
                    sy = j;
				}
                field[i][j] = EMPTY;
			}
        tryFix(sx, sy);
        tryWin(sx, sy);
        field[sx][sy] = WHITE;
        printf("%d %d\n", sx, sy);
        fflush(stdout);
	}
}