#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cstdio>
#include <cstring>
#include <algorithm>
#include <set>


const int sz = 18;
const int infin = 1e9;
const int maxn = 200146;


using namespace std;


int segm[(1 << (sz + 1)) + 6];


int getMax(int cur, int l, int r, int cl, int cr)
{
    if(r < cl || cr < l)
        return -infin;
    if(l <= cl && cr <= r)
        return segm[cur];
    int mid = (cl + cr) / 2;
    return max(getMax(cur * 2, l, r, cl, mid), getMax(cur * 2 + 1, l, r, mid + 1, cr));
}


int getMax(int l, int r)
{
    return getMax(1, l, r, 0, (1 << sz) - 1);
}


void setValue(int idx, int value)
{
    idx += (1 << sz);
    segm[idx] = value;
    while(idx)
	{
        idx /= 2;
        segm[idx] = max(segm[idx * 2], segm[idx * 2 + 1]);
	}
}


int a[maxn], b[maxn], c[maxn], d[maxn];


int main()
{
    freopen("improvements.in","r",stdin);
    freopen("improvements.out","w",stdout);
    int n;
    scanf("%d", &n);
    for(int i = 0; i < n; i++)
	{
        scanf("%d", &a[i]);
        a[i]--;
	}
    for(int i = 0; i < (1 << (sz + 1)) + 6; i++)
        segm[i] = -infin;
    for(int i = 0; i < n; i++)
	{
        b[a[i]] = i;
	}
	for(int i = 0; i < n; i++)
	{
        int pos = a[i];
        int zzz = getMax(0, pos - 1) + 1;
        zzz = max(zzz, 1);
        setValue(pos, zzz);
	}

    for(int i = 0; i < n; i++)
        c[i] = getMax(i, i);

    reverse(a, a + n);

    
    for(int i = 0; i < (1 << (sz + 1)) + 6; i++)
        segm[i] = -infin;
    for(int i = 0; i < n; i++)
	{
        b[a[i]] = i;
	}
	for(int i = 0; i < n; i++)
	{
        int pos = a[i];
        int zzz = getMax(0, pos - 1) + 1;
        zzz = max(zzz, 1);
        setValue(pos, zzz);
	}

    for(int i = 0; i < n; i++)
        d[i] = getMax(i, i);
    reverse(d, d + n);

    for(int i = 0; i < n; i++)
	{
       // printf("%d %d\n", c[i], d[i]);
	}
    int ans = 0;
    for(int i = 0; i <= n; i++)
	{
        int rs = 0;
        if(i > 0)
            rs += c[i - 1];
        if(i < n)
            rs += d[i];
        ans = max(ans, rs);
	}
    printf("%d\n", ans);
}