import java.util.*;
import java.io.*;

/**
 * Created by neerc on 07.12.2014.
 */
public class B {
    class Cls implements Comparable<Cls> {
        double a;
        double b;
        double w;

        public int compareTo(Cls obj) {
            if (a / b == obj.a / obj.b) {
                return 0;
            } else {
                return (a / b < obj.a / obj.b ? -1 : 1);
            }
        }
    }

    void solve() throws IOException {
        int n = nextInt();
        double A = nextDouble();
        double B = nextDouble();

        double total_a = 0;
        double total_b = 0;
        Cls[] objs = new Cls[n];
        Cls[] src = new Cls[n];
        for (int i = 0; i < n; ++i) {
            Cls obj = new Cls();
            obj.w = nextDouble();
            obj.a = nextDouble();
            obj.b = nextDouble();

            total_a += obj.a * obj.w;
            total_b += obj.b * obj.w;

            objs[i] = obj;
            src[i] = obj;
        }
        Arrays.sort(objs);

        for (int i = 0; i < n && total_a >= A && total_b >= B; ++i) {
            double need = total_b - B;
            double dw = Math.min(objs[i].w, need / objs[i].b);

            objs[i].w -= dw;
            total_a -= objs[i].a * dw;
            total_b -= objs[i].b * dw;
        }

        if (total_a >= A && total_b <= B) {
            //out.println(total_a + " " + total_b);
            out.printf(Locale.US,"%.8f",total_a);
            out.print(" ");
            out.printf(Locale.US,"%.8f",total_b);
            out.println();
            for (int i = 0; i < n; ++i) {
                if (i != 0) {
                    out.print(" ");
                }
                out.printf(Locale.US,"%.8f",src[i].w);
            }
        } else {
            out.println("-1 -1");
        }
    }

    public static void main(String[] args) throws IOException {
        new B().run();
    }

    BufferedReader reader;
    PrintWriter out;
    StringTokenizer tokenizer;

    void run() throws IOException {
        reader = new BufferedReader(new InputStreamReader(System.in));
        out = new PrintWriter(new OutputStreamWriter(System.out));
        reader=new BufferedReader(new FileReader("burrito.in"));
        out=new PrintWriter(new FileWriter("burrito.out"));
        tokenizer = null;
        solve();
        reader.close();
        out.flush();
    }


    String nextToken() throws IOException {
        while (tokenizer == null || !tokenizer.hasMoreTokens()) {
            tokenizer = new StringTokenizer(reader.readLine());
        }
        return tokenizer.nextToken();
    }

    int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }
}
