#include <algorithm>
#include <string>
#include <iostream>
#include <vector>
#include <memory.h>
#include <fstream>
#include <cmath>

using namespace std;

int a[666666], rsq[666666], b[666666];
const int modulo = 222222;
bool L[666666], R[666666];

void replace(int i, int x) {
	i += modulo - 1;
	rsq[i] = x;
	i /= 2;
	while (i > 0) {
		rsq[i] = rsq[i + i] + rsq[i + i + 1];
		i /= 2;
	}
}

int getsum(int l, int r) {
	if (l > r) swap(l, r);
	++l, --r;
	int i = l + modulo - 1, j = r + modulo - 1;
	int ans = 0;
	while (i<=j) {
		if (i%2) ans = ans + rsq[i];
		if ((j+1)%2) ans += rsq[j];
		i=(i+1)/2;
		j=(j-1)/2;
	}
	return ans;
}
        
int main() {
	freopen("improvements.in","r",stdin);
	freopen("improvements.out","w",stdout);    	
	int n;
	cin >> n;
	for (int i = 1; i<=n; ++i) {
		cin >> a[i];
	}
	int i = 1; 
	int last = -1;
	int answer = 0;
	while (i<=n) {
		int j = i + 1;
		while (j<=n && a[j] > a[j-1]) {
			++j;			
		}
		--j;
		//(i, j)
		int k = 0;
		for (int l = i; l<=j; ++l) {
			++k;
			b[k] = a[l];
		}
		b[0] = last;
		b[k+1] = b[k];
		for (int l = 1; l <=k; ++l) {
			if (getsum(b[l-1],b[l]) > 0) L[l] = true; else L[l] = false;
			if (getsum(b[l],b[l+1]) > 0) R[l] = true; else R[l] = false;
		}       
		for (int l = 1; l<=k; ++l) {
			if (L[l]&&R[l]) {
				L[l] = false;
				R[l] = false;
				L[l+1] = false;
				R[l-1] = false;			
				++answer;
			}
		}
		for (int l = 1; l<=k; ++l) {
			if (L[l]||R[l]) {
				++answer;
				L[l] = false;
				R[l] = false;
				L[l+1] = false;
				R[l-1] = false;
			}
		}

		last = a[j];
		for (int l = 1; l<=k; ++l) replace(b[l], 1);		
		i = j + 1;
	}
	cout << n - answer << endl;
	return 0;
}