#include <algorithm> 
#include <string> 
#include <iostream> 
#include <vector> 
#include <memory.h> 
#include <fstream> 
#include <cmath> 
  
using namespace std; 
  
int a[666666], rsq[666666], b[666666]; 
const int modulo = 222222; 
bool L[666666], R[666666]; 
  
void replace(int i, int x) { 
    i += modulo - 1; 
    rsq[i] = x; 
    i /= 2; 
    while (i > 0) { 
        rsq[i] = rsq[i + i] + rsq[i + i + 1]; 
        i /= 2; 
    } 
} 
  
int getsum(int l, int r) { 
    if (l > r) swap(l, r); 
    ++l, --r; 
    int i = l + modulo - 1, j = r + modulo - 1; 
    int ans = 0; 
    while (i<=j) { 
        if (i%2) ans = ans + rsq[i]; 
        if ((j+1)%2) ans += rsq[j]; 
        i=(i+1)/2; 
        j=(j-1)/2; 
    } 
    return ans; 
} 

bool intersect(int x1, int y1, int x2, int y2) {
	if (x1>y1) swap(x1,y1);
	if (x2>y2) swap(x2,y2);
	if (x1>x2) swap(x1,x2), swap(y1,y2);
	if (x1<x2 && x2<y1 && y1 < y2) return true;
	return false;
}

bool F(int l, int r, int num) {
	for (int i = 1; i < num; ++i) {
		if (intersect(l, r, a[i], a[i+1])) return true;
	}
	return false;
}
          
int main() { 
    freopen("improvements.in","r",stdin); 
    freopen("improvements.out","w",stdout);      
    int n; 
    cin >> n; 
    for (int i = 1; i<=n; ++i) { 
        cin >> a[i]; 
    } 
    int i = 1;  
    int last = -1; 
    int answer = 0; 
    while (i<=n) { 
        int j = i + 1; 
        while (j<=n && a[j] > a[j-1]) { 
            ++j;             
        } 
        --j; 
        //(i, j) 
        int k = 0; 
        for (int l = i; l<=j; ++l) { 
            ++k; 
            b[k] = a[l]; 
        } 
        b[0] = last; 
        b[k+1] = b[k]; 
        for (int l = 1; l <=k; ++l) { 
        	if (F(b[l-1], b[l], i - 1)) L[l] = true; else L[l] = false;
		if (F(b[l], b[l+1], i - 1)) R[l] = true; else R[l] = false;
	}        
        for (int l = 1; l<=k; ++l) { 
            if (L[l]&&R[l]) { 
                L[l] = false; 
                R[l] = false; 
                L[l+1] = false; 
                R[l-1] = false;          
                ++answer; 
            } 
        } 
        for (int l = 1; l<=k; ++l) { 
            if (L[l]||R[l]) { 
                ++answer; 
                L[l] = false; 
                R[l] = false; 
                L[l+1] = false; 
                R[l-1] = false; 
            } 
        } 
  
        last = a[j]; 
        for (int l = 1; l<=k; ++l) replace(b[l], 1);         
        i = j + 1; 
    } 
    cout << n - answer << endl; 
    return 0; 
}