#include <iostream>
#include <algorithm>
#include <string>
#include <cstdlib>

using namespace std;

typedef long long ll;

int digits[60];
char symbol, input[300];
pair<int, int> paths[300];
int length, n;

int places(int d)
{
	if (d > 9)
		return 2;

	return 1;
}

bool solution(int from)
{
	if (from == length)
	{
		for (int i = 1; i <= n; ++i)
		{
			if (digits[i] == -1)
				return false;
		}

		return true;
	}

	if (paths[from].first > 0 && digits[paths[from].first] == -1)
	{
		digits[paths[from].first] = from;
		if (solution(from + places(paths[from].first)))
		{
			return true;
		}
		digits[paths[from].first] = -1;
	}

	if (paths[from].second > 0 && digits[paths[from].second] == -1)
	{
		digits[paths[from].second] = from;
		if (solution(from + places(paths[from].second)))
		{
			return true;
		}
		digits[paths[from].second] = -1;
	}

	return false;
}

int main()
{
	freopen("joke.in", "r", stdin);
	freopen("joke.out", "w", stdout);

	int i, j, index;

	length = 0;
	symbol = cin.get();
	while (isdigit(symbol))
	{
		input[length++] = symbol;
		symbol = cin.get();
	}

	for (i = 0; i < 60; ++i)
	{
		digits[i] = -1;
	}

	if (length > 9)
		n = (length - 9) / 2 + 9;
	else
		n = length;

	for (i = 0; i < length - 1; ++i)
	{
		paths[i].first = 0;
		paths[i].second = 0;

		switch (input[i])
		{
			case '0':
				break;

			case '1': case '2': case '3': case '4':
				if (input[i + 1] != '0')
				{
					paths[i].second = input[i] - '0';
					paths[i].first = paths[i].second * 10 + (input[i + 1] - '0');

					if (paths[i].first > n)
					{
						paths[i].first = 0;
					}
				}
				else
				{
					paths[i].first = (input[i] - '0') * 10;
				}
				break;

			case '5':
				if (input[i + 1] == '0')
				{
					paths[i].first = 50;
				}
				else
				{
					paths[i].first = 5;
				}
				paths[i].second = 0;
				break;

			case '6': case '7': case '8': case '9':
				paths[i].first = input[i] - '0';
				paths[i].second = 0;
				break;
		}
	}
	paths[length - 1].first = input[length - 1] - '0';
	paths[length - 1].second = 0;

	solution(0);
	index = 0;
	for (i = 0; i < length; ++i)
	{
		for (j = 1; j <= n; ++j)
		{
			if (digits[j] == index)
			{
				cout << j << ' ';
				index += places(j);
				break;
			}
		}
	}

	return 0;
}