#include <cstdio>
#include <cmath>
#include <ctime>
#include <cassert>
#include <string>
#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>

using namespace std;

#define TASK "burrito"

const int N = 100500;

int n, A, B;
int g[N], a[N], b[N];
double s[N];
double ca, cb;
vector<int> cands;

bool cmp(int i, int j)
{
	return a[i] * b[j] > a[j] * b[i];
}

int main()
{
#ifdef __HOME
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	freopen(TASK".in", "r", stdin);
	freopen(TASK".out", "w", stdout);
#endif
	scanf("%d %d %d", &n, &A, &B);
	cands.reserve(n);
	for (int i = 0; i < n; ++i)
	{
		scanf("%d %d %d", g + i, a + i, b + i);
		if (a[i] == 0 || g[i] == 0) continue;
		if (b[i] == 0) {
			s[i] = g[i];
			ca += s[i] * a[i];
			continue;
		}
		cands.push_back(i);
	}
	sort(cands.begin(), cands.end(), cmp);
	for (int _i = 0; _i < cands.size(); ++_i)
	{
		int i = cands[_i];
		if (cb + 1LL * g[i] * b[i] > B) {
			s[i] = (B - cb) / b[i];
			assert(s[i] <= g[i]);
			ca += s[i] * a[i];
			cb += s[i] * b[i];
			break;
		}
		else {
			s[i] = g[i];
			ca += s[i] * a[i];
			cb += s[i] * b[i];
		}
	}
	if (ca < A) {
		cout << "-1 -1" << endl;
		return 0;
	}
	printf("%.10lf %.10lf\n", ca, cb);
	for (int i = 0; i < n; ++i)
		printf("%.10lf ", s[i]);
	printf("\n");
	return 0;
}