#include <cstdio>
#include <cmath>
#include <ctime>
#include <cassert>
#include <string>
#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>

using namespace std;

#define TASK "epic"

const int N = 128;
const int M = 50000;

int n, r[N], p[N], s[N];
char c[N];
int m, rq[M + N], pq[M + N], sq[M + N];
char cq[M + N];

int main()
{
#ifdef __HOME
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	freopen(TASK".in", "r", stdin);
	freopen(TASK".out", "w", stdout);
#endif
	srand(1393464);
	scanf("%d\n", &n);
	for (int i = 0; i < n; ++i)
	{
		scanf("%c %d %d %d\n", c + i, r + i, p + i, s + i);
		--r[i];
		--p[i];
		--s[i];
	}
	int l = M / n;
	m = l * n;
	for (int j = 0; j < l; ++j)
	{
		int nxt = (j + 1) % l;
		for (int i = 0, k = j * n; i < n; ++i, ++k)
		{
			switch (c[i])
			{
			case 'R':
				cq[k] = 'P';
				rq[k] = nxt * n + p[i];
				pq[k] = nxt * n + rand() % n;
				sq[k] = nxt * n + rand() % n;
				break;
			case 'P':
				cq[k] = 'S';
				pq[k] = nxt * n + s[i];
				rq[k] = nxt * n + rand() % n;
				sq[k] = nxt * n + rand() % n;
				break;
			case 'S':
				cq[k] = 'R';
				sq[k] = nxt * n + r[i];
				pq[k] = nxt * n + rand() % n;
				rq[k] = nxt * n + rand() % n;
				break;
			}
		}
	}
	cout << m << endl;
	for (int i = 0; i < m; ++i)
		printf("%c %d %d %d\n", cq[i], rq[i] + 1, pq[i] + 1, sq[i] + 1);
	return 0;
}