
#include <cstdio>
#include <cmath>
#include <ctime>
#include <cassert>
#include <string>
#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>

using namespace std;

#define TASK "improvements"

const int N = 200500;

int n, x[N];
int a[N], m;
int dp[N];

int get_min(int i)
{
	int res = 0;
	for (; i >= 0; i = (i & (i + 1)) - 1)
		res = max(res, dp[i]);
	return res;
}

void set_val(int i, int val)
{
	dp[i] = val;
	for (; i < N; i |= (i + 1))
		dp[i] = max(val, dp[i]);
}

int seq()
{
	fill(dp, dp + N, 0);
	int ret = 0;
	for (int i = 0; i < m; ++i)
	{
		int newval = get_min(a[i] - 1) + 1;
		set_val(a[i], newval);
		ret = max(ret, newval);
	}
	return ret;
}

int solve(int z)
{
	m = 0;
	for (int i = 0; i < n; ++i)
		if (x[i] <= z)
			a[m++] = x[i];
	int ret = seq();
	m = 0;
	for (int i = 0; i < n; ++i)
		if (x[i] > z)
			a[m++] = n - x[i] + 1;
	ret += seq();
	return ret;
}

int solve()
{
	int ans = 0;
	for (int i = 1; i <= n; ++i)
		ans = max(ans, solve(i));
	return ans;
	int l = 1, r = n;
	while (r - l > 2)
	{
		int m1 = l + (r - l) / 3;
		int m2 = r - (r - l) / 3;
		if (solve(m1) < solve(m2))
			l = m1;
		else
			r = m2;
	}
	return max(solve(l), max(solve(l + 1), solve(l + 2)));
}

int main()
{
#ifdef __HOME
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	freopen(TASK".in", "r", stdin);
	freopen(TASK".out", "w", stdout);
#endif
	scanf("%d", &n);
	for (int i = 0; i < n; ++i)
		scanf("%d", x + i);
	printf("%d\n", solve());
	return 0;
}