#include <cstdio>
#include <iostream>
#include <cmath>
#include <string>
#include <cstring>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <ctime>
#include <cassert>

using namespace std;

typedef long long ll;
typedef long double ld;

const ld eps = 1.0e-12;
const int inf = 1e9;
const int N = 200;

#define file "epic"

int FSM[N][3];
char s[N];
int ans[50000][3];
char ansS[50000];
int ansSize;

int dist[N][N], sym[N][N];

bool ar[N][N];
int newar[N];
int depth;
int n;

int states[N];

int Number(char c)
{
  return c == 'R' ? 0 : (c == 'P' ? 1 : 2);
}
int Sym(int c)
{
  return c == 0 ? 'R' : (c == 1 ? 'P' : 'S');
}

void dfs()
{
  if (depth > 120) while (1);
  int mini = -1, minj = -1;
  for (int i = 0; i < n; i++)
    for (int j = 0; j < n; j++)
      if (ar[depth][i] && ar[depth][j])
        if (mini == -1 || dist[i][j] < dist[mini][minj])
          mini = i, minj = j;
  if (mini == -1)
  {
    ansS[ansSize] = 'P';
    ansSize++;
  }
  else if (dist[mini][minj] == inf)
  {
    for (int i = 0; i < n; i++)
      if (ar[depth][i]) states[i] = ansSize;
    ansS[ansSize] = 'P';
    ansSize++;
  }
  else
  {
    for (int tt = dist[mini][minj]; tt > 0; tt--)
    {
      int c = sym[mini][minj];
      ansS[ansSize] = Sym(c);
      ans[ansSize][Number(s[mini])] = ansSize + 1;
      ansSize++;              
      for (int i = 0; i < n; i++) newar[i] = 0;
      for (int i = 0; i < n; i++) if (ar[depth][i]) newar[FSM[i][c]] = 1;
      for (int i = 0; i < n; i++) ar[depth][i] = newar[i];
      mini = FSM[mini][c], minj = FSM[minj][c];
    }
    ansS[ansSize] = 'R';                                
    int curAnsSize = ansSize++;
    for (int c = 0; c < 3; c++)
    {                                                      
      for (int i = 0; i < n; i++)
        ar[depth + 1][i] = (ar[depth][i] && Number(s[i]) == c);
      for (int i = 0; i < n; i++) newar[i] = 0;
      for (int i = 0; i < n; i++) if (ar[depth + 1][i]) newar[FSM[i][0]] = 1;
      for (int i = 0; i < n; i++) ar[depth + 1][i] = newar[i];
      depth++;                  
      ans[curAnsSize][c] = ansSize;
      dfs();
      depth--;
    }
  }
}

int main()
{
  freopen(file".in", "r", stdin);
  freopen(file".out", "w", stdout);

  cin >> n;
  for (int i = 0; i < n; i++)
  {       
    do scanf("%c", &s[i]); while (s[i] == ' ' || s[i] == '\n');
    scanf("%d%d%d", &FSM[i][0], &FSM[i][1], &FSM[i][2]);
    FSM[i][0]--, FSM[i][1]--, FSM[i][2]--;
  } 
  for (int i = 0; i < n; i++)
    for (int j = 0; j < n; j++)
      if (s[i] != s[j]) dist[i][j] = 0;
      else dist[i][j] = inf;
  for (int tt = 0; tt < n + 10; tt++)
  {
    for (int i = 0; i < n; i++)
      for (int j = 0; j < n; j++)
        if (dist[i][j] == inf)
          for (int c = 0; c < 3; c++)
            if (dist[FSM[i][c]][FSM[j][c]] != inf)
              dist[i][j] = dist[FSM[i][c]][FSM[j][c]] + 1, sym[i][j] = c;
  }
  for (int i = 0; i < n; i++) ar[0][i] = 1;
  for (int i = 0; i < n; i++) states[i] = -1;
  dfs();

  for (int i = 0; i < n; i++)
    if (states[i] != -1)
    {
         if (s[i] == 'R') ansS[states[i]] = 'P', ans[states[i]][0] = states[FSM[i][1]];
    else if (s[i] == 'P') ansS[states[i]] = 'S', ans[states[i]][1] = states[FSM[i][2]];
    else if (s[i] == 'S') ansS[states[i]] = 'R', ans[states[i]][2] = states[FSM[i][0]];
    }
  cout << ansSize << endl;
  for (int i = 0; i < ansSize; i++)
  {
    printf("%c ", ansS[i]);
    for (int j = 0; j < 3; j++)
      printf("%d ", ans[i][j] + 1);
    printf("\n");
  }

  return 0;
}
