#include <cstdio>
#include <iostream>
#include <cmath>
#include <string>
#include <cstring>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <ctime>
#include <cassert>

using namespace std;

typedef long long ll;
typedef long double ld;

const ld eps = 1.0e-12;
const int N = 2100;

#define file "filter"

char s[N];      
ll inp[N][N];
ll user[N][N];

int a[N], u[N];

int ans[N];

int main()
{
  freopen(file".in", "r", stdin);
  freopen(file".out", "w", stdout);

  int m;
  cin >> m;
  int f;
  cin >> f;
  for (int i = 0; i < f; i++)
    scanf("%d", &a[i]), a[i] %= m;
  int n;
  cin >> n;
  for (int k = 0; k < n; k++)
  {
    scanf("%s", s);
    for (int i = 0; i < N; i++) inp[k][i] = 0;
    for (int i = 0; i < (m + 3) / 4; i++)
    {
      assert((s[i] >= '0' && s[i] <= '9') || (s[i] >= 'a' && s[i] <= 'z'));
      inp[k][i] = ((s[i] >= '0' && s[i] <= '9') ? s[i] - '0' : s[i] - 'a' + 10);
    }
    for (int i = 0; i < (m + 31) / 32; i++)
    {
      ll cur = 0;
      for (int j = 0; j < 8; j++)
        cur += inp[k][i * 8 + j] << (ll)(j * 4);
      inp[k][i] = cur;
    }
  }
  int q;
  cin >> q;
  for (int i = 0; i < q; i++)
  {
    scanf("%d", &u[i]), u[i] %= m;
    for (int j = 0; j < f; j++)
    {
      int bit = u[i] * a[j] % m;
      user[i][bit / 32] += (1ll << (ll)(bit % 32));
    }
  }         

  m = (m + 31) / 32;
  
  int cnt = 0;
  for (int i = 0; i < n; i++)
  {
    for (int j = 0; j < q; j++)
    {
      bool cmp = 1;
      for (int k = 0; k < m; k++)
        cmp = (cmp && (user[j][k] | inp[i][k]) == inp[i][k]);
      if (cmp)
      {
        cnt++;
        ans[i] = 1;
        break;
      }
    }
  }               
  cout << cnt << ' ';
  for (int i = 0; i < n; i++)
    if (ans[i] == 1) printf("%d ", i);

  return 0;
}
