import java.io.*;
import java.util.*;

public class Main {

    public static BufferedReader in;
    public static PrintWriter out;
    public static StringTokenizer tok = null;

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static String nextToken() throws IOException {
        if (tok == null || !tok.hasMoreTokens()) {
            tok = new StringTokenizer(in.readLine());
        }

        return tok.nextToken();
    }

    public static char nextChar() throws IOException {
        return (char) in.read();
    }

    public static class Ing implements Comparable<Ing> {
        int i;
        int g;
        int a;
        int b;

        public Ing(int i, int g, int a, int b) {
            this.i = i;
            this.g = g;
            this.a = a;
            this.b = b;
        }

        @Override
        public int compareTo(Ing o) {
            return Integer.compare(b * o.a, a * o.b);
        }
    }

    public static final double eps = 1e-10;

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        in = new BufferedReader(new InputStreamReader(new FileInputStream("burrito.in")));
        out = new PrintWriter(new BufferedOutputStream(new FileOutputStream("burrito.out")));

        int n = nextInt();
        int A = nextInt();
        int B = nextInt();

        List<Ing> l = new ArrayList<Ing>(n);
        for (int i = 0; i < n; i++) {
            l.add(new Ing(i, nextInt(), nextInt(), nextInt()));
        }

        Collections.sort(l);

        double[] ans = new double[n];

        double bad = 0.0;
        double good = 0.0;
        int i = 0;
        while (i < n && bad < B) {
            Ing curr = l.get(i);

            double s;
            if (bad + curr.b * curr.g > B - eps) {
                s = (B - bad) / curr.b;
                bad = B;
                good += curr.a * s;
            } else {
                s = curr.g;
                bad += curr.b * curr.g;
                good += curr.a * curr.g;
            }


            ans[curr.i] = s;
            i++;
        }

        if (good < A) {
            out.println("-1 -1");
        } else {
            out.println(String.format("%.9f %.9f", good, bad));
            for (int j = 0; j < n; j++) {
                out.print(String.format("%.9f ", ans[j]));
            }
        }

        out.flush();
    }
}
