import java.io.*;
import java.util.*;

public class Main {

    public static BufferedReader in;
    public static PrintWriter out;
    public static StringTokenizer tok = null;

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static String nextToken() throws IOException {
        if (tok == null || !tok.hasMoreTokens()) {
            tok = new StringTokenizer(in.readLine());
        }

        return tok.nextToken();
    }

    public static char nextChar() throws IOException {
        return (char) in.read();
    }

    public static class Ing implements Comparable<Ing> {
        int i;
        int g;
        int a;
        int b;
        double q;

        public Ing(int i, int g, int a, int b) {
            this.i = i;
            this.g = g;
            this.a = a;
            this.b = b;
            if (b > 0) {
                q = (double) a / b;
            } else {
                q = Double.POSITIVE_INFINITY;
            }
        }


        @Override
        public int compareTo(Ing o) {
            return Double.compare(o.q, q);
        }
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        in = new BufferedReader(new InputStreamReader(new FileInputStream("burrito.in")));
        out = new PrintWriter(new BufferedOutputStream(new FileOutputStream("burrito.out")));

        int n = nextInt();
        int A = nextInt();
        int B = nextInt();

        List<Ing> l = new ArrayList<Ing>(n);
        for (int i = 0; i < n; i++) {
            l.add(new Ing(i, nextInt(), nextInt(), nextInt()));
        }

        Collections.sort(l);

        double[] ans = new double[n];

        double bad = 0.0;
        double good = 0.0;
        int i = 0;
        while (i < n && bad <= B) {
            Ing curr = l.get(i);

            double s;
            if (bad + curr.b * curr.g > B) {
                s = (B - bad) / curr.b;
                bad = B;
            } else {
                s = curr.g;
                bad += curr.b * s;
            }

            good += curr.a * s;
            ans[curr.i] = s;
            i++;
        }

        if (good < A) {
            out.println("-1 -1");
        } else {
            out.println(String.format("%.9f %.9f", good, bad));
            for (int j = 0; j < n; j++) {
                out.print(String.format("%.9f ", ans[j]));
            }
        }

        out.flush();
    }
}
