import java.io.*;
import java.util.*;

public class Main {

    public static BufferedReader in;
    public static PrintWriter out;
    public static StringTokenizer tok = null;

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static String nextToken() throws IOException {
        if (tok == null || !tok.hasMoreTokens()) {
            tok = new StringTokenizer(in.readLine());
        }

        return tok.nextToken();
    }

    public static char nextChar() throws IOException {
        return (char) in.read();
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        in = new BufferedReader(new InputStreamReader(new FileInputStream("filter.in")));
        out = new PrintWriter(new BufferedOutputStream(new FileOutputStream("filter.out")));

        int m = nextInt();
        int f = nextInt();
        int[] a = new int[f];
        for (int i = 0; i < f; i++) {
            a[i] = nextInt();
        }

        int n = nextInt();
        String[] s = new String[n];
        for (int i = 0; i < n; i++) {
            s[i] = nextToken();
        }

        int q = nextInt();
        int[] u = new int[q];
        for (int i = 0; i < q; i++) {
            u[i] = nextInt();
        }

        boolean[][] b = new boolean[n][m];
        for (int i = 0; i < n; i++) {
            b[i] = new boolean[m];
            for (int j = 0; j < s[i].length(); j++) {
                int dig = digToInt(s[i].charAt(j));
                for (int k = 0; k < 4 && 4 * j + k < m; k++) {
                    b[i][4 * j + k] = (dig & (1 << k)) != 0;
                }
            }
        }

        boolean[] fileHas = new boolean[n];
        for (int i = 0; i < q; i++) {
            for (int k = 0; k < n; k++) {
                boolean allInFile = true;
                for (int j = 0; j < f; j++) {
                    int bitN = (u[i] * a[j]) % m;
                    allInFile = allInFile && b[k][bitN];
                }

                fileHas[k] = fileHas[k] || allInFile;
            }
        }

        int filesC = 0;
        for (int i = 0; i < n; i++) {
            if (fileHas[i]) {
                filesC++;
            }
        }

        out.print(filesC + " ");
        for (int i = 0; i < n; i++) {
            if (fileHas[i]) {
                out.print(i + " ");
            }
        }

        out.flush();
    }

    public static int digToInt(char dig) {
        if (Character.isDigit(dig)) {
            return dig - '0';
        } else {
            return 10 + (dig - 'a');
        }
    }

}
