import java.io.*;
import java.util.ArrayList;
import java.util.List;
import java.util.Locale;
import java.util.StringTokenizer;

public class Main {

    public static BufferedReader in;
    public static PrintWriter out;
    public static StringTokenizer tok = null;

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static String nextToken() throws IOException {
        if (tok == null || !tok.hasMoreTokens()) {
            tok = new StringTokenizer(in.readLine());
        }

        return tok.nextToken();
    }

    public static char nextChar() throws IOException {
        return (char) in.read();
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        in = new BufferedReader(new InputStreamReader(new FileInputStream("filter.in")));
        out = new PrintWriter(new BufferedOutputStream(new FileOutputStream("filter.out")));


        int m = nextInt();
        int f = nextInt();
        int[] a = new int[f];
        for (int i = 0; i < f; i++) {
            a[i] = nextInt();
        }

        int n = nextInt();
        String[] s = new String[n];
        for (int i = 0; i < n; i++) {
            s[i] = nextToken();
        }

        int q = nextInt();
        int[] u = new int[q];
        for (int i = 0; i < q; i++) {
            u[i] = nextInt();
        }

        try {
            List<List<Boolean>> b = new ArrayList<List<Boolean>>(n);
            for (int i = 0; i < n; i++) {
                b.add(strtoArr(m, s[i]));
            }

            boolean[] fileHas = new boolean[n];
            for (int i = 0; i < q; i++) {
                for (int k = 0; k < n; k++) {
                    boolean allInFile = true;
                    for (int j = 0; j < f; j++) {
                        int bitN = (u[i] * a[j]) % m;
                        allInFile = allInFile && b.get(k).get(bitN);
                    }

                    fileHas[k] = fileHas[k] || allInFile;
                }
            }

            int filesC = 0;
            for (int i = 0; i < n; i++) {
                if (fileHas[i]) {
                    filesC++;
                }
            }

            out.print(filesC + " ");
            for (int i = 0; i < n; i++) {
                if (fileHas[i]) {
                    out.print(i + " ");
                }
            }
        } catch (ArrayIndexOutOfBoundsException e) {
            out.print("OLOLO");
        }

        out.flush();
    }

    public static ArrayList<Boolean> strtoArr(int m, String file) {
        ArrayList<Boolean> res = new ArrayList<Boolean>(m);
        for (int i = 0; i < file.length(); i++) {
            int dig = digToInt(file.charAt(i));
            for (int k = 0; k < 4 && 4 * i + k < m; k++) {
                res.add((dig & (1 << k)) != 0);
            }
        }

        return res;
    }

    public static int digToInt(char dig) {
        if (Character.isDigit(dig)) {
            return dig - '0';
        } else {
            return 10 + (dig - 'a');
        }
    }

}
