import java.io.*;
import java.util.StringTokenizer;

public class Main {

    public static BufferedReader in;
    public static PrintWriter out;
    public static StringTokenizer tok = null;

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static String nextToken() throws IOException {
        if (tok == null || !tok.hasMoreTokens()) {
            tok = new StringTokenizer(in.readLine());
        }

        return tok.nextToken();
    }

    public static char nextChar() throws IOException {
        return (char) in.read();
    }

    public static void main(String[] args) throws IOException {
        in = new BufferedReader(new InputStreamReader(new FileInputStream("knockout.in")));
        out = new PrintWriter(new BufferedOutputStream(new FileOutputStream("knockout.out")));

        int n = nextInt();
        int m = nextInt();

        int[] a = new int[n];
        int[] b = new int[n];

        int[] x = new int[m];
        int[] y = new int[m];
        int[] t = new int[m];

        for (int i = 0; i < n; i++) {
            a[i] = nextInt();
            b[i] = nextInt();
        }
        for (int i = 0; i < m; i++) {
            x[i] = nextInt();
            y[i] = nextInt();
            t[i] = nextInt();
        }

        for (int i = 0; i < m; i++) {
            int quantity = 0;
            for (int j = 0; j < n; j++) {
                int time = t[i];
                int coord = 0;
                time %= 2 * Math.abs(b[j] - a[j]);
                if (a[j] < b[j]) {
                    if (time > b[j] - a[j]) {
                        coord = b[j] - (time - b[j] + a[i]);
                    }
                    else {
                        coord = a[j] + time;
                    }
                }
                else {
                    if (time > a[j] - b[j]) {
                        coord = b[j] + time - a[j] + b[j];
                    }
                    else {
                        coord = a[j] - time;
                    }
                }
                if (x[i] <= coord && coord <= y[i]) {
                    quantity++;
                }
            }
            out.println(quantity);
        }

        out.flush();
    }
}
