#include <cstdio>
#include <set>
#include <map>
#include <algorithm>
#include <iostream>
#include <vector>
#include <cmath>
#include <cassert>
#include <ctime>
using namespace std;
#define REP(i,n) for(int i=0;i<(n);i++)

#define FILENAME "improvements"
struct FileOpener
{
	FileOpener()
	{
		FILE* f = fopen(FILENAME".in", "r");
		if (f)
		{
			fclose(f);
			freopen(FILENAME".in", "r", stdin);
			freopen(FILENAME".out", "w", stdout);
		}
	}
} fileopener;

const int MAXN = 300000;

typedef struct Node* pNode;

struct Node
{
	int cur;
	pNode l, r;
	Node(int cur) :cur(cur)
	{
		l = NULL;
		r = NULL;
	}
	Node(int cur, pNode l, pNode r) :cur(cur), l(l), r(r)
	{

	}
};

pNode build_tree(int len, int val)
{
	if (len == 1)
		return new Node(val);
	else
	{
		return new Node(val, build_tree(len / 2,val), build_tree(len-len / 2,val));
	}
}

pNode addValMax(pNode root, int cl, int cr, int i, int v)
{
	if (cl == i && cr == i)
	{
		return new Node(v);
	}
	else if (cl <= i && i <= cr)
	{
		int mid = (cl + cr) / 2;
		pNode res = new Node(v, addValMax(root->l, cl, mid, i, v),addValMax(root->r,mid+1,cr,i,v));
		res->cur = max(res->l->cur, res->r->cur);
		return res;
	}
	else
		return root;
}

pNode addValMin(pNode root, int cl, int cr, int i, int v)
{
	if (cl == i && cr == i)
	{
		return new Node(v);
	}
	else if (cl <= i && i <= cr)
	{
		int mid = (cl + cr) / 2;
		pNode res = new Node(v, addValMin(root->l, cl, mid, i, v), addValMin(root->r, mid + 1, cr, i, v));
		res->cur = min(res->l->cur, res->r->cur);
		return res;
	}
	else
		return root;
}

int n;

int findMax(pNode root, int cl, int cr, int l, int r)
{
	if (l <= cl && cr <= r)
		return root->cur;
	else if (r < cl || cr < l)
		return -1;
	else
	{
		int mid = (cl + cr) / 2;
		return max(findMax(root->l, cl, mid, l, r), findMax(root->r, mid + 1, cr, l, r));
	}
}

int findMin(pNode root, int cl, int cr, int l, int r)
{
	if (l <= cl && cr <= r)
		return root->cur;
	else if (r < cl || cr < l)
		return n+1;
	else
	{
		int mid = (cl + cr) / 2;
		return min(findMin(root->l, cl, mid, l, r), findMin(root->r, mid + 1, cr, l, r));
	}
}

map<pair<pair<int,int>, int>, int > st;
int p[MAXN];
pNode maxRoot[MAXN];
pNode minRoot[MAXN];
int ds;


int solve(int l, int r, int val)
{
	if (l == 0) return 0;
	pair<pair<int, int>, int> vv = make_pair(make_pair(l, r), val);
	if (st.count(vv)) return st[vv];
	int maxPos, minPos;
	maxPos = -1;
	minPos = -1;
	/*for (int i = 0; i < l; i++)
	{
		if (p[i] < val)
			maxPos = i;
	}
	for (int i = r + 1; i <= n; i++)
		if (p[i] < val)
		{
			minPos = i;
			break;
		}*/
	maxPos = findMax(maxRoot[l-1], 0, ds - 1, 0, val - 1);
	minPos = findMin(minRoot[r + 1], 0, ds - 1, 0, val - 1);
	if (minPos > n) minPos = -1;

	int target = -1;
	if (minPos != -1 && p[maxPos] < p[minPos])
		target = minPos;
	else
		target = maxPos;
	if (target == minPos)
		return st[vv]=solve(l, minPos, p[minPos]) + 1;
	else
		return st[vv]=solve(maxPos, r, p[maxPos]) + 1;
}


int solve()
{
	int res = 0;
	for (int start = n; start >= 0; start--)
	{
		res=max(res,solve(start, start,p[start]));
	}
	return res;
}

int getds(int n)
{
	n--;
	n |= n >> 1;
	n |= n >> 2;
	n |= n >> 4;
	n |= n >> 8;
	n |= n >> 16;
	return n + 1;
}

int main()
{
	srand(time(0));
	scanf("%d", &n);
	unsigned result = 0;
	//REP(T, 1000)
	{
		st.clear();
		/*REP(i, n)
			p[i + 1] = i + 1;
		random_shuffle(p + 1, p + n + 1);*/
		ds = getds(n + 1);
		REP(i, n)
		{
			int t;
			scanf("%d", &t);
			p[t] = i + 1;
		}

 		maxRoot[0] = build_tree(ds,-1);
		maxRoot[0] = addValMax(maxRoot[0], 0, ds - 1, 0, 0);
		minRoot[n + 1] = build_tree(ds, n + 1);
		for (int i = 1; i <= n; i++)
			maxRoot[i] = addValMax(maxRoot[i-1], 0, ds - 1, p[i], i);
		for (int i = n; i >= 0; i--)
			minRoot[i] = addValMin(minRoot[i + 1], 0, ds - 1, p[i], i);

		
		//solve(1, n, 0);
		cout<<solve()<<endl;
			/*for (map < pair<pair<int, int>, int>,int > ::iterator it = st.begin(); it != st.end(); it++)
			{
				pair<pair<int, int>, int> pr = it->first;
				printf("(%d->%d (%d))\n", pr.first.first, pr.first.second, pr.second);
			}*/

		//result = max(result, st.size());
	}
	//printf("%d\n", result);
	return 0;
}