#define _USE_MATH_DEFINES

#include <cstdio>
#include <cstring>
#include <string>
#include <iostream>
#include <iomanip>
#include <algorithm>
#include <cassert>
#include <map>
#include <vector>
#include <set>
#include <bitset>
#include <stack>
#include <queue>
#include <list>
#include <ctime>
#include <cmath>

using namespace std;

#define forn(i,n) for(int i = 0; i < int(n); ++i)
#define all(a) a.begin(),a.end()
#define sz(a) int(a.size())
#define mp make_pair
#define pb push_back

typedef long long li;
typedef long double ld;

typedef pair<int, int> pt;
#define ft first
#define sc second
#define x first
#define y second

const int INF = int(1e9);
const li INF64 = li(1e18);
const ld EPS = 1e-9;

#define TASK_NAME "filter"

const int M = 1000 + 50;
const int N = 1000 + 50;

bitset <M> masks[N];
int m, f, a[N], n, q, b[N];
char buf[N];

void tobitset(bitset <M>& b) {
	int l = strlen(buf);
	forn(i, l) {
		int t;
		if (isdigit(buf[i]))
			t = buf[i] - '0';
		else
			t = buf[i] - 'a' + 10;

		forn(j, 4)
			if (t & (1 << j))
				b[i * 4 + j] = 1;
	}
}

bool read() {
	if (scanf("%d %d", &m, &f) != 2)
		return false;
	forn(i, f)
		scanf("%d", &a[i]);
	scanf("%d", &n);
	forn(i, n) {
		scanf("%s", buf);
		tobitset(masks[i]);
	}

	scanf("%d", &q);
	forn(i, q)
		scanf("%d", &b[i]);
	return true;
}
bool good[N];

void solve() {
	forn(i, q) {
		bitset <M> cur;
		forn(j, f)
			cur[(li(b[i]) * a[j]) % m] = 1;

		forn(j, n)
			if (!good[j] && (masks[j] & cur).count() == cur.count())
				good[j] = true;
	}

	vector <int> res;
	forn(i, n)
		if (good[i])
			res.push_back(i);

	cout << sz(res) << " ";
	forn(i, sz(res))
		cout << res[i] << " ";
	puts("");
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else

#ifdef TASK_NAME
	freopen(TASK_NAME ".in", "r", stdin);
	freopen(TASK_NAME ".out", "w", stdout);
#endif

#endif

	while (read())
		solve();

	cerr << "Time: " << clock() << endl;
	return 0;

	return 0;
}