#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <vector>
#include <algorithm>
#include <cmath>
using namespace std;

typedef long long ll;
const double eps = 1e-9;
const int N = (int)1e5 + 100;
int perm[N];
int g[N], a[N], b[N];
double res[N];

bool cmp(int i, int j)
{
	return a[i] * b[j] > a[j] * b[i];
}

bool Eq(double a, double b)
{
	return fabs(a - b) < eps;
}

bool GrEq(double a, double b)
{
	return a > b || Eq(a, b);
}

int main()
{
	freopen("burrito.in", "r", stdin);
	freopen("burrito.out", "w", stdout);

	int n;
	double A, B;
	scanf("%d%lf%lf", &n, &A, &B);

	for (int i = 0; i < n; i++)
	{
		perm[i] = i;
		scanf("%d%d%d", &g[i], &a[i], &b[i]);
	}

	sort(perm, perm + n, cmp);

	double curA = 0;
	double curB = 0;
	for (int i = 0; i < n; i++)
	{
		int index = perm[i];
		double cnt = min((double)g[index], (B - curB) / b[index]);
		cnt = max(cnt, 0.0);
		curA += cnt * a[index];
		curB += cnt * b[index];
		res[index] = cnt;
	}

	if (GrEq(curA, A))
	{
		printf("%.10lf %.10lf\n", curA, curB);
		for (int i = 0; i < n; i++)
			printf("%.10lf ", res[i]);
	}
	else
		puts("-1 -1");

	return 0;
}