#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <vector>
#include <algorithm>
#include <string>
using namespace std;

const int N = 1000 + 10;
const int M = 5000;
const int F = 200;
int a[F];
char hx[M];
bool bits[N][M];
bool used[N];

int getValue(char c)
{
	if (c >= '0' && c <= '9')
		return c - '0';
	return c - 'a' + 10;
}

void putBits(int index, int pos, int value)
{
	for (int i = 0; i < 4; i++)
	{
		if (value & (1 << i))
			bits[index][pos + i] = 1;
	}
}

void parseHex(int index)
{
	int len = strlen(hx);
	for (int i = 0; i < len; i++)
	{
		putBits(index, 4 * i, getValue(hx[i]));
	}
}

int main()
{
	freopen("filter.in", "r", stdin);
	freopen("filter.out", "w", stdout);
	int m, f;
	scanf("%d%d", &m, &f);
	for (int i = 0; i < f; i++)
		scanf("%d", &a[i]);

	int n;
	scanf("%d", &n);
	for (int i = 0; i < n; i++)
	{
		scanf(" %s", hx);
		parseHex(i);
	}
	int q;
	scanf("%d", &q);
	for (int i = 0; i < q; i++)
	{
		int u;
		scanf("%d", &u);
		for (int s = 0; s < n; s++)
		{
			if (used[s])
				continue;
			bool ok = true;
			for (int q = 0; q < f; q++)
			{
				int value = ((long long)u * (long long)a[q]) % m;
				if (!bits[s][value])
				{
					ok = false;
					break;
				}
			}
			if (ok)
				used[s] = 1;
		}
	}
	int cnt = 0;
	for (int i = 0; i < n; i++)
		cnt += (int)used[i];
	printf("%d ", cnt);
	for (int i = 0; i < n; i++)
		if (used[i])
			printf("%d ", i);

	return 0;
}