#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <sstream>
#include <map>
#include <set>
#include <cmath>
#include <cstdio>
#include <ctime>


using namespace std;
typedef long long ll;

double eps = 1e-8;

vector<int> t;

int getmx(int v, int tl, int tr, int l, int r)
{
	if (l > r)
		return -1;
	if (tl == l && tr == r)
		return t[v];
	int tm = (tl + tr) / 2;
	return max(getmx(v * 2, tl, tm, l, min(tm, r)), getmx(v * 2 + 1, tm + 1, tr, max(l, tm + 1), r));
}

void update(int v, int tl, int tr, int ind, int zn)
{
	if (tl == tr)
		t[v] = zn;
	else
	{
		int tm = (tl + tr) / 2;
		if (ind <= tm)
			update(v * 2, tl, tm, ind, zn);
		else
			update(v * 2 + 1, tm + 1, tr, ind, zn);
		t[v] = max(t[v * 2], t[v * 2 + 1]);
	}
}



int main(){
	freopen("improvements.in", "r", stdin);
	freopen("improvements.out", "w", stdout);
	int n;
	cin >> n;
	vector<int> v(n);
	for (int i = 0; i < n; ++i)
	{
		int a;
		cin >> a;
		a--;
		v[a] = i;
	}
	t.assign(4 * n, 0);

	vector<int> mxleft(n);
	for (int i = 0; i < n; ++i)
	{
		int cur = v[i];
		int mx = getmx(1, 0, n - 1, 0, cur);
		mxleft[i] = mx + 1;
		update(1, 0, n - 1, cur, mxleft[i]);
		if (i != 0)
			mxleft[i] = max(mxleft[i], mxleft[i - 1]);
	}

	vector<int> mxright(n);

	t.assign(4 * n, 0);
	for (int i = n - 1; i >= 0; --i)
	{
		int cur = v[i];
		int mx = getmx(1, 0, n - 1, 0, cur);
		mxright[i] = mx + 1;
		update(1, 0, n - 1, cur, mxright[i]);
		if (i != n - 1)
			mxright[i] = max(mxright[i], mxright[i + 1]);
	}

	int ans = -1;
	for (int i = 0; i < n; ++i)
	{
		ans = max(mxleft[i] + mxright[i] - 1, ans);
	}

	cout << ans;

	return 0;
}

/*
4
1 3 2 4

6
1 5 2 4 3 6


4
1 4 2 3
*/