#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <cstring>
#include <cassert>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <stack>
#include <queue>
#include <deque>
#include <complex>

using namespace std;

#define pb push_back
#define mp make_pair
#define fs first
#define sc second
#define pbk pop_back
#define sz(s) int((s).size())
#define len(s) int((s).size())
#define all(s) (s).begin(), (s).end()
#define y0 yy0
#define y1 yy1
#define next _next
#define prev  _prev
#define hash _hash
#define link _link
#ifdef LOCAL42
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#else
#define eprintf(...) 42
#endif
#define LLD "%I64d"

typedef long long ll;
typedef long long llong;
typedef long long int64;
typedef unsigned int uint;
typedef unsigned long long ull;
typedef unsigned long long ullong;
typedef unsigned long long lint;
typedef vector<int> vi;
typedef pair<int, int> pii;
typedef long double ld;

const int inf = int(1e9);
const double eps = 1e-9;
const double pi = 4 * atan(double(1));

const int N = 100500;

struct spec
{
	int g, a, b;
	int id;
	double x;
	double rat()
	{
		return (b == 0) ? inf : a * 1.0 / b;
	}
} G[N];

bool operator <(spec a, spec b)
{
	return a.rat() > b.rat();
}

bool by_id(spec a, spec b)
{
	return a.id < b.id;
}

int main() {
#define TASK "burrito"
	freopen(TASK ".in", "r", stdin);
	freopen(TASK ".out", "w", stdout);
	int n;
	scanf("%d", &n);
	double A, B;
	scanf("%lf %lf", &A, &B);
	for (int i = 0; i < n; i++)
		scanf("%d %d %d", &G[i].g, &G[i].a, &G[i].b), G[i].id = i, G[i].x = 0;
	double sb = 0, sa = 0;
	sort(G, G + n);
	for (int i = 0; i < n; i++)
	{
		if (sb + G[i].b * G[i].g < B + eps)
			sb += G[i].b * G[i].g, sa += G[i].a * G[i].g, G[i].x = G[i].g;
		else
		{
			double x;
			if (G[i].b == 0)
				x = G[i].g;
			else
				x = (B - sb) / G[i].b;
			G[i].x = x;
			sb += x * G[i].b;
			sa += x * G[i].a;
			break;
		}
	}
	if (sa < A - eps)
		puts("-1 -1");
	else
	{
		printf("%.10lf %.10lf\n", sa, sb);
		sort(G, G + n, by_id);
		for (int i = 0; i < n; i++)
			printf("%.10lf ", G[i].x);
	}
	return 0;
}
