#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <cstring>
#include <cassert>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <stack>
#include <queue>
#include <deque>
#include <complex>

using namespace std;

#define pb push_back
#define mp make_pair
#define fs first
#define sc second
#define pbk pop_back
#define sz(s) int((s).size())
#define len(s) int((s).size())
#define all(s) (s).begin(), (s).end()
#define y0 yy0
#define y1 yy1
#define next _next
#define prev  _prev
#define hash _hash
#define link _link
#ifdef LOCAL42
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#else
#define eprintf(...) 42
#endif
#define LLD "%I64d"

typedef long long ll;
typedef long long llong;
typedef long long int64;
typedef unsigned int uint;
typedef unsigned long long ull;
typedef unsigned long long ullong;
typedef unsigned long long lint;
typedef vector<int> vi;
typedef pair<int, int> pii;
typedef long double ld;

const int inf = int(1e9);
const double eps = 1e-9;
const double pi = 4 * atan(double(1));
const int N = int(2e5) + 200;

int a[N], val[N], up[N], down[N];

int main() {
#define TASK "improvements"
	freopen(TASK ".in", "r", stdin);
	freopen(TASK ".out", "w", stdout);
	int n;
	scanf("%d", &n);
	for (int i = 0; i < n; ++i) {
		scanf("%d", &a[i]);
	}
	for (int i = 0; i <= n; ++i) {
		val[i] = inf;
	}
	val[0] = 0;
	for (int i = 0; i < n; ++i) {
		int pos = upper_bound(val, val + n + 1, a[i]) - val;
		val[pos] = a[i];
	}
	for (int i = 1; i <= n; ++i) {
		up[i] = -inf;
	}
	for (int i = 1; i <= n; ++i) {
		if (val[i] == inf) {
			continue;
		}
		up[val[i]] = max(up[val[i]], i);
	}
	for (int i = 2; i <= n; ++i) {
		up[i] = max(up[i], up[i - 1]);
	}
	eprintf("up:\n");
	for (int i = 1; i <= n; ++i) {
		eprintf("%d ", up[i]);
	}
	eprintf("\n");
	for (int i = 0; i <= n; ++i) {
		val[i] = -inf;
	}
	val[0] = n + 1;
	for (int i = 0; i < n; ++i) {
		int pos = -1, l = 0, r = n;
		while (l <= r) {
			int mid = (l + r) / 2;
			if (val[mid] < a[i]) {
				pos = mid;
				r = mid - 1;
			}
			else {
				l = mid + 1;
			}
		}
		val[pos] = a[i];
	}
	for (int i = 1; i <= n; ++i) {
		down[i] = -inf;
	}
	for (int i = 1; i <= n; ++i) {
		if (val[i] == -inf) {
			continue;
		}
		down[val[i]] = max(down[val[i]], i);
	}
	for (int i = n - 1; i > 0; --i) {
		down[i] = max(down[i], down[i + 1]);
	}
	eprintf("down:\n");
	for (int i = 1; i <= n; ++i) {
		eprintf("%d ", down[i]);
	}
	eprintf("\n");
	int ans = max(up[n], down[1]);
	for (int i = 1; i < n; ++i) {
		ans = max(ans, up[i] + down[i + 1]);
	}
	cout << ans << endl;
	return 0;
}
