#include <iostream>
#include <iomanip>
#include <queue>
#include <vector>
#include <map>
#include <cstdio>
#include <algorithm>

using namespace std;

struct sample {
	sample(int G = 0, int A = 0, int B = 0, int I = 0) : g(G), a(A), b(B), index(I) {
		ans = 0.0;
	}
	int g;
	int a;
	int b;
	int index;
	double ans;

	bool operator<(const sample& r) const {
		if (b == 0 && r.b == 0)
			return a > r.a;
		if (b == 0)
			return true;
		if (r.b == 0)
			return false;
		return a * r.b > r.a * b;
	}
};

int main() {
//#ifndef _DEBUG
	freopen("burrito.in", "r", stdin);
	freopen("burrito.out", "w", stdout);
//#endif

	ios_base::sync_with_stdio(false);

	int n;
	double A, B;
	cin >> n >> A >> B;

	vector<sample> ss(n);
	for (int i = 0; i < n; ++i) {
		cin >> ss[i].g >> ss[i].a >> ss[i].b;
		ss[i].index = i;
		ss[i].ans = 0.0;
	}
	sort(ss.begin(), ss.end());

	double joy = 0.0;
	double unh = 0.0;

	for (int i = 0; i < n; ++i) {
		if (ss[i].b == 0) {
			ss[i].ans = 1.0 * ss[i].g;
			joy += ss[i].ans * ss[i].a;
		}
		else {
			ss[i].ans = std::min(1.0 * ss[i].g, (B - unh) / ss[i].b);
			joy += ss[i].ans * ss[i].a;
			unh += ss[i].ans * ss[i].b;
		}
	}

	const double EPS = 1e-10;
	if (joy < A - EPS || unh > B + EPS) {
		cout << -1 << " " << -1 << endl;
	}
	else {
		cout << fixed << setprecision(8) << joy << " " << unh << endl;
		vector<double> answer(n);
		for (int i = 0; i < n; ++i) {
			answer[ss[i].index] = ss[i].ans;
		}
		for (int i = 0; i < n; ++i) {
			cout << fixed << setprecision(8) << answer[i] << " ";
		}
		cout << endl;
	}

	return 0;
}