#include <iostream>
#include <iomanip>
#include <queue>
#include <vector>
#include <map>
#include <cstdio>
#include <bitset>
#include <algorithm>

using namespace std;

string ALL_SYMS = "RPS";
map<char, char> BEATS;
map<char, char> BEATED_BY;

struct state {
	char to_play;
	map<char, int> transfer;
};

vector<state> opponent;
vector<state> me;
int free_state;

void assure_min_state(int i) {
	if (i >= me.size()) {
		me.resize(i + 1, state());
	}
}

map<char, int> get_opst_cnt(vector<int>& opstates) {
	map<char, int> opst_cnt;
	opst_cnt['R'] = 0;
	opst_cnt['P'] = 0;
	opst_cnt['S'] = 0;
	for (int i = 0; i < opstates.size(); ++i) {
		state& opstate = opponent[opstates[i]];
		opst_cnt[opstate.to_play] += 1;
	}
	return opst_cnt;
}

pair<char, int> get_largest_opfraction(map<char, int>& opst_cnt) {
	pair<char, int> largest_opfraction('!', -1);
	for (int i = 0; i < 3; ++i) {
		char sym = ALL_SYMS[i];
		if (opst_cnt[sym] > largest_opfraction.second) {
			largest_opfraction.first = sym;
			largest_opfraction.second = opst_cnt[sym];
		}
	}
	return largest_opfraction;
}

int hist[101];
void make_unique(vector<int>& r) {
	for (int i = 0; i <= 100; ++i) hist[i] = 0;
	for (int i = 0; i < r.size(); ++i) {
		hist[r[i]] = 1;
	}
	r.clear();
	for (int i = 0; i <= 100; ++i) {
		if (hist[i]) r.push_back(i);
	}
}

//void my_step(int me_cur, vector<int>& opstates) {
//	map<char, int> opst_cnt = get_opst_cnt(opstates);
//	
//	pair<char, int> largest_opfraction = get_largest_opfraction(opst_cnt);
//
//	// if we know what's gonna be the opponent's turn
//	if (largest_opfraction.second == opstates.size()) {
//		me[me_cur].to_play = BEATS[largest_opfraction.first];
//		vector<int> next_states = opstates;
//		for (int i = 0; i < opstates.size(); ++i) {
//			next_states[i] = opponent[next_states[i]].transfer[me[me_cur].to_play];
//		}
//		make_unique(next_states);
//
//		map<char, int> next_opst_cnt = get_opst_cnt(next_states);
//		pair<char, int> next_largest_opf = get_largest_opfraction(next_opst_cnt);
//
//		// if next states are not all equal
//		if (next_largest_opf.second < next_states.size() ||
//			next_states.size() < opstates.size()) {
//			int next_state = free_state++;
//			assure_min_state(next_state);
//			for (int s = 0; s < 3; ++s) {
//				me[me_cur].transfer[ALL_SYMS[s]] = next_state;
//			}
//			my_step(next_state, next_states);
//		}
//		else {
//			if (next_largest_opf.first == largest_opfraction.first) {
//				for (int s = 0; s < 3; ++s) {
//					me[me_cur].transfer[ALL_SYMS[s]] = me_cur;
//				}
//			}
//			else {
//
//			}
//		}
//	}
//	else { // there are several possibilities - tree-turn
//		me[me_cur].to_play = BEATS[largest_opfraction.first];
//		vector<int> r_states, p_states, s_states;
//		for (int i = 0; i < opstates.size(); ++i) {
//			state& opstate = opponent[opstates[i]];
//			if (opstate.to_play == 'R') r_states.push_back(opstates[i]);
//			if (opstate.to_play == 'P') p_states.push_back(opstates[i]);
//			if (opstate.to_play == 'S') s_states.push_back(opstates[i]);
//		}
//		// turning
//		for (int i = 0; i < r_states.size(); ++i) r_states[i] = opponent[r_states[i]].transfer[me[me_cur].to_play];
//		for (int i = 0; i < p_states.size(); ++i) p_states[i] = opponent[p_states[i]].transfer[me[me_cur].to_play];
//		for (int i = 0; i < s_states.size(); ++i) s_states[i] = opponent[s_states[i]].transfer[me[me_cur].to_play];
//		make_unique(r_states);
//		make_unique(p_states);
//		make_unique(s_states);
//
//		// tree for R
//		if (r_states.size() == 1) {
//			me[me_cur].transfer['R'] = 1 + r_states[0];
//		}
//		else if (r_states.size() > 1) {
//			int new_state = free_state++;
//			assure_min_state(new_state);
//			me[me_cur].transfer['R'] = new_state;
//			my_step(new_state, r_states);
//		}
//		// tree for P
//		if (p_states.size() == 1) {
//			me[me_cur].transfer['P'] = 1 + p_states[0];
//		}
//		else if (p_states.size() > 1) {
//			int new_state = free_state++;
//			assure_min_state(new_state);
//			me[me_cur].transfer['P'] = new_state;
//			my_step(new_state, p_states);
//		}
//		// tree for S
//		if (s_states.size() == 1) {
//			me[me_cur].transfer['S'] = 1 + s_states[0];
//		}
//		else if (s_states.size() > 1) {
//			int new_state = free_state++;
//			assure_min_state(new_state);
//			me[me_cur].transfer['S'] = new_state;
//			my_step(new_state, s_states);
//		}
//	}
//}

map<vector<int>, int> STATES;

void my_step(int me_cur, vector<int>& opstates) {
	for (int i = 0; i < 3; ++i) {
		me[me_cur].transfer[ALL_SYMS[i]] = me_cur;
	}
	map<char, int> opst_cnt = get_opst_cnt(opstates);	
	pair<char, int> largest_opfraction = get_largest_opfraction(opst_cnt);
	me[me_cur].to_play = BEATS[largest_opfraction.first];

	vector<int> r_states, p_states, s_states;
	for (int i = 0; i < opstates.size(); ++i) {
		state& opstate = opponent[opstates[i]];
		if (opstate.to_play == 'R') r_states.push_back(opstates[i]);
		if (opstate.to_play == 'P') p_states.push_back(opstates[i]);
		if (opstate.to_play == 'S') s_states.push_back(opstates[i]);
	}
	// turning
	for (int i = 0; i < r_states.size(); ++i) 
		r_states[i] = opponent[r_states[i]].transfer[me[me_cur].to_play];
	for (int i = 0; i < p_states.size(); ++i) 
		p_states[i] = opponent[p_states[i]].transfer[me[me_cur].to_play];
	for (int i = 0; i < s_states.size(); ++i) 
		s_states[i] = opponent[s_states[i]].transfer[me[me_cur].to_play];
	
	make_unique(r_states);
	make_unique(p_states);
	make_unique(s_states);

	map<vector<int>, int>::iterator it;
	
	if (!r_states.empty()) {
		it = STATES.find(r_states);
		if (it != STATES.end()) {
			me[me_cur].transfer['R'] = it->second;
		}
		else {
			int new_state = free_state++;
			assure_min_state(new_state);
			STATES[r_states] = new_state;
			me[me_cur].transfer['R'] = new_state;
			my_step(new_state, r_states);
		}
	}

	if (!p_states.empty()) {
		it = STATES.find(p_states);
		if (it != STATES.end()) {
			me[me_cur].transfer['P'] = it->second;
		}
		else {
			int new_state = free_state++;
			assure_min_state(new_state);
			STATES[p_states] = new_state;
			me[me_cur].transfer['P'] = new_state;
			my_step(new_state, p_states);
		}
	}

	if (!s_states.empty()) {
		it = STATES.find(s_states);
		if (it != STATES.end()) {
			me[me_cur].transfer['S'] = it->second;
		}
		else {
			int new_state = free_state++;
			assure_min_state(new_state);
			STATES[s_states] = new_state;
			me[me_cur].transfer['S'] = new_state;
			my_step(new_state, s_states);
		}
	}
}

int main() {
	freopen("epic.in", "r", stdin);
	freopen("epic.out", "w", stdout);
	ios_base::sync_with_stdio(false);
	BEATS['P'] = 'S';
	BEATS['S'] = 'R';
	BEATS['R'] = 'P';
	BEATED_BY['S'] = 'P';
	BEATED_BY['R'] = 'S';
	BEATED_BY['P'] = 'R';

	int n;
	cin >> n;
	opponent.resize(n);
	for (int i = 0; i < n; ++i) {
		string toplay = "";
		int tr, tp, ts;
		cin >> toplay >> tr >> tp >> ts;
		opponent[i].to_play = toplay[0];
		opponent[i].transfer['R'] = tr - 1;
		opponent[i].transfer['P'] = tp - 1;
		opponent[i].transfer['S'] = ts - 1;
	}

	assure_min_state(n);
	// 0 - initial state
	// 1..i..n - if opponent's state is (i - 1)
	for (int i = 1; i <= n; ++i) {
		int opstate = i - 1;
		me[i].to_play = BEATS[opponent[opstate].to_play];
		me[i].transfer[opponent[opstate].to_play] = 1 + opponent[opstate].transfer[me[i].to_play]; 
		for (int s = 0; s < 3; ++s) {
			char sym = ALL_SYMS[s];
			if (sym != opponent[opstate].to_play) {
				me[i].transfer[sym] = i;
			}
		}
		vector<int> for_map(1, i - 1);
		STATES[for_map] = i;
	}

	free_state = n + 1;

	vector<int> opstates_initial;
	for (int i = 0; i < n; ++i) {
		opstates_initial.push_back(i);
	}
	my_step(0, opstates_initial);

	cout << me.size() << endl;
	for (int i = 0; i < me.size(); ++i) {
		cout << me[i].to_play << " ";
		cout << me[i].transfer['R'] + 1 << " ";
		cout << me[i].transfer['P'] + 1 << " ";
		cout << me[i].transfer['S'] + 1 << endl;
	}

	return 0;
}
/*
23 4 3 5 7 11
3
effde7
c07902
0800c1
3 2 4 6

*/