#include <iostream>
#include <iomanip>
#include <queue>
#include <vector>
#include <map>
#include <cstdio>
#include <bitset>
#include <algorithm>

using namespace std;

typedef unsigned long long T;

inline int from_hex(char c) {
	if (isdigit(c))
		return c - '0';
	return c - 'a' + 10;
}


T a[101];
bitset<1005> bloom[1001];

vector<bool> ret_queries;

int m, f, n;

bool can_be_in_file(const T user, const int ifile) {
	const bitset<1005> &cur_bloom = bloom[ifile];
	for (int ifunc = 0; ifunc < f; ++ifunc) {
		const int j = (user * a[ifunc]) % m;
		if (!cur_bloom.at(j)) {
			return false;
		}
	}
	return true;
}

void solve(const T user) {
	for (int ifile = 0; ifile < n; ++ifile) {
		if (ret_queries[ifile]) {
			continue;
		}

		if (can_be_in_file(user, ifile)) {
			ret_queries[ifile] = true;
		}
	}
}


int main() {
//#ifndef _DEBUG
	freopen("filter.in", "r", stdin);
	freopen("filter.out", "w", stdout);
//#endif
	ios_base::sync_with_stdio(false);

	cin >> m >> f;
	for (int i = 0; i < f; ++i) {
		cin >> a[i];
	}

	cin >> n;
	for (int i = 0; i < n; ++i) {
		string s; cin >> s;
		for (int j = 0; j < s.length(); ++j) {
			bitset<1005> &cur_bloom = bloom[i];
			const char c = s[j];
			const int bits = from_hex(c);
			for (int k = 0; k < 4; ++k) {
				if (bits & (1 << k)) {
					const int bit_pos = 4 * j + k;
					cur_bloom.set(bit_pos);
				}
			}
		}
	}
	
	ret_queries.resize(n, false);

	int queries; cin >> queries;
	for (int q = 0; q < queries; ++q) {
		T u; cin >> u;
		solve(u);
	}

	int ret = 0;
	for (int i = 0; i < ret_queries.size(); ++i) {
		if (ret_queries[i]) {
			++ret;
		}
	}

	cout << ret << " ";
	for (int i = 0; i < ret_queries.size(); ++i) {
		if (ret_queries[i]) {
			cout << i << " ";
		}
	}
	cout << endl;

	return 0;
}
/*
23 4 3 5 7 11
3 
effde7
c07902
0800c1
3 2 4 6

*/