#include <iostream>
#include <queue>
#include <vector>
#include <map>
#include <cstdio>
#include <stack>
#include <string>

using namespace std;

int get_length(int max_number) {
	int ret = 0;
	for (int i = 1; i <= max_number; ++i) {
		ret += 1 + (i >= 10);
	}
	return ret;
}

int get_max_number(const int length) {
	for (int i = 1; i <= 50; ++i) {
		if (get_length(i) == length) {
			return i;
		}
	}
	return 50;
}

vector<bool> mask;
int max_number;
string s;
vector<int> ret;

int ch(char c) {
	return c - '0';
}

void backtrack(int pos) {
	if (pos == s.length()) {
		for (int i = 0; i < ret.size(); ++i) {
			cout << ret[i] << " ";
		}
		cout << endl;
		exit(0);
	}

	vector<int> variants;
	variants.push_back(s[pos] - '0');

	if (pos + 1 < s.length()) {
		variants.push_back(ch(s[pos]) * 10 + ch(s[pos + 1]));
	}

	for (int v = 0; v < variants.size(); ++v) {
		const int var = variants[v];
		if (pos + 1 < s.length() && ch(s[pos + 1]) == 0 && var < 10) {
			continue;
		}
		if (var > max_number) {
			continue;
		}
		if (mask[var] == true) {
			continue;
		}

		mask[var] = true;
		ret.push_back(var);

		backtrack((var < 10) ? (pos + 1) : (pos + 2));

		ret.pop_back();
		mask[var] = false;
	}
}

int main() {
//#ifndef _DEBUG
	freopen("joke.in", "r", stdin);
	freopen("joke.out", "w", stdout);
//#endif

	ios_base::sync_with_stdio(false);
	
	cin >> s;

	max_number = get_max_number(s.length());

	mask.assign(s.length(), false);

	backtrack(0);
}

/*
4111109876532

1234567891011121314151617181920212223242526272829303132333435363738394041424344454647484950

5049484746454443424140393837363534333231302928272625242322212019181716151413121110987654321
*/