#include <iostream>
#include <queue>
#include <vector>
#include <map>
#include <cstdio>

using namespace std;

int get_pos(const pair<int, int> &car, const int t) {
	const int len = car.second - car.first;
	int pos = -1;
	if ((t / len) % 2 == 0) {
		pos = car.first + (t % len);
	}
	else {
		pos = car.first + len - (t % len);
	}
	return pos;
}

int main() {
//#ifndef _DEBUG
	freopen("knockout.in", "r", stdin);
	freopen("knockout.out", "w", stdout);
//#endif

	ios_base::sync_with_stdio(false);

	int n, m; cin >> n >> m;

	vector<pair<int, int> > cars(n);
	for (int i = 0; i < n; ++i) {
		cin >> cars[i].first >> cars[i].second;
	}

	for (int q = 0; q < m; ++q) {
		int x, y, t; cin >> x >> y >> t;

		int inside_count = 0;

		for (int i = 0; i < n; ++i) {
			const pair<int, int> &car = cars[i];
			const int pos = get_pos(car, t);
			if (pos >= x && pos <= y) {
				++inside_count;
			}
		}
		cout << inside_count << endl;
	}
}

/*
5 5
0 1
0 2
2 3 
3 5
4 5
0 5 0
0 1 2
0 2 1
2 5 2
2 5 3
*/