#include <iostream>
#include <cstdio>
#include <cctype>
#include <cassert>
#include <vector>

using namespace std;

int a[111];
vector < int > files[1111], queryMask[1111];
int query[1111];
vector < int > ans;

void convertMaskToNum(const string& s, vector < int > &v) {
    int n = s.length();
    v.resize(n);
    for(int i = 0;i < n;i++) {
        v[i] = (isdigit(s[i]) ? s[i] - '0' : s[i] - 'a' + 10);
    }
}

bool contains(const vector < int > &file, const vector < int > &queryMask, int m) {
    int n = file.size();
    assert(n == queryMask.size());
    for(int i = 0;i < n - 1;i++) {
        if((file[i] & queryMask[i]) != queryMask[i]) {
            return false;
        }
    }
    int tailLen = m % 4;
    if(tailLen == 0) {
        tailLen += 4;
    }
    for(int i = 0;i < tailLen;i++) {
        if((queryMask[n - 1] & (1 << i))) {
            if(!(file[n - 1] & (1 << i))) {
                return false;
            }
        }
    }
    return true;
}

int main() {
    freopen("filter.in", "r", stdin);
    freopen("filter.out", "w", stdout);
    ios_base::sync_with_stdio(false);
    int m, f, n, q;
    string s;
    cin >> m >> f;
    for(int i = 0;i < f;i++) {
        cin >> a[i];
    }
    cin >> n;
    for(int i = 0;i < n;i++) {
        cin >> s;
        convertMaskToNum(s, files[i]);
    }
    cin >> q;
    for(int i = 0;i < q;i++) {
        cin >> query[i];
    }
    int maskLen = (m + 3) / 4;
    for(int i = 0;i < q;i++) {
        queryMask[i].resize(maskLen);
        for(int j = 0;j < f;j++) {
            int curBit = (1LL * query[i] * a[j]) % (1LL * m);
            int index = curBit / 4;
            int bitIndex = curBit % 4;
            assert(index < maskLen);
            queryMask[i][index] |= (1 << bitIndex);
        }
    }
    for(int i = 0;i < n;i++) {
        bool ok = false;
        for(int j = 0;j < q;j++) {
            if(contains(files[i], queryMask[j], m)) {
                ok = true;
                break;
            }
        }
        if(ok) {
            ans.push_back(i);
        }
    }
    cout << ans.size();
    for(size_t i = 0;i < ans.size();i++) {
        cout << ' ' << ans[i];
    }
    cout << '\n';
    return 0;
}
