import java.io.*;
import java.math.BigInteger;
import java.util.*;

public class Main implements Runnable{

    Scanner sc;
    PrintWriter out;

    public static void main(String[] args) {
        new Main().run();
    }

    @Override
    public void run() {
        try {
            sc =  new Scanner(new File("filter.in"));
            out = new PrintWriter(new File("filter.out"));
        } catch (Exception e) {
            e.printStackTrace();
        }
        solve();
        out.flush();
    }

    int m, f;
    int[] a;
    int cntFiles;
    BitSet[] file;
    int cntPerson;
    //int[] u;
    TreeSet<Integer> isUsedFile = new TreeSet<Integer>();

    private void solve() {
        m = sc.nextInt();
        f = sc.nextInt();
        a = new int[f];
        for (int i = 0; i < f; i++) {
            a[i] = sc.nextInt();
        }

        cntFiles = sc.nextInt();

        file = new BitSet[cntFiles];
        for (int idFile = 0; idFile < cntFiles; idFile++) {
            char[] str = sc.next().toCharArray();
            for(int x = 0, y = str.length - 1; x < y; ++x, --y){
                char ch = str[x];
                str[x] = str[y];
                str[y] = ch;
            }
            String s = new BigInteger(new String(str), 16).toString(2);
            file[idFile] = new BitSet();
            for(int pos = 0; pos < s.length(); ++pos)
                if( s.charAt(pos) == '1' )
                    file[idFile].set(s.length() - 1 - pos);
//            System.err.println(Integer.toBinaryString(file[i]));
        }

        cntPerson = sc.nextInt();
        //u = new int[cntPerson];
        for (int iter = 0; iter < cntPerson; iter++) {
            int uk = sc.nextInt();
            int msk = 0;
            int[] bits = new int[f];
            int sz = 0;
            for(int ai : a){
                int j = (int)( (long)uk * ai % m );
                bits[sz++] = j;
//                System.err.print(" " + j);
            }
//            System.err.println();
            //out.println(Integer.toBinaryString(msk));
            for( int idFile = 0; idFile < cntFiles; ++idFile ){
                boolean ok = true;
                for( int posBit : bits ){
                    ok &= file[idFile].get(posBit);
                }
                if(ok)
                    isUsedFile.add(idFile);
            }
        }

        out.print(isUsedFile.size());
        for( int v : isUsedFile ) out.print( " " + v );

    }
}

//
//23  4 3 5 7 11
//        3
//        effde7
//        c07902
//        0800c1
//        3 2 4 6
