package neercv;
 
import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Random;
import java.util.StringTokenizer;
import java.util.TreeSet;
 
public class Solution {
     
    BufferedReader in;
    PrintWriter out;
    StringTokenizer tok;
     
    void init() throws FileNotFoundException{
        try{
            in = new BufferedReader(new FileReader("inssau2.txt"));
            out = new PrintWriter("outssau2.txt");
        } catch (Exception e) {
            in = new BufferedReader(new FileReader("burrito.in"));
            out = new PrintWriter("burrito.out");
        }
    }
     
    String readString() throws IOException{
        while (tok == null || !tok.hasMoreTokens()) tok = new StringTokenizer(in.readLine());
        return tok.nextToken();         
    }
     
    int readInt() throws NumberFormatException, IOException{
        return Integer.parseInt(readString());
    }
     
     
    class Drob implements Comparable<Drob>{
        int g;
        int a;
        int b;
        int index;
         
        Drob(int g,int a, int b, int index){
            this.g = g;
            this.a = a;
            this.b = b;
            this.index=  index;
        }
 
        @Override
        public int compareTo(Drob o) {
            if (b == o.b) return -a+o.a;
            if (a == o.a) return b - o.b;
            int a1 = a*o.b;
            int a2 = o.a * b;
            return -a1+a2;
        }
         
         
    }
     
    void solve() throws NumberFormatException, IOException{
        int n = readInt();
        int first = readInt();
        int second = readInt();
        ArrayList<Drob> list = new ArrayList<Drob>();
        for (int i=0;i<n;i++){
            Drob d = new Drob(readInt(),readInt(),readInt(),i);
            if (d.a != 0)
                list.add(d);
        }
         
        Collections.sort(list);
         
        long counta = 0;
        long countb = 0;
         
        double[] ans = new double[n];
         
        for (Drob d : list){
            if (countb + (long)d.g* d.b <= second){
                counta += (long)d.g* d.a;
                countb += (long)d.g * d.b;
                ans[d.index] = d.g;
            } else {
                double last = 1d*(second - countb) / d.b;
                if (counta + last*d.a < first){
                    out.println("-1 -1");
                    return;
                }
                out.println((counta + last *d.a)+" "+(countb + last*d.b));
                ans[d.index] = last;
                for (int i=0;i<n;i++){
                    out.print(ans[i] + " ");
                }
                return;
            }
        }
        if (counta < first){
            out.println("-1 -1");
            return;         
        }
        out.println(counta+" "+countb);
        for (int i=0;i<n;i++){
            out.print(ans[i] + " ");
        }
         
         
    }
     
    void run(){
        try{
            init();
            long time = System.currentTimeMillis();
            solve();
            out.close();
            System.err.println(System.currentTimeMillis() - time);
            in.close();
        } catch(Exception e){
            e.printStackTrace();            
        }
    }
     
     
    public static void main(String[] args) {
        new Solution().run();       
    }
 
}