package neercv;
 
import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.Random;
import java.util.StringTokenizer;
import java.util.TreeSet;
 
public class Solution {
     
    BufferedReader in;
    PrintWriter out;
    StringTokenizer tok;
     
    void init() throws FileNotFoundException{
        try{
            in = new BufferedReader(new FileReader("inssau2.txt"));
            out = new PrintWriter("outssau2.txt");
        } catch (Exception e) {
            in = new BufferedReader(new FileReader("filter.in"));
            out = new PrintWriter("filter.out");
        }
    }
     
    String readString() throws IOException{
        while (tok == null || !tok.hasMoreTokens()) tok = new StringTokenizer(in.readLine());
        return tok.nextToken();         
    }
     
    int readInt() throws NumberFormatException, IOException{
        return Integer.parseInt(readString());
    }
    
    int getDex(char x){
    	if (x >='0' && x<='9') return x - '0';
    	return x - 'a' + 10;
    }
    
    int MAX = 17;
    int MOD = 63;
    
    long[] readBits() throws IOException{
    	String s = readString();
    	long[] result = new long[17];
    	for (int i=0;i<m;i+=4){
    		int z = getDex(s.charAt(i / 4));
    		int j = 0;
    		while (z > 0){
    			int index = i + j;
    			if (z % 2 == 1) {
    				int x = index / 63;
    				int y = index % 63;
    				result[x] |= 1l << y;
    			}
    			z = z / 2; 
    			j++;
    		}
    	}
    	return result;
    }
     
    
    int getHash(int a, int b){
    	return (a*b)%m;
    }
    
    int m;
    void solve() throws NumberFormatException, IOException{
        m = readInt();
        int f = readInt();
        int[] a= new int[f];
        for (int i=0;i<f;i++){
        	a[i] = readInt()%m;
        }        
        int n = readInt();
        long[][] bits = new long[n][];
        for (int i=0;i<n;i++){
        	bits[i] = readBits();
        }
        int q = readInt();
        long[][] userbits = new long[q][MAX];
        
        for (int i = 0; i < q; i++){
        	int uk = readInt() % m;
        	for (int j =0;j<f;j++){
        		int index = getHash(uk, a[j]);
        		int x = index / 63;
				int y = index % 63;
        		userbits[i][x] |= 1l << y;        		
        	}
        }
        ArrayList<Integer> answer = new ArrayList<Integer>();
        
        for (int i=0;i<n;i++){
        	for (int j=0;j<q;j++){
        		boolean ok = true;
        		for (int k = 0; k < MAX; k++){
        			if ((bits[i][k] | userbits[j][k]) > bits[i][k]) {
        				ok = false;
        				break;
        			}
        		}
        		if (ok) {
        			answer.add(i);
        			break;
        		}
        	}
        }
        
        out.print(answer.size());
        for (int i : answer){
        	out.print(" "+i);
        }
         
    }
     
    void run(){
        try{
            init();
            long time = System.currentTimeMillis();
            solve();
            out.close();
            System.err.println(System.currentTimeMillis() - time);
            in.close();
        } catch(Exception e){
            e.printStackTrace();            
        }
    }
     
     
    public static void main(String[] args) {
        new Solution().run();       
    }
 
}