package neercv;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Random;
import java.util.StringTokenizer;
import java.util.TreeSet;

public class Solution {
	
	BufferedReader in;
	PrintWriter out;
	StringTokenizer tok;
	
	void init() throws FileNotFoundException{
		try{
			in = new BufferedReader(new FileReader("inssau2.txt"));
			out = new PrintWriter("outssau2.txt");
		} catch (Exception e) {
			in = new BufferedReader(new FileReader("joke.in"));
			out = new PrintWriter("joke.out");
		}
	}
	
	String readString() throws IOException{
		while (tok == null || !tok.hasMoreTokens()) tok = new StringTokenizer(in.readLine());
		return tok.nextToken();			
	}
	
	int readInt() throws NumberFormatException, IOException{
		return Integer.parseInt(readString());
	}
	
	char[] input;
	
	boolean[] have;
	int[] perm;
	int max = 0;
	int n = 0;
	
	void brut(int pos, int cur){
		if (pos == n){
			//TreeSet<Integer> set = new TreeSet<Integer>();
			for (int i=0;i<max;i++){
				out.print(perm[i]);
				if (i != max -1) 
					out.print(' ');
				
				//set.add(perm[i]);
			}
			out.println();
			//out.println(set.size() == max);			
			out.close();
			return;
		}
		if (input[pos] == '0') return;
		int n1 = getNumber(input[pos]);
		if (n1 <= max && !have[n1]){
			have[n1] = true;
			perm[cur] = n1;			
			brut(pos+1,cur+1);
			have[n1] = false;
		}
		
		if (pos + 1 < n){
			n1 = getNumber(input[pos], input[pos+1]);
			if (n1 <= max && !have[n1]){
				have[n1] = true;
				perm[cur] = n1;			
				brut(pos+2,cur+1);
				have[n1] = false;
			}			
		}
	}
	
	int getNumber(char x){
		return x - '0';		
	}
	
	int getNumber(char x, char y){
		return getNumber(x) * 10 + getNumber(y);
	}
	
	int get(int n){
		if (n < 10) return 1;
		return 2;
	}
	
	int[] getRand(){
		int[] a = new int[50];
		for (int i=0;i<50;i++)
			a[i] = i+1;
		Random rnd = new Random();
		for (int i=0;i<50;i++){
			int x = rnd.nextInt(50);
			int t = a[x];
			a[x] = a[i];
			a[i] = t;
		}
		return a;
	} 
	
	void solve() throws NumberFormatException, IOException{
//		String s = "";
//		int[] x = getRand();
//		for (int i : x)
//			s+=i;
//		out.println(s);
		input = readString().toCharArray();
		int len = input.length;
		n = len;
		for (int i=1;i<=51;i++){
			if (len == 0) {
				max = i - 1;
				break;
			}
			len -= get(i);
		}
		
		have = new boolean[max+1];
		perm = new int[max+1];
		
		
		brut(0,0);
		
	}
	
	void run(){
		try{
			init();
			long time = System.currentTimeMillis();
			solve();
			out.close();
			System.err.println(System.currentTimeMillis() - time);
			in.close();
		} catch(Exception e){
			e.printStackTrace();			
		}
	}
	
	
	public static void main(String[] args) {
		new Solution().run();		
	}

}
