package neercv;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.StringTokenizer;

public class Solution {
	
	BufferedReader in;
	PrintWriter out;
	StringTokenizer tok;
	
	void init() throws FileNotFoundException{
		try{
			in = new BufferedReader(new FileReader("inssau2.txt"));
			out = new PrintWriter("outssau2.txt");
		} catch (Exception e) {
			in = new BufferedReader(new FileReader("knockout.in"));
			out = new PrintWriter("knockout.out");
		}
	}
	
	String readString() throws IOException{
		while (tok == null || !tok.hasMoreTokens()) tok = new StringTokenizer(in.readLine());
		return tok.nextToken();			
	}
	
	int readInt() throws NumberFormatException, IOException{
		return Integer.parseInt(readString());
	}
	
	void solve() throws NumberFormatException, IOException{
		int n = readInt();
		int m = readInt();
		int[] a = new int[n];
		int[] b = new int[n];
		for (int i=0;i<n;i++){
			a[i] = readInt();
			b[i] = readInt();
		}
		
		for (int i=0;i<m;i++){
			int x = readInt();
			int y = readInt();
			int t = readInt();
			int ans = 0;
			for (int j=0;j<n;j++){
				int len = Math.abs(a[j] - b[j]);
				int cel = t / len;
				int ost = t % len;
				int cur = 0;
				if (cel % 2 == 0){
					if (a[j] < b[j]) {
						cur = a[j] + ost;												
					} else {
						cur = a[j] - ost;
					}
				} else{
					if (a[j] < b[j]) {
						cur = b[j] - ost;												
					} else {
						cur = b[j] + ost;
					}										
				}
				if (cur >= x && cur <= y) ans++;
			}
			out.println(ans);
		}
		
	}
	
	void run(){
		try{
			init();
			solve();
			out.close();
			in.close();
		} catch(Exception e){
			e.printStackTrace();			
		}
	}
	
	
	public static void main(String[] args) {
		new Solution().run();		
	}

}
