#include <iostream>
#include <cstdio>
#include <cmath>
#include <ctime>
#include <iomanip>
#include <algorithm>
#include <vector>
#include <queue>
#include <set>
#include <map>
#include <bitset>
#include <string>
#include <cstring>

using namespace std;

int tree[ 4 * 200200 ];
int n, x[ 200200 ], f[ 200200 ], g[ 200200 ], p[ 200200 ];

void upd( int v, int l, int r, int pos, int value )
{
    if ( l == r )
	{
        tree[v] = value;
        return;
	}
    int x = ( l + r ) / 2;
    if ( pos <= x ) upd( v + v, l, x, pos, value ); else upd( v + v + 1, x + 1, r, pos, value );
    tree[v] = max( tree[v + v], tree[v + v + 1] );
}

int query( int v, int l, int r, int ll, int rr )
{
    if ( ll > rr ) return 0;
    if ( l == ll && rr == r ) return tree[v];
    int x = ( l + r ) / 2;
    int result = 0;
    if ( ll <= x )
	{
        int left_son = query( v + v, l, x, ll, min( rr, x ) );
        result = max( result, left_son );
    }
    if ( x + 1 <= rr )
    {
        int right_son = query( v + v + 1, x + 1, r, max( x + 1, ll ), rr );
        result = max( result, right_son );
    }
    return result;
} 

void solve()
{
    scanf("%d", &n);
    for ( int i = 1; i <= n; i++ ) scanf("%d", &x[i]), p[ x[i] ] = i;
    //for ( int i = 1; i <= n; i++ ) cout << p[i] << " "; cout << "\n";
    for ( int i = 1; i <= n; i++ )
	{   
        f[i] = 1 + query( 1, 1, n, 1, p[i] );
        upd( 1, 1, n, p[i], f[i] );
    }
    for ( int i = 1; i <= n; i++ ) upd( 1, 1, n, i, 0 );
    for ( int i = n; i >= 1; i-- )
	{   
        g[i] = 1 + query( 1, 1, n, 1, p[i] );
        upd( 1, 1, n, p[i], g[i] );
    }
    int answer = 0;
    for ( int i = 1; i <= n; i++ ) answer = max( answer, f[i] + g[i] - 1 );
    cout << answer << "\n";
}

int main()
{
	freopen("improvements.in", "r", stdin);
	freopen("improvements.out", "w", stdout);
	time_t start = clock();
	int t = 1;
	for ( int i = 0; i < t; i++ ) solve();
	cerr << fixed << setprecision( 7 ) << "Time: " << 1.0 * ( clock() - start ) / CLOCKS_PER_SEC << "\n";
	return 0;
}