#include <fstream>
#include <algorithm>

using namespace std;

const int MAXN = 200 * 1000 + 5, INF = 1000 * 1000 * 1000 + 5;
int x[MAXN], dp[MAXN], st[2][4 * MAXN], fen[MAXN];
pair<int, int> srt[MAXN];

void upFen(int x, int val) {
    for(; x < MAXN; x |= x + 1)
        fen[x] = max(fen[x], val);
}

int getFen(int x) {
    int res = 0;
    for(; x >= 0; x = (x & (x + 1)) - 1)
        res = max(res, fen[x]);
    return res;
}

void buildst(int t, int v, int tl, int tr) {
    if(tl == tr - 1) {
        if(t == 0)
            st[t][v] = dp[tl];
        else
            st[t][v] = 0;
        return;
    }
    int tm = (tl + tr) / 2;
    buildst(t, 2 * v, tl, tm);
    buildst(t, 2 * v + 1, tm, tr);
    st[t][v] = max(st[t][2 * v], st[t][2 * v + 1]);
}

void update(int t, int v, int tl, int tr, int pos, int val) {
    if(tl == tr - 1) {
        st[t][v] = val;
        return;
    }
    int tm = (tl + tr) / 2;
    if(pos < tm)
        update(t, 2 * v, tl, tm, pos, val);
    else
        update(t, 2 * v + 1, tm, tr, pos, val);
    st[t][v] = max(st[t][2 * v], st[t][2 * v + 1]);
}

int get(int t, int v, int tl, int tr, int l, int r) {
    if(tl == l && tr == r)
        return st[t][v];
    int tm = (tl + tr) / 2, res = 0;
    if(l < tm)
        res = max(res, get(t, 2 * v, tl, tm, l, min(r, tm)));
    if(r > tm)
        res = max(res, get(t, 2 * v + 1, tm, tr, max(l, tm), r));
    return res;
}

int main() {
    ifstream in("improvements.in");
    ofstream out("improvements.out");
    int n;
    in >> n;
    for(int i = 1; i <= n; i++)
        in >> x[i];
    for(int i = 1; i <= n; i++) {
        dp[i] = getFen(x[i] - 1) + 1;
        upFen(x[i], dp[i]);
    }
    buildst(0, 1, 0, n + 1);
    buildst(1, 1, 0, n + 1);
    int ans = get(0, 1, 0, n + 1, 0, n + 1);
    for(int i = 1; i <= n; i++)
        srt[i - 1] = make_pair(x[i], i);
    sort(srt, srt + n);
    reverse(srt, srt + n);
    for(int i = 0; i < n; i++) {
        int pos = srt[i].second;
        update(0, 1, 0, n + 1, pos, 0);
        int val = get(1, 1, 0, n + 1, 0, pos - 1) + 1;
        update(1, 1, 0, n + 1, pos, val);
        ans = max(ans, get(0, 1, 0, n + 1, 0, n + 1) + get(1, 1, 0, n + 1, 0, n + 1));
    }
    out << ans << '\n';
    return 0;
}
