
#include <iostream>
#include <iomanip>
#include <cstdio>
#include <vector>
#include <cmath>
#include <algorithm>
using namespace std;

const int N = 100010;
vector<double> a, b, s, g;
int n;
double A, B;

#define all(x) x.begin(),x.end()

inline bool cmp(int i, int j) {
    return a[i] * b[j] < a[j] * b[i];
}

int main()
{
    ios_base::sync_with_stdio(false);
    freopen("burrito.in", "r", stdin);
    freopen("burrito.out", "w", stdout);
    cin >> n >> A >> B;
    a.resize(n);
    b.resize(n);
    s.resize(n);
    g.resize(n);

    vector<int> srtd;

    double extraB = 0, sumA = 0;
    for (int i = 0; i < n; i++) {
        cin >> g[i] >> a[i] >> b[i];
        s[i] = g[i];
        extraB += s[i] * b[i], sumA += s[i] * a[i];
    }
    extraB -= B;

    for (int i = 0; i < n; i++) {
        if(fabs(b[i]) > 1e-6) srtd.push_back(i);
    }
    sort(all(srtd), cmp);

    for (int is = 0; is < srtd.size() && extraB > 1e-8; is++) {
        int i = srtd[is];
        if (b[i] * s[i] < extraB) {
            extraB -= b[i] * s[i];

            sumA -= a[i] * s[i];
            s[i] = 0;
        }
        else {
            s[i] -= extraB / b[i];
            sumA -= extraB / b[i] * a[i];
            extraB = 0;
            break;
        }
    }

    if (sumA >= A - 1e-8 && extraB < 1e-8) {
        double ss = 0;
        for (int i = 0; i < n; i++) ss += b[i] * s[i];
        cout << fixed << setprecision(10) << sumA << " " << ss << endl;
        for (int i = 0; i < n; i++) cout << fixed << setprecision(10) << s[i] << " ";
        cout << endl;
    }
    else {
        cout << -1 << " " << -1 << endl;
    }

    return 0;
}
