#include <iostream>
#include <iomanip>
#include <cstdio>
#include <vector>
#include <string>
#include <cmath>
#include <algorithm>
using namespace std;

#define R 0
#define P 1
#define S 2

inline int next(int cur) {
	if (cur == R) return P;
	else if (cur == P) return S;
	else return R;
}
vector<int> states;
vector<vector<int> > goes;

vector<int> ostates;
vector<vector<int> > ogoes;

int main(){
	freopen("epic.in", "r", stdin);
	freopen("epic.out", "w", stdout);

	int n;
	cin >> n;

	states.resize(n);
	ostates.resize(n);
	goes.assign(n, vector<int>(3));
	ogoes.assign(n, vector<int>(3, -1));

	for (int i = 0; i < n; i++) {
		string s;
		int g1, g2, g3;
		cin >> s >> g1 >> g2 >> g3;

		if (s == "R")
			states[i] = R;
		else if (s == "P")
			states[i] = P;
		else
			states[i] = S;

		goes[i][0] = --g1;
		goes[i][1] = --g2;
		goes[i][2] = --g3;

		ostates[i] = next(states[i]);

		for (int j = 0; j < 3; j++) {
			int to = goes[i][j];
			ogoes[i][states[i]] = goes[i][ostates[i]];
		}
	}

	cout << n << endl;
	for (int i = 0; i < n; i++) {
		if (ostates[i] == R) cout << "R ";
		if (ostates[i] == P) cout << "P ";
		if (ostates[i] == S) cout << "S ";

		for (int j = 0; j < 3; j++) {
			int to = ogoes[i][j];
			if (to == -1) cout << 1 << " ";
			else cout << to + 1 << " ";
		}
		cout << endl;
	}
	return 0;
}
