#include <iostream>
#include <iomanip>
#include <cstdio>
#include <vector>
#include <cmath>
#include <string>
#include <algorithm>

using namespace std;

int m, n, F;
vector<unsigned int> a;

vector< vector<bool> > masks;
int to2[256];

void init() {
	for (int i = 0; i <= 9; i++) {
		to2['0' + i] = i;
	}

	for (int i = 0; i < 6; i++) {
		to2['a' + i] = 10 + i;
	}
}

int main(){
	freopen("filter.in", "r", stdin);
	freopen("filter.out", "w", stdout);
	init();

	cin >> m >> F;

	a.resize(F);
	for (int f = 0; f < F; f++) {
		cin >> a[f];
	}

	cin >> n;

	masks.assign(n, vector<bool>(m));
	for (int i = 0; i < n; i++) {
		string code;
		cin >> code;
		for (int c = 0; c < code.size(); c++) {
			int tw = to2[code[c]];
			for (int j = 0; j < 4 && (4 * c + j) < m; j++) {
				masks[i][4 * c + j] = tw & (1 << j);
			}
		}
	}

	vector<bool> used(n, false);
	int Q;
	cin >> Q;
	for (int q = 0; q < Q; q++) {
		unsigned int uk;
		cin >> uk;
		for (int mask = 0; mask < n; mask++) {
			bool ok = true;
			for (int f = 0; f < F; f++) {
				int j = (1ULL * uk * a[f]) % m;
				if (!masks[mask][j]) {
					ok = false;
					break;
				}
			}
			if (ok) used[mask] = true;
		}
	}

	int cnt = 0;
	for (int i = 0; i < n; i++) if (used[i]) cnt++;
	cout << cnt << " ";
	for (int i = 0; i < n; i++) if (used[i]) cout << i << " ";


	return 0;
}
