#include <cstdio>
#include <iostream>
#include <vector>
#include <string>
#include <cstdlib>
#include <set>
#include <map>
#include <memory.h>
#include <cmath>
#include <queue>
#include <algorithm>
#include <cassert>

#define fi first
#define se second
#define forn(i, n) for (int i = 0; i < (int)n; i++)
#define fore(i, b, e) for (int i = (int)b; i <= (int)e; i++)
#define pii pair <int, int>
#define vi vector <int>
#define pb push_back
#define mp make_pair

#define TASKNAME "damage"

typedef long long lint;
typedef long long i64;
typedef long long li;

using namespace std;

struct Point
{
	double x, y;
	double len() {
		return sqrt(x * x + y * y);
	}
	Point(double _x, double _y) : x(_x), y(_y) {}
};

inline Point operator + (Point a, Point b) {
	return Point(a.x + b.x, a.y + b.y);
}

inline Point operator - (Point a, Point b) {
	return Point(a.x - b.x, a.y - b.y);
}

inline Point operator * (double k, Point a) {
	return Point(a.x * k, a.y * k);
}

inline Point operator * (Point a, double k) {
	return Point(a.x * k, a.y * k);
}

double d, l, r, t, h;
double w;
double g;

inline double getRad(double x) {
	if (x < g) return sqrt(r*r - (r-x)*(r-x));
	if (x > l + g) return getRad(l + 2 * g - x);
	return d;
}

#define PI 3.1415926

inline double circ(double r, double d) {
	double phi = acos(d/r);
	//assert((PI - phi) * r * r + sqrt(r * r - d * d)*d >= 0); 
	//assert((PI - phi) * r * r + sqrt(r * r - d * d)*d <= PI * r * r);
	return (PI - phi) * r * r + sqrt(r * r - d * d)*d;
}

inline double getVal(double x) {
	double R = getRad(x);
	Point v((-t / l), (w / l));
	//assert(abs(v.len() - 1) < 1e-6);
	Point c = v*d + (Point(w, t) * (x / l));
	Point p1 = c + R*v, p2 = c - R*v;
	//assert(((p1 - c).len() - R) < 1e-6);
	//assert(((p2 - c).len() - R) < 1e-6);
	if (abs(p1.y - p2.y) < 1e-4) {
		if (p1.y > h && p2.y > h) return 0;
		else return PI * R * R;
	}
	double k1 = (p2.y - h) / (p2.y - p1.y), k2 = (h - p1.y) / (p2.y - p1.y);
	Point p = k1 * p1 + k2 * p2;
	//assert(abs(p.y - h) < 1e-6);
	//assert(abs(k1 + k2 - 1) < 1e-6);
    if (p.y > c.y) {
		return circ(R, (p - c).len());
	}
	return PI*R*R - circ(R, (c - p).len());
}

int main()
{
	freopen(TASKNAME ".in", "r", stdin);
	freopen(TASKNAME ".out", "w", stdout);
	cin >> d >> l >> r >> t >> h;
	d /= 2;
	g = r - sqrt(r * r - d * d);
	w = sqrt(l*l - t*t);
	double limit = l + 2 * g, ans = 0, delta;
	int stpcnt = 1000000;
	delta = limit / stpcnt;
	h += (g * t) / l;
	for (double x0 = 0; x0 <= limit; x0 += delta)
	{   
		ans += getVal(x0) * delta;
  	}
	printf("%.5lf", ans / 1e6);
	//cout.precision(3);
	//cout.setf(ios::fixed);
	//cout << ans / 1e6;
}