import java.io.*;
import java.util.Arrays;
import java.util.Locale;
import java.util.StringTokenizer;

/**
 * Created by neerc on 07.12.2014.
 */
public class TaskB {
    class Item implements Comparable<Item> {
        long g;
        long a;
        long b;
        double res = 0.0;
        int id;

        Item(long g, long a, long b, int id) {
            this.g = g;
            this.a = a;
            this.b = b;
            this.id = id;
        }

        @Override
        public int compareTo(Item other) {
            long left  = a * other.b;
            long right = b * other.a;
            return Long.compare(right, left);
        }
    }

    public void solve(FastScanner in, PrintWriter out) throws IOException {
        int n = in.nextInt();
        long A = in.nextLong();
        long B = in.nextLong();
        Item[] items = new Item[n];
        double[] res = new double[n];
        for (int i = 0; i < n; i++)
            items[i] = new Item(in.nextLong(), in.nextLong(), in.nextLong(), i);
        Arrays.sort(items);
        long curA = 0;
        long curB = 0;
        long down = 1;
        for (int i = 0; i < n; i++) {
            Item c = items[i];
            if (c.g * c.b + curB <= B) {
                curA += c.g * c.a;
                curB += c.g * c.b;
                c.res = c.g;
            } else {
                down = c.b;
                curA = curA * c.b + (B - curB) * c.a;
                c.res = (B - curB) * 1.0 / c.b;
                break;
            }
        }
        if (curA < A * down) {
            out.println("-1 -1");
        } else {
            out.printf("%.10f %d%n", curA * 1.0 / down, B);
            for (int i = 0; i < n; i++)
                res[items[i].id] = items[i].res;
            for (int i = 0; i < n; i++)
                out.printf("%.10f ", res[i]);
            out.println();
        }
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        FastScanner in = new FastScanner(new FileInputStream("burrito.in"));
        PrintWriter out = new PrintWriter(new FileOutputStream("burrito.out"));
        new TaskB().solve(in, out);
        in.close();
        out.close();
    }

    static class FastScanner {
        BufferedReader br;
        StringTokenizer st;

        FastScanner(InputStream in) {
            br = new BufferedReader(new InputStreamReader(in));
        }

        public String next() throws IOException {
            while (st == null || !st.hasMoreTokens()) {
                String line = br.readLine();
                if (line == null)
                    return null;
                st = new StringTokenizer(line);
            }
            return st.nextToken();
        }

        public void close() throws IOException {
            br.close();
        }

        public int nextInt() throws IOException {
            return Integer.parseInt(next());
        }

        public long nextLong() throws IOException {
            return Long.parseLong(next());
        }
    }
}
