#include <iostream>
#include <vector>
#include <cstdlib>
#include <cmath>
#include <fstream>

using namespace std;

const double M_PI = acos(-1.0);

int cnt_all = 0;
int cnt_good = 0;

double d, l, r, t, h;

inline double getDist(double x1, double y1, double z1, double x2, double y2, double z2)
{
	return ((x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2) + (z1 - z2) * (z1 - z2));
}

inline void update(double x, double y, double z)
{
	cnt_all++;

	double alpha = - (M_PI / 2 - asin(t / l));

	double new_x = x * cos(alpha) - z * sin(alpha);
	double new_y = y;
	double new_z = x * sin(alpha) + z * cos(alpha);

	if (new_z < h) {
		cnt_good++;
	}
}

int main()
{
	ifstream fin("damage.in");
	ofstream fout("damage.out");
	ios_base::sync_with_stdio(false);

	fin >> d >> l >> r >> t >> h;

	double hsf = r - sqrt(r * r - d * d / 4.0);

	double down_x = -d/2;
	double down_y = 0;
	double down_z = r - hsf;

	double up_x = -d/2;
	double up_y = 0;
	double up_z = hsf + l - r;

	for (int i = 0; i < 10000000; i++) {
		double z = rand() * 1.0 / RAND_MAX * (l + 2 * hsf) - hsf;
		double x = rand() * 1.0 / RAND_MAX * d - d;
		double y = rand() * 1.0 / RAND_MAX * d - d / 2;

		if ((x + d / 2) * (x + d/ 2) + y * y > d * d / 4) {
			continue;
		}

		if (z < 0) {
			double dist = getDist(x, y, z, down_x, down_y, down_z);
			if (dist < r * r) {
				update(x, y, z);
			}
		}
		else if (z > l) {
			double dist = getDist(x, y, z, up_x, up_y, up_z);
			if (dist < r * r) {
				update(x, y, z);
			}
		}
		else {
			update(x, y, z);
		}
	}

	fout.precision(30);
	fout.setf(ios::fixed);
	cerr << cnt_all << ' ' << cnt_good << endl;
	fout << 1e-6 * (M_PI * d * d / 4 * l + 2 * (M_PI * r * r * hsf
		- M_PI * (r * r * r / 3 - (r - hsf) * (r - hsf) * (r - hsf) / 3))) * cnt_good * 1.0 / cnt_all << endl;
}