import java.io.*;
import java.util.*;

/**
 * Created by neerc on 07.12.2014.
 */
public class TaskF {
    int toInt(char c) {
        if (Character.isDigit(c))
            return c - '0';
        return c - 'a' + 10;
    }

    int[] parse(String s, int m) {
        int[] res = new int[m];
        int p = 0;
        for (int i = 0; i < s.length(); i++) {
            int cur = toInt(s.charAt(i));
            for (int b = 0; b < 4; b++)
                if ((cur & (1 << b)) != 0 && p + b < m)
                    res[p + b] = 1;
            p += 4;
        }
        return res;
    }

    public void solve(FastScanner in, PrintWriter out) throws IOException {
        int m = in.nextInt();
        int f = in.nextInt();
        long[] a = new long[f];
        for (int i = 0; i < f; i++)
            a[i] = in.nextLong();
        int n = in.nextInt();
        int[][] state = new int[n][];
        for (int i = 0; i < n; i++)
            state[i] = parse(in.next(), m);
        int q = in.nextInt();
        long[] u = new long[q];
        for (int i = 0; i < q; i++)
            u[i] = in.nextLong();
        List<Integer> res = new ArrayList<Integer>();
        for (int i = 0; i < n; i++)
            for (int j = 0; j < q; j++) {
                boolean ok = true;
                for (int h = 0; h < f; h++) {
                    long cur = (u[j] * a[h]) % m;
                    if (state[i][(int)cur] != 1)
                        ok = false;
                }
                if (ok) {
                    res.add(i);
                    break;
                }
            }
        out.print(res.size() + " ");
        for (int elem : res)
            out.print(elem + " ");
        out.println();
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        FastScanner in = new FastScanner(new FileInputStream("filter.in"));
        PrintWriter out = new PrintWriter(new FileOutputStream("filter.out"));
        new TaskF().solve(in, out);
        in.close();
        out.close();
    }

    static class FastScanner {
        BufferedReader br;
        StringTokenizer st;

        FastScanner(InputStream in) {
            br = new BufferedReader(new InputStreamReader(in));
        }

        public String next() throws IOException {
            while (st == null || !st.hasMoreTokens()) {
                String line = br.readLine();
                if (line == null)
                    return null;
                st = new StringTokenizer(line);
            }
            return st.nextToken();
        }

        public void close() throws IOException {
            br.close();
        }

        public int nextInt() throws IOException {
            return Integer.parseInt(next());
        }

        public long nextLong() throws IOException {
            return Long.parseLong(next());
        }
    }
}
