import java.io.*;
import java.util.ArrayDeque;
import java.util.Arrays;
import java.util.Locale;
import java.util.StringTokenizer;

/**
 * Created by neerc on 07.12.2014.
 */
public class TaskI {
    class Bit {
        int[] f;

        Bit(int n) {
            f = new int[n];
        }

        void upd(int at, int by) {
            for (; at < f.length; at = (at | (at + 1)))
                f[at] += by;
        }

        int get(int at) {
            int res = 0;
            for (; at >= 0; at = (at & (at + 1)) - 1)
                res += f[at];
            return res;
        }

        int get(int l, int r) {
            return get(r) - get(l - 1);
        }
    }

    public void solve(FastScanner in, PrintWriter out) throws IOException {
        int n = in.nextInt();
        int[] where = new int[n + 1];
        for (int i = 1; i <= n; i++)
            where[i] = in.nextInt();
        Bit tree = new Bit(n + 1);
        int last = 0;
        tree.upd(0, 1);
        int res = n;
        for (int i = 1; i <= n; i++) {
            int pos = where[i];
            tree.upd(pos, 1);
            boolean ok = false;
            if (pos < last) {
                if (tree.get(pos, last) == last - pos + 1)
                    ok = true;
                if (tree.get(0, pos) == pos + 1)
                    ok = true;
            } else {
                if (tree.get(last, pos) == pos - last + 1)
                    ok = true;
                if (tree.get(pos, n) == n - pos + 1)
                    ok = true;
            }
            if (!ok)
                res--;
        }
        out.println(res);
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        FastScanner in = new FastScanner(new FileInputStream("improvements.in"));
        PrintWriter out = new PrintWriter(new FileOutputStream("improvements.out"));
        new TaskI().solve(in, out);
        in.close();
        out.close();
    }

    static class FastScanner {
        BufferedReader br;
        StringTokenizer st;

        FastScanner(InputStream in) {
            br = new BufferedReader(new InputStreamReader(in));
        }

        public String next() throws IOException {
            while (st == null || !st.hasMoreTokens()) {
                String line = br.readLine();
                if (line == null)
                    return null;
                st = new StringTokenizer(line);
            }
            return st.nextToken();
        }

        public void close() throws IOException {
            br.close();
        }

        public int nextInt() throws IOException {
            return Integer.parseInt(next());
        }

        public long nextLong() throws IOException {
            return Long.parseLong(next());
        }
    }
}
