#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <math.h>
#include <memory>
#include <cstdio>
#include <algorithm>
using namespace std;
#define forn(it, from ,to) for(int it = from; it < to; ++it)
#define mems(arr, val) memset(arr, val, sizeof(arr))
#define mp(a, b) make_pair(a, b)
#define all(A) (A).begin(), (A).end()
typedef long long LL;
const int MAXN = 200010;
int T[MAXN * 4];
int lazy[MAXN * 4];
void build(int v, int tl, int tr)
{
	if (tl == tr)
	{
		T[v] = 1;
		lazy[v] = -1;
		return;
	}

	int tm = (tl + tr) >> 1;
	build(2 * v, tl, tm);
	build(2 * v + 1, tm + 1, tr);
	T[v] = T[2 * v] + T[2 * v + 1];
	lazy[v] = -1;
}

void push(int v)
{
	if (lazy[v] == -1) return;
	lazy[2 * v] = lazy[v];
	lazy[2 * v + 1] = lazy[v];
	lazy[v] = -1;
}

int get(int v, int tl, int tr)
{
	if (lazy[v] != -1) return (tr - tl + 1) * max(0, lazy[v]);
	return T[v];
}
int getsum(int v, int tl, int tr, int l, int r)
{
	if (l > r) return 0;
	if (tl == l && tr == r)
	{
		return get(v, tl, tr);
	}

	push(v);
	int tm = (tl + tr) >> 1;
	int ans = getsum(2 * v, tl, tm, l, min(tm, r)) + getsum(2 * v + 1, tm + 1, tr, max(tm + 1, l), r);
	T[v] = get(2 * v, tl, tm) + get(2 * v + 1, tm + 1, tr);
	return ans;
}

void incr(int v, int tl, int tr, int l, int r, int val)
{
	if (l > r) return;
	if (tl == l && tr == r)
	{
		lazy[v] = val;
		//T[v] += val * (tr - tl + 1);
		return;
	}

	push(v);
	int tm = (tl + tr) >> 1;
	incr(2 * v, tl, tm, l, min(r, tm), val);
	incr(2 * v + 1, tm + 1,tr , max(l, tm + 1), r, val);
	T[v] = get(2 * v, tl, tm) + get(2 * v + 1, tm + 1, tr);
}



int main(){
#ifdef _DEBUG
	freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#else
	freopen("improvements.in", "r", stdin); freopen("improvements.out", "w", stdout);
#endif
	build(1, 0, MAXN - 1);
	int n;
	cin >> n;
	vector<int> c(n + 1);
	c[0] = 0;
	forn(i, 0, n)
	{
		int tmp;
		cin >> tmp;
		c[i + 1] = tmp;
	}

	int ans = n;

	for (int i = 0; i < n - 1; ++i)
	{
		int l = min(c[i], c[i + 1]);
		int r = max(c[i], c[i + 1]);
		if (getsum(1, 0, MAXN - 1, c[i + 1], c[i + 1]) == 0) continue;
		int left = getsum(1, 0, MAXN - 1, 1, l - 1);
		int mid = getsum(1, 0, MAXN - 1, l + 1, r - 1);
		int right = getsum(1, 0, MAXN - 1, r + 1, n);
		int mini = min(left + mid, min(left + right, right + mid));
		if (mini == left + mid)
		{
			ans -= mini;
			incr(1, 0, MAXN - 1, 1, l - 1, 0);
			incr(1, 0, MAXN - 1, l, r, 0);
		}
		else
		{
			if (mini == right + mid)
			{
				ans -= mini;
				incr(1, 0, MAXN - 1, r + 1, n, 0);
				incr(1, 0, MAXN - 1, l, r, 0);
			}
			else
			{
				ans -= mini;
				incr(1, 0, MAXN - 1, r, n, 0);
				incr(1, 0, MAXN - 1, 1, l, 0);
	
			}
		}
	}
	cout << ans;

	return 0;
}