#define _CRT_SECURE_NO_WARNINGS
#include<cstdio>
#include<iostream>
#include<algorithm>
#include<cstdlib>
#include<cmath>
using namespace std;
const int MAX_N = 200005;
const double EPS = 1e-8;

struct elem
{
	double g, a, b;
    int num;
	elem() {}
	elem(double g, double a, double b, int num) :g(g), a(a), b(b), num(num) {}
};

int less_num(double x, double y)
{
	return (y - x > EPS);
}

int more_num(double x, double y)
{
	return (x - y > EPS);
}

int equal_num(double x, double y)
{
	return (fabs(x - y) < EPS);
}

bool comp(const elem &x, const elem &y)
{
	double x1 = x.b * y.a;
	double x2 = x.a * y.b;
	if (less_num(x1, x2)) return 1;
	if (more_num(x1, x2)) return 0;
	if (less_num(x.a, y.a)) return 1;
	if (equal_num(x.a, y.a) && less_num(x.g, y.g)) return 1;
	return 0;
}

elem mas[MAX_N];
double ans[MAX_N];

int main()
{
	freopen("burrito.in", "r", stdin);
	freopen("burrito.out", "w", stdout);
	int n;
	double total_A, total_B;
	cin >> n >> total_A >> total_B;
	for (int i = 0; i < n; i++)
	{
		cin >> mas[i].g >> mas[i].a >> mas[i].b;
		mas[i].num = i;
	}
	sort(mas, mas + n, comp);

	double sum_A = 0.0, sum_B = 0.0;
	for (int i = 0; i < n; i++)
	{
		if (more_num(sum_B + mas[i].g * mas[i].b, total_B))
		{
			double kol_g = (total_B - sum_B) / mas[i].b;
			double ans_A = sum_A + kol_g * mas[i].a;
			double ans_B = sum_B + kol_g * mas[i].b;
			ans[mas[i].num] = kol_g;
			if (less_num(ans_A, total_A))
			{
				printf("-1 -1\n");
				return 0;
			}

			printf("%.8lf %.8lf\n", ans_A, ans_B);
			for (int j = 0; j < n; j++)
				printf("%.8lf ", ans[j]);
			printf("\n");
			return 0;
		}
		else
		{
			double kol_g = mas[i].g;
			sum_A += kol_g * mas[i].a;
			sum_B += kol_g * mas[i].b;
			ans[mas[i].num] = kol_g;
		}
	}

	if (less_num(sum_A, total_A))
	{
		printf("-1 -1\n");
		return 0;
	}
	printf("%.8lf %.8lf\n", sum_A, sum_B);
	for (int i = 0; i < n; i++)
		printf("%.8lf ", ans[i]);
	printf("\n");

	return 0;
}