#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

const double EPS = 1e-9;

struct Ingredient {
	double max_amount;
	double joy;
	double harm;
	int index;
};

const bool operator<(const Ingredient &left, const Ingredient &right) {
	return left.joy * right.harm < left.harm * right.joy;
}

int main() {
	FILE *f;
	freopen_s(&f, "burrito.in", "rt", stdin);
	freopen_s(&f, "burrito.out", "wt", stdout);

	int n;
	double min_allowed_joy, max_allowed_harm;
	scanf_s("%d %lf %lf", &n, &min_allowed_joy, &max_allowed_harm);
	vector<Ingredient> ingredients(n);
	for (int i = 0; i < n; ++i) {
		ingredients[i].index = i;
		scanf_s("%lf %lf %lf", &ingredients[i].max_amount, &ingredients[i].joy, &ingredients[i].harm);
	}

	sort(ingredients.begin(), ingredients.end());
	reverse(ingredients.begin(), ingredients.end());

	double current_joy = 0, currrent_harm = 0;
	vector<double> taken(n, 0);
	for (int i = 0; i < n && currrent_harm + EPS < max_allowed_harm; ++i) {
		double take_amount = ingredients[i].max_amount;
		if (ingredients[i].harm > 0)
			take_amount = min(take_amount, (max_allowed_harm - currrent_harm) / ingredients[i].harm);
		taken[ingredients[i].index] = take_amount;
		current_joy += take_amount * ingredients[i].joy;
		currrent_harm += take_amount * ingredients[i].harm;
	}
	if (current_joy + EPS < min_allowed_joy) {
		printf("-1 -1");
	} else {
		printf("%0.8lf %0.8lf\n", current_joy, currrent_harm);
		for (int i = 0; i < n; ++i)
			printf("%0.8lf ", taken[i]);
	}
	return 0;
}