#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>

using namespace std;

const double EPS = 1e-9;

struct Ingredient {
	int max_amount;
	int joy;
	int harm;
	int index;
};

const bool operator<(const Ingredient &left, const Ingredient &right) {
	return left.joy * right.harm > left.harm * right.joy;
}

int main() {
	freopen("burrito.in", "rt", stdin);
	freopen("burrito.out", "wt", stdout);

	int n;
	int min_allowed_joy, max_allowed_harm;
	scanf("%d %d %d", &n, &min_allowed_joy, &max_allowed_harm);
	vector<Ingredient> ingredients(n);
	for (int i = 0; i < n; ++i) {
		ingredients[i].index = i;
		scanf("%d %d %d", &ingredients[i].max_amount, &ingredients[i].joy, &ingredients[i].harm);
	}

	sort(ingredients.begin(), ingredients.end());

	int currrent_harm = 0;
	vector<double> taken(n, 0);
	for (int i = 0; i < n; ++i) {
		if (ingredients[i].joy == 0) continue;
		if (currrent_harm + ingredients[i].max_amount * ingredients[i].harm > max_allowed_harm)
		{
			taken[ingredients[i].index] = (double)(max_allowed_harm - currrent_harm) / ingredients[i].harm;
			break;
		}
		else
		{
			taken[ingredients[i].index] = (double)ingredients[i].max_amount;
			currrent_harm += ingredients[i].max_amount * ingredients[i].harm;
		}
	}
	double current_joy = 0.;
	double current_h = 0.;
	for (int i = 0; i < n; i++)
	{
		current_joy += ingredients[i].joy * taken[ingredients[i].index];
		current_h += ingredients[i].harm * taken[ingredients[i].index];
	}
	if (current_joy < (double)min_allowed_joy) {
		printf("-1 -1");
	} else {
		printf("%0.10lf %0.10lf\n", current_joy, current_h);
		for (int i = 0; i < n; ++i)
			printf("%0.10lf ", taken[i]);
	}
	return 0;
}