#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <algorithm>
#include <iomanip>

using namespace std;

struct Ingredient {
	double joy;
	double harm;
	double capacity;
	int index;
};

void read_input(int &n, double &min_joy, double &max_harm, vector<Ingredient> &ingretients) {
	cin >> n >> min_joy >> max_harm;
	ingretients.resize(n);
	for (int i = 0; i < n; ++i) {
		cin >> ingretients[i].capacity >> ingretients[i].joy >> ingretients[i].harm;
		ingretients[i].index = i;
	}
}

void calc_taken(int n, double max_harm, vector<Ingredient> &ingretients, vector<double> &taken) {
	double total_joy = 0;
	double total_harm = 0;
	taken.resize(n, 0);
	for (int i = 0; i < n; ++i) {
		double take = ingretients[i].capacity;
		if (ingretients[i].harm > 0)
			take = min(take, (max_harm - total_harm) / ingretients[i].harm);
		taken[ingretients[i].index] = take;
		total_joy += take * ingretients[i].joy;
		total_harm += take * ingretients[i].harm;
	}
}

void print_answer(int n, double min_joy, vector<double> &taken, vector<Ingredient> &ingretients) {
	double total_joy = 0;
	double total_harm = 0;
	for (int i = 0; i < n; ++i) {
		total_joy += ingretients[i].joy * taken[ingretients[i].index];
		total_harm += ingretients[i].harm * taken[ingretients[i].index];
	}
	if (total_joy < min_joy)
		cout << -1 << ' ' << -1 << endl;
	else {
		cout << fixed << setprecision(10) << total_joy << ' ' << total_harm << endl;
		for (int i = 0; i < n; ++i)
			cout << fixed << setprecision(10) << taken[i] << ' ';
	}
}

int main() {
	freopen("burrito.in", "rt", stdin);
	freopen("burrito.out", "wt", stdout);

	int n;
	double max_harm, min_joy;
	vector<Ingredient> ingretients;
	vector<double> taken;
	read_input(n, min_joy, max_harm, ingretients);
	sort(ingretients.begin(), ingretients.end(), [](const Ingredient &left, const Ingredient &right) {
		if (right.joy == 0)
			return false;
		if (left.harm == 0 && left.joy != 0)
			return false;
		return left.joy * right.harm < left.harm * right.joy;
	});
	reverse(ingretients.begin(), ingretients.end());
	calc_taken(n, max_harm, ingretients, taken);
	print_answer(n, min_joy, taken, ingretients);
	return 0;
}