#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <string>
#include <bitset>

using namespace std;

int convert_digit(char c) {
	return c >= 'a' ? c - 'a' + 10 : c - '0';
}

const int MAX_BITS_COUNT = 1000;

bitset<MAX_BITS_COUNT> convert_filter(int count, string &s) {
	bitset<MAX_BITS_COUNT> result;
	for (int i = 0, j = 0; i < s.size(); ++i) {
		int digit = convert_digit(s[i]);
		for (int k = 0; j < count && k < 4; ++j, ++k)
			result[j] = digit & (1 << k);
	}
	return result;
}

bool can_contain(bitset<MAX_BITS_COUNT> &filter, int uid, vector<int> &params, int m) {
	for (int i = 0; i < params.size(); ++i) {
		int hash = ((long long)(params[i]) * uid) % m;
		if (!filter[hash])
			return false;
	}
	return true;
}

void print_result(vector<int> &result) {
	cout << result.size() << ' ';
	for (int i = 0; i < result.size(); ++i)
		cout << result[i] << ' ';
}

int main() {
	freopen("filter.in", "rt", stdin);
	freopen("filter.out", "wt", stdout);

	int m, f;
	cin >> m >> f;
	vector<int> params(f);
	for (int i = 0; i < f; ++i) {
		cin >> params[i];
	}
	int n;
	cin >> n;
	vector<bitset<MAX_BITS_COUNT>> filters(n);
	string s;
	for (int i = 0; i < n; ++i) {
		cin >> s;
		filters[i] = convert_filter(m, s);
	}

	int q;
	cin >> q;
	vector<int> uids(q);
	for (int i = 0; i < q; ++i) {
		cin >> uids[i];
	}

	vector<int> result;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < q; ++j) {
			if (can_contain(filters[i], uids[j], params, m)) {
				result.push_back(i);
				break;
			}
		}
	}

	print_result(result);
	return 0;
}