#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <string>
#include <memory>
#include <deque>
#include <sstream>
#include <set>
#include <cmath>

using namespace std;

#define TASK_NAME "filter"

char files[1000][256]; // file hash values

bool bit_value(int file_id, int bit_id)
{
	char h = files[file_id][(bit_id / 4)];
	int hex_value;
	if ((h >= '0') && (h <= '9'))
	{
		hex_value = h - '0';
	}
	else
	{
		hex_value = h - 'a' + 10;
	}
	return (hex_value & (1 << (bit_id % 4))) != 0;
}

bool result_files[1000] = { false };

int main()
{
#ifndef _DEBUG
	freopen(TASK_NAME ".in", "rt", stdin);
	freopen(TASK_NAME ".out", "wt", stdout);
#endif

	int m; // [1; 1000]
	cin >> m;
	int f; // [1; 100]
	cin >> f;
	int a[100]; // [1; 2^31] mod m
	for (int i = 0; i < f; i++)
	{
		cin >> a[i];
		a[i] = a[i] % m;
	}
	int n; // [1; 1000]
	cin >> n;
	for (int i = 0; i < n; i++)
	{
		cin >> files[i];
	}
	int q;
	cin >> q; // [1; 1000]
	for (int i = 0; i < q; i++)
	{
		int u; // [1; 2^31] mod m
		cin >> u;
		u = u % m;
		//TODO: do something with u
		for (int j = 0; j < n; j++) // files
		{
			bool ok = true;
			for (int k = 0; k < f; k++) // a (hash args)
			{
				int bit = (u * a[k]) % m;
				if (!bit_value(j, bit))
				{
					ok = false;
					break;
				}
			}
			if (ok)
			{
				result_files[j] = true;
			}
		}
	}
	int count_files = 0;
	for (int i = 0; i < n; i++)
	{
		if (result_files[i])
		{
			count_files++;
		}
	}
	cout << count_files;
	for (int i = 0; i < n; i++)
	{
		if (result_files[i])
		{
			cout << " " << i;
		}
	}
#ifdef _DEBUG
	system("pause");
#endif
	return 0;
}
