#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <string>
#include <memory>
#include <deque>
#include <sstream>
#include <set>
#include <cmath>
#include <list>

using namespace std;

#define TASK_NAME "improvements"

class Segment
{
public:
	int start;
	int end;

	Segment(int s, int e) : start(s), end(e)
	{
	}

	bool Intersects(const Segment &other)
	{
		return  (((start < other.start) && (other.start < end) && (end < other.end)) ||
			((other.start < start) && (start < other.end) && (other.end < end)));
	}
};

class Chunk
{
public:
	list<Segment*> segments;
	int count;

	Chunk() : count(0)
	{
	}

	void Add(Segment *segment)
	{
		segments.push_back(segment);
		count++;
	}
};

int ceil_int(int c)
{
	return (int)ceil(c);
}

int main()
{
#ifndef _DEBUG
	freopen(TASK_NAME ".in", "rt", stdin);
	freopen(TASK_NAME ".out", "wt", stdout);
#endif

	int n;
	cin >> n;

	int prev;
	cin >> prev;
	int start = 0;
	int dir = 1;

	Segment *prev_seg = 0;
	Segment *prev_seg2 = 0;

	int count = 0;
	
	for (int i = 0; i < n - 1; i++)
	{
		int v;
		cin >> v;
		if (dir > 0)
		{
			if (v < prev)
			{
				start = prev;
				dir = -1;
				if (prev_seg != 0)
				{
					if ((prev_seg->start < start) && (prev_seg->end < prev))
					{
						count++;
					}
				}
				start = prev;
				dir = -1;

				prev_seg = new Segment(start, prev);
			}
		}
		else
		{
			if (v > prev)
			{
				start = prev;
				dir = 1;

				if (prev_seg2 != 0)
				{
					if ((prev_seg2->start > start) && (prev_seg2->end > prev))
					{
						count++;
					}
				}
				start = prev;
				dir = -1;

				prev_seg2 = new Segment(start, prev);
			}
		}
		prev = v;
	}
	if (dir > 0)
	{
		Segment *cur_seg = new Segment(start, prev);
			start = prev;
			dir = -1;
			if (prev_seg != 0)
			{
				if ((prev_seg->start < start) && (prev_seg->end < prev))
				{
					count++;
				}
			}
			start = prev;
			dir = -1;

			prev_seg = cur_seg;
	}
	else
	{
			start = prev;
			dir = 1;

			if (prev_seg2 != 0)
			{
				if ((prev_seg2->start > start) && (prev_seg2->end > prev))
				{
					count++;
				}
			}
			start = prev;
			dir = -1;
	}

	cout << (n - count);

#ifdef _DEBUG
	system("pause");
#endif
	return 0;
}
