#include <algorithm>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <cstring>
#include <iostream>
#include <iomanip>
#include <string>
#include <vector>
#include <map>
#include <queue>
#include <list>
#include <set>

#define TASK "joke"

using namespace std;

struct node {
	int x;
	node *l, *r;
};

string joke;
int correctDepth;

void build(node *parent, size_t off, set<int> &seen) {
	if (off >= joke.length()) {
		parent->l = parent->r = NULL;
		return;
	}

	int left = joke[off] - '0';
	parent->l = new node;
	if (left != 0 && seen.find(left) == seen.end())
	{
		seen.insert(left);
		parent->l->x = left;
		//cout << "Added " << left << endl;
		build(parent->l, off + 1, seen);
		seen.erase(seen.find(left));
	}
	else
		parent->l->x = -1;

	if (off + 1 >= joke.length()) {
		parent->r = NULL;
		return;
	}

	int right = joke[off] - '0';
	right = right * 10 + joke[++off] - '0';

	parent->r = new node;
	if (right > correctDepth || seen.find(right) != seen.end()) {
		parent->r->x = -1;
		return;
	}

	parent->r->x = right;
	seen.insert(right);
	//cout << "Added " << right << endl;
	build(parent->r, off + 1, seen);
	seen.erase(seen.find(right));
}

bool answer(node* parent, vector<int> &elems) {
	if (parent == NULL) {
		if (elems.size() == correctDepth) {
			for (int i = 0; i < elems.size(); ++i)
				cout << elems[i] << ' ';
			cout << endl;
			return true;
		}
		//cout << "Found elements: " << elems.size() << endl;
		return false;
	}

	if (parent->x == -1)
		return false;

	elems.push_back(parent->x);
	//cout << "Visited " << parent->x << " at depth " << elems.size() << endl;
	if (!answer(parent->l, elems))
		answer(parent->r, elems);
	elems.pop_back();
	return true;
}

int main() {
	freopen(TASK".in", "rt", stdin);
	freopen(TASK".out", "wt", stdout);

	cin >> joke;
	if (joke.length() < 10)
		correctDepth = joke.length();
	else
		correctDepth = ((joke.length() - 9) >> 1) + 9;

	set<int> s;
	node root;
	build(&root, 0, s);

	vector<int> v;
	if (!answer(root.l, v))
		answer(root.r, v);

	return 0;
}