#include <iostream>
#include <algorithm>
#include <cstring>
#include <cstdio>
#include <map>
#include <set>
#include <vector>
#include <iomanip>
#include <queue>
#include <stack>
#include <cassert>
#include <string>
#include <cmath>
#include <ctime>

using namespace std;

const int MAX_N = 1005;
const int SZ = 62;

struct BitSet {
    long long q[MAX_N / SZ + 5];

    BitSet() {
        memset(q, 0, sizeof(q));
    }

    void set(int u) {
        q[u / SZ] |= (1LL << (u % SZ));
    }

    bool contains(BitSet &t) {
        for (int i = 0; i < MAX_N / SZ + 5; i++) {
            if ((~q[i]) & t.q[i]) {
                return false;
            }
        }

        return true;
    }
};

int m, f, a[MAX_N], n;
BitSet files[MAX_N];

int main() {
    freopen("filter.in", "r", stdin);
    freopen("filter.out", "w", stdout);

    cin >> m >> f;

    for (int i = 0; i < f; i++) {
        cin >> a[i];
    }

    cin >> n;

    for (int i = 0; i < n; i++) {
        char c;

        int idx = 0;
        for (int j = 0; j < (m + 3) / 4; j++) {
            cin >> c;

            int val = c - '0';

            if (isalpha(c)) {
                val = c - 'a' + 10;
            }

            for (int k = 0; k < 4; k++) {
                if (val & (1 << k) && idx < m) {
                    files[i].set(idx);
                }

                idx++;
            }
        }
    }

    int q;

    cin >> q;

    vector< int > ans;

    for (int i = 0; i < q; i++) {
        int u;

        cin >> u;

        BitSet user;

        for (int j = 0; j < f; j++) {
            user.set(((long long)u * a[j]) % m);
        }

        for (int j = 0; j < n; j++) {
            if (files[j].contains(user)) {
                ans.push_back(j);
            }
        }
    }

    sort(ans.begin(), ans.end());

    ans.resize(unique(ans.begin(), ans.end()) - ans.begin());

    cout << ans.size() << " ";

    for (int i = 0; i < ans.size(); i++) {
        cout << ans[i] << " ";
    }

    cout << endl;

    return 0;
}
