#include <iostream>
#include <algorithm>
#include <cstring>
#include <cstdio>
#include <map>
#include <set>
#include <vector>
#include <iomanip>
#include <queue>
#include <stack>
#include <cassert>
#include <string>
#include <cmath>
#include <ctime>

using namespace std;

const int MAX_N = 1005;

int n, m, a[MAX_N], b[MAX_N], ans[MAX_N], pos[MAX_N], dir[MAX_N];
pair< pair< int, int >, pair< int, int > > q[MAX_N];

void move_forward(int d, int dt) {
    int len = b[d] - a[d];

    if (dt < len - pos[d]) {
        pos[d] += dt;
        return;
    }

    dt -= len - pos[d];
    pos[d] = len;
    dir[d] ^= 1;

    if (dt == 0) {
        return;
    }

    int mv = dt % (len + 1);

    if ((dt / (len + 1)) % 2 == 0) {
        pos[d] -= mv;
    } else {
        mv = pos[d] - mv;
        pos[d] -= mv;
        dir[d] ^= 1;
    }
}

void move(int d, int dt) {
    int len = b[d] - a[d];

    if (len == 0) {
        return;
    }

    bool rev = false;
    if (dir[d]) {
        rev = true;
        pos[d] = len - pos[d];
        dir[d] = 0;
    }
    
    move_forward(d, dt);

    if (rev) {
        pos[d] = len - pos[d];
        dir[d] ^= 1;
    }

    if (pos[d] == 0) {
        dir[d] = 0;
    } else if (pos[d] == len) {
        dir[d] = 1;
    }
}

int main() {
    freopen("knockout.in", "r", stdin);
    freopen("knockout.out", "w", stdout);

    cin >> n >> m;

    for (int i = 0; i < n; i++) {
        cin >> a[i] >> b[i];
        if (a[i] > b[i]) {
            dir[i] = 1;
            swap(a[i], b[i]);
            pos[i] = b[i] - a[i];
        }
    }

    for (int i = 0; i < m; i++) {
        cin >> q[i].second.first >> q[i].second.second >> q[i].first.first;
        q[i].first.second = i;
    }

    sort(q, q + m);

    int cur_t = 0;

    for (int i = 0; i < m; i++) {
        int delta = q[i].first.first - cur_t;
        cur_t = q[i].first.first;

        for (int j = 0; j < n; j++) {
            move(j, delta);

            int p = pos[j] + a[j];

            if (p >= q[i].second.first && p <= q[i].second.second) {
                ans[q[i].first.second]++;
            }
        }
    }

    for (int i = 0; i < m; i++) {
        cout << ans[i] << endl;
    }

    return 0;
}
