#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <stack>
#include <queue>
#include <string>
#include <map>
#include <set>
#include <cstdlib>
#include <iomanip>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef vector<int> vi;
typedef vector<ll> vll;


#define pb(a) push_back((a))
#define mp(a, b) make_pair((a), (b))

#define FOR(i, n) for (int i = 0; i < (n); ++i)

struct dr {
	ll a;
	ll b;
	bool operator<(const dr& other) const {
		return a * other.b < b * other.a;
	}

};

void solve_b() {
	ll n, A, B;
	cin >> n >> A >> B;
	vector<ll> g(n), a(n), b(n);
	for (int i = 0; i < n; ++i)
		cin >> g[i] >> a[i] >> b[i];
	vector<pair<dr, int> > t(n);
	for (int i = 0; i < n; ++i) {
		t[i].first = { b[i], a[i] };
		t[i].second = i;
	}
	sort(t.begin(), t.end());
	long double ost = B;
	vector<long double> s(n);
	for (int i = 0; i < n; ++i) {
		int pos = t[i].second;
		if (a[pos] != 0) {
			long double x = g[pos] * a[pos];
			if (g[pos] * b[pos] > ost) {
				x = ost * a[pos] / b[pos];
				s[pos] = x;
				break;
			}
			s[pos] = x;
			ost -= x * b[pos] / a[pos];
		}
	}
	long double sat = 0;
	for (int i = 0; i < n; ++i) {
		sat += s[i];
	}
	const long double EPS = 1e-9;
	if (sat < A + EPS)
		cout << -1 << " " << -1;
	else {
		long double unh = 0;
		for (int i = 0; i < n; ++i)
			unh += (a[i] ? s[i] * b[i] / a[i] : 0);
		cout << fixed << setprecision(10) << sat << " " << unh << "\n";
		for (int i = 0; i < n; ++i)
			cout << fixed << setprecision(10) << (a[i] ? s[i] / a[i] : 0) << " ";
	}
}

string taskname = "burrito";

int main() {
#ifdef LOCAL_DEBUG
	freopen("in.txt", "r", stdin);
	freopen("out.txt", "w", stdout);
#else
	freopen((taskname + ".in").c_str(), "r", stdin);
	freopen((taskname + ".out").c_str(), "w", stdout);
#endif
	ios_base::sync_with_stdio(0);
	solve_b();
	return 0;
}