#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <stack>
#include <queue>
#include <string>
#include <map>
#include <set>
#include <cstdlib>
#include <iomanip>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef vector<int> vi;
typedef vector<ll> vll;


#define pb(a) push_back((a))
#define mp(a, b) make_pair((a), (b))

#define FOR(i, n) for (int i = 0; i < (n); ++i)

struct state {
	char move;
	int next[3];
};

int n;
state opp[100];
state ans[50000];
int cl[100];
vector<pair<int, int> > find_state;
int last;
vector<int> v[50000];
int has_st = 1, has_cl = 1;
vector<int> final;

void bfs() {
	vector<int> q;
	q.push_back(0);
	for (int i = 0; i < 200; ++i) {
		vector<int> new_q;
		for (vector<int>::iterator it = q.begin(); it != q.end(); ++it) {
			int pos = *it;
			vector<int> t[3];
			for (int k = 0; k < v[pos].size(); ++k) {
				int cur = v[pos][k];
				t[opp[cur].move - 'P'].push_back(cur);
			}
			if (t[0].size() != v[pos].size() && t[1].size() != v[pos].size() && t[2].size() != v[pos].size()) {
				ans[pos].move = 'P';
				for (int j = 0; j < 3; ++j) {
					if (t[j].size() != 0) {
						for (int k = 0; k < t[j].size(); ++k) {
							v[has_st].push_back(opp[t[j][k]].next[0]);
							cl[t[j][k]] = has_cl;
						}
						ans[pos].next[j] = has_st;
						new_q.push_back(has_st);
						++has_st;
						++has_cl;
					}
					else
						ans[pos].next[j] = pos;
				}
			}
			else {
				int t;
				for (t = 0; t < 3; ++t) {
					vector<int> classes(v[pos].size());
					for (int k = 0; k < v[pos].size(); ++k) {
						classes[k] = cl[opp[v[pos][k]].next[t]];
					}
					sort(classes.begin(), classes.end());
					classes.erase(unique(classes.begin(), classes.end()), classes.end());
					if (classes.size() > 1) {
						ans[pos].move = 'P' + t;
						ans[pos].next[0] = ans[pos].next[1] = ans[pos].next[2] = pos;
						ans[pos].next[ans[pos].move - 'P'] = has_st;
						for (int k = 0; k < v[pos].size(); ++k) {
							int cur_cl = lower_bound(classes.begin(), classes.end(), cl[v[pos][k]]) - classes.begin();
							v[has_st].push_back(opp[v[pos][k]].next[t]);
							cl[v[pos][k]] = has_cl + cur_cl;
						}
						new_q.push_back(has_st);
						++has_st;
						has_cl += classes.size();
						break;
					}
				}
				if (t == 3) {
					ans[pos].move = 'P';
					ans[pos].next[0] = ans[pos].next[1] = ans[pos].next[2] = has_st;
					for (int k = 0; k < v[pos].size(); ++k) {
						v[has_st].push_back(opp[v[pos][k]].next[0]);
					}
					new_q.push_back(has_st);
					++has_st;
				}
			}
		}
		q.swap(new_q);
	}
	for (int i = 0; i < q.size(); ++i)
		final.push_back(q[i]);
}

void build(int st) {
	vector<int> used(n, -1);
	int cur_st = st, cur_opp_st = v[st][0];
	while (used[cur_opp_st] == -1) {
		ans[cur_st].move = 'P' + ((opp[cur_opp_st].move - 'P' + 2) % 3);
		ans[cur_st].next[0] = ans[cur_st].next[1] = ans[cur_st].next[2] = has_st;
		used[cur_opp_st] = cur_st;
		cur_opp_st = opp[cur_opp_st].next[ans[cur_st].move - 'P'];
		cur_st = has_st;
		++has_st;
	}
	ans[cur_st].move = 'P' + ((opp[cur_opp_st].move - 'P' + 2) % 3);
	ans[cur_st].next[0] = ans[cur_st].next[1] = ans[cur_st].next[2] = used[cur_opp_st];
}

void solve_e() {
	cin >> n;
	for (int i = 0; i < n; ++i) {
		cin >> opp[i].move;
		if (opp[i].move > 'P')
			--opp[i].move;
		cin >> opp[i].next[1] >> opp[i].next[0] >> opp[i].next[2];
		--opp[i].next[1];
		--opp[i].next[0];
		--opp[i].next[2];
		cl[i] = 0;
		v[0].push_back(i);
	}
	bfs();
	for (int i = 0; i < final.size(); ++i)
		build(final[i]);
	cout << has_st << "\n";
	for (int i = 0; i < has_st; ++i) {
		if (ans[i].move > 'P')
			++ans[i].move;
		cout << ans[i].move << " " << ans[i].next[0] + 1 << " " << ans[i].next[1] + 1 << " " << ans[i].next[2] + 1 << "\n";
	}
}

string taskname = "epic";

int main() {
#ifdef LOCAL_DEBUG
	freopen("in.txt", "r", stdin);
	freopen("out.txt", "w", stdout);
#else
	freopen((taskname + ".in").c_str(), "r", stdin);
	freopen((taskname + ".out").c_str(), "w", stdout);
#endif
	ios_base::sync_with_stdio(0);
	solve_e();
	return 0;
}