#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <stack>
#include <queue>
#include <string>
#include <map>
#include <set>
#include <cstdlib>
#include <iomanip>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef vector<int> vi;
typedef vector<ll> vll;


#define pb(a) push_back((a))
#define mp(a, b) make_pair((a), (b))

#define FOR(i, n) for (int i = 0; i < (n); ++i)

void solve_f() {
	typedef vector<bool> vb;
	ll m, f;
	cin >> m >> f;
	vll a(f);
	for (int i = 0; i < f; ++i) {
		cin >> a[i];
		a[i] = a[i] % m;
	}

	int n;
	cin >> n;

	vector<vb> fil(n, vb(1000, false));
	for (int i = 0; i < n; ++i) {
		string s;
		cin >> s;
		int ind = 0;
		for (int j = 0; j < s.size(); ++j) {
			int t = 0;
			if (s[j] >= '0' && s[j] <= '9') {
				t = s[j] - '0';
			}
			else {
				t = s[j] - 'a' + 10;
			}
			int lind = ind + 4;
			for (; ind < lind; ++ind) {
				fil[i][ind] = t & 1;
				t >>= 1;
			}
		}
	}
	int q;
	cin >> q;
	vll u(q);
	for (int i = 0; i < q; ++i) {
		cin >> u[i];
	}

	vector<vll> bl(q);
	for (int i = 0; i < q; ++i) {
		for (int j = 0; j < f; ++j) {
			ll hash = (u[i] * a[j]) % m;
			bl[i].push_back(hash);
		}
	}
	vector<ll> ans;

	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < q; ++j) {
			bool good = true;
			for (int k = 0; k < bl[j].size(); ++k) {
				if (!fil[i][bl[j][k]]) {
					good = false;
					break;
				}
			}
			if (good) {
				ans.push_back(i);
				break;
			}
		}
	}
	cout << ans.size() << ' ';
	for (int i = 0; i < ans.size(); ++i) {
		cout << ans[i] << ' ';
	}

}

struct dr {
	ll a;
	ll b;
	bool operator<(const dr& other) const {
		return a * other.b < b * other.a;
	}

};

void solve_b() {
	ll n, A, B;
	cin >> n >> A >> B;
	vector<ll> g(n), a(n), b(n);
	for (int i = 0; i < n; ++i)
		cin >> g[i] >> a[i] >> b[i];
	vector<pair<dr, int> > t(n);
	for (int i = 0; i < n; ++i) {
		t[i].first = { b[i], a[i] };
		t[i].second = i;
	}
	sort(t.begin(), t.end());
	long double ost = B;
	vector<long double> s(n);
	for (int i = 0; i < n; ++i) {
		int pos = t[i].second;
		if (a[pos] != 0) {
			long double x = g[pos] * a[pos];
			if (g[pos] * b[pos] > ost)
				x = ost * a[pos] / b[pos];
			s[pos] = x / a[pos];
			ost -= x * b[pos] / a[pos];
		}
	}
	long double sat = 0, unh = 0;
	for (int i = 0; i < n; ++i) {
		sat += s[i] * a[i];
		unh += s[i] * b[i];
	}
	const long double EPS = 1e-9;
	if (sat < A + EPS)
		cout << -1 << " " << -1;
	else {
		cout << fixed << setprecision(10) << sat << " " << unh << "\n";
		for (int i = 0; i < n; ++i)
			cout << fixed << setprecision(10) << s[i] << " ";
	}
}

string taskname = "filter";

int main() {
#ifdef LOCAL_DEBUG
	freopen("in.txt", "r", stdin);
	freopen("out.txt", "w", stdout);
#else
	freopen((taskname + ".in").c_str(), "r", stdin);
	freopen((taskname + ".out").c_str(), "w", stdout);
#endif
	ios_base::sync_with_stdio(0);
	//for (int i = 0; i < 50; ++i)
	//	cout << i + 1;
	solve_f();
	return 0;
}