#include <iostream>
#include <cstdio>
#include <cmath>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;

int n, A, B;

const double eps = 1e-9;

struct ingr {
    int g, a, b;
    int i; double amount;

    bool operator < (const ingr &o) const {
        if (b == 0 && o.b ==0)
            return a > o.a;
        if (b == 0)
            return true;
        if (o.b == 0)
            return false;
        return (a*o.b > o.a * b);
        // a/b < o.a/o.b
    }
};

ingr a[200000];

double ansA=0.0, ansB=0.0;

bool mycmp(const ingr &a, const ingr &b) {
    return a.i < b.i;
}


int main() {
    freopen("burrito.in", "r", stdin);
    freopen("burrito.out", "w", stdout);

    scanf("%d%d%d", &n, &A, &B);

    for (int i =0; i < n; ++i) {
        scanf("%d%d%d", &a[i].g, &a[i].a, &a[i].b);
        a[i].i=i;
    }

    sort(a, a+n);

    for (int i =0; i <n; ++i) {
        if (ansB + a[i].g*a[i].b - B < eps) {
            a[i].amount = a[i].g;
            ansA += a[i].g * a[i].a;
            ansB += a[i].g * a[i].b;
            continue;
        }
        a[i].amount = (B - ansB) / a[i].b;
        ansA += a[i].amount * a[i].a;
        ansB += a[i].amount * a[i].b;
        break;
    }

    sort(a, a+n, mycmp);

    cout.precision(9);
    if (ansA - A < eps) {
        printf("-1 -1\n");
        return 0;
    }

    cout << fixed << ansA << " " << fixed <<ansB << "\n";
    for (int i =0; i < n; ++i)
        cout << fixed << a[i].amount << " ";

    return 0;
}
