import java.io.InputStreamReader;
import java.io.IOException;
import java.io.BufferedReader;
import java.io.OutputStream;
import java.io.FileOutputStream;
import java.io.PrintWriter;
import java.util.Random;
import java.io.FileInputStream;
import java.util.StringTokenizer;
import java.io.InputStream;
 
/**
 * Built using CHelper plug-in
 * Actual solution is at the top
 */
public class epic_petr_wa {
    public static void main(String[] args) {
        InputStream inputStream;
        try {
            inputStream = new FileInputStream("epic.in");
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
        OutputStream outputStream;
        try {
            outputStream = new FileOutputStream("epic.out");
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
        InputReader in = new InputReader(inputStream);
        PrintWriter out = new PrintWriter(outputStream);
        Epic solver = new Epic();
        solver.solve(1, in, out);
        out.close();
    }

    static class Epic {

        public static final int COPIES = 10;

        public void solve(int testNumber, InputReader in, PrintWriter out) {
            int n = in.nextInt();
            int[] what = new int[n];
            int[][] jump = new int[n][3];
            for (int i = 0; i < n; ++i) {
                what[i] = "RPS".indexOf(in.next().charAt(0));
                for (int j = 0; j < 3; ++j) jump[i][j] = in.nextInt() - 1;
            }
            out.println(COPIES * n);
            Random random = new Random(54731543531L);
            for (int i = 0; i < COPIES * n; ++i) {
                int j = i % n;
                out.print("RPS".charAt((what[j] + 1) % 3));
                for (int k = 0; k < 3; ++k) {
                    out.print(" ");
                    if (k == what[j]) {
                        out.print(jump[j][(what[j] + 1) % 3] + n * random.nextInt(COPIES) + 1);
                    } else {
                        int x;
                        do {
                            x = random.nextInt(COPIES * n);
                        } while (x == i);
                        out.print(x + 1);
                    }
                }
                out.println();
            }
        }
    }

    static class InputReader {
        public BufferedReader reader;
        public StringTokenizer tokenizer;

        public InputReader(InputStream stream) {
            reader = new BufferedReader(new InputStreamReader(stream), 32768);
            tokenizer = null;
        }

        public String next() {
            while (tokenizer == null || !tokenizer.hasMoreTokens()) {
                try {
                    tokenizer = new StringTokenizer(reader.readLine());
                } catch (IOException e) {
                    throw new RuntimeException(e);
                }
            }
            return tokenizer.nextToken();
        }

        public int nextInt() {
            return Integer.parseInt(next());
        }

    }
}