import java.io.InputStreamReader;
import java.io.IOException;
import java.util.Arrays;
import java.io.BufferedReader;
import java.io.OutputStream;
import java.io.FileOutputStream;
import java.io.PrintWriter;
import java.io.FileInputStream;
import java.util.StringTokenizer;
import java.io.InputStream;

/**
 * Built using CHelper plug-in
 * Actual solution is at the top
 */
public class improvements_petr {
    public static void main(String[] args) {
        InputStream inputStream;
        try {
            inputStream = new FileInputStream("improvements.in");
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
        OutputStream outputStream;
        try {
            outputStream = new FileOutputStream("improvements.out");
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
        InputReader in = new InputReader(inputStream);
        PrintWriter out = new PrintWriter(outputStream);
        Improvements solver = new Improvements();
        solver.solve(1, in, out);
        out.close();
    }

    static class Improvements {
        public void solve(int testNumber, InputReader in, PrintWriter out) {
            int n = in.nextInt();
            int[] x = new int[n];
            for (int i = 0; i < n; ++i) {
                x[i] = in.nextInt();
            }
            int[] y = new int[n];
            for (int i = 0; i < n; ++i) {
                for (int j = 0; j < n; ++j) {
                    if (x[j] > x[i]) ++y[j];
                }
            }
            int[] z = new int[n];
            Arrays.fill(z, -1);
            for (int i = 0; i < n; ++i) z[y[i]] = i;
            for (int zz : z) if (zz < 0) throw new RuntimeException();
            int[] prefs = maxIncreasing(z);
            int[] t = new int[n];
            for (int i = 0; i < n; ++i) t[n - 1 - i] = z[i];
            int[] suffs = maxIncreasing(t);
            int res = 0;
            for (int i = 0; i <= n; ++i) {
                res = Math.max(res, prefs[i] + suffs[n - i]);
            }
            out.println(res);
        }

        // This could be O(nlogn) if needed.
        private int[] maxIncreasing(int[] z) {
            int[] res = new int[z.length + 1];
            int[] best = new int[z.length];
            for (int take = 0; take < z.length; ++take) {
                best[take] = 1;
                for (int j = 0; j < take; ++j)
                    if (z[j] < z[take])
                        best[take] = Math.max(best[take], best[j] + 1);
                res[take + 1] = Math.max(res[take], best[take]);
            }
            return res;
        }
    }

    static class InputReader {
        public BufferedReader reader;
        public StringTokenizer tokenizer;

        public InputReader(InputStream stream) {
            reader = new BufferedReader(new InputStreamReader(stream), 32768);
            tokenizer = null;
        }

        public String next() {
            while (tokenizer == null || !tokenizer.hasMoreTokens()) {
                try {
                    tokenizer = new StringTokenizer(reader.readLine());
                } catch (IOException e) {
                    throw new RuntimeException(e);
                }
            }
            return tokenizer.nextToken();
        }

        public int nextInt() {
            return Integer.parseInt(next());
        }

    }
}
