import java.io.*;       
import java.util.*;

public class improvements_va {
	public static void main(String[] args) {
		new improvements_va().run();
	}

	BufferedReader br;
	StringTokenizer in;
	PrintWriter out;

	public String nextToken() throws IOException {
		while (in == null || !in.hasMoreTokens()) {
			in = new StringTokenizer(br.readLine());
		}
		return in.nextToken();
	}

	public int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	public class Tree {
		int[] tree;

		public Tree(int n, int[] a, int r) {
			int k = 1;
			while (k < n)
				k *= 2;
			tree = new int[2 * k];
			// }
		}

		public void update(int v, int x) {
			v += tree.length / 2;
			tree[v] = Math.max(x, tree[v]);
			v /= 2;
			while (v > 0) {
				tree[v] = Math.max(tree[2 * v], tree[2 * v + 1]);
				v /= 2;
			}
		}

		public int get(int v, int l, int r, int a, int b) {
			if (r < a || b < l) {
				return 0;
			}
			if (a <= l && r <= b) {
				return tree[v];
			}

			return Math.max(get(2 * v, l, (l + r) / 2, a, b),
					get(2 * v + 1, (l + r) / 2 + 1, r, a, b));
		}

		public int get(int l, int r) {
			return get(1, 1, tree.length / 2, l + 1, r + 1);
		}

		public int get(int v) {
			return tree[v + tree.length / 2];
		}

		public String toString() {
			return Arrays.toString(Arrays.copyOfRange(tree, tree.length / 2,
					tree.length));
		}
	}

	public void solve() throws IOException {
		int n = nextInt();

		int[] a = new int[n + 2];
		int[] ra = new int[n + 2];
		for (int i = 0; i < n; i++) {
			a[i + 1] = nextInt() + 1;
		}

		a[0] = 1;
		a[n + 1] = 0;
		n += 2;

		int res = 2;

		for (int i = 0; i < a.length; i++) {
			ra[a[i]] = i;
		}
		Tree[] ans = new Tree[n];
		for (int i = 0; i < ans.length; i++) {
			ans[i] = new Tree(n, a, i);
		}

		for (int r = n - 1; r >= 0; r--) {
			int rr = ra[r];
			for (int l = 0; l < r; l++) {
				int rl = ra[l];
				int x = Math.min(rr, rl) + 1;
				int y = Math.max(rr, rl) - 1;
				if (x > y) {
					ans[l].update(rr, 2);
					continue;
				}
				int put = Math.max(ans[r].get(x, y), ans[l].get(x, y)) + 1;
				put = Math.max(put, 2);
				ans[l].update(rr, put);
			}
		}

		res = ans[0].get(0);

		out.println(n - res);
	}

//	}

	public void run() {
		try {
			br = new BufferedReader(new FileReader("improvements.in"));
			out = new PrintWriter("improvements.out");

			solve();

			out.close();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}
}
