#include <iostream>
#include <cstdio>
#include <algorithm>
#include <ctime>
#include <cmath>

using namespace std;

#define NAME "burrito"

int n;
double A, B;
int arr[100005];
double ans[100005];
double a[100005], b[100005], g[100005];
double d[100005];

bool comp(int l, int r) {
	if (b[l] == 0 && b[r] == 0) return a[l] > a[r];
	if (b[l] == 0) return true;
	if (b[r] == 0) return false;
	return d[l] > d[r];
}

int main() {
	freopen(NAME".in", "r", stdin);
	freopen(NAME".out", "w", stdout);

	cin >> n >> A >> B;
	for (int i = 0; i < n; i++) {
		cin >> g[i] >> a[i] >> b[i];
		arr[i] = i;
		d[i] = a[i] / b[i];
	}

	random_shuffle(arr, arr + n);
	stable_sort(arr, arr + n, comp);

	double cura = 0, curb = 0;
	double ag, bg, k, p;
	int i;
	for (int ii = 0; ii < n; ii++) {
		i = arr[ii];
		if (g[i] == 0) {
			ans[i] = 0;
			continue;
		}
		if (b[i] == 0) {
			ans[i] = g[i];
			cura += g[i] * a[i];
			continue;
		}
		ag = a[i] * g[i];
		bg = b[i] * g[i];
		k = min(B - curb, bg);
		if (fabs(k) < 1e-8) {
			break;
		}
		p = k / bg;
		cura += ag * p;
		curb += bg * p;
		ans[i] = p * g[i];
	}

	if (A - cura > 1e-8) {
		cout << "-1 -1";
		return 0;
	}
	printf("%.8f %.8f\n", cura, curb);
	for (int i = 0; i < n; i++) {
		printf("%.8f ", ans[i]);
	}

	return 0;
}