#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <queue>
#include <string>
#include <cstring>
#include <map>
#include <set>
#include <ctime>
#include <utility>
#include <cassert>
#include <vector>

#define F first
#define S second
#define pb push_back
#define mp make_pair

using namespace std;

typedef long long LL;
typedef pair <int, int> pii;

const int inf = (int)1e9;
const int mod = (int)1e9 + 7;
const int maxn = (int)1e6;
const double eps = 1e-9;

#define fname "improvements."

int n, a[maxn], pos1[maxn], pos2[maxn], d1[maxn], d2[maxn], t[4 * maxn], ans;

int get(int v, int tl, int tr, int l, int r) {
	if (l > r)
		return 0;
	if (tl == l && tr == r)
		return t[v];
	int mid = (tl + tr) / 2;
	return max(get(v + v, tl, mid, l, min(mid, r)), get(v + v + 1, mid + 1, tr, max(l, mid + 1), r));
}

void upd(int v, int tl, int tr, int pos, int val) {
	if (tl == tr) {
		t[v] = val;
		return;
	}
	int mid = (tl + tr) / 2;
	if (pos <= mid)
		upd(v + v, tl, mid, pos, val);
	else
		upd(v + v + 1, mid + 1, tr, pos, val);
	t[v] = max(t[v + v], t[v + v + 1]);
	return;
}

int main() {
	freopen(fname"in", "r", stdin);
	freopen(fname"out", "w", stdout);

	cin >> n;

	for (int i = 1; i <= n; ++i) {
		cin >> a[i];
		pos1[a[i]] = i;
		pos2[a[i]] = i;
	}

	reverse(pos2 + 1, pos2 + 1 + n);

	for (int i = 1; i <= n; i++)
	{
		d1[pos1[i]] = 1 + get(1, 1, n, 1, pos1[i] - 1);
		upd(1, 1, n, pos1[i], d1[pos1[i]]);
	}

	for (int i = 1; i <= n; ++i)
		upd(1, 1, n, i, 0);

	for (int i = 1; i <= n; i++)
	{
		d2[pos2[i]] = 1 + get(1, 1, n, 1, pos2[i] - 1);
		upd(1, 1, n, pos2[i], d2[pos2[i]]);
	}

//	for (int i = 1; i <= n; ++i)
//		cerr << d1[i] << ' ';
//	return 0;

	for (int i = 1; i <= n; ++i)
		ans = max(ans, d1[i] + d2[i] - 1);

	cout << ans;
	return 0;
}
