import java.io.*;
import java.util.*;

public class a {
	BufferedReader in;
	PrintWriter out;
	StringTokenizer st;

	public String next() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(in.readLine());
			} catch (Exception e) {
				// TODO: handle exception
			}
		}
		return st.nextToken();
	}

	public int nextInt() {
		return Integer.parseInt(next());
	}

	public long nextLong() {
		return Long.parseLong(next());
	}

	class Triple implements Comparable<Triple> {
		int g, a, b, i;

		public Triple(int g, int a, int b, int i) {
			this.g = g;
			this.a = a;
			this.b = b;
			this.i = i;
		}

		public int compareTo(Triple o) {
			if (b == 0 && o.b == 0){
				return o.a - a; 
			}
			
			if (b == 0) return -1;
			if (o.b==0) return 1;
			
			return o.a * b - a * o.b;
		}
		
		public String toString() {
			return a+ " " + b; 
		}
	}

	public void run() throws Exception {
		Locale.setDefault(Locale.US);
		in = new BufferedReader(new FileReader("burrito.in"));
		out = new PrintWriter(new FileWriter("burrito.out"));

		int n = nextInt();
		int A = nextInt();
		int B = nextInt();

		Triple[] a = new Triple[n];

		for (int i = 0; i < n; i++) {
			a[i] = new Triple(nextInt(), nextInt(), nextInt(), i);
		}

		Random rn = new Random(1232341234L);
		for (int i = 2; i < n; i++) {
			int j = Math.abs(rn.nextInt()) % i;
			Triple w = a[i];
			a[i] = a[j];
			a[j] = w;
		}

		Arrays.sort(a);
		//System.err.println(Arrays.toString(a));

		double curB = 0;
		double curA = 0;
		double[] ans = new double[n];

		for (int i = 0; i < n; i++) {
			if (curB + a[i].g * a[i].b <= B) {
				curB += a[i].g * a[i].b;
				curA += a[i].g * a[i].a;
				ans[a[i].i] = a[i].g;
			} else {
				// curB + a[i].g*a[i].b = B
				ans[a[i].i] = (B - curB) / a[i].b;
				curA += ans[a[i].i] * a[i].a;
				curB += ans[a[i].i] * a[i].b;
				long curAA = (long) curA * a[i].b + (long) (B - curB) * a[i].a;
				if (A * a[i].b > curAA) {
					out.println("-1 -1");
					out.close();
					System.exit(0);
				}
				break;
			}
		}

		if (A > curA) {
			out.println("-1 -1");
			out.close();
			System.exit(0);
		}
		
		out.printf("%.12f %.12f\n", curA, curB);
		for (int i=0; i<n; i++) out.printf("%.12f ", ans[i]);
		out.close();
	}

	public static void main(String[] args) throws Exception {
		new a().run();
	}
}
