import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.Locale;
import java.util.StringTokenizer;


public class Solution {
	
	private static BufferedReader in;
	private static StringTokenizer st;
	private static PrintWriter out;

	public static class Pair implements Comparable<Pair>{
		int g,a,b,ind;
		public Pair(int g, int a, int b, int ind) {
			this.a = a; this.b = b; this.g = g; this.ind = ind;
		}

		public int compareTo(Pair arg) {
			return (this.a * arg.b > arg.a * this.b ? -1:1);
		}
	}
	public static void main(String[] args) throws IOException {
		Locale.setDefault(Locale.US);
//		standart();
		file("burrito");
		int n = nextInt();
		int A = nextInt();
		int B = nextInt();
		Pair p[] = new Pair[n+1];
		double ans[] = new double[n+1];
		for (int i = 1; i <= n; i++) {
			int g = nextInt();
			int a = nextInt();
			int b = nextInt();
			p[i] = new Pair(g, a, b, i);
		}
		double eps = 1e-8;
		Arrays.sort(p,1,n+1);
//		for (int i = 1; i <= n; i++) {
//			System.out.println(p[i].a+" "+p[i].b);
//		}
		double a = 0, b = 0;
		for (int i = 1; i <=n; i++) {
			double g = p[i].g;
			if(p[i].b > 0){
				g = Math.min(g, 1.0 * (B-b) / p[i].b);
			}
			ans[p[i].ind] = g;
			a += p[i].a * g;
			b += p[i].b * g;
		}
		if(a+eps >= A && b <= B+eps){
			out.println(a+" "+b);
			for (int i = 1; i <=n; i++) {
				out.print(ans[i]+" ");
			}
		}else{
			out.println("-1 -1");
		}
		out.close();
	}

	private static long nextLong() throws NumberFormatException, IOException {
		return Long.parseLong(next());
	}

	private static double nextDouble() throws NumberFormatException, IOException {
		return Double.parseDouble(next());
	}

	private static int nextInt() throws NumberFormatException, IOException {
		return Integer.parseInt(next());
	}

	private static String next() throws IOException {
		while(!st.hasMoreTokens())
			st = new StringTokenizer(in.readLine());
		return st.nextToken();
	}

	private static void file(String file) throws IOException {
		in = new BufferedReader(new FileReader(new File(file+".in")));
		st = new StringTokenizer("");
		out=  new PrintWriter(new BufferedWriter(new FileWriter(file+".out")));
	}

	private static void standart() {
		in = new BufferedReader(new InputStreamReader(System.in));
		st = new StringTokenizer("");
		out = new PrintWriter(new OutputStreamWriter(System.out));
	}
}
