#include <iostream>
#include <fstream>
#include <cstdio>
#include <iomanip>
#include <cassert>
#include <cmath>
#include <math.h>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <queue>
#include <deque>
#include <ctime>
#include <string>
#include <cstdlib>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef pair<int, int> pii;

#define sz(x) ((int)((x).size()))

const int MAXN = (int)(4e5) + 10;

int n;
int x[MAXN], lf[MAXN], rg[MAXN];
pii c[2 * MAXN];
bool u[MAXN], used[MAXN];
vector<int> g[MAXN];

int go(int v) {
	used[v] = true;
	int res = 1;
	for (int i = 0; i < sz(g[v]); i++) {
		int to = g[v][i];
		if (!used[to])
			res += go(to);
	}
	return res;
}

int main() {
	freopen("improvements.in", "r", stdin);
	freopen("improvements.out", "w", stdout);

	scanf("%d", &n);
	for (int i = 0, lst = 0; i < n; i++) {
		scanf("%d", &x[i]);
		lf[i] = lst, rg[i] = x[i];
		lst = x[i];
		if (lf[i] > rg[i])
			swap(lf[i], rg[i]);
		c[2 * i] = make_pair(lf[i], i);
		c[2 * i + 1] = make_pair(rg[i], i);
	}
	sort(c, c + 2 * n);
	set<pii> st;
	for (int i = 0; i < 2 * n; ) {
		int j = i;
		while (j < 2 * n && c[i].first == c[j].first) j++;
		for (int k = i; k < j; k++) {
			if (u[c[k].second]) {
				st.erase(make_pair(rg[c[k].second], c[k].second));
			}
		}
		for (int k = i; k < j; k++) {
			if (u[c[k].second])
				continue;
			if (!st.empty()) {
				int v = c[k].second;
				int u = st.begin()->second;
				if (rg[v] > rg[u]) {
					g[v].push_back(u);
					g[u].push_back(v);
				}
			}
		}
		for (int k = i; k < j; k++) {
			if (!u[c[k].second]) {
				u[c[k].second] = true;
				st.insert(make_pair(rg[c[k].second], c[k].second));
			}
		}
		i = j;
	}/*
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < sz(g[i]); j++) {
			printf("%d ", g[i][j]);
		}
		puts("");
	}*/
	int ans = 0;
	for (int i = 0; i < n; i++) {
		if (!used[i]) {
			ans += go(i) - 1;
		}
	}
	printf("%d\n", n - ans);


	return 0;
}
